/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

/* COSTANTI */
var MAX_PRINT_TITLES = 200;
var WARNING_PRINT_TITLES = 100;

function _customLoadHandler()
 {var tipo = (getForm("hxpForm").xverb.value == '@print')? 'stampa': ''; //la pagina di stampa contiene un frameset
  var queryFrase = writeFrase(1000,tipo);
  if (typeof(queryFrase) == 'undefined') //docs dei rif. normativi...
   queryFrase = "";
  if ((getForm("hxpForm").xverb.value == '@print') && (getForm("hxpForm").selid.value==getForm("hxpForm").cId.value)) //se pagina di stampa documenti di raccolte (potrebbero essere multiarchivio)
   document.title = '(IWeb) Stampa - ' + queryFrase; 
  else if (getForm("hxpForm").xverb.value == '@print') //se pagina di stampa documenti
   document.title = getForm("hxpForm").db.value.toUpperCase() + ' Stampa - ' + queryFrase; 
  else
   document.title = getForm("hxpForm").db.value.toUpperCase() + ' ' + queryFrase;
  if (typeof(parent)!='undefined')  
   if (typeof(parent.actionFrame)!='undefined')
    if (typeof(parent.actionFrame.refreshPage)!='undefined')
     parent.actionFrame.refreshPage();
  /* abilito i pulsanti di back e fwd history */
  if ( (getForm("hxpForm").verbo.value == 'showtarget') && (getForm("hxpForm").xverb.value == 'child') ){
  	if (history.length > 0){
    var el = document.getElementById('prevHide');
    el.style.display = "none";
    el = document.getElementById('prevShow');
    el.style.display = "";
    var el = document.getElementById('nextHide');
    el.style.display = "none";
    el = document.getElementById('nextShow');
    el.style.display = "";
   }
  }
  if(getForm("hxpForm").xverb.value.indexOf('asText')>=0)
  {var el=document.getElementById('hxp-doc-data-asText');
   getForm("hxpForm").asText.value=getForm("hxpForm").asText.value.replace(/</g,'&#60;');
   getForm("hxpForm").asText.value=getForm("hxpForm").asText.value.replace(/>/g,'&#62;');
   getForm("hxpForm").asText.value=getForm("hxpForm").asText.value.replace(/(.)&#60;([^\?])/g,'$1<br>&#60;$2');
   el.innerHTML=getForm("hxpForm").asText.value;
   getForm("hxpForm").asText.value='';
  }
 }
 
 function printHeaderF(val){
	return Math.min(val,MAX_PRINT_TITLES);
 } 

 function prevHistory(){
  history.go(-1);
  return false;
 }
 
 function nextHistory(){
  history.go(1); 	
  return false;
 }

function doFindLike(numPhis)
 {
   var dbVal;
   var qStr;
   var qWin;
   var tForm;
   
   var hxpForm = getForm("hxpForm");
   
   dbVal=hxpForm["db"].value;
   qStr ='[?XMLCMD]';
   qStr+='<?xml version="1.0" encoding="windows1252"?>';
   qStr+='<cmd c="xe" bits="0" d="'+numPhis+'" key="testo">';
   qStr+='</cmd>';
   qStr+='<!-- {queryDescr[documenti simili al n. ';
   qStr+=(1.0*hxpForm["pos"].value)+1;
   qStr+=' della selezione ';
   qStr+=id2uid(hxpForm["selid"].value);
   qStr+=']} -->';

   qWin=window.opener;
   
   tForm=qWin.getForm("hxpForm");

   var svdb   =tForm.db.value   ; 
   var svverbo=tForm.verbo.value; 
   var svxverb=tForm.xverb.value; 
   var svquery=tForm.query.value; 
   var svqext =tForm.qext.value ; 
   var svqopt =tForm.qopt.value ; 

   tForm.db.value=dbVal;
   tForm.verbo.value="query";
   tForm.xverb.value="";
   tForm.query.value=qStr;
   tForm.qext.value="";
   tForm.qopt.value|=1;

   tForm.target='findLike'+numPhis+''+tForm.selid.value;

   var theWindow=window.open
   ('',tForm.target,'status,resizable=yes,scrollbars=yes,width=800,height=600,top=0,left=0');
   theWindow.focus();

   tForm.submit();

   tForm.db.value   =svdb   ; 
   tForm.verbo.value=svverbo; 
   tForm.xverb.value=svxverb; 
   tForm.query.value=svquery; 
   tForm.qext.value =svqext ; 
   tForm.qopt.value =svqopt ; 

   return(false);
 }

