/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

 /* export.js */

 function findChildInput(theNode,theName)//torna il nodo input descendant or self di theNode con nome theName
 {var inputList=theNode.getElementsByTagName("input");
  for (var i=0;i<inputList.length;i++)
  {if(inputList.item(i).getAttribute("name")==theName)
   {return inputList.item(i);
   }
  }
  return null;
 }
 function checkInput(theForm,name,value)
 {var theInput=findChildInput(theForm,name);
  if(theInput==null)
  {var theInput=document.createElement('input');
   theInput.setAttribute('type','hidden');
   theInput.setAttribute('name',name);
   theForm.appendChild(theInput);
   result='';
  }
  else result=theInput.getAttribute('value');
  theInput.setAttribute('value',value);
  return result;
 }
 function exportSele()
 {var cverbo=getForm("hxpForm").verbo.value;
  var cxverb=getForm("hxpForm").xverb.value;
  var cselid=getForm("hxpForm").selid.value;
  var result=prompt("nome del file sul server",'');
  if(result==null)return false;
  var cfilename=checkInput(getForm("hxpForm"),'filename',result);
  var cbits=checkInput(getForm("hxpForm"),'bits',document.theForm.bits.checked?document.theForm.bits.value:'');
  //?cbits|=0x80000000; // esporta sul socket
  var prevTarget=getForm("hxpForm").target;
  getForm("hxpForm").target='export';
  getForm("hxpForm").verbo.value='export';
  getForm("hxpForm").xverb.value='';
  getForm("hxpForm").nextXVerb.value='';
  getForm("hxpForm").nextVerb.value='';
  getForm("hxpForm").selid.value=document.theForm.lastqueryid.value;
  var w=window.open('',getForm("hxpForm").target,"status,resizable=yes,scrollbars=yes,width=500,height=300"); 
  getForm("hxpForm").submit();
  w.focus();
  getForm("hxpForm").selid.value=cselid;
  getForm("hxpForm").target=prevTarget;
  getForm("hxpForm").verbo.value=cverbo;
  getForm("hxpForm").xverb.value=cxverb;
  checkInput(getForm("hxpForm"),'filename',cfilename);
  checkInput(getForm("hxpForm"),'bits',cbits);
  return false;
 }
