<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

  <!-- console/worker.jsp -->

  <%
   int theObserverId=0;
   int iPort = (thePort.length()>0)?Integer.parseInt(thePort):-1;
   conn = broker.acquireConnection(theHost,iPort,theDb,"","",-1);
   if(conn>=0 && broker.Connect(conn,theHost,iPort,createDb?null:theDb,-1,theUser,thePassword))
   {String coordString = theDb+(theHost.length()>0?("@"+theHost+(thePort.length()>0?(":"+thePort):"")):"");
    if(theMenublock.equals(menuitems[0])&&verbo.equals(verbo_catalogazione_XML))
    {if(thePath!=null&&thePath.length()>0)
     {broker.XMLImport(conn,theDb,thePath,ServerCommand.xml_import_INDIRECT|(rq.keyVal("owner").equals("1")?ServerCommand.xml_import_OWNER:0),true,rq.keyVal("cattitle").equals("1")?true:false,rq.keyVal("cmpindex").equals("1")?true:false,theObserverId=broker.storeObserver(new ServerObserver(new Date(),"Mapping XML on "+coordString+" from \""+thePath+"\"")));
     }
    }
    else if(verbo.equals(verbo_riorganizzazione_unita_informative))
    {broker.XMLCommand(conn,theDb,"<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?><cmd c=\"x13\" bits=\""+(rq.keyVal("applydtd").equals("1")?"1":"0")+"\"/></cmd>",theObserverId=broker.storeObserver(new ServerObserver(new Date(),"Reorganization "+(rq.keyVal("applydtd").equals("1")?"and converson ":"")+"of information units "+coordString)));
    }
    else if(theMenublock.equals(menuitems[0])&&verbo.equals(verbo_crea_azzera_archivio))
    {broker.createDb(conn,theDbPath,theDb,true);
     %><b>Done!<b><%;
    }
    else if(theMenublock.equals(menuitems[0])&&verbo.equals(verbo_elenco_chiavi_XML))
    {%><%= "<pre>" + Text.tohtml(new String((new RawData(broker.XMLKeys(conn,theDb))).data)) %><%
    }
    else if(theMenublock.equals(menuitems[0])&&verbo.equals(verbo_rigenerazione_titoli))
    {broker.reTitle(conn,theDb,theObserverId=broker.storeObserver(new ServerObserver(new Date(),"Title rebuild "+coordString)));
    }
    else if(theMenublock.equals(menuitems[0])&&verbo.equals(verbo_compattamento_db))
    {broker.compactDb(conn,theDb,rq.keyVal("forcecompact").equals("1")?ServerCommand.compact_FORCE:0,false,theObserverId=broker.storeObserver(new ServerObserver(new Date(),"Archive Pack "+coordString)));
    }
    else if(theMenublock.equals(menuitems[0])&&verbo.equals(verbo_staticizzazione_db))
    {broker.compactDb(conn,theDb,true,theObserverId=broker.storeObserver(new ServerObserver(new Date(),"Archive Static Mode "+coordString)));
    }
    else if(theMenublock.equals(menuitems[0])&&verbo.equals(verbo_riapertura_archivio))
    {/*
      Riapertura su tutti i server dell'archivio, subito, timeout 30 secondi.
      "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?><cmd c=\"7\" bits=\"3\" timeout=\"30\" num=\"2\"></cmd>"
      Riapertura su tutti i server dell'archivio, subito in locale, gli altri al primo accesso.
      "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?><cmd c=\"7\" bits=\"2\" num=\"2\"></cmd>"
     */
     //String xwResponse=broker.XMLCommand(conn,theDb,"<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?><cmd c=\"7\" bits=\"2\" num=\"2\"></cmd>");
     //String xwResponse=broker.XMLCommand(conn,theDb,"<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?><cmd c=\"7\" bits=\"3\" timeout=\"30\" num=\"2\"></cmd>");
     broker.invalidateHost(theHost,iPort);
     broker.updateDbInfo(conn,theDb);
     %><%= "done!" %><%
     /* %><%= "" + Text.tohtml(xwResponse) %><% */
    }
    else if(theMenublock.equals(menuitems[1])&&verbo.equals(verbo_calcola_impronta))
    {theObserverId=broker.storeObserver(new ServerObserver(new Date(),"Fingerprint "+coordString));
     (new AttachPrint(broker,conn,theDb,theObserverId,rq.keyVal("hash_query"))).start();
    }
    else if(theMenublock.equals(menuitems[2])&&verbo.equals(verbo_rigenerazione_indici))
    {broker.rmIndex(conn,theDb);
     broker.mkIndex(conn,theDb,rq.keyVal("reindexwcmp").equals("1")?0:ServerCommand.mkindex_NO_COMPACT,false,theObserverId=broker.storeObserver(new ServerObserver(new Date(),"Rebuild"+(rq.keyVal("reindexwcmp").equals("1")?" and pack":"")+" indexex "+coordString)));
    }
    else if(theMenublock.equals(menuitems[2])&&verbo.equals(verbo_indicizzazione))
    {broker.mkIndex(conn,theDb,theObserverId=broker.storeObserver(new ServerObserver(new Date(),"Index building "+coordString)));
    }
    else if(theMenublock.equals(menuitems[2])&&verbo.equals(verbo_compattamento_indici))
    {broker.compactIndex(conn,theDb,theObserverId=broker.storeObserver(new ServerObserver(new Date(),"Index Pack "+coordString)));
    }
    else if(theMenublock.equals(menuitems[2])&&verbo.equals(verbo_checkvoc))
    {broker.checkVocabulary(conn,theDb,theObserverId=broker.storeObserver(new ServerObserver(new Date(),"Index Check "+coordString)));
    }
    // Federico 10/07/08: introdotto recupero delle informazioni sugli allegati testuali prodotti dal File Conversion Service
    // nell'estrazione del testo [RW 0053061]
    else if(theMenublock.equals(menuitems[1]) && verbo.equals(verbo_fcs_txt_info)) {
        ShowFcsTxtAttachInfo txtInfo = new ShowFcsTxtAttachInfo(broker, conn, theDb, rq.keyVal("fcstxt_query"));
        Document report              = txtInfo.getFcsTxtAttachInfo();
        Element rootEl               = report.getRootElement();

        if (rootEl.getName().equals("error")) {
            out.write(rootEl.getText());
        }
        else {
            List allegatiTxtFCS = report.selectNodes("//file");

            for (int i = 0; i < allegatiTxtFCS.size(); i++) {
                Element el            = (Element)allegatiTxtFCS.get(i);
                String name           = el.attributeValue("name");
                String title          = el.attributeValue("title");
                String indexing       = el.attributeValue("indexing", "");
                String original       = el.attributeValue("original");
                String original_title = el.attributeValue("original_title");

                %><fieldset>
            		<legend style="font-family:arial; font-size:100%; font-style:oblique; font-weight:bold; color:#000000; padding:0px 4px;">
                        Attachment <%out.write(String.valueOf(i + 1));%>
                    </legend>
                    <dl style="margin:3px 5px; height:4em; background-color:#transparent; color:#00639C; vertical-align:center; overflow:auto;">
                      <dt style="float:left; width:180px; line-height:1em; font-weight:bold; color:#000000;">
                        Original document:
                      </dt>
                      <dd style="margin-left:50px; line-height:1em; color:#000000;">
                          <a target="_new" href="/xway/application/generic/engine/genericadm.jsp?verbo=attach&amp;db=<%out.write(theDb);%>&amp;id=<%out.write(original);%>&amp;host=&amp;port=-1&amp;login=&amp;name=&amp;userRights=&amp;specificAppCode=&amp;specificDbCode=&amp;showdocUOR=&amp;doceditUOR=&amp;acl=&amp;user=&amp;pwd=&amp;_cd=">
                            <%out.write(original_title);%>
                          </a>
                      </dd>
                      <dt style="float:left; width:180px; line-height:1em; font-weight:bold; color:#000000;">
                        Extracted text:
                      </dt>
                      <dd style="margin-left:50px; line-height:1em; color:#000000;">
                        <a target="_new" href="/xway/application/generic/engine/genericadm.jsp?verbo=attach&amp;db=<%out.write(theDb);%>&amp;id=<%out.write(name);%>&amp;host=&amp;port=-1&amp;login=&amp;name=<%out.write(title);%>&amp;userRights=&amp;specificAppCode=&amp;specificDbCode=&amp;showdocUOR=&amp;doceditUOR=&amp;acl=&amp;user=&amp;pwd=&amp;_cd=">
                            <%out.write(title);%>
                        </a>
                      </dd>
                      <dt style="float:left; width:180px; line-height:1em; font-weight:bold; color:#000000;">
                        Indexing:
                      </dt>
                      <dd style="margin-left:50px; line-height:1em; color:#000000;">
                        <%out.write(indexing);%>
                      </dd>
                    </dl>
                  </fieldset><br><br>
                <%
            }
        }
    }
    else {%><%= "unknown verb: '" + verbo +"@" + theMenublock + "' " %><%}
    if(theObserverId!=0)
    {ServerObserver o=broker.getObserver(theObserverId);
     %><%= o.title %><%
     %><br><br><form method="post" action="watch.jsp"><input type="hidden" name="id" value="<%= ""+theObserverId %>"><input type="hidden" name="skin" value="<%= theSkin %>"><input class="typeButton" type="submit" value="watch..."></form><%
    }
   }
   else {%><b>Cannot connect!<b><%;}
   %><form method="post" name="theForm"><input type="hidden" name="skin" value="<%= theSkin %>"><input type="hidden" name="host"  value="<%= theHost.length()>0?theHost:"" %>"><input type="hidden" name="port"  value="<%= thePort.length()>0?thePort:"" %>"></form><%
  %>

