<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<%@ page import = "it.highwaytech.apps.code.*" %>
<%@ include file = "resource.jsp" %>
<% 
 final String pageTitle = "desCipher";
%>
<html>
<head>
 <%@ include file = "head.jsp" %>
</head>
<body> 
  <table class="pageframe" style="width:100%;height:100%" cellpadding="8" cellspacing="10">
  <tbody>
  <tr class="pageframe" height="2%">
   <td class="pageframe" height="2%"><%@ include file = "top.jsp" %></td>
  </tr>   
  <tr class="pageframe" height="100%">
  <td class="pageframe" valign="top">
<%

it.highwaytech.apps.JRequest rq = null;

try {
	rq = new it.highwaytech.apps.JRequest(request,response);
	String theDb       = rq.keyVal("db");
	String theHost     = rq.keyVal("host");
	String thePort     = rq.keyVal("port");
	String theUser     = rq.keyVal("user");
	String testo       = rq.keyVal("testo"); 
	String chiave      = rq.keyVal("chiave");
	String cifrato     = "";

	if ( testo.length() > 0 && chiave.length() >= 8 ) {
		testo = testo.replaceAll("\n", "");
		testo = testo.replaceAll("\r", "");
		Cryptor cryptor = new Cryptor(chiave);
		cifrato = cryptor.encrypt(testo);
		cifrato = it.highwaytech.util.Text.tohtml(cifrato).toString();
		
	}
	else if ( testo.length() > 0 && chiave.length() < 8 )
		cifrato = "ERRORE - La chiave deve essere almeno di 8 caratteri";
	
  %>
  <html>
  <head>
  <title>desCipher</title>
  <link rel="stylesheet" href="jsp.css" type="text/css"/>
  </head>
  <body>
  <br>
  <form name="theForm" method="post" action="<%= rq.hwScript %>">
   <textarea title="testo da criptare" name="testo" rows="20" cols="80"  value="<%= testo!=null&&testo.length()>0?testo:"" %>"></textarea>
   <br>
   <br><input style="width:32em;" type="text" name="chiave" value="<%= chiave!=null&&chiave.length()>0?chiave:"" %>"> Chiave (almeno 8 caratteri)
   <br>
   <br><input style="width:32em;" type="text" name="cifrato" size="100" value="<%= cifrato!=null&&cifrato.length()>0?cifrato:"" %>"> Stringa cifrata
   <br>
   <br><input class="typeButton" type="submit" value="submit">
   <input type="hidden"   name="host"      value="<%= rq.keyVal("theHost") %>">
   <input type="hidden"   name="port"      value="<%= rq.keyVal("thePort") %>">                               
   <input type="hidden"   name="user"      value="<%= rq.keyVal("theUser") %>">  
   <input type="hidden"   name="db"        value="<%= rq.keyVal("theDb")   %>">
   <input type="hidden"   name="skin"      value="<%= rq.readStringParameter("skin","jsp") %>">
   <input type="hidden"   name="menublock" value="<%= rq.readStringParameter("menublock",defaultMenuItem) %>">
  </form>
  </font> 
  </body> 
  </html> 
  <%
 
}catch(Throwable t) {
 t.printStackTrace();
 %><%= "<br>Sorry, an exception occurred: <br><b>"+t.toString()+"</b><br>" %><%
}finally {
	if(rq!=null)rq.close(); 
 %> 
  </td>
  </tr> 
  </tbody>  
  </table>
 </body> 
 </html> 
 <%
}

%>

