<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<%
it.highwaytech.apps.JRequest rq = null;
rq =new it.highwaytech.apps.JRequest(request);
it.highwaytech.broker.Broker broker = null;
it.highwaytech.broker.ServerObserver observer=null;
//it.highwaytech.apps.generic.
it.highwaytech.broker.ImportTh theworker=null;
int conn=-1;
int theObserverId=-1;

String relazioni=rq.keyVal("relazioni");
String indotte=rq.keyVal("indotte");
String theDb    =rq.keyVal("db");
String thePort  = rq.keyVal("port");
String theHost  = rq.keyVal("host");
String theUser  = rq.keyVal("user");
String thePassword = rq.keyVal("pwd");

byte[] thefile=rq.keyFile("thesauro.file");


if(thefile == null || theDb == null || theDb.equals(""))
{
%>
<jsp:forward page="thimport.jsp" />
<%
}

else
{
synchronized(broker.observers)
  {
   try{
       broker = new it.highwaytech.broker.Broker();
       int iPort = (thePort!=null && thePort.length()>0)?Integer.parseInt(thePort):-1;
       conn = broker.acquireConnection(theHost,iPort,theDb,"","",-1);
        if (conn>=0 && broker.Connect(conn,theHost,iPort,theDb,-1,theUser,thePassword)) 
          {
           theObserverId=broker.storeObserver(observer=new it.highwaytech.broker.ServerObserver(new java.util.Date(),"importazione thesauro"));
            theworker=new it.highwaytech.broker.ImportTh();
            theworker.importa(broker,conn,theDb,new it.highwaytech.broker.ByteArray2Text(thefile),observer,theObserverId,relazioni,indotte);
            theworker.run();
           //new it.highwaytech.broker.ImportTh().importa(broker,conn,theDb,new it.broker.generic.ByteArray2Text(thefile),observer,theObserverId,relazioni,indotte);  
              %>
             <jsp:forward page="watch.jsp" />
              <% 
           
          }
      }
   catch(Exception e)
      {
      if(theObserverId!=-1) broker.removeObserver(theObserverId);
      if(broker!=null&&conn>=0)broker.releaseConnection(conn);
      if(rq!=null)rq.close(); 
      %><%= "<br>Sorry, an exception occurred: <br><b>"+e.toString()+"</b><br>" %><%
      }   
  }

}//fine else

 %>










