<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<%@ page import = "java.sql.*" %>
<%@ page import = "java.util.*" %>
<%@ page import = "java.io.UnsupportedEncodingException" %>
<%@ page import = "java.io.IOException" %>
<%@ page import = "it.highwaytech.broker.Broker" %>
<%@ page import = "it.highwaytech.broker.ServerCommand" %>
<%@ page import = "it.highwaytech.db.DbKey" %>
<%@ page import = "it.highwaytech.db.QueryResult" %>
<%@ include file = "resource.jsp" %>
<%!
 Broker broker = null;
 class KeyReader {
  private Vector keys = null;
  private int conn;
  private String db;
  private String table;
  private String field;
  private String start;
  private int step;
  private int counter;
  private int position;
  private int mode;
  KeyReader(int conn, String db, String table, String field, String start, int step, int mode) {
   this.conn = conn;
   this.db = db;
   this.table = table;
   this.field = field;
   this.start = start;
   this.step = step;
   position = 0;
   counter = 0;
   this.mode = mode;
  }
  DbKey getKey() throws SQLException, UnsupportedEncodingException {
   if (keys==null || (keys.size()>0 && position==keys.size())) {
    keys = broker.getIdxKeys(conn,db,table,field,start,"",step,ServerCommand.btree_NEXTKEY,mode);
    if (keys==null||keys.size()==0||(counter>0&&keys.size()==1)) return null;
    position = (counter==0 ? 0:1);
    if (keys.size()>0) {
     start = ((DbKey)keys.get(keys.size()-1)).toString();
     counter += keys.size() - position;
    } 
   }
   return (keys.size()>position ? (DbKey)keys.get(position++) : null);
  }
 }

 void writeKey(JspWriter out, String prefix, DbKey key) throws IOException
 {out.write(prefix + " " + key.toString() + "\r\n");
 }
 void writePlus(JspWriter out, DbKey key) throws IOException 
 {writeKey(out,"+",key);
 }
 void writeMinus(JspWriter out,DbKey key) throws IOException
 {writeKey(out,"-",key);
 }
%>
<% 
 final String pageTitle = "index compare";
 int conn=-1;
 int conn2=-1;
 it.highwaytech.apps.JRequest rq = null;

try {

 rq = new it.highwaytech.apps.JRequest(request,response);
 String theDb       = rq.keyVal("db");
 String theHost     = rq.keyVal("host");
 String thePort     = rq.keyVal("port");
 String theUser     = rq.keyVal("user");
 String thePassword = rq.keyVal("pwd");
 String theField    = rq.keyVal("field");
 String theTable    = rq.keyVal("tablename");
 String theQuery    = rq.keyVal("query");
 
 String theDb2       = rq.keyVal("db2");
 String theHost2     = rq.keyVal("host2");
 String thePort2     = rq.keyVal("port2");
 String theUser2     = rq.keyVal("user2");
 String thePassword2 = rq.keyVal("pwd2");
 String theField2    = rq.keyVal("field2");
 String theTable2    = rq.keyVal("tablename2");
 String theQuery2    = rq.keyVal("query2");
 
 if(theUser2.length()==0 && theHost2.length()==0 && thePort2.length()==0)theUser2=theUser;
 if(thePassword2.length()==0 && theHost2.length()==0 && thePort2.length()==0)thePassword2=thePassword;
 if(theHost2.length()==0 && thePort2.length()==0)theHost2=theHost;
 if(thePort2.length()==0 && theHost2.length()==0)thePort2=thePort;
 if(theDb2.length()==0)theDb2=theDb;
 
 String theSkin = rq.readStringParameter("skin","jsp");

 if (rq.numTuples>0 &&
     theDb!=null && theDb.length()>0 &&
     theField!=null && theField.length()>0 &&
     theField2!=null && theField2.length()>0) {
  broker = new Broker();
  int iPort = (thePort!=null && thePort.length()>0)?Integer.parseInt(thePort):-1;
  conn = broker.acquireConnection(theHost,iPort,theDb,"","",-1);
  if (conn>=0 && broker.Connect(conn,theHost,iPort,theDb,-1,theUser,thePassword)) {
  
   int iPort2 = (thePort2!=null && thePort2.length()>0)?Integer.parseInt(thePort2):-1;
   conn2 = broker.acquireConnection(theHost2,iPort,theDb2,"","",-1);
   if (conn2>=0 && broker.Connect(conn2,theHost2,iPort2,theDb2,-1,theUser2,thePassword2)) {
   
    String coordString = theDb+(theHost.length()>0?("@"+theHost+(thePort.length()>0?(":"+thePort):"")):"");
    String coordString2 = theDb2+(theHost2.length()>0?("@"+theHost2+(thePort2.length()>0?(":"+thePort2):"")):"");
  
    rq.setContentType("text/plain");
    int keyCounter = 0;
    int keyStep = 128;
    
    Vector result = null;
    Vector result2 = null;
    DbKey key=null, key2=null;
    int mode = 0;
    int mode2 = 0;
    if (theQuery.length()>0) {
      QueryResult qr = broker.find(conn,theDb,theQuery,"",0,0,0);
      //broker.setCurrentSet(conn,theDb,qr);
      //broker.getNumDoc(conn,theDb,qr,0);
      mode = ServerCommand.btree_SPETTRALE;
    }
    if (theQuery2.length()>0) {
      QueryResult qr = broker.find(conn2,theDb2,theQuery2,"",0,0,0);
      //broker.setCurrentSet(conn2,theDb2,qr);
      //broker.getNumDoc(conn2,theDb2,qr,0);
      mode2 = ServerCommand.btree_SPETTRALE;
    }
    KeyReader kr = new KeyReader(conn,theDb,theTable,theField,"",keyStep,mode);
    KeyReader kr2 = new KeyReader(conn2,theDb2,theTable2,theField2,"",keyStep,mode2);
    %><%= "\r\n" + theField + (coordString.equals(coordString2)?"":(" (" + coordString + ")")) + " vs " + theField2 + (coordString.equals(coordString2)?"":(" (" + coordString2 + ")")) + "\r\n\r\n" %><%
    for(;;) {
     if(key==null)key=kr.getKey();
     if(key2==null)key2=kr2.getKey();
     if(key==null&&key2==null)break;
     
     if(key==null){
       do {writeMinus(out,key2);} 
       while((key2=kr2.getKey())!=null);
       break;
     }                                     
     if(key2==null){
       do {writePlus(out,key);}
       while((key=kr.getKey())!=null);
       break;
     }
     if (key.toString().equals(key2.toString())) {
      key=kr.getKey();
      key2=kr2.getKey();
      continue;
     }
     int compare = key.toString().compareTo(key2.toString());
     if (compare==0) {
      key=kr.getKey();
      key2=kr2.getKey();
      continue;
     }
     if (compare<0) {
        writePlus(out,key);
        key=kr.getKey();
        continue;
     }
     if (compare>0) {
        writeMinus(out,key2);
        key2=kr2.getKey();
        continue;
     }
    }
   }
   else {%>Cannot connect!<%;}
  }
  else {%>Cannot connect!<%;}
 }
 else {
  %>
  <html>
  <head>
  <%@ include file = "head.jsp" %>
  </head>
  <body> 
  <table class="pageframe" style="width:100%;height:100%" cellpadding="8" cellspacing="10">
  <tbody>
  <tr class="pageframe" height="2%">
   <td class="pageframe" height="2%"><%@ include file = "top.jsp" %></td>
  </tr>   
  <tr class="pageframe" height="100%">
  <td class="pageframe" valign="top">
  <form name="theForm" method="post" action="<%= rq.hwScript %>">
   <table>
   <%@ include file = "console/connData.jsp" %>  
   <tbody>

   <tr>
   <td colspan="3"><input type="text" style="width:100%" name="query" value="<%= theQuery %>"></td>
   <td>query</td>
   </tr>
   <tr>
    <td><input type="text" name="field" value="<%= theField.length()>0?theField:"" %>"></td>
    <td>field</td>
    <td><input type="text" name="tablename" value="<%= theTable.length()>0?theTable:"tabella" %>"></td>
    <td>table</td>
   </tr>
   <tr><td colspan="4">&#160;</td></tr>
   
   <tr> <!-- parametri connessione (facoltativi) -->
    <td><input type="text" id="host2" name="host2"  value="<%= theHost2.length()>0?theHost2:"" %>"></td>
    <td class="inputLabel"><label for="host2">host</label></td>
    <td><input type="text" id="user2" name="user2"  value="<%= theUser2.length()>0?theUser2:"" %>"></td>
    <td><label for="user">username</label></td>
   </tr>
   <tr>
    <td><input type="text" id="port2" name="port2"  value="<%= thePort2 %>"></td>
    <td class="inputLabel"><label for="port">port</label></td>
    <td><input type="password" id="pwd2" name="pwd2"  value="<%= thePassword2 %>"></td>
    <td class="inputLabel"><label for="pwd2">password</label></td>
   </tr>
   <tr>
    <td><input type="text" id="db2" name="db2" value="<%= theDb2 %>"></td>
    <td class="inputLabel"><label for="db2">db (logical)</label></td>
    <td></td>
    <td></td>
   </tr>

   <tr><td colspan="4"></td></tr>
   
   <tr>
   <td colspan="3"><input type="text" style="width:100%" name="query2" value="<%= theQuery2 %>"></td>
   <td>query</td>
   </tr>
   <tr>
   <td><input type="text" name="field2" value="<%= theField2.length()>0?theField2:"" %>"></td>
   <td>field</td>
   <td><input type="text" name="tablename2" value="<%= theTable2.length()>0?theTable2:"tabella" %>"></td>
   <td>table</td>
   </tr>
   
   <tr><td colspan="4">&#160;</td></tr>
   <tr>
    <td><input class="typeButton" type="submit" value="submit"></td>
    <td colspan="3">&#160;</td>    
   </tr>
   </tbody>
   </table>    
  </form>
  </td>
  </tr> 
  </tbody>  
  </table>
  </body> 
  </html> 
  <%
 }
}catch(Throwable t) {
 t.printStackTrace();
 %><%= "<br>Sorry, an exception occurred: <br><b>"+t.toString()+"</b><br>" %><%
}finally {
 if(broker!=null) {
  try {
   if(conn>=0)broker.releaseConnection(conn);
  }
  finally {
   if(conn2>=0)broker.releaseConnection(conn2);
  }
 }
 if(rq!=null)rq.close(); 
}

%>

