<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<%@ page import = "java.sql.*" %>
<%@ page import = "java.util.*" %>

<html>
<head>
<title>keycount</title>
<link rel="stylesheet" href="jsp.css" type="text/css"/>
</head>
<body> 
<h2>keycount</h2>

<%
it.highwaytech.broker.Broker broker = null;
int conn=-1;
it.highwaytech.apps.JRequest rq = null;

try {

 rq = new it.highwaytech.apps.JRequest(request);
 String theDb       = rq.keyVal("db");
 String theHost     = rq.keyVal("host");
 String thePort     = rq.keyVal("port");
 String theUser     = rq.keyVal("user");
 String thePassword = rq.keyVal("pwd");
 String theField    = rq.keyVal("field");
 String theTable    = rq.keyVal("tablename");

 if (rq.numTuples>0 &&
     theDb!=null && theDb.length()>0 &&
     theField!=null && theField.length()>0) {
  broker = new it.highwaytech.broker.Broker();
  int iPort = (thePort!=null && thePort.length()>0)?Integer.parseInt(thePort):-1;
  conn = broker.acquireConnection(theHost,iPort,theDb,"","",-1);
  if (conn>=0 && broker.Connect(conn,theHost,iPort,theDb,-1,theUser,thePassword)) {
   int keyCounter = 0;
   int keyStep = 100;
   java.util.Vector result = null;
   String theStart = "";
   for(;;){
    result = broker.getIdxKeys(conn,theDb,theTable,theField,theStart,"",keyStep,
                               it.highwaytech.broker.ServerCommand.btree_NEXTKEY,0);
    if(result==null)
     break;
    keyCounter=keyCounter!=0?keyCounter+result.size()-1:result.size();
    if(result.size()<keyStep)
     break;
    theStart=((it.highwaytech.db.DbKey)result.get(result.size()-1)).toString();
   }
   %><%= "<br><b>"+theField+" has <big>"+keyCounter+"</big> keys.</b>" %><%
   System.err.println(theField+" has "+keyCounter+" keys.");
  }
  else {%><b>Cannot connect!<b><%;}
 }
 else {
  %>
   <form method="post" action="<%= rq.hwScript %>">
        <input type="text" name="host"  value="<%= theHost!=null&&theHost.length()>0?theHost:"" %>">   host
    <br><input type="text" name="port"  value="<%= thePort!=null&&thePort.length()>0?thePort:"" %>">            port
    <br><input type="text" name="user"  value="<%= theUser!=null&&theUser.length()>0?theUser:"" %>">     username
    <br><input type="password" name="pwd"  value="<%= thePassword!=null&&thePassword.length()>0?thePassword:"" %>"> password
    <br><input type="text" name="db"    value="<%= theDb!=null&&theDb.length()>0?theDb:"" %>">                  db
    <br><input type="text" name="tablename" value="<%= theTable!=null&&theTable.length()>0?theTable:"tabella" %>"> table
    <br><input type="text" name="field" value="<%= theField!=null&&theField.length()>0?theField:"" %>"> field
    <br><br><input type="submit" value="submit">
   </form>
  <%
 }
}catch(Throwable t) {
 t.printStackTrace();
 %><%= "<br>Sorry, an exception occurred: <br><b>"+t.toString()+"</b><br>" %><%
}finally {
 if(broker!=null&&conn>=0)broker.releaseConnection(conn);
 if(rq!=null)rq.close(); 
 %> 
 </font> 
 </body> 
 </html> 
 <%
}

%>

