<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<%@ page import = "java.sql.*" %>
<%@ page import = "java.util.*" %>

<html>
<head>
<link rel="stylesheet" href="jsp.css" type="text/css"/>
<title>key number</title>
</head>
<body> 
<%
it.highwaytech.broker.Broker broker = null;
int conn=-1;
it.highwaytech.apps.JRequest rq = null;

try {

 rq = new it.highwaytech.apps.JRequest(request);
 String theDb    = rq.keyVal("db");
 String theHost  = rq.keyVal("host");
 String thePort  = rq.keyVal("port");
 String theUser  = rq.keyVal("user");
 String theField = rq.keyVal("field");
 String theTable = rq.keyVal("tablename");
 String thePassword = rq.keyVal("pwd");

 if (rq.numTuples>0 &&
     theDb!=null && theDb.length()>0) {
  %><h2><a href="<%= rq.hwScript %>">key number</a> <small>(<%= theDb %> su <%= theHost %>)</small></h2><%
  broker = new it.highwaytech.broker.Broker();
  int iPort = (thePort!=null && thePort.length()>0)?Integer.parseInt(thePort):-1;
  conn = broker.acquireConnection(theHost,iPort,theDb,"","",-1);
  if (conn>=0 && broker.Connect(conn,theHost,iPort,theDb,-1,theUser,thePassword)) {
   String keyName;
   final String startKey = "<pathelem value=\"";
   int keyNumber, start=0, stop=0;
   it.highwaytech.util.RawData XMLKeys = new it.highwaytech.util.RawData((broker.getServerConnection(conn)).getXMLKeys(theDb));
   stop=XMLKeys.indexOf("<field name=\""+theField.toUpperCase()+"\">",stop);
   %><%= "<pre>" %><%;
   for(;;){
    start = XMLKeys.indexOf(startKey,stop);
    if(start<0)break;
    start += startKey.length();
    stop = XMLKeys.indexOf('"',start);
    if(stop<0)break;
    keyName = new String(XMLKeys.data,start,stop-start);
    //start = stop; 
    if(XMLKeys.indexOf("\" id=\""+theField.toUpperCase()+"_",start)<0)break;

    try{keyNumber=broker.getDb(conn,theDb).keyString2IdxNumber(broker.getServerConnection(conn),theTable,theField+","+keyName);}
    catch(Throwable t){t.printStackTrace(); %><%= "got exception on key '"+keyName+"' ("+it.highwaytech.util.Text.tohtml(t.toString())+")\n"%><%;continue;}

    %><%= ""+
          it.highwaytech.util.Text.byte2XDigit((byte)(((keyNumber&0x000000f0)>> 4)&0x0f))+it.highwaytech.util.Text.byte2XDigit((byte)(((keyNumber&0x0000000f)>> 0)&0x0f))+" "+
          it.highwaytech.util.Text.byte2XDigit((byte)(((keyNumber&0x0000f000)>>12)&0x0f))+it.highwaytech.util.Text.byte2XDigit((byte)(((keyNumber&0x00000f00)>> 8)&0x0f))+" "+
          it.highwaytech.util.Text.byte2XDigit((byte)(((keyNumber&0xf0000000)>>28)&0x0f))+it.highwaytech.util.Text.byte2XDigit((byte)(((keyNumber&0x0f000000)>>24)&0x0f))+" "+
          it.highwaytech.util.Text.byte2XDigit((byte)(((keyNumber&0x00f00000)>>20)&0x0f))+it.highwaytech.util.Text.byte2XDigit((byte)(((keyNumber&0x000f0000)>>16)&0x0f))+" "+
          it.highwaytech.util.Text.tohtml(keyName) + "\n" %><%;
    /*
    %><%= "0"+
          java.lang.Integer.toHexString(((keyNumber&0x000000ff)>> 0)&0xff)+" "+
          java.lang.Integer.toHexString(((keyNumber&0x0000ff00)>> 8)&0xff)+" "+
          java.lang.Integer.toHexString(((keyNumber&0xff000000)>>24)&0xff)+" "+
          java.lang.Integer.toHexString(((keyNumber&0x00ff0000)>>16)&0xff)+" "+
          it.highwaytech.util.Text.tohtml(keyName) + "\n" %><%;
    */
   }
   %><%= "<hr>"+it.highwaytech.util.Text.tohtml(XMLKeys.readString()) %><%;
  }
  else {%><b>Cannot connect!<b><%;}
 }
 else {
  %><h2><a href="<%= rq.hwScript %>">key number</a></h2>
   <form method="post" action="<%= rq.hwScript %>">
        <input type="text" name="host"  value="<%= theHost!=null&&theHost.length()>0?theHost:"" %>">   host
    <br><input type="text" name="port"  value="<%= thePort!=null&&thePort.length()>0?thePort:"" %>">            port
    <br><input type="text" name="user"  value="<%= theUser!=null&&theUser.length()>0?theUser:"" %>">     username
    <br><input type="password" name="pwd"  value="<%= thePassword!=null&&thePassword.length()>0?thePassword:"" %>"> password
    <br><input type="text" name="db"    value="<%= theDb!=null&&theDb.length()>0?theDb:"" %>">                  db
    <br><input type="text" name="tablename" value="<%= theTable!=null&&theTable.length()>0?theTable:"tabella" %>"> table
    <br><input type="text" name="field" value="<%= theField!=null&&theField.length()>0?theField:"XML" %>"> field
    <br><br><input type="submit" value="submit">
   </form>
  <%
 }
}catch(Throwable t) {
 t.printStackTrace();
 %><%= "<br>Sorry, an exception occurred: <br><b>"+t.toString()+"</b><br>" %><%
}finally {
 if(broker!=null&&conn>=0)broker.releaseConnection(conn);
 if(rq!=null)rq.close(); 
 %> 
 </font> 
 </body> 
 </html> 
 <%
}

%>

