<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<%@ page import = "java.sql.*" %>
<%@ page import = "java.util.*" %>
<%@ include file = "resource.jsp" %>
<% 
 final String pageTitle = "cancellazione documento";
%>
<html>
<head>
 <%@ include file = "head.jsp" %>
<body> 
  <table class="pageframe" style="width:100%;height:100%" cellpadding="8" cellspacing="10">
  <tbody>
  <tr class="pageframe" height="2%">
   <td class="pageframe" height="2%"><%@ include file = "top.jsp" %></td>
  </tr>   
  <tr class="pageframe" height="100%">
  <td class="pageframe" valign="top">
<%
it.highwaytech.broker.Broker broker = null;
int conn=-1;
it.highwaytech.apps.JRequest rq = null;

try 
{
 rq = new it.highwaytech.apps.JRequest(request);
 String theDb    = rq.keyVal("db");
 String theHost  = rq.keyVal("host");
 String thePort  = rq.keyVal("port");
 String theUser  = rq.keyVal("user");
 String thePassword = rq.keyVal("pwd");
 String theQuery = rq.keyVal("query");
 String theDoc   = rq.keyVal("idDoc");
 String theSkin  = rq.readStringParameter("skin","jsp");
 String theNotUnique= rq.readStringParameter("notUnique","");
 boolean notUnique = theNotUnique.equals("1");

 if (rq.numTuples>0 &&
     theDb!=null && theDb.length()>0 &&
     ((theDoc!=null && theDoc.length()>0)||(theQuery!=null && theQuery.length()>0))
     ) {
  broker = new it.highwaytech.broker.Broker();
  int iPort = (thePort!=null && thePort.length()>0)?Integer.parseInt(thePort):-1;
  conn = broker.acquireConnection(theHost,iPort,theDb,"","",-1);
  if (conn>=0 && broker.Connect(conn,theHost,iPort,theDb,-1,theUser,thePassword)) 
  {int erased=0;
   if(theQuery!=null && theQuery.length()>0)
   { 
    it.highwaytech.db.QueryResult qr=broker.find(conn,theDb,theQuery,"",0,-1,0);
    if(qr.elements==1||notUnique)
    {for(int index=0;index<qr.elements;index++) {
      int docNumber=broker.getNumDoc(conn,theDb,qr,index);
      try {broker.removeDoc(conn,theDb,docNumber);}
      catch(SQLException e)
      {if (e.getMessage().indexOf("ocumento cancellato")>0) erased++;
       else throw e;
      }
     }     
     %><b>Done!<b><%;
     if (erased!=0) %><%= " (" + (qr.elements-erased) + "/" + qr.elements + ")" %><%;
    }
    else
    {
     %><b><%= qr.elements %> found<b><%;
    }
   }
   else 
   if (theDoc!=null && theDoc.length()>0)
   { broker.removeDoc(conn,theDb,Integer.parseInt(theDoc));
     %><b>Done!<b><%;
   }
   else
   {
     %><b>???<b><%;
   }   
  }
  else 
  {
   %><b>Cannot connect!<b><%;
  }
 }
 else 
 {
  %>
   <form name="theForm" method="post" action="<%= rq.hwScript %>">
   <table>
   <%@ include file = "console/connData.jsp" %>  
   <tbody>
   <tr>
    <td><input type="text" name="idDoc" value="<%= theDoc!=null&&theDoc.length()>0?theDoc:"" %>"></td>
    <td>doc#</td>
    <td><input type="text" name="query" value="<%= theQuery!=null&&theQuery.length()>0?theQuery:"" %>"></td>
    <td>query</td>
   </tr>
   <tr>
    <td colspan="2"></td>
    <td colspan="2"><input style="width:16px" type="checkbox" name="notUnique" value="1" <%= notUnique?"checked":"" %> >not unique</td>
   </tr>
   <tr><td colspan="4"></td></tr>
   <tr>
    <td><input class="typeButton" type="submit" value="submit"></td>
    <td colspan="3"></td>
   </tr> 
   </tbody>
   </table>     
   </form>
  <%
 }
}
catch(Throwable t) 
{
 t.printStackTrace();
 %><%= "<br>Sorry, an exception occurred: <br><b>"+t.toString()+"</b><br>" %><%
}
finally 
{
 if(broker!=null&&conn>=0)broker.releaseConnection(conn);
 if(rq!=null)rq.close(); 
 %> 
  </td>
  </tr> 
  </tbody>  
  </table>
 </body> 
 </html> 
 <%
}

%>

