<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<%@ page import = "java.sql.*" %>
<%@ page import = "java.util.*" %>
<%@ page import = "it.highwaytech.apps.generic.*" %>
<%@ include file = "resource.jsp" %>
<%
final String pageTitle = "export thesaurus";

it.highwaytech.broker.Broker broker = null;
it.highwaytech.apps.JRequest rq = null;

int    conn       = -1;
String theDb      = "";
String theHost    = "";
String thePort    = "";
String theUser    = "";
String thePassword    = "";
String theTable   = "tabella";
String theField = "";

String errMess    = "";
//String txtResu    = "";
String theSkin    = "";
int    numPort    = -1;
int    execExp    = 0;

try
{
   rq = new it.highwaytech.apps.JRequest(request);
   execExp = rq.readIntParameter("esegui", 0);
   theSkin  = rq.readStringParameter("skin","jsp");
   
   if (execExp == 1)
   {
      theDb    = rq.keyVal("db");
      theHost  = rq.keyVal("host");
      thePort  = rq.keyVal("port");
      theUser  = rq.keyVal("user");
      thePassword  = rq.keyVal("pwd");
      theTable = rq.keyVal("tablename");
      theField = rq.keyVal("fields");
      
      if ((theDb    == null) || (theDb.length()    == 0)) theDb   = "";
      if ((theHost  == null) || (theHost.length()  == 0)) theHost = "localhost";
      if ((thePort  == null) || (thePort.length()  == 0)) thePort = "";
      if ((theUser  == null) || (theUser.length()  == 0)) theUser = "";
      if ((thePassword  == null) || (thePassword.length()  == 0)) thePassword = "";
      if ((theTable == null) || (theTable.length() == 0)) theTable = "tabella";
      if ((theField == null) || (theField.length() == 0)) theField = "";

      broker = new it.highwaytech.broker.Broker();
      if (thePort != "") numPort = Integer.parseInt(thePort);
      conn = broker.acquireConnection(theHost, numPort, theDb, "", "", -1);
      if ((conn >= 0) && (broker.Connect(conn, theHost, numPort, theDb, -1, theUser, thePassword)))
      {/*
         THTools TH = new THTools(broker, conn, theDb, theField);
         txtResu = TH.esporta();
         response.setContentType("text/plain");
         response.setHeader("Content-Disposition", "attachment;filename=thesaurus.txt");
         ServletOutputStream os = response.getOutputStream();
         os.write(txtResu.getBytes());
         os.flush();
         os.close();
         */
         THTools TH = new THTools(broker, conn, theDb, theField);
         response.setContentType("text/plain");
         response.setHeader("Content-Disposition", "attachment;filename=thesaurus.txt");
         ServletOutputStream os = response.getOutputStream();
         TH.esporta(os);
         os.flush();
         os.close();
      }
   }
   else
   {
     %>
      <html>
      <head>
       <%@ include file = "head.jsp" %>
      </head>
      <body>
        <table class="pageframe" style="width:100%;height:100%" cellpadding="8" cellspacing="10">
        <tbody>
        <tr class="pageframe" height="2%">
         <td class="pageframe" height="2%"><%@ include file = "top.jsp" %></td>
        </tr>   
        <tr class="pageframe" height="100%">
        <td class="pageframe" valign="top">
         <form name="theForm" method="post" action="th_exp.jsp" enctype="multipart/form-data">
            <input type="hidden" id="esegui" name="esegui" value="1">
            <table>
            <%@ include file = "console/connData.jsp" %>  
            <tbody>
            <tr>
             <td><input type="text" id="tablename" name="tablename" value="<%=theTable%>"></td>
             <td><label for="tablename">Nome tabella</label></td>
             <td><input type="text" id="fields" name="fields" value="<%=theField%>"></td>
             <td><label for="fields">Elenco campi</label> (separati da virgola e senza spazi)</td>
            </tr>
            <tr>
             <td colspan="4"></td>
            </tr>
            <tr>
             <td><input class="typeButton" type="submit" value="esegui"></td>
             <td colspan="3"></td>    
            </tr>
            </tbody>
            </table>
         </form>
         <hr />
         <%= errMess %>
        </td>
        </tr> 
        </tbody>  
        </table>
      
      </body> 
      
      </html> 
     <%
   
   }
}
catch(Throwable t)
{
   t.printStackTrace();
   errMess = "<p>Sorry, an exception occurred: <br/><b>" + t.toString() + "</b></p>";
}
finally
{
   if(broker != null && conn >= 0) broker.releaseConnection(conn);
   if(rq!=null) rq.close(); 
}

%>