<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<%@ page import = "java.sql.*" %>
<%@ page import = "java.util.*" %>
<%@ page import = "it.highwaytech.apps.generic.*" %>
<%

it.highwaytech.broker.Broker           theBroker = null;
it.highwaytech.apps.JRequest           theRQ = null;
it.highwaytech.broker.ServerObserver   theObserver = null;

int    theObsID   = -1;
int    theConn    = -1;
String theDB      = "";
String theHost    = "";
String thePort    = "";
String theUser    = "";
String thePass    = "";
String theTable   = "tabella";
byte[] theFile    = null;
String txtMess    = "";
int    numPort    = -1;

theRQ    = new it.highwaytech.apps.JRequest(request);
theDB    = theRQ.keyVal("db");
theHost  = theRQ.keyVal("host");
thePort  = theRQ.keyVal("port");
theUser  = theRQ.keyVal("user");
thePass  = theRQ.keyVal("pwd");
theTable = theRQ.keyVal("tablename");
theFile  = theRQ.keyFile("thesauro.file");

if ((theDB    == null) || (theDB.length()    == 0)) theDB   = "";
if ((theHost  == null) || (theHost.length()  == 0)) theHost = "localhost";
if ((thePort  == null) || (thePort.length()  == 0)) thePort = "";
if ((theUser  == null) || (theUser.length()  == 0)) theUser = "";
if ((thePass  == null) || (thePass.length()  == 0)) thePass = "";
if ((theTable == null) || (theTable.length() == 0)) theTable = "tabella";

if(theFile == null || theDB == null || theDB.equals(""))
{
%>
<jsp:forward page="th_imp.jsp" />
<%
}
else
{
   synchronized(theBroker.observers)
   {
      try
      {
         theBroker = new it.highwaytech.broker.Broker();
         if (thePort != "") numPort = Integer.parseInt(thePort);
         theConn = theBroker.acquireConnection(theHost, numPort, theDB, theUser, thePass, -1);
         if ((theConn >= 0) && (theBroker.Connect(theConn, theHost, numPort, theDB, -1, theUser, thePass)))
         {
            theObserver = new it.highwaytech.broker.ServerObserver(new java.util.Date(), "Import Thesaurus");
            theObsID = theBroker.storeObserver(theObserver);
            THTools TH = new THTools(theBroker, theConn, theDB, theFile, theObserver, theObsID);
            TH.start();
            %>
            <jsp:forward page="watch.jsp" />
            <% 
         }
      }
      catch(Exception e)
      {
         if (theObsID !=-1) theBroker.removeObserver(theObsID);
         if ((theBroker != null) && (theConn >= 0))  theBroker.releaseConnection(theConn);
         if (theRQ != null) theRQ.close(); 
         %><%= "<br>Sorry, an exception occurred: <br><b>" + e.toString() + "</b><br>" %><%
      }
   }
}
%>

