<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<%@ page import = "java.sql.*" %>
<%@ page import = "java.util.*" %>
<%@ include file = "resource.jsp" %>
<% 
 final String pageTitle = "thesaurus";
%>
<html>
<head>
 <%@ include file = "head.jsp" %>
</head>
<body> 
 <table class="pageframe" style="width:100%;height:100%" cellpadding="8" cellspacing="10">
 <tbody style="width:100%;height:92%">
 <tr class="pageframe" height="2%">
  <td class="pageframe" height="2%"><%@ include file = "top.jsp" %></td>
 </tr>   
 <tr class="pageframe" style="width:100%;height:90%">
 <td class="pageframe" valign="top" style="width:100%;height:90%">
<%
it.highwaytech.broker.Broker broker = null;
int conn=-1;
it.highwaytech.apps.JRequest rq = null;

try {

 rq = new it.highwaytech.apps.JRequest(request);
 String theDb    = rq.keyVal("db");
 String theHost  = rq.keyVal("host");
 String thePort  = rq.keyVal("port");
 String theUser  = rq.keyVal("user");
 String thePassword = rq.keyVal("pwd");
 String theField = rq.keyVal("field");
 String theTable = rq.keyVal("tablename");
 String theStart = rq.keyVal("start");
 String theVrels = rq.keyVal("vrels");
 String theXrels = rq.keyVal("xrels");
 String theCommon= rq.keyVal("common");
 String editMode = rq.keyVal("editMode");
 String theBound = rq.keyVal("bound");
 int theLastrel  = rq.readIntParameter("lastrel",0);
 boolean keyLower= rq.readIntParameter("keylower",0)!=0?true:false;;
 boolean isEdit  = rq.keyVal("edit").length()>0 && Integer.parseInt(rq.keyVal("edit"))==1?true:false;
 boolean isStart = rq.keyVal("isStart").length()>0 && Integer.parseInt(rq.keyVal("isStart"))==1?true:false;
 String theSkin  = rq.readStringParameter("skin","jsp");

 if (!isStart && rq.numTuples>0 &&
     theDb!=null && theDb.length()>0 &&
     theField!=null && theField.length()>0) {
  broker = new it.highwaytech.broker.Broker();
  int iPort = (thePort!=null && thePort.length()>0)?Integer.parseInt(thePort):-1;
  conn = broker.acquireConnection(theHost,iPort,theDb,"","",-1);
  if (conn>=0 && broker.Connect(conn,theHost,iPort,theDb,-1,theUser,thePassword)) {

   if(editMode.compareTo("insert")==0)
    broker.insertThsKey(conn,theDb,new it.highwaytech.db.ThsKey
                                             (broker.keyString2ThsNumber
                                               (conn,theDb,theTable,theField),
                                              rq.keyVal("et1").getBytes(it.highwaytech.util.RawData.defaultEncoding),
                                              rq.readIntParameter("erl",0),
                                              rq.readIntParameter("edomain",0xff),
                                              rq.keyVal("et2").getBytes(it.highwaytech.util.RawData.defaultEncoding)),null);
   else
   if(editMode.compareTo("delete")==0)
    broker.deleteThsKey(conn,theDb,new it.highwaytech.db.ThsKey
                                             (broker.keyString2ThsNumber
                                               (conn,theDb,theTable,theField),
                                              rq.keyVal("et1").getBytes(it.highwaytech.util.RawData.defaultEncoding),
                                              rq.readIntParameter("erl",0),
                                              rq.readIntParameter("edomain",0xff),
                                              rq.keyVal("et2").getBytes(it.highwaytech.util.RawData.defaultEncoding)),null);

   int domain = rq.readIntParameter("domain",0xff);
   //it.highwaytech.db.ThsKey theKey;
   it.highwaytech.db.KeyPath keyPath;
   int thsMode = 0; //it.highwaytech.broker.ServerCommand.btree_FREQUENZE;
   //java.util.Vector result = null;
   it.highwaytech.db.KeyPathList result = null;
   int keyCount = rq.readIntParameter("keyCount",isEdit?16:20);

   boolean upEnabled=false, downEnabled=false;

   result = broker.getKeysEx(conn,
                             theDb,
                             theTable,
                             theField,
                             (byte)domain,
                             keyCount,
                             (keyLower?it.highwaytech.broker.ServerCommand.btree_PREVKEY :
                                       it.highwaytech.broker.ServerCommand.btree_NEXTKEY)
                             |it.highwaytech.broker.ServerCommand.btree_ONSTARTBROKENNOBREAK,
                             theVrels,
                             theXrels,
                             theCommon,
                             theStart,
                             (byte)theLastrel,
                             theBound
                             );

   if(result!=null){

    upEnabled = (broker.getKeysEx(conn,
                                  theDb,
                                  theTable,
                                  theField,
                                  (byte)domain,
                                  1,
                                  it.highwaytech.broker.ServerCommand.btree_PREVKEY
                                  |it.highwaytech.broker.ServerCommand.btree_ONSTARTBROKENNOBREAK,
                                  theVrels,
                                  theXrels,
                                  theCommon,
                                  result.keyPath(0).toString(),
                                  (byte)0,//theLastrel,
                                  theBound
                                  )!=null);

    downEnabled = (result.length()==keyCount &&
                   broker.getKeysEx(conn,
                                    theDb,
                                    theTable,
                                    theField,
                                    (byte)domain,
                                    1,
                                    it.highwaytech.broker.ServerCommand.btree_NEXTKEY
                                    |it.highwaytech.broker.ServerCommand.btree_ONSTARTBROKENNOBREAK,
                                    theVrels,
                                    theXrels,
                                    theCommon,
                                    result.keyPath(result.length()-1).toString(),
                                    (byte)0,//theLastrel,
                                    theBound
                                    )!=null);
   }
   %><form method="post" name="theForm"><%
   %> <input type="hidden" name="skin" value="<%= theSkin %>"><%
   %><table><tr><td nowrap><i><% ////// barra dei link
   %><%= "<a href=\"javascript:void(0);\" onclick=\"document.theForm.isStart.value='1';document.theForm.submit();return false;\">Fonte</a> | " %><%
   if (result!=null&&upEnabled)  {keyPath=result.keyPath(0);                %><%= "<a href=\"javascript:void(0);\" onclick=\"document.theForm.start.value=unescape('"+it.highwaytech.util.Text.qString(keyPath.toString())+"');document.theForm.keylower.value='1';document.theForm.submit();return false;\">Previous Page</a> | " %><%;} else {%><%= "Previous Page | " %><%;}
   if (result!=null&&downEnabled){keyPath=result.keyPath(result.length()-1);%><%= "<a href=\"javascript:void(0);\" onclick=\"document.theForm.start.value=unescape('"+it.highwaytech.util.Text.qString(keyPath.toString())+"');document.theForm.keylower.value='' ;document.theForm.submit();return false;\">Next Page</a> | " %><%;} else {%><%= "Next Page | " %><%;}

   %><%= "<a href=\"javascript:void(0);\" onclick=\"if(document.theForm.seektext.value=='')return false;document.theForm.start.value=document.theForm.seektext.value;document.theForm.keylower.value='';document.theForm.submit();return false;\">Posiziona</a>" %><%
   %> </i></td><td nowrap><input type="text" name="seektext"> <%
   %> </td></tr></table><hr> <% 
   %> <input type="hidden" name="host"      value="<%= theHost %>"><%
   %> <input type="hidden" name="port"      value="<%= thePort %>"><%
   %> <input type="hidden" name="user"      value="<%= theUser %>"><%
   %> <input type="hidden" name="pwd"       value="<%= thePassword %>"><%
   %> <input type="hidden" name="db"        value="<%= theDb   %>"><%
   %> <input type="hidden" name="tablename" value="<%= theTable %>"><%
   %> <input type="hidden" name="field"     value="<%= theField %>"><%
   %> <input type="hidden" name="keylower"  value=""><%
   %> <input type="hidden" name="vrels"     value="<%= (theVrels.length()>0?theVrels:"1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16") %>"><%
   %> <input type="hidden" name="xrels"     value="<%= theXrels %>"><%
   %> <input type="hidden" name="common"    value="<%= theCommon %>"><%
   %> <input type="hidden" name="lastrel"   value="<%= theLastrel %>"><%
   %> <input type="hidden" name="start"     value=""><%
   %> <input type="hidden" name="isStart"   value=""><%
   %> <input type="hidden" name="edit"      value="<%= ""+(isEdit?1:0) %>"><%
   %> </form> <%
   %> 
   <div style="width:100%;height:90%;overflow:auto;">
   <%
   if(result!=null){
    %>
    <table width="90%">
    <%
    boolean writeEnable;
    for(int index=0; index<result.length(); index++){
     it.highwaytech.db.KeyPath elem=result.keyPath(index);
     it.highwaytech.db.KeyPath prev=index>0?result.keyPath(index-1):null;
     writeEnable = false;
     for(int j=0;j<elem.length();j++){
      writeEnable = writeEnable || 
                    index==0 || 
                    prev.length()<j+1 || 
                    (j!=0 && elem.getRel(j-1)!=prev.getRel(j-1)) ||
                    elem.getTerm(j).compareTo(prev.getTerm(j))!=0;
      if(writeEnable) {
       %><%= "<tr><td>" %><%
       for(int k=0;k<j;k++){
        %><%= "&nbsp;&nbsp;&nbsp;" %><%
       }
       if(j!=0){
        %><%= "<small><i>"+elem.getRel(j-1)+"</i></small>&nbsp;&nbsp;" %><%
       }
       %><%= ""+elem.getTerm(j) %><%
       %><%= "</td></tr>" %><%
      }
     }
    }
    %></table><%
   }

   /*
   if(result!=null){
    %><table width="90%"><%
    for(int index=0; index<result.size(); index++){
     theKey = (it.highwaytech.db.ThsKey)result.get(index);
     if(index==0||(((it.highwaytech.db.ThsKey)(result.get(index-1))).getParent().compareTo(theKey.getParent())!=0)){
      %><%= "<tr><td width=100% colspan=2><b>" + theKey.getParent() + "</b></td></tr>" %><%
     }
     %><%= "<tr><td width=5% align=right><small><i>" + ((index==0||(((it.highwaytech.db.ThsKey)(result.get(index-1))).getParent().compareTo(theKey.getParent())!=0)||(((it.highwaytech.db.ThsKey)(result.get(index-1))).getRel()!=theKey.getRel()))?(""+theKey.getRel()):"") + "</small></i>&nbsp;&nbsp;</td><td width=95% >" + theKey.getChild() + "</td></tr>" %><%
    }
    %>
    </table>
    <%
   }
   */

   if (isEdit){
    %><form method="post" name="edit"><%
    %> <input type="hidden" name="skin" value="<%= theSkin %>"><%
    %><hr><table><tr><td nowrap><% ////// barra di edit
    %> <input type="text" name="erl" size="2"></td><td nowrap>&nbsp;<i> <% 
    %> <input type="text" name="et1"></td><td nowrap>&nbsp;<i> <% 
    %> <input type="text" name="et2"></td><td nowrap>&nbsp;<i> <% 
    %><%= "<a href=\"javascript:void(0);\" onclick=\"if((document.edit.et1.value!=''||document.edit.et2.value!='')&&document.edit.erl.value!=''){document.edit.editMode.value='insert';document.edit.submit();}return false;\">Inserisci</a> | " %><%
    %><%= "<a href=\"javascript:void(0);\" onclick=\"if((document.edit.et1.value!=''||document.edit.et2.value!='')&&document.edit.erl.value!=''){document.edit.editMode.value='delete';document.edit.submit();}return false;\">Elimina</a> " %><%
    %> </i></td></tr></table><hr> <% 
    %> <input type="hidden" name="host"      value="<%= theHost %>"><%
    %> <input type="hidden" name="port"      value="<%= thePort %>"><%
    %> <input type="hidden" name="user"      value="<%= theUser %>"><%
    %> <input type="hidden" name="pwd"       value="<%= thePassword %>"><%
    %> <input type="hidden" name="db"        value="<%= theDb   %>"><%
    %> <input type="hidden" name="tablename" value="<%= theTable %>"><%
    %> <input type="hidden" name="field"     value="<%= theField %>"><%
    %> <input type="hidden" name="keylower"  value=""><%
    %> <input type="hidden" name="editMode"  value=""><%
    %> <input type="hidden" name="vrels"     value="<%= theVrels %>"><%
    %> <input type="hidden" name="xrels"     value="<%= theXrels %>"><%
    %> <input type="hidden" name="common"    value="<%= theCommon %>"><%
    %> <input type="hidden" name="lastrel"   value="<%= theLastrel %>"><%
    %> <input type="hidden" name="start"     value="<%= theStart %>"><%
    %> <input type="hidden" name="edit"      value="<%= ""+(isEdit?1:0) %>"><%
    %> </form> <%
   }
   %> 
   </div> 
   <%
  }
  else {%><b>Cannot connect!<b><%;}
 }
 else {
  %>
    <form name="theForm" method="post" action="<%= rq.hwScript %>">
    <table>
     <%@ include file = "console/connData.jsp" %>  
     <tbody>
     <tr>
     <td><input type="text"     name="tablename" value="<%= theTable.length()>0?theTable:"tabella" %>"></td>
     <td>table</td>
     <td><input type="text"     name="field"     value="<%= theField.length()>0?theField:"generico" %>"></td>
     <td>field</td>
     </tr>
     <tr>
     <td><input type="text"     name="vrels"     value="<%= theVrels.length()>0?theVrels:"1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16" %>"></td>
     <td>relazioni visibili</td>
     <td><input type="text"     name="xrels"     value="<%= theXrels.length()>0?theXrels:"" %>"></td>
     <td>relazioni espanse</td>
     </tr>
     <tr>
     <td><input type="text"     name="common"    value="<%= theCommon.length()>0?theCommon:"" %>"></td>
     <td>percorso di relazione</td>
     <td><input type="text"     name="lastrel"   value="<%= theLastrel>0?""+theLastrel:"" %>"></td>
     <td>relazione terminale</td>
     </tr>
     <tr>
     <td><input type="text" name="start"     value="<%= theStart!=null&&theStart.length()>0?theStart:"" %>"></td>
     <td>posizionamento</td>
     <td><input class="typeButton" type="submit" value="submit"></td>
     <td></td>
    </tr>
    </tbody>
    </table>    
    <input type="hidden" name="edit" value="<%= ""+(isEdit?1:0) %>">
    </form>
  <%
 }
}catch(Throwable t) {
 t.printStackTrace();
 %><%= "<br>Sorry, an exception occurred: <br><b>"+t.toString()+"</b><br>" %><%
}finally {
 if(broker!=null&&conn>=0)broker.releaseConnection(conn);
 if(rq!=null)rq.close(); 

   /*
   Vector elements=new Vector(10);
   //elements.add(5,new Integer(5));
   for(int j=elements.size();j<5;j++)
    elements.add(null);
   elements.add(new Integer(5));
   %><%= "elements.get(4) = " +elements.get(4) %><%
   %><%= "elements.get(5) = " +elements.get(5) %><%
   */

 %> 
    </td>
   </tr> 
 </tbody>  
 </table>
 </body> 
 </html> 
 <%
}

%>

