<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<%

 /*** torna l'output di Broker.XMLKeys() come contenuto XML ***/
 
 it.highwaytech.broker.Broker broker = null;
 int conn=-1;
 it.highwaytech.apps.JRequest rq = null;
 try 
 {rq=new it.highwaytech.apps.JRequest(request);
  String theDb    = rq.keyVal("db");
  String theHost  = rq.readStringParameter("host","");//rq.keyVal("host");
  String thePort  = rq.keyVal("port");
  String theUser  = rq.readStringParameter("user","");
  String thePassword   = rq.keyVal("pwd");
  if(theDb.length()>0)
  {broker=new it.highwaytech.broker.Broker();
   int iPort=(thePort.length()>0)?Integer.parseInt(thePort):-1;
   conn=broker.acquireConnection(theHost,iPort,"","","",-1);
   if(conn>=0&&broker.Connect(conn,theHost,iPort,theDb,-1,theUser,thePassword))
   {rq.setContentType("text/xml; charset=windows-1252");
    %><%= new String(broker.XMLKeys(conn,theDb),"windows-1252") %><%
   }
   else 
   {%><%= "connect failed!" %><%
   }
  }
  else 
  {
   %>
    <html>
    <head>
    <title>xmlkeys</title>
    <link rel="stylesheet" href="jsp.css" type="text/css"/>
    </head>
    <body> 
     <h2>xmlkeys</h2>
     <form method="post" action="<%= rq.hwScript %>">
          <input type="text"     name="host"     value="<%= theHost.length()>0?theHost:"localhost" %>"> host
      <br><input type="text"     name="port"     value="<%= thePort %>">                                port
      <br><input type="text"     name="user"     value="<%= theUser.length()>0?theUser:"" %>">   username
      <br><input type="password" name="pwd"      value="<%= thePassword %>">                                 password
      <br><input type="text"     name="db"       value="<%= theDb %>">                                  db
      <br><br><input type="submit" value="submit">
     </form>
    </body> 
    </html> 
   <%
  }
 }
 catch(Throwable t) 
 {t.printStackTrace();
  %><%= "<html><body><br>Sorry, an exception occurred: <br><b>"+t.toString()+"</b><br></body></html>" %><%
 }
 finally 
 {if(broker!=null&&conn>=0)
   broker.releaseConnection(conn);
  if(rq!=null)rq.close(); 
 }
 
 //String xwResponse=broker.XMLCommand(conn,theDb,"<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?><c cmd="\5" bits="x1d\"/></cmd>");
 
%>
 
 
 
 
 
 