/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

// Data: 10/05/2000
// Scopo: Funzioni (con messaggi in italiano) di verifica dei FORM. Presuppone di aver gia' linkato funzioni.js.

// Verifica la validita' di un campo data
function ValidateDate(theinput) {
	var str;

	str = trim(theinput.value);
	if (str.length == 0) {
		theinput.value = str;
		return true;
	}
	switch (ChkDate(str)) {
	case 0:
		return true;
	case 1:
		alert('Inserire una data nel formato gg/mm/aaaa');
		theinput.focus();
		return false;
	case 2:
		alert('Inserire un giorno compreso tra 01 e 31');
		theinput.focus();
		return false;
	case 3:
		alert('Inserire un mese compreso tra 01 e 12');
		theinput.focus();
		return false;
	case 4:
		alert('Inserire un anno superiore a 0000');
		theinput.focus();
		return false;
	case 28:
		alert('Inserire un giorno compreso tra 01 e 28');
		theinput.focus();
		return false;
	case 29:
		alert('Inserire un giorno compreso tra 01 e 29');
		theinput.focus();
		return false;
	case 30:
		alert('Inserire un giorno compreso tra 01 e 30');
		theinput.focus();
		return false;
	case 31:
		alert('Inserire un giorno compreso tra 01 e 31');
		theinput.focus();
		return false;
	}
}

// Verifica la validita' di un campo ora
function ValidateTime(theinput) {
	var str;

	str = trim(theinput.value);
	if (str.length == 0) {
		theinput.value = str;
		return true;
	}
	switch (ChkTime(str)) {
	case 0:
		return true;
	case 1:
		alert('Inserire un\'ora nel formato hh:mm');
		theinput.focus();
		return false;
	case 2:
		alert('Inserire un\'ora compresa tra 00 e 23');
		theinput.focus();
		return false;
	case 3:
		alert('Inserire un minuto compreso tra 00 e 59');
		theinput.focus();
		return false;
	}
}

// Verifica la validita' di un campo numerico
function ValidateNumeric(theinput) {
	var str;

	str = trim(theinput.value);
	if (!IsNumber(str)) {
		alert('Inserire un valore numerico');
		theinput.focus();
		return false;
	}
	return true;
}

// Verifica la validita' di un campo obbligatorio
function ValidateMandatory(theinput) {
	var str;

	if (theinput.type == 'select-one' || theinput.type == 'select-multiple')
		str = theinput.options[theinput.selectedIndex].value
	else
		str = trim(theinput.value);
	if (!str.length) {
		alert('Campo obbligatorio vuoto');
		theinput.focus();
		return false;
	}
	return true;
}