/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/
//****************************** //
//docEdit.js                     //
//****************************** //

//nome della finestra statica (vuota) che viene aperta quando c' un popup in modo che venga mantenuto il protocollo
//corrente (http o https)
var staticEmptyWindow = "./../formatter/html/templates/static.html";
// il prefisso per il parsing dei riferimenti agli input nelle istanze
var parsedInstanceKey='_parsedInstance_';

function findSubstring(whichS,whereS){
    for (var i=0; i<whichS.length; i++) {
        if (whereS.substring(i,i+whichS.length) == whichS) {
            return true;
        }
    }
    return false;
}

//pezza assurda...io volevo tutti i name belli...comunque solo istanze a livello 0,1,2 con gestione come al solito

function getFatherDotName(element, prefisso) {
    // Allo stato attuale si gestisce solo la casistica semplice:
    // elementi inseriti in elementi ripetibili...funzione usata da filelist_x
    //alert("element.name: "+element.name+" prefix : "+prefisso);
    var dad;
    dad = element.parentNode;
	// Debug: alert(dad);
    while ( (typeof(dad.id) == 'undefined' || dad.id.indexOf(prefisso + '.') == -1 )&& dad.parentNode!=null) {
		// Debug: alert ("dentro while "+dad);
        dad = dad.parentNode;
    }
    // Debug: alert("esco da while");
    if(typeof(dad.id) != 'undefined') {
		// Debug: alert(dad.id.substring(dad.id.lastIndexOf('.') + 1));
	    return dad.id.substring(dad.id.lastIndexOf('.') + 1);
    }
    else {
	    alert("Impossibile individuare elemento padre");
	    return 0;
    }
}

function getDotName(elementname) {

    var idx1=elementname.lastIndexOf("[");
    var idx2=elementname.lastIndexOf("]");
    if(idx1!=-1 && idx2!=-1) return(elementname.substring(idx1+1,idx2));
    else
        return "";
}


function emptyAndRenameInput(inputNode,prefix,idOld,idNew,stringFlags, level,isdelete){

    //alert(inputNode.name+" "+stringFlags);
    //alert("prefix : "+prefix + "  idOld: " + idOld + "  idNew: " + idNew + "  level: " + level+" ");

    if (stringFlags.substring(1,2)=="1"){
        //alert("Prima della modifica ho nome "+inputNode.getAttribute("name"));
        var nome=inputNode.getAttribute("name");

        //pezza assurda...io volevo tutti i name belli...se li usiamo brutti almeno troviamoli tutti
        //e non solo una parte e/o solo in un solo browser

        //alert("getFatherDotName "+getFatherDotName(inputNode,prefix));
        var realidold=getDotName(nome);
        //alert("realidold "+realidold);
        /*
         if(realidold==getFatherDotName(inputNode,prefix))
         {//alert("questi campi sono gi stati sistemati per name...TODO da togliere se non obbligatorio per gli sctpt");}
         if(realidold!=idOld)
         {alert("patch per risolvere i problemi di Explorer");}
         //cnq se i name sono ok non si hanno problemi e anche la pagina dinamica  valida (strada maestra)
          */

        var parteVecchia="["+idOld+"]";
        var parteNuova="["+idNew+"]";

        if(realidold!=idOld && realidold!=getFatherDotName(inputNode,prefix))
        {//alert("patch per risolvere i problemi di Explorer per Input "+nome+" a livello "+level);
            //qui si rimette (perch c' se non la si toglie) la restrizione ai livelli
            if((nome.indexOf("[")!=-1) && (nome.lastIndexOf("[")!=-1) && (nome.indexOf("[")!=nome.lastIndexOf("[")))
            {
                //l' istanza a cui appartiene l' elemento  di livello 2
                parteVecchia=prefix+'['+parseInt(getFatherDotName(inputNode,prefix)-1)+']';
                parteNuova=prefix+'['+getFatherDotName(inputNode,prefix)+']';
            }
            else
            {//la istanza a cui appartiene l' elemento  di livello 1
                //si deve considerare sia l' inserimento che la modifica...in inserimento sempre 0
                //parteVecchia="[0]";
                parteVecchia="["+realidold+"]";
            }


        }


        if (isdelete)
        {
            parteVecchia=prefix+"["+idOld+"]";
            parteNuova=prefix+"["+idNew+"]";
        }

        var nomeNuovo = replaceLevel(nome, parteVecchia, parteNuova, level);
        inputNode.setAttribute("name", nomeNuovo);

        //alert("Dopo la modifica ho nome "+inputNode.getAttribute("name"));
        //Se nome inizia per 'lookup_campi_' sostituisco anche value
        if ( nome.length > 12 && nome.substring(0,13)=='lookup_campi_') {
            var val = inputNode.getAttribute("value");
            //modifica di mbussetti - 26/12/2005
            //in questo modo la regular expression fa match correttamente anche quando idOld  formato da pi di una cifra
            //RW25718
            var parteVecchia = new RegExp('\\[' + idOld + '\\]',"g");
            var parteNuova = "[" + idNew + "]";
            //check se caso specifico di aggiunta di istanza esterna e lookup su istanza innestata -> solo indici pari aggiornati
            if ( level == 0 ) {
                var a = val.indexOf(" ;");
                a = ( a == -1 ) ? 99999 : a;
                var index = val.indexOf("[") + 1;
                index = val.indexOf("[", index);
                if ( index != -1 && index < a ) {
                    // livello speciale
                    level = -1;
                }
            }
            var valueNuovo=replaceLevel(val, parteVecchia, parteNuova, level);
            //alert ("nome=" + val + ",parteVecchia=" + parteVecchia + ",parteNuova=" + parteNuova + ",level=" + level);
            //alert(valueNuovo);
            //inputNode.setAttribute("value", valueNuovo); //		no mozilla compliant
            inputNode.value = valueNuovo;


            //alert(inputNode.getAttribute("value"));

        } //alert("USCITA "+inputNode.getAttribute("name"));
    }

    //svuoto i campi hidden non di lookup e che NON sono xml:space e che non contengono .@tipo_uff nel nome (servono per i ruoli)
    if ( stringFlags.substring(0, 1) == "1" && inputNode.getAttribute("type") == 'hidden' && inputNode.getAttribute("name").indexOf(".@tipo_uff") == -1 && inputNode.getAttribute("name").substring(0, 7) != "lookup_" && inputNode.getAttribute("name").indexOf(".@xml:space") == -1 ) {
        //inputNode.setAttribute("value",""); //no mozilla compliant
		
        inputNode.value = "";
    }
    //checkbox vengono impostati a non checked
    if ( stringFlags.substring(0, 1) == "1" && inputNode.getAttribute("type") == 'checkbox' ) {
        inputNode.removeAttribute("checked");
        inputNode.checked = false;
    }
    //svuoto tutti i campi input che non siano checkbox e button oppure file
    if (stringFlags.substring(0,1)=="1" && inputNode.getAttribute("type")!='hidden' && inputNode.getAttribute("type")!='checkbox' && inputNode.getAttribute("type")!='button' && inputNode.getAttribute("type")!='file'){
        //inputNode.setAttribute("value", ""); //no mozilla compliant
        inputNode.value = "";
    }
    //alert("@@@@ "+inputNode.name);
    //return(inputNode);
}



function emptyAndRenameTextarea(textareaNode,prefix,idOld,idNew,stringFlags,level,isdelete){

    //alert(stringFlags);
    /*
     if (stringFlags.substring(0,1)=="1"){//alert("non so dove mi trovo");
     var currTextareaText = document.createTextNode("");
     if (textareaNode.hasChildNodes()){
     // alert("Lavorando su textarea ho trovato che ha "+textareaNode.childNodes.length+" figli");
      for (var iText=0; iText<textareaNode.childNodes.length; iText++){
      // alert("figlio "+iText+" -> "+textareaNode.childNodes.item(iText).nodeName);
       if (textareaNode.childNodes.item(iText).nodeName=="#text"){
       // alert("Sto per mettere "+currTextareaText.nodeValue+" al posto di "+textareaNode.childNodes.item(iText).nodeValue);
        textareaNode.replaceChild(currTextareaText, textareaNode.childNodes.item(iText));
        }
        }
        }
        else {
        textareaNode.appendChild(currTextareaText);
        }
        }
        if (stringFlags.substring(1,2)=="1"){//alert("dalla padella nella brace");
        var nome = textareaNode.getAttribute("name");
        //nomeNuovo = replaceLevel(nome, "."+prefix+"["+idOld+"]", "."+prefix+"["+idNew+"]", level);
         //textareaNode.setAttribute("name", nomeNuovo);
          var parteVecchia="["+idOld+"]";
          var parteNuova="["+idNew+"]";
          var nomeNuovo = replaceLevel(nome, parteVecchia, parteNuova, level);
          textareaNode.setAttribute("name", nomeNuovo);
          }
          */

    var currTextareaText = document.createTextNode("");



    if(!isdelete)
    {
        //alert("textareaNode "+textareaNode+" textareaNode.innerHTML "+ textareaNode.innerHTML);
        //currTextareaText=textareaNode.innerHTML;


        if (textareaNode.hasChildNodes()){ //alert("textarea che contiene elementi");
            // alert("Lavorando su textarea ho trovato che ha "+textareaNode.childNodes.length+" figli");
            for (var iText=0; iText<textareaNode.childNodes.length; iText++){
                // alert("figlio "+iText+" -> "+textareaNode.childNodes.item(iText).nodeName);
                if (textareaNode.childNodes.item(iText).nodeName=="#text"){
                    // alert("Sto per mettere "+currTextareaText.nodeValue+" al posto di "+textareaNode.childNodes.item(iText).nodeValue);
                    textareaNode.replaceChild(currTextareaText, textareaNode.childNodes.item(iText));
                }
            }
        }
        else {
            textareaNode.appendChild(currTextareaText);
        }

    } //(!isdelete)
    else
    {//apparentemente non devo fare nulla...
        //alert("paperino");

    }

    var nome = textareaNode.getAttribute("name");

    var parteVecchia="["+idOld+"]";
    var parteNuova="["+idNew+"]";

    var realidold=getDotName(nome);
    //alert("realidold select "+realidold);
    if(realidold!=idOld && realidold!=getFatherDotName(textareaNode,prefix))
    {//alert("patch per risolvere i problemi di Explorer per Input "+nome+" a livello "+level);
        //qui si rimette (perch c' se non la si toglie) la restrizione ai livelli
        if((nome.indexOf("[")!=-1) && (nome.lastIndexOf("[")!=-1) && (nome.indexOf("[")!=nome.lastIndexOf("[")))
        {
            //l' istanza a cui appartiene l' elemento  di livello 2
            parteVecchia=prefix+'['+parseInt(getFatherDotName(textareaNode,prefix)-1)+']';
            parteNuova=prefix+'['+getFatherDotName(textareaNode,prefix)+']';
        }
        else
        {//la istanza a cui appartiene l' elemento  di livello 1
            //si deve considerare sia l' inserimento che la modifica...in inserimento sempre 0
            //parteVecchia="[0]";
            parteVecchia="["+realidold+"]";
        }
    }

    if(isdelete)
    {
        //alert("isdelete");
        parteVecchia=prefix+"["+idOld+"]";
        parteNuova=prefix+"["+idNew+"]";
    }

    var nomeNuovo = replaceLevel(nome, parteVecchia, parteNuova, level);
    textareaNode.setAttribute("name", nomeNuovo);

}




function emptyAndRenameSelect(selectNode,prefix,idOld,idNew,stringFlags,level,isdelete){
    var nome = selectNode.getAttribute("name");
    // alert("Prima della modifica ho nome "+nome);
    //var parteVecchia = "."+prefix+"["+idOld+"]";
    //var parteNuova = "."+prefix+"["+idNew+"]";

    var parteVecchia="["+idOld+"]";
    var parteNuova="["+idNew+"]";



    var realidold=getDotName(nome);


    //alert("realidold select "+realidold);
    if(realidold!=idOld && realidold!=getFatherDotName(selectNode,prefix))
    {//alert("patch per risolvere i problemi di Explorer per Input "+nome+" a livello "+level);
        //qui si rimette (perch c' se non la si toglie) la restrizione ai livelli
        if((nome.indexOf("[")!=-1) && (nome.lastIndexOf("[")!=-1) && (nome.indexOf("[")!=nome.lastIndexOf("[")))
        {
            //l' istanza a cui appartiene l' elemento  di livello 2
            parteVecchia=prefix+'['+parseInt(getFatherDotName(selectNode,prefix)-1)+']';
            parteNuova=prefix+'['+getFatherDotName(selectNode,prefix)+']';
        }
        else
        {//la istanza a cui appartiene l' elemento  di livello 1
            //si deve considerare sia l' inserimento che la modifica...in inserimento sempre 0
            //parteVecchia="[0]";
            parteVecchia="["+realidold+"]";
        }
    }

    if(isdelete)
    {
        //alert("isdelete");
        parteVecchia = "."+prefix+"["+idOld+"]";
        parteNuova = "."+prefix+"["+idNew+"]";
    }


    var nomeNuovo = replaceLevel(nome, parteVecchia, parteNuova, /*level*/0);
    var nomeNuovo = replaceLevel(nome, parteVecchia, parteNuova,level);
    // alert("Dopo la modifica ho nome "+nomeNuovo);
    selectNode.setAttribute("name", nomeNuovo);
    //alert(nome + " -> " + nomeNuovo + " " + parteVecchia);
}
//???????????????????????????   ma questa non  stata eliminata e se la tolgo cosa succede ...perch odiamo le ancore???????????????????????????
function emptyAndRenameAnchor(selectNode,prefix,idOld,idNew,stringFlags){
    var nome = selectNode.getAttribute("name");
    // alert("Prima della modifica ho nome "+nome);
    var parteVecchia = "."+prefix+"["+idOld+"]";
    var parteNuova = "."+prefix+"["+idNew+"]";
    var nomeNuovo = nome.replace(parteVecchia, parteNuova);
    // alert("Dopo la modifica ho nome "+nomeNuovo);
    selectNode.setAttribute("name", nomeNuovo);
}

function replaceSubstring(inputString, fromString, toString) {
    //alert(inputString+" # "+fromString+" # "+toString);
    //if(inputString==null) return "";
    // Goes through the inputString and replaces every occurrence of fromString with toString
    var temp = inputString;
    if (fromString == "") {
        return inputString;
    }
    if (toString.indexOf(fromString) == -1) { // If the string being replaced is not a part of the replacement string (normal situation)
        while (temp.indexOf(fromString) != -1) {
            var toTheLeft = temp.substring(0, temp.indexOf(fromString));
            var toTheRight = temp.substring(temp.indexOf(fromString)+fromString.length, temp.length);
            temp = toTheLeft + toString + toTheRight;
        }
    } else { // String being replaced is part of replacement string (like "+" being replaced with "++") - prevent an infinite loop
        var midStrings = new Array("~", "`", "_", "^", "#");
        var midStringLen = 1;
        var midString = "";
        // Find a string that doesn't exist in the inputString to be used
        // as an "inbetween" string
        while (midString == "") {
            for (var i=0; i < midStrings.length; i++) {
                var tempMidString = "";
                for (var j=0; j < midStringLen; j++) { tempMidString += midStrings[i]; }
                if (fromString.indexOf(tempMidString) == -1) {
                    midString = tempMidString;
                    i = midStrings.length + 1;
                }
            }
        } // Keep on going until we build an "inbetween" string that doesn't exist
        // Now go through and do two replaces - first, replace the "fromString" with the "inbetween" string
        while (temp.indexOf(fromString) != -1) {
            var toTheLeft = temp.substring(0, temp.indexOf(fromString));
            var toTheRight = temp.substring(temp.indexOf(fromString)+fromString.length, temp.length);
            temp = toTheLeft + midString + toTheRight;
        }
        // Next, replace the "inbetween" string with the "toString"
        while (temp.indexOf(midString) != -1) {
            var toTheLeft = temp.substring(0, temp.indexOf(midString));
            var toTheRight = temp.substring(temp.indexOf(midString)+midString.length, temp.length);
            temp = toTheLeft + toString + toTheRight;
        }
    } // Ends the check to see if the string being replaced is part of the replacement string or not
    return temp; // Send the updated string back to the user
} // Ends the "replaceSubstring" function


function emptyAndRenameSpan(currInst,inputNode,prefix,idOld,idNew,stringFlags, level,isdelete){
    // ******************************************************************************** //
    // Individuare gli span degli elementi preview per modificare i riferimenti alle    //
    // chiamate javascript in essi contenuti correggendo i riferimenti alla ripetizione //
    // Naturalmente viene effettuato anche il rename sugli inpu e le textarea           //
    // ******************************************************************************** //

    //alert(prefix + " " + idOld + " " + idNew + " " );
    //letmesee(currInst.innerHTML);
    var currInstInput=currInst.getElementsByTagName("span");
    var target='';
    var targreplace='';
    if(currInstInput.length>0)
    {
        for(var k=0;k<currInstInput.length;k++) {
            name = currInstInput.item(k).getAttribute("name");
            if(name!= null && name.length>8 && name.substring(name.length-8,name.length)=='.preview')
            {
                target= prefix+'['+idOld+']';
                targreplace=prefix+'['+idNew+']';
                break;
            }	}

    }


    /*
     if(currInstInput.length>0) {
     var name=null;
     for(var k=0;k<currInstInput.length;k++) {
     name = currInstInput.item(k).getAttribute("name");
     if(name!=null) {
     if(name.length>8 && name.substring(name.length-8,name.length)=='.preview') {
     if(idOld==0) {
     target=name.substring(1,name.length-8);
     target=target.substring(0,target.lastIndexOf("]")+1);
     break;//aggiunto per crv_back

     }
     else {
     target=new String(name.substring(1,name.length-8)).replace('0',idOld);
     target=target.substring(0,target.lastIndexOf("]")+1);
     break;//aggiunto per crv_back

     }
     }

     }
     }
     }
     */
    if(target!='') {
        // alert(target);
        //letmesee(currInst.innerHTML);
        /*
         var currInstHInput=currInst.getElementsByTagName("input");
         for(var t=0;t<currInstHInput.length;t++) {
         //emptyAndRenameInput(currInstHInput.item(t),prefix,idOld,idNew,stringFlags, level);
          //alert(currInstHInput.item(t).parentNode.innerHTML);
           //alert(currInstHInput.item(t).cloneNode(true).innerHTML);
            currInstHInput.item(t).parentNode.replaceChild(emptyAndRenameInput(currInstHInput.item(t).cloneNode(true),prefix,idOld,idNew,stringFlags, level),currInstHInput.item(t));
            //alert("ECHO 0 input "+currInstHInput.item(t).parentNode.innerHTML);
             }
             var currInstHarea=currInst.getElementsByTagName("textarea");
             for(var t=0;t<currInstHarea.length;t++) {
             emptyAndRenameTextarea(currInstHarea.item(t),prefix,idOld,idNew,stringFlags, level);
             }
             */
        //alert("target "+target + " targreplace "+targreplace);
        //currInst.innerHTML=replaceSubstring(currInst.innerHTML,target,target.replace(idOld,idNew));
        //var myname=replaceSubstring(name,target,target.replace(idOld,idNew));
        currInst.innerHTML=replaceSubstring(currInst.innerHTML,target,targreplace);
        //var myname=replaceSubstring(name,target,targreplace);

        //	letmesee(currInst.innerHTML);
        //return myname;
        return replaceSubstring(name,target,targreplace);
        //return true;
    }
    return false;
}


function arrangeInstance(prefix,currInst,idOld,idNew,stringFlags, level,isdelete){
	//alert(prefix + "  " + currInst + " " + idOld + " " + idNew +"  " + stringFlags +" " + level);
    if (stringFlags.substring(1,2)=="1"){
        // alert("Sto lavorando sull'ID");
        currInst.setAttribute("id", prefix+'.'+idNew);
        //alert("nuovo id: " +currInst.id)
    }


    var currInstSelect=currInst.getElementsByTagName("span");

    //alert(currInstSelect.length);
    if(currInstSelect.length>=0)
    {var temp=emptyAndRenameSpan(currInst,currInstSelect.item(0), prefix, idOld, idNew, stringFlags, level,isdelete);
    //if(temp!=false) return temp;
    }
    /*
     for (var i=currInstSelect.length-1; i<currInstSelect.length; i++){
     if(i!=-1)
     return emptyAndRenameSpan(currInst,currInstSelect.item(i), prefix, idOld, idNew, stringFlags, level);
     //if(i==currInstSelect.length) return true;
      }
      */
    // alert(emptyAndRenameSpan(currInst,currInstSelect.item(i), prefix, idOld, idNew, stringFlags, level));

    var currInstInput = currInst.getElementsByTagName("input");
    for (var i=0; i<currInstInput.length; i++){
        //alert("Sto lavorando sull'input numero " + i + " " + currInstInput.item(i).name);

        //simone - 22 Dec 2004 - per risolvere bug dom di explorer
        if (currInstInput.item(i).type=='radio') {
            var s = currInst.innerHTML;
            s = replaceAll(s, prefix + '[' + idOld + ']', prefix + '[' + idNew + ']');
            currInst.innerHTML = s;
        }
        else{
            emptyAndRenameInput(currInstInput.item(i), prefix, idOld, idNew, stringFlags, level,isdelete);
            //alert("ECHO 2 input "+currInstInput.item(i).innerHTML);
        }
    }

    var currInstTextarea = currInst.getElementsByTagName("textarea");
    for (var i=0; i<currInstTextarea.length; i++){
        // alert("Sto lavorando sulla textarea numero "+i);
        emptyAndRenameTextarea(currInstTextarea.item(i), prefix, idOld, idNew, stringFlags, level,isdelete);
    }
    var currInstSelect = currInst.getElementsByTagName("select");
    //alert("Istanza: " + currInst.getAttribute("id"));
    for (var i=0; i<currInstSelect.length; i++){
        // alert("Sto lavorando sulla select numero "+i);
        emptyAndRenameSelect(currInstSelect.item(i), prefix, idOld, idNew, stringFlags, level,isdelete);
    }
    var currInstSelect=currInst.getElementsByTagName("file");
    for (var i=0; i<currInstSelect.length; i++){
        // alert("Sto lavorando sulla select numero "+i);
        emptyAndRenameInput(currInstSelect.item(i), prefix, idOld, idNew, stringFlags, level,isdelete);
        //alert("ECHO file "+currInstSelect.item(i).innerHTML);
    }



    /*
     var currInstAnchor = currInst.getElementsByTagName("a");
     for (var i=0; i<currInstAnchor.length; i++){
     // alert("Sto lavorando sulla ancora numero "+i);
      emptyAndRenameAnchor(currInstAnchor.item(i), prefix, idOld, idNew, stringFlags);
      }
      */

    if(temp!=false) return temp;
    return true;
}



function checkEmptyInstance(currInst){
    var currInstInput = currInst.getElementsByTagName("input");
    for (var i=0; i<currInstInput.length; i++){
        if (currInstInput.item(i).getAttribute("value")!=""){
            return false;
        }
    }
    var currInstTextarea = currInst.getElementsByTagName("textarea");
    // alert("ci sono "+currInstTextarea.length+" elementi textarea");
    for (var i=0; i<currInstTextarea.length; i++){
        if (currInstTextarea.item(i).hasChildNodes()){
            // alert(currInstTextarea.item(i).hasChildNodes());
            //alert("la textarea numero "+i+" ha "+currInstTextarea.item(i).childNodes.length+" figli");
            for (var iText=0; iText<currInstTextarea.item(i).childNodes.length; iText++){
                // alert ("Il figlio num "+iText+" della textarea "+i+" contiene "+currInstTextarea.item(i).childNodes.item(iText).nodeValue);
                if (currInstTextarea.item(i).childNodes.item(iText).nodeName=="#text" && currInstTextarea.item(i).childNodes.item(iText).nodeValue!=""){
                    //alert("Il figlio num "+iText+"  testo pieno");
                    return false;
                }
                //else alert("Il figlio num "+iText+"  testo vuoto")
            }
        }
    }

    var currInstSelect = currInst.getElementsByTagName("select");
    for (var i=0; i<currInstSelect.length; i++){return false; //alert("trovata select nel blocco da sbiancare");
    }


    return true;
}

function getInstanceId(prefix, index) {
    return(prefix+'.'+index);
}

function getLastInstanceIndex(prefix) {
    for(var index=0;;index++)
        if(document.getElementById(getInstanceId(prefix,index))==null)
            return(index-1);
}

function emptyfile(notation)
{
    var theelem=getElementByName(notation.name.replace("xw:file.@name","xw:file.@title"));
    if(theelem!=null)
    {theelem.value="";}
    else
        alert("Errore !!!");

}

function emptyval(theelem)
{

    if(theelem!=null)
    {theelem.value="";}
    else
        alert("Errore !!!");
}

function deletefile(notation,ismodify)
{	var theelem;alert("It's no time 4 that now");
//se  presente il thumbnail  una immagine???
retval=confirm("Confermi cancellazione?");
if(! retval) return;

if(ismodify==undefined || ismodify==false)
{
    theelem=getElementByName("*"+notation.name.replace("xw:file.@delete","xw:file.@name"));
    emptyInputFile(theelem);
    theelem=getElementByName("*"+notation.name.replace("xw:file.@delete","xw:file.@title"));
    emptyval(theelem);
}
else if(ismodify==true)
{
    theelem=getElementByName("*"+notation.name.replace("xw:file.@delete","xw:file.@id"));
    emptyval(theelem);
    theelem=getElementByName("*"+notation.name.replace("xw:file.@delete","xw:file.@title"));
    emptyval(theelem);

}



}



function hasInputFile(HTMLNode)
{
    var child=HTMLNode.getElementsByTagName("input");
    var found=false;
    for (var i=0; i<child.length; i++){
        if(child[i].type.toLowerCase() =="file")
        {
            found=true;
            break;
        }
    }
    return found;
}

function emptyInputFile(HTMLNode)
{if(HTMLNode.nodeType==1)
{if(HTMLNode.getAttribute('type')=="file")
{
    var newObj = document.createElement('input');
    var theAttributes = HTMLNode.attributes;
    for (var j=0;theAttributes.length>j;j++){
        try {
            if(theAttributes.item(j).nodeValue!="" && theAttributes.item(j).nodeValue!=null && theAttributes.item(j).nodeName!="height")
                newObj.setAttribute(theAttributes.item(j).nodeName,theAttributes.item(j).nodeValue);
        }
        catch(e) {
            newObj.setAttribute(theAttributes.item(j).nodeName,'');
        }
    }

    HTMLNode.parentNode.replaceChild(newObj,HTMLNode);
}
else
{var childs=HTMLNode.childNodes;//alert("pulizia elementi nodo non files");
for (var i=0; childs.length>i; i++){
    emptyInputFile(childs.item(i));
}
}
}
}


function addInstance(prefix, level, thisObject, focus) {

    //NB:questo meccanismo non consente di raggiungere gli elementi di una form per nome
    //alert("prefix:" + prefix +  " level:" + level);
    if ( level == 1 ) {
        // istanza figlia di istanza
        var new_prefix = prefix.substring(0, prefix.indexOf('['));
        var end_prefix = prefix.substring(prefix.indexOf(']'));
        var thisDad = thisObject.parentNode;

        while ( thisDad.id.length < new_prefix || thisDad.id.substring(0, new_prefix.length) != new_prefix ) {
            thisDad = thisDad.parentNode;
        }
        //letmesee(thisDad.innerHTML);
        var instNumber = thisDad.id.substring(thisDad.id.lastIndexOf('.') + 1);
        prefix = new_prefix + '[' + instNumber + end_prefix;
    }
    // alert("prefix "+prefix);
    var index=getLastInstanceIndex(prefix);
    //	alert("add:index="+index);
    if( index < 0 ) {
        alert("can't find instance id: "+getInstanceId(prefix,0));
        return false;
    }
    var theInstance=document.getElementById(getInstanceId(prefix,index));

    // alert("prefix: " + prefix + "     index: " + index);

    var dad=theInstance.parentNode;

    var newInst=theInstance.cloneNode(true);

    // Gregorio 14/06/2005
    // commentata l'istruzione seguente in quanto inficiava
    // il corretto funzionamento della successiva arrangeInstance
    // newInst.innerHTML=theInstance.innerHTML;

    try{
        newInst.innerHTML;
    }
    catch(e) { newInst.innerHTML=theInstance.innerHTML;
    }

    //16/03/2006 cerco di forzare in questo modo brutale l' inserimento degli elementi script...Francesco
    var origscript=theInstance.getElementsByTagName("script");
    var destscript=newInst.getElementsByTagName("script");

    for(var k=0;k<theInstance.getElementsByTagName("script").length;k++)
    {
        destscript[k].parentNode.replaceChild(origscript[k],destscript[k]);
    }
    //letmesee(theInstance.innerHTML);
    //letmesee(newInst.innerHTML);

    var francescoexit= arrangeInstance(prefix,newInst,index,index+1,"11", typeof(level) == 'undefined' ? "" : level,false);
 
    // Elaborazione di Arrange ulteriore (specificata nel docedit.js specifico)
    if ( typeof(customExtraArrange) != 'undefined' ) {    	
        customExtraArrange(newInst, prefix, index, index+1, "11", typeof(level) == 'undefined' ? "" : level);
    }

    if ( level != 1 ) {
        // letmesee(newInst.innerHTML);
        deleteWrongSubInstancesAndSetInnestedId(prefix, newInst, index, index + 1);
    }

    //letmesee(newInst.innerHTML);

    if(hasInputFile(newInst) && getForm('indexForm').browser.value!='IE5' && getForm('indexForm').browser.value!='Explorer') emptyInputFile(newInst);


    dad.appendChild(newInst);

    if(! (francescoexit==true || francescoexit==false ))
        loadIWobject(francescoexit,'',true);

    // dad.appendChild(new Node(newInst.innerHTML));

    if ( typeof(attachAddInstance) != 'undefined' ) {//alert("attachAddInstance");
        attachAddInstance(newInst, prefix);
    }
    if ( typeof(customAddInstance) != 'undefined' ) {
        customAddInstance(newInst, prefix);
    }
    if ( typeof(gmlAddInstance) != 'undefined' ) {
        gmlAddInstance(newInst, prefix,index,level);
    }

    //  do il focus al primo input
    if ( typeof(focus) == 'undefined' || focus == true ) {
        var els = newInst.getElementsByTagName("input");
        for ( var i = 0; i < els.length; i++ )
            if ( els.item(i).type != 'hidden' ) {
                els.item(i).focus();
                break;
            }
    }

    return false;
}



function rearrangeIWobject(blockstring){
    // Si cerca di individuare i due span con name identico e che finisce in ".preview"
    var SpanPosition_1 = -1;
    var NamePosition_1 = '';
    var SpanPosition_2 = -1;
    var NamePosition_2 = '';
    // alert('rearrangeIWobject');
    //ricerca oggetto iw nel blocco...se lo trovo devo risistemare...
    //letmesee(blockstring.innerHTML);
    var currInstSpan=blockstring.getElementsByTagName("span");
    //sono presenti due span con lo stesso nome, uno che contiene l'oggetto
    //per il previiew  e l' altro il javascript eseguito quando si scrive la pagina
    if (currInstSpan != null) {
        if (currInstSpan.length > 1) {
            for (var j=0;j<currInstSpan.length;j++) {
                if (currInstSpan.item(j).name != null) {
                    if (currInstSpan.item(j).name.lastIndexOf(".preview")!=-1) {
                        if (NamePosition_1 == '') {
                            NamePosition_1 = currInstSpan.item(j).name;
                            SpanPosition_1 = j;
                        }
                        else {
                            NamePosition_2 = currInstSpan.item(j).name;
                            SpanPosition_2 = j;
                            break;
                        }
                    }
                }
            }

        }
        if (NamePosition_2 != '') {
            //var target="*x_files"+currInstSpan.item(SpanPosition_1).name.substring(0,currInstSpan.item(SpanPosition_1).name.lastIndexOf(".preview"))+".xw:file.@name";
            var target="*"+currInstSpan.item(SpanPosition_1).name.substring(0,currInstSpan.item(SpanPosition_1).name.lastIndexOf(".preview"))+".xw:file.@name";
            //var target2=currInstSpan.item(SpanPosition_1).name.substring(1,currInstSpan.item(SpanPosition_1).name.lastIndexOf(".preview"))+".xw:file.@name";
            //var target2="*"+currInstSpan.item(SpanPosition_1).name.substring(0,currInstSpan.item(SpanPosition_1).name.lastIndexOf(".preview"))+".xw:file.@name";

            //alert(target);
            //alert(target2)

            var theNamelist = blockstring.getElementsByTagName("input");
            var theName;
            var www=true;

            for(var z=0;z<theNamelist.length;z++) {
                //alert(theNamelist.item(z).name+ "  "+theNamelist.item(z).value + "  "+target);
                if(theNamelist.item(z).name==target) {
                    theName=theNamelist.item(z).value;
                }

            }
            //alert("NOME UPLOAD "+theName);

            if(typeof(theName)=='undefined') {
                theName='';
                www=false;
                //alert("NUOVO");
            }
            /*
             if(theName.length==0 ) {

             for(var z=0;z<theNamelist.length;z++) {
             //alert(theNamelist.item(z).name+ "  "+theNamelist.item(z).value + "  "+target2);
              if(theNamelist.item(z).name==target2) {
              theName=theNamelist.item(z).value;


              www=false;
              }

              }
              }
              */
            www= ! (isNewFiles_x(theName));

            //alert(www+ " NOME LOCALE "+theName);


            //alert(www+" theName !!!"+theName);
            ///alert(currInstSpan.item(0).name+" "+theName+" "+www);
            loadIWobject(currInstSpan.item(SpanPosition_1).name,theName,www);

        }
        else {
            //alert('gruppo non pertinente');
            return;
        }
    }
}


function ClearSelect(myNode)
{
    var currInstSelect = myNode.getElementsByTagName("select");

    for (var i=0; i<currInstSelect.length; i++){
        var myoptions=currInstSelect.item(i).getElementsByTagName("option");
        for (var l=0; l< myoptions.length; l++)
        {if(l==0) myoptions.item(l).selected=true;
        else myoptions.item(l).selected=false;
        }

    }

}

function removeInstance(prefix, thisNode, level) {
    //alert("prefix:" + prefix + "  level:" + level)
    var thisDad;
    if ( prefix.indexOf('[') != -1 ) {
        //istanza figlia di istanza
        var new_prefix = prefix.substring(0, prefix.indexOf('['));
        thisDad = thisNode.parentNode;
        while ( thisDad.id.length < new_prefix || thisDad.id.substring(0, new_prefix.length) != new_prefix ) {
            thisDad = thisDad.parentNode;
        }
        prefix = thisDad.id.substring(0, thisDad.id.lastIndexOf('.'));
    }
    thisDad=thisNode.parentNode;
    //simone -> non e' detto che gli elementi di una istanza siano figli... risalgo fino all'elemento
    //che contiene id=prefix cioe' quello che racchiude l'istanza... tutti gli elementi dell'istanza sono
    //suoi discendenti
    while ( typeof(thisDad.id) == 'undefined' || thisDad.id.length < prefix || thisDad.id.substring(0, prefix.length) != prefix ){
        thisDad = thisDad.parentNode;
    }
    var lastIndex=getLastInstanceIndex(prefix);

    //alert("Dad: name=" + thisDad.name + "  id=" + thisDad.id);
    //alert("lastindex: " + lastIndex);
    //alert("remove:lastIndex="+lastIndex);

    if(lastIndex<1){
        //questo  quando si lavora sulla unica istanza rimasta...in ogni modo esce qualcosa
        if (checkEmptyInstance(thisDad)){
            alert("Almeno un'istanza deve rimanere!");
            return false;
        }
        else {

            // Richiesta conferma di cancellazione istanza o meno
            if ( typeof(customConfirmRemoveInstance) != 'undefined' && customConfirmRemoveInstance() == false ) {
                return false;
            }

            //alert("Vorrei svuotare l'istanza!");
            //usata in modo improprio per svuotare tutti i campi
            arrangeInstance(prefix, thisDad,"","", "10",'undefined',false);

            ClearSelect(thisDad);

            if ( typeof(attachRemoveInstance) != 'undefined' ) {
                attachRemoveInstance(prefix, "", thisNode);
            }
            if ( typeof(customRemoveInstance) != 'undefined' ) {
                customRemoveInstance(prefix, "", thisNode);
            }
            return true;
        }
    }

    // Richiesta conferma di cancellazione istanza o meno
    if ( typeof(customConfirmRemoveInstance) != 'undefined' && customConfirmRemoveInstance() == false ) {
        return false;
    }

    var idTarget = thisDad.getAttribute("id");
    // alert("idtarget: " + idTarget);
    while(idTarget.substring(0,prefix.length+1)!=prefix+"."){
        thisDad = thisDad.parentNode;
        idTarget = thisDad.getAttribute("id");
    }

    //alert("idtarget: " + idTarget)

    //alert("Ho trovato l'ID")
    var startNumber = idTarget.lastIndexOf(".");
    var index = parseInt(idTarget.substring(startNumber+1, idTarget.length), 10);
    //alert("startNumber "+index)
    //alert("L'indice vale "+index)
    if(index>lastIndex){
        alert("ERROR: Something wrong happened! Trying to remove an instance that doesn't exist!");
        return false;
    }
    var garbageInst = document.getElementById(idTarget);
    //alert("Ho trovato il documento");
    //alert("Rimuovo " + garbageInst.id);
    garbageInst.parentNode.removeChild(garbageInst);
    // alert("Sto entrando nell'if con index="+index+" e lastIndex="+lastIndex);
    if (index<lastIndex){
        //alert("Sono entrato nell'if");
        //alert ("iCatch,lastIndex="+iCatch+" "+lastIndex);
        for (var iCatch=index+1; iCatch<=lastIndex; iCatch++){
            //alert("Sono entrato nel for con iCatch="+iCatch);
            var basketInst=document.getElementById(getInstanceId(prefix, iCatch));
            //arrangeInstance(prefix,basketInst,iCatch,iCatch-1,"01",true);
            //letmesee(basketInst.innerHTML);
            // arrangeInstance(prefix,basketInst,iCatch,iCatch-1,"01", typeof(level) == 'undefined' ? "" : level,true);
            arrangeInstance(prefix,basketInst,iCatch,iCatch-1,"01", "",true);
            //alert(prefix + "." + iCatch + " --> " + basketInst.id);
            // letmesee(basketInst.innerHTML);
            if ( level != 1 ) {
                // alert('deleteWrongSubInstancesAndSetInnestedId');
                // alert('prefix: '+prefix+'; basketInst.id:'+basketInst.id+'; iCatch:'+iCatch);
                notDeleteWrongSubInstancesButSetInnestedId(prefix, basketInst, iCatch, iCatch - 1);
            }
            //alert("Ho appena spostato un'instanza all'id "+basketInst.getAttribute("id"));
            if ( typeof(basketInst) != 'undefined' )
                rearrangeIWobject( basketInst);
        }
    }
    if ( typeof(attachRemoveInstance) != 'undefined' ) {
        attachRemoveInstance(prefix, thisDad.id);
    }
    if ( typeof(customRemoveInstance) != 'undefined' ) {
        customRemoveInstance(prefix, thisDad.id);
    }

    if ( typeof(gmlRemoveInstance) != 'undefined' ) {
        gmlRemoveInstance(prefix,thisDad.id,index,level,lastIndex);
    }


    return true;
}

function clearDocument(codRep,descrRep) {
    if ( insertMode() == false ) {
        //sono nella pagina di modifica
        return unlockAndGoTo('showdoc', true);
    }
    else {
		
		//fcossu 14/06/2010 Inserimento Persona Interna, Appartenenza non persistente dopo "Pulisci" [EB 797]
		if (typeof(getForm("hxpForm").dbTable) != 'undefined' && getForm("hxpForm").dbTable.value == "@persona_interna") {
			getForm('hxpForm').xverb.value = "@" + getElementByName('.@cod_uff').value + "|" + getElementByName('.@cod_amm').value + "|" + 
											 getElementByName('.@cod_aoo').value +
                                        	 ((typeof(getElementByName('.@additionalCodUff')) != 'undefined' && getElementByName('.@additionalCodUff') != null && 
                                        	 getElementByName('.@additionalCodUff').value.length > 0) ? "|" + getElementByName('.@additionalCodUff').value : "");
		}
		
		if (typeof(getForm("hxpForm").dbTable) != 'undefined' && getForm("hxpForm").dbTable.value == "@persona_esterna") {
			getForm('hxpForm').xverb.value = "@" + getElementByName('.appartenenza[0].@cod_uff').value + "|" + getElementByName('.appartenenza[0].@cod_amm').value + "|" + 
											 getElementByName('.appartenenza[0].@cod_aoo').value + 
											 ((typeof(getElementByName('.appartenenza[0].@additionalCodUff')) != 'undefined' && 
											 getElementByName('.appartenenza[0].@additionalCodUff') != null && 
											 getElementByName('.appartenenza[0].@additionalCodUff').value.length > 0) ? "|" + 
											 getElementByName('.appartenenza[0].@additionalCodUff').value : "");
		}
		
        // Richiesta conferma di abbandono o meno
        if ( typeof(customConfirmClearDocument) != 'undefined' && customConfirmClearDocument() == false )
            return false;

        //nuovo codice
        //ora si fa reload della pagina di inserimento -> risolve vari problemi
        //ed e' indispensabile se nella form di inserimento ci sono degli input type=file

        if ( 'undefined' != typeof(codRep) ){
            getForm("hxpForm").codice_rep.value = codRep;
        }
        if ( 'undefined' != typeof(descrRep) ){
            getForm("hxpForm").descrizione_rep.value = descrRep;
        }
        getForm("hxpForm").verbo.value="docEdit";
        getForm("hxpForm").pos.value=0;
        getForm("hxpForm").selid.value="";

        //simone - 29 Nov 2004
        getForm("hxpForm").toDo.value = '';

        getForm("hxpForm").submit();
        return false;
        /* vecchio codice
         getForm("hxpForm").reset(); //non basta poiche' il default viene modificato
         for ( var i = 0; i < getForm("hxpForm").length; i++ ) //non svuotare i campi hidden
         if ( getForm("hxpForm")[i].type != 'hidden' && getForm("hxpForm")[i].type != 'file' )
         getForm("hxpForm")[i].value = '';
         */
    }
    return false;
}

function insertMode() {
    // Federico 09/11/06: corretto test su 'pos' e aggiunto test "value == '0'" di 'physDoc'
    if (getForm("hxpForm").selid.value.length == 0 &&
            getForm("hxpForm").pos.value == '0' &&
            (getForm("hxpForm").physDoc.value.length == 0 || getForm("hxpForm").physDoc.value == '0')) {

        return true;
    }
    else {
        return false;
    }
}

function uploadError(n) {
    if (n == -1)
        alert("La dimensione di un allegato supera la massima soglia consentita:\nimpossibile proseguire con il salvataggio");
    else
        alert("Si  verificato un errore nell'upload di un allegato:\nimpossibile proseguire con il salvataggio");
    getForm("hxpForm").filesWithSize.value = '';
    return false;
}

var l_listOfNumerics, l_codRep, l_descrRep;
function saveDocument(listOfNumerics, codRep, descrRep) {
    l_listOfNumerics = listOfNumerics;
    l_codRep = codRep;
    l_descrRep = descrRep;
    OpenWaitMsg();
    setTimeout("realSaveDocument();", 10);
    return false;
}
var signingAppletDiv=null;
var signingAppletDivId='signingAppletDiv';
var signingAppletIframeId='signingAppletIframe';
var signingAppletIframeName=signingAppletIframeId;
function onSigningAppletACK()
{document.getElementById(signingAppletDivId).style.display='none';
 OpenWaitMsg();
 setTimeout("realSaveDocument(false);", 10);
}
function hideSigningApplet()
{document.getElementById(signingAppletIframeId).src=bioAppletResourceLocation()+'static.html';
 document.getElementById(signingAppletDivId).style.display='none';
}
function onSigningAppletNACK()
{if(confirm("L'identit non  stata verificata. Riprovare?"))
 {signingCeremony();
 }
 else hideSigningApplet();
}
function onSigningAppletDecline()
{hideSigningApplet();
}
function showSenselectApplet()
{try{document.getElementById('signingCeremonyAnchor').focus();}catch(e){alert(e);}
 try{scrollTo(0,9999);}catch(e){alert(e);}
}
/*
function senselectSignatureData()
{var session = new _hxpSession(getForm('indexForm'));
 session.push();
 session.setParameter('successURL',bioAppletResourceLocation()+'bioAppletSuccess.html');
 session.setParameter('failureURL',bioAppletResourceLocation()+'bioAppletFailure.html');
 var result = session.getServerResponse('query','bioApplet',false,[]);
 session.pop();
 if(result.status==200)return result.responseText;
 alert('unexpected error: '+result.statusText+' ('+result.status+')');
 return '';
}
*/
//http://localhost:8080/xway/application/xdocway/engine/xdocway.jsp?verbo=query&xverb=bioApplet&transformJava=true&successURL=http://localhost:8080/xway/application/xdocway/engine/../formatter/html/templates/bioAppletSuccess.html&failureURL=http://localhost:8080/xway/application/xdocway/engine/../formatter/html/templates/bioAppletFailure.html
function bioAppletResourceLocation(){return window.location.protocol+'//'+window.location.host+window.location.pathname.substring(0,window.location.pathname.lastIndexOf('/'))+'/../formatter/html/templates/';}
function fillSigningAppletContainer()
{var f = getForm('indexForm');
 var session = new _hxpSession(f);
 session.push();
 session.setParameter('successURL',bioAppletResourceLocation()+'bioAppletSuccess.html');
 session.setParameter('failureURL',bioAppletResourceLocation()+'bioAppletFailure.html');
 var formData = _pushForm(f,f.uri.value,signingAppletIframeName,[['verbo','query'],['xverb','bioApplet'],['query','']]);
 f.submit();
 _popForm(f,formData);
 session.pop();
}
function signingCeremony()
{if(signingAppletDiv==null)
 {signingAppletDiv=document.createElement('div');
  signingAppletDiv.id=signingAppletDivId;
  document.body.appendChild(signingAppletDiv);
  document.getElementById(signingAppletDivId).innerHTML =
   '<iframe width="100%" height="230" marginwidth="0" marginheight="0" hspace="0" vspace="0" frameborder="0" scrolling="no"'+
   ' src="'+staticEmptyWindow+'" name="signingAppletIframe" id="signingAppletIframe" ></iframe>\n<a name="signingCeremonyAnchor" id="signingCeremonyAnchor"/>\n';
 }
 fillSigningAppletContainer();
 document.getElementById(signingAppletDivId).style.display='';
 showSenselectApplet();
 setTimeout("showSenselectApplet();",2000);
}
/*
function signingAppletIframeSrc()
{return('../../../bioApplet/bioApplet.html?successURL='+window.location.protocol+'//'+window.location.host+'/xway/bioApplet/success.html&'+
                                          'failureURL='+window.location.protocol+'//'+window.location.host+'/xway/bioApplet/failure.html');
}
function signingCeremony()
{if(signingAppletDiv==null)
 {signingAppletDiv=document.createElement('div');
  signingAppletDiv.id=signingAppletDivId;
  document.body.appendChild(signingAppletDiv);
  document.getElementById(signingAppletDivId).innerHTML=
  '<iframe width="100%" height="230" marginwidth="0" marginheight="0" hspace="0" vspace="0" frameborder="0" scrolling="no" id="signingAppletIframe" '+
          'src="'+signingAppletIframeSrc()+'"></iframe>\n'+
  '<a name="signingCeremonyAnchor" id="signingCeremonyAnchor"/>\n';
 }
 else
 {document.getElementById('signingAppletIframe').src=signingAppletIframeSrc();
  document.getElementById(signingAppletDivId).style.display='';
 }
 showSenselectApplet();
 setTimeout("showSenselectApplet();",2000);
}
*/
function realSaveDocument(ceremonyEnabled)
{
    /* Federico 08/10/04:
     * A livello generic non posso conoscere quali sono gli elementi del documento che possono contenere
     * del codice html prodotto dall'editor javascript --> recupero la lista di tali elementi invocando,
     * se esiste, una funzione specifica che restituisce un array di stringhe (la lista degli elementi).
     * Fatto questo, avvio il filtering del contenuto di ogni elemento della lista cos ottenuta.
     *
     * Federico-Nicola 01/02/06: spostata la chiamata di 'customCheckJsEditorContent' a livello generico
     * in modo che venga effettuata anche usando un browser diverso da IE [RW 0032659]
     */
    if (typeof(customGetHtmlNodes) != 'undefined') {
        var nodeList = customGetHtmlNodes();
        var curElem = null;

        // ndrago [RW 0035152]
        for (var i = 0; i < nodeList.length; i++) {
            curElem = getElementByName(nodeList[i], 'textarea');
            if (curElem != null) {
                // avvio il filtering dell'html prodotto dagli editor delle textarea prima del submit
                if (typeof(editor_filterOutput) != 'undefined')
                    editor_filterOutput(nodeList[i]);
                // avvio il filtering custom del contenuto della textarea degli editor [RW 0032659]
                if (typeof(customCheckJsEditorContent) != 'undefined')
                    curElem.value = customCheckJsEditorContent(curElem.value);
            }
        }
    }
    /* Federico 23/06/05: il js necessario al building block "inputCheckboxSetValueOnOff" viene inserito dall'xsl
     * solo se viene rilevata la presenza di almeno un blocco di questo tipo.
     * Se presente, invoco la funzione "chkBoxOnOffSetEmptyValues" per valorizzare gli input hidden vuoti associati
     * ai checkbox inseriti dai blocchi menzionati.
     */
    if (typeof(chkBoxOnOffSetEmptyValues) != 'undefined') {
        chkBoxOnOffSetEmptyValues();
    }

    var listOfNumerics = l_listOfNumerics;
    var codRep = l_codRep;
    var descrRep = l_descrRep

    var canSave = true;
    var theForm = "hxpForm";

    if ( checkForm() == true ) {

        if ((typeof(ceremonyEnabled)=='undefined' || ceremonyEnabled==true) && senselectEnabled() && hasSignData()) {
            CloseWaitMsg();
            signingCeremony();
            return false;
        }
        if ( typeof(document.IW) != 'undefined' ) {
            var r;

            if ( (r=uploadFiles('', getForm("hxpForm").sizeMaxImg.value)) != true ) { CloseWaitMsg(); return uploadError(r);}
            if ( (r=uploadFiles("FILES", getForm("hxpForm").sizeMaxFile.value)) != true ) { CloseWaitMsg(); return uploadError(r);}
            if ( uploadFiles_x() == false ) { CloseWaitMsg(); return uploadError();}
        }
        /* Controllo sui valori assegnati ai diritti dichiarati di tipo numerico */

        if (listOfNumerics != ""){
            var listOfCodes = listOfNumerics.split('|');
            for (var i = 0; i < listOfCodes.length; i++){
                var theCode = listOfCodes[i];
                if (theCode != ""){
                    var theValue = document[theForm][rivesti2(theCode)].value;
                    if (theValue != ""){
                        for (var j = 0; j < theValue.length; j++){
                            if (isNaN(parseInt(theValue.charAt(j),10))) {
                                alert ('Valore di un diritto testuale diverso dal tipo dichiarato: salvataggio non eseguito ');
                                document[theForm][rivesti2(theCode)].value = "*NUM*";
                                canSave = false;
                                break;
                            }
                        }
                    }
                }
            }
        }

        if (canSave){
            getForm("hxpForm").revSel.value='1'; //per viewer
            getForm("hxpForm").nextVerb.value = "showdoc"; //per viewer
            getForm("hxpForm").nextXVerb.value = "@child"; //per viewer
            getForm("hxpForm").xverb.value='@save';

            if ( 'undefined' != typeof(codRep) ) getForm("hxpForm").codice_rep.value = codRep;
            if ( 'undefined' != typeof(descrRep) ) getForm("hxpForm").descrizione_rep.value = descrRep;

            //alert(listOfNumerics);
            getForm("hxpForm").submit();
        }
        else CloseWaitMsg();
    }

    return false;
}

function checkForm()
{
    var ret = true;
    //generic check
    if ( typeof(customCheckForm) != 'undefined' )
        ret &= customCheckForm();
    else if ( ret == false )
        CloseWaitMsg(); //N.B se customcheck esiste la closewaitmsg  a carico di essa

    return ret;
}

function setSaveParams(pne, pnce)
{
    getForm("hxpForm").pne.value = pne;
    getForm("hxpForm").pnce.value = pnce;
}

function unlockDocument()
{if(insertMode() == false)
{
    OpenWaitMsg();
    getForm("hxpForm").xverb.value='@unlock';
    getForm("hxpForm").revSel.value='1'; //per viewer
    getForm("hxpForm").nextVerb.value = "showdoc"; //per viewer
    getForm("hxpForm").nextXVerb.value = "@child"; //per viewer
    getForm("hxpForm").submit();
}
else if(typeof(opener)!='undefined')
{opener.focus();
self.close();
}
return false;
}


function changeHandler(theInput)
{if(theInput.type=='textarea')
    theInput.innerHTML=theInput.value;
else
    if(theInput.type=='text')
    {
    }
}


function loadHandler() {

    /* Federico 15/09/05:
     * L'inizializzazione degli editor js e' stata spostata qui in modo che essa venga effettuata a pagina
     * completamente caricata (RW 0030305).
     * L'inizializzazione si basa sul fatto che a livello specifico sia definita una funzione 'customInitHtmlNodes'
     * che consente di ottenere i nomi delle textarea associate agli editor e gli oggetti di configurazione di
     * ognuno di essi.
     * Per i dettagli si veda l'omonima funzione nel file 'docEdit.js' specifico di XSpring.
     */
    if (typeof(editor_generate) != 'undefined' && typeof(customInitHtmlNodes) != 'undefined') {
        var nodeList = customInitHtmlNodes();

        // avvio l'inizializzazione degli editor javascript
        for (var i = 0; i < nodeList.length; i++) {
            if (typeof(nodeList[i].txtAreaName) != 'undefined' && typeof(nodeList[i].configObj) != 'undefined') {
                editor_generate(nodeList[i].txtAreaName, nodeList[i].configObj);
            }
            else {
                // l'editor 'i' non pu essere inizializzato correttamente!
                alert("Impossibile inizializzare l'editor js " + i + "!\nImpossibile proseguire.");
                break;
            }
        }
    }

    //per viewer
    if(getForm("hxpForm").xverb.value.indexOf('asText')>=0)
    {getForm("hxpForm").asText.value=getForm("hxpForm").asText.value.replace(/(.)<([^\?])/g,'$1<$2');
    getForm("hxpForm").asText.value=getForm("hxpForm").asText.value.replace(/\&/g,'&amp;');
    getForm("hxpForm").asText.value=getForm("hxpForm").asText.value.replace(/_n_/g,'\n');
    getForm("hxpForm").xmlDoc.value=getForm("hxpForm").asText.value;
    document.DocumentAsText=getForm("hxpForm").asText.value;
    getForm("hxpForm").asText.value='';
    }

    arrangeRifInterni("CC");
    arrangeRifInterni("CDS");

    //DD 21/03/06 Eventuale disabilitazione checkbox invia notifica  (RW:0035181)
    gestCheckboxInviaNotifica();

    if ( typeof(customLoadHandler) != 'undefined' ) customLoadHandler();

    if ( typeof(rifinterniLoadHandler) != 'undefined' ) rifinterniLoadHandler();

    if ( typeof(filelistLoadHandler) != 'undefined' ) filelistLoadHandler();

    if ( typeof(getForm("hxpForm").fromLookup) != 'undefined' )
        if ( getForm("hxpForm").fromLookup.value == "close" ) {
            var Ajax = (isAjaxCompliant() && typeof(opener) != 'undefined' &&  opener.document.getElementById('lookupDiv') != null) ? true : false;
            var doItWithAjax = typeof(opener) != 'undefined' && typeof(opener.customDoLookupWithAjax) != 'undefined' && !opener.customDoLookupWithAjax() ? false : true;
            if (!Ajax || !doItWithAjax)
                opener.reDoLookupAfterInsert(getForm("hxpForm").lookup_new.value, self);
            else {
                opener.reDoLookupAfterInsertLookup(getForm("hxpForm").lookup_new.value);
                setTimeout('self.close()', 500);
            }
        }

    //var profileSelect = getElementByName("scelta profili","select");

    //if (profileSelect != null) addEmptyOption(profileSelect);

    if ( typeof(setDefaultVisibility) != 'undefined' ) setDefaultVisibility();

    //DD 29/01/06 Valorizza tutti gli attributi title delle immagini
    setAllImgTitlesFromAlt();
}


function arrangeRifInterni(tipo)
{
    if ( typeof(getForm("hxpForm").countRifs) != 'undefined' ) {
        var countRifs = getForm("hxpForm").countRifs.value;
        var firstIndex = 0;
        for ( var i = 0; i < countRifs; i++ ) {
            if ( document.getElementById(getInstanceId(tipo, i)) != null ) {
                firstIndex = i;
                break;
            }
        }
        var lastIndex = firstIndex;
        for ( var i = countRifs - 1; i >= firstIndex ;i-- ) {
            if ( document.getElementById(getInstanceId(tipo, i)) != null ){
                lastIndex = i;
                break;
            }
        }
        //alert(tipo + "  " + firstIndex + " - " + lastIndex)
        var newIndex = 0;
        for ( var i = firstIndex; i <= lastIndex; i++ ){
            var basketInst = document.getElementById(getInstanceId(tipo, i));
            if ( basketInst != null ) {
                //alert(i + " -> " + newIndex)
                arrangeInstance(tipo, basketInst, i, newIndex, "01", 'undefined',false);
                newIndex++;
            }
        }
    }
}


function unloadHandler()
{
    var execRifinterniUnloadHandler = true;
    if (typeof(f_operation)!='undefined' && f_operation=='NOCLOSE') //roba custom per fascicoli di dcw
        execRifinterniUnloadHandler = false;
    if ( typeof(rifinterniUnloadHandler) != 'undefined' && execRifinterniUnloadHandler) rifinterniUnloadHandler();

    // Federico 05/01/06: introdotta chiamata a un custom unloadHandler [RW 0032020]
    if (typeof(customUnloadHandler) != 'undefined') customUnloadHandler();
}


function unlockAndGoTo(verbo, useTable, usePersonalView) {
    // Richiesta conferma di abbandono o meno
    if ( typeof(customConfirmUnlockAndGoTo) != 'undefined' && customConfirmUnlockAndGoTo() == false )
        return false;

    if (useTable==false)
        getForm("hxpForm").dbTable.value="";
    else if (typeof(customDbTableForUnlockAndGoTo)!='undefined')
        getForm("hxpForm").dbTable.value=customDbTableForUnlockAndGoTo(getForm("hxpForm").dbTable.value);

    //aggiunta di mbussetti del 21/09/2005: le pagine di inserimento/modifica/visualizzazione sono diversificate
    //per i modelli e le istanze (dbTable=@workflow_model/@workflow_instance) ma la pagina di ricerca  comune,
    //quindi bisogna modificare il dbTable
    var wDbTable = getForm("hxpForm").dbTable.value;
    if (wDbTable.indexOf("@workflow") != -1 && insertMode() == true) {
        getForm("hxpForm").dbTable.value = "@workflow";
    }

    if (typeof(usePersonalView) == 'undefined' || usePersonalView == false)
        getForm("hxpForm").personalView.value = "";

    getForm("hxpForm").destPage.value=verbo;
    if (insertMode() == true){ //sono nella pagina di inserimento
        getForm("hxpForm").toDo.value = '';
        getForm("hxpForm").verbo.value=verbo;
        getForm("hxpForm").submit();
        return false;
    }
    else
        return unlockDocument();
}

var dad = null; //nel caso di multistanza e' nodo padre, altrimenti null (utilizzato da lookup.js)

function lookup(inputNode, aliasName, inputName, ord, aliasName1, hxp_inst_str) {
    //Fabio 10/09/2004
    var sourceForm = getForm("hxpForm");
    var requestForm = getForm('indexForm');

    var iForm, titolo, campi, xq = "", val, db = "", newrecord = "";
    var old_target = requestForm.target;
    var old_verbo = requestForm.verbo.value;
    var old_selid = requestForm.selid.value;
    var old_newrecord = requestForm.lookup_new.value;
    var sold_target = sourceForm.target;
    var sold_verbo = sourceForm.verbo.value;
    var sold_selid = sourceForm.selid.value;
    var sold_newrecord = sourceForm.lookup_new.value;

    //salvo parametri di hxpForm
    var old_qord = requestForm.qord.value;
    var old_lookup_titolo = requestForm.lookup_titolo.value;
    var old_lookup_campi = requestForm.lookup_campi.value;
    var old_lookup_xq = requestForm.lookup_xq.value;
    var old_lookup_new = requestForm.lookup_new.value;
    var old_lookup_db = requestForm.lookup_db.value;
    var old_lookup_fieldVal = requestForm.lookup_fieldVal.value;
    var old_lookup_alias = requestForm.lookup_alias.value;

    //salvo parametri di indexForm
    var sold_qord = sourceForm.qord.value;
    var sold_lookup_titolo = sourceForm.lookup_titolo.value;
    var sold_lookup_campi = sourceForm.lookup_campi.value;
    var sold_lookup_xq = sourceForm.lookup_xq.value;
    var sold_lookup_new = sourceForm.lookup_new.value;
    var sold_lookup_db = sourceForm.lookup_db.value;
    var sold_lookup_fieldVal = sourceForm.lookup_fieldVal.value;
    var sold_lookup_alias = sourceForm.lookup_alias.value;

    //multistanza - necessario poiche' non e' possibile modificare dinamicamente onclick di elemento
    if ( inputName.indexOf('[$hxp_instance()]') != -1 ) {

        dad = inputNode.parentNode;

        var theInputName = inputNode.name;

        // Federico 14/05/07: data la possibilita' di specificare una stringa diversa dal nome dell'input
        // che contiene "[$hxp_instance()]" o "$hxp_instance()" (usata per il calcolo del numero d'istanza)
        // [RW 0043770]
        if (typeof(hxp_inst_str) == 'undefined' || hxp_inst_str == null) {
            hxp_inst_str = theInputName;
        }

        var prefix = hxp_inst_str.substring(0, hxp_inst_str.lastIndexOf('['));

        if ( prefix.charAt(0) == '.')
            prefix = prefix.substring(1);

        while ( typeof(dad.id) == 'undefined' || dad.id.indexOf(prefix + '.') == -1 )
            dad = dad.parentNode;

        var instNumber = dad.id.substring(dad.id.lastIndexOf('.') + 1);

        //caso di istanza figlia di multistanza
        if ( inputName.indexOf('$hxp_fatherinstance()') != -1 ) {
            var id = dad.id;
            var fatherInstNumber = id.substring(id.indexOf('[') + 1, id.indexOf(']'));
            inputName = inputName.replace('$hxp_fatherinstance()', fatherInstNumber);
        }

        inputName = inputName.replace('$hxp_instance()', instNumber);
        //alert (inputName);

        titolo = getElementByName('lookup_titolo_' + inputName).value;
        //alert(titolo);
        campi = getElementByName('lookup_campi_' + inputName).value;
        //alert(campi);

        // Modifica effettuata da gregorio in data 12/08/2004 12.16
        // if ( typeof(getElementByName('lookup_xq_' + inputName)) != 'undefined' )
        if ( getElementByName('lookup_xq_' + inputName) ) {
            xq = getElementByName('lookup_xq_' + inputName).value;
        }
        // Modifica effettuata da gregorio in data 12/08/2004 12.16
        // if ( typeof(getElementByName('lookup_new_' + inputName)) != 'undefined' )
        if ( getElementByName('lookup_new_' + inputName) ) {
            newrecord = getElementByName('lookup_new_' + inputName).value;
        }
        // Modifica effettuata da gregorio in data 12/08/2004 12.16
        // if ( typeof(getElementByName('lookup_db_' + inputName)) != 'undefined' )
        if ( getElementByName('lookup_db_' + inputName) ) {
            db = getElementByName('lookup_db_' + inputName).value;
        }

        val = getElementByName(inputName).value;
    }
    else {

        //no multistanza

        dad = null;
        titolo = sourceForm['lookup_titolo_' + inputName].value;
        campi = sourceForm['lookup_campi_' + inputName].value;
        if ( typeof(sourceForm['lookup_xq_' + inputName]) != 'undefined' )
            xq = sourceForm['lookup_xq_' + inputName].value;
        if ( typeof(sourceForm['lookup_new_' + inputName]) != 'undefined' )
            newrecord = sourceForm['lookup_new_' + inputName].value;
        if ( typeof(sourceForm['lookup_db_' + inputName]) != 'undefined' )
            db = sourceForm['lookup_db_' + inputName].value;
        val = sourceForm[inputName].value;
    }

    nodeToSetDefault = getElementByName(inputName);

    //se db acl -> seleziono quello corretto (multi acl)
    if (db == 'acl' && getForm("hxpForm").aclDb.value != '')
        db = getForm("hxpForm").aclDb.value;

    //Fabio 10/09/2004 copia qua e la i valori perch in customPreLookup() si assumeva che le due form coincidessero
    iForm = requestForm;
    iForm.selid.value          = sourceForm.selid.value          ="";
    iForm.qord.value           = sourceForm.qord.value           =ord;
    iForm.lookup_titolo.value  = sourceForm.lookup_titolo.value  =titolo;
    iForm.lookup_campi.value   = sourceForm.lookup_campi.value   =campi;
    iForm.lookup_xq.value      = sourceForm.lookup_xq.value      =xq;
    iForm.lookup_new.value     = sourceForm.lookup_new.value     =newrecord;
    iForm.lookup_db.value      = sourceForm.lookup_db.value      =db;
    iForm.lookup_fieldVal.value= sourceForm.lookup_fieldVal.value=val;
    iForm.lookup_alias.value   = sourceForm.lookup_alias.value   =aliasName;

    if ( typeof(aliasName1) != 'undefined' && aliasName1.length > 0 )
        iForm.lookup_alias.value += "|" + aliasName1;

    iForm.verbo.value = "lookup_response";
    iForm.target = iForm.target + 'lookup_child';

    //if ( typeof(iForm.fromLookup) != 'undefined'  &&  iForm.fromLookup.value == 'true' )
    if ( typeof(sourceForm.fromLookup) != 'undefined'  &&  sourceForm.fromLookup.value == 'true' )
        iForm.target += '_new';

    var r = true;

    if (typeof(customPreLookup) != 'undefined')	{
        //r = customPreLookup(iForm, inputName, val); Fabio 10/09/2004
        r = customPreLookup(sourceForm, inputName, val);
        if ( r == true ) { //Fabio 10/09/2004
            requestForm.selid.value           =sourceForm.selid.value          ;
            requestForm.qord.value            =sourceForm.qord.value           ;
            requestForm.lookup_titolo.value   =sourceForm.lookup_titolo.value  ;
            requestForm.lookup_campi.value    =sourceForm.lookup_campi.value   ;
            requestForm.lookup_xq.value       =sourceForm.lookup_xq.value      ;
            requestForm.lookup_new.value      =sourceForm.lookup_new.value     ;
            requestForm.lookup_db.value       =sourceForm.lookup_db.value      ;
            requestForm.lookup_fieldVal.value =sourceForm.lookup_fieldVal.value;
            requestForm.lookup_alias.value    =sourceForm.lookup_alias.value   ;
        }
    }

    // Federico 15/04/09: introdotta possibilit di invocare una funzione custom prima del lookup senza
    // entrare in conflitto con il meccanismo di 'customPreLookup' (per evitare i dannosi assegnamenti
    // requestForm.* = sourceForm.*) [M 0000253]
    if (typeof(customBeforeLookup) != 'undefined') {
        r = customBeforeLookup(iForm, inputName, val);
    }

    if ( r == true ) {

        var Ajax = (isAjaxCompliant() && document.getElementById('lookupDiv') != null) ? true : false;
        var doItWithAjax = typeof(customDoLookupWithAjax) != 'undefined' && !customDoLookupWithAjax() ? false : true;
        if (!Ajax || !doItWithAjax) {
            var windowFeature = "width=620 height=520 resizable";
            if ( typeof(customSetWindowFeature) != 'undefined' )
                windowFeature = customSetWindowFeature();
            theIndexWindow=window.open(staticEmptyWindow, iForm.target, windowFeature);
            iForm.submit();
        }
        else {//AJAX
            // Federico 25/08/09: le '&' in fieldVal devono essere escapate [EB 118]
            iForm.lookup_fieldVal.value = replaceAll(iForm.lookup_fieldVal.value, '&', '%26');

            var params = buildUrlForGet("", true, true, true, true) +
                "&selid=" + iForm.selid.value + "&verbo=lookup_response&lookup_campi=" + iForm.lookup_campi.value +
                "&lookup_fieldVal=" + iForm.lookup_fieldVal.value + "&lookup_alias=" + iForm.lookup_alias.value +
                "&lookup_titolo=" + iForm.lookup_titolo.value + "&lookup_xq=" + iForm.lookup_xq.value +
                "&lookup_new=" + iForm.lookup_new.value + "&lookup_db=" + iForm.lookup_db.value +
                "&qord=" + iForm.qord.value + "&transformJava=ajax";
            if (!lookupIsBusy) {
                setLastFieldsUsedLookup(iForm.lookup_campi.value, iForm.lookup_fieldVal.value);
                setNewRecordLookupVars(iForm.lookup_campi.value, iForm.lookup_titolo.value, iForm.lookup_db.value);
                lookupIsBusy = true;
                jsXML.sendAsyncPost(getForm('hxpForm').uri.value, params, handleLookup, errorHandlerLookup, null);
            }
        }
    }

    requestForm.target = old_target;
    requestForm.verbo.value = old_verbo;
    requestForm.selid.value = old_selid;
    requestForm.lookup_new.value = old_newrecord;

    sourceForm.target = sold_target;
    sourceForm.verbo.value = sold_verbo;
    sourceForm.selid.value = sold_selid;
    sourceForm.lookup_new.value = sold_newrecord;

    //salvo parametri di hxpForm
    requestForm.qord.value = old_qord;
    requestForm.lookup_titolo.value = old_lookup_titolo;
    requestForm.lookup_campi.value = old_lookup_campi;
    requestForm.lookup_xq.value = old_lookup_xq;
    requestForm.lookup_new.value = old_lookup_new;
    requestForm.lookup_db.value = old_lookup_db;
    requestForm.lookup_fieldVal.value = old_lookup_fieldVal;
    requestForm.lookup_alias.value = old_lookup_alias;

    //salvo parametri di indexForm
    sourceForm.qord.value = sold_qord;
    sourceForm.lookup_titolo.value = sold_lookup_titolo;
    sourceForm.lookup_campi.value = sold_lookup_campi;
    sourceForm.lookup_xq.value = sold_lookup_xq;
    sourceForm.lookup_new.value = sold_lookup_new;
    sourceForm.lookup_db.value = sold_lookup_db;
    sourceForm.lookup_fieldVal.value = sold_lookup_fieldVal;
    sourceForm.lookup_alias.value = sold_lookup_alias;

    return false;
}

function getHtmlNode(inputNode, inputName)
{
    var _dad = inputNode.parentNode;
    for ( var i = 0; i < _dad.childNodes.length; i++ )
        if ( _dad.childNodes.item(i).name == inputName )
            return _dad.childNodes.item(i);
}

/* nel caso di onblur all'uscita del lookup occorre impostare il nuovo default (lookup.js) */
var nodeToSetDefault = null;

function onblurLookup(inputNode, aliasName, inputName, ord, aliasName1, hxp_inst_str)
{
    var fieldName;
    nodeToSetDefault = inputNode;
    var _inputName = inputName;
    if ( inputName.indexOf('[$hxp_instance()]') != -1 ) { //multistanza
        var dad = inputNode.parentNode;
        var theInputName = inputNode.name;

        // Federico 14/05/07: data la possibilita' di specificare una stringa diversa dal nome dell'input
        // che contiene "[$hxp_instance()]" o "$hxp_instance()" (usata per il calcolo del numero d'istanza)
        // [RW 0043770]
        if (typeof(hxp_inst_str) == 'undefined' || hxp_inst_str == null) {
            hxp_inst_str = theInputName;
        }

        var prefix = hxp_inst_str.substring(0, hxp_inst_str.lastIndexOf('['));

        if ( prefix.charAt(0) == '.') {
            prefix = prefix.substring(1);
        }

        while ( typeof(dad.id) == 'undefined' || dad.id.indexOf(prefix + '.') == -1 ) {
            dad = dad.parentNode;
        }
        var instNumber = dad.id.substring(dad.id.lastIndexOf('.') + 1);
        _inputName = inputName.replace('$hxp_instance()', instNumber);

        //caso di istanza figlia di multistanza
        if ( typeof(_inputName.indexOf('$hxp_fatherinstance()')) != 'undefined' ) {
            // var fatherInstNumber = childName.substring(childName.indexOf('[') + 1, childName.indexOf(']'));
            var id = dad.id;
            var fatherInstNumber = id.substring(id.indexOf('[') + 1, id.indexOf(']'));
            _inputName = _inputName.replace('$hxp_fatherinstance()', fatherInstNumber);
        }
    }
    if ( inputNode.value.length == 0 && inputNode.defaultValue.length != 0 ) { //svuotare tutti i campi del lookup
        if ( typeof(customEraseLookup) == 'undefined' || (typeof(customEraseLookup) != 'undefined' && customEraseLookup(_inputName) == true ) ) {
            //var fieldsArray = getHtmlNode(inputNode, 'lookup_campi_' + _inputName).value.split(';');
            var fieldsArray = getElementByName('lookup_campi_' + _inputName).value.split(';');
            for ( var i = 0 ; i < fieldsArray.length; i++ ) {
                fieldName = fieldsArray[i].split('=')[0];
                fieldName = fieldName.replace(/ /, '');
                for ( var j = 0; j < getForm("hxpForm").length; j++ ) {
                    //cancello campi di lookup (operazione molto costosa)
                    if ( getForm("hxpForm")[j].name == fieldName ) {
                        getForm("hxpForm")[j].value = "";
                        break;
                    }
                }
            }
        }
    }
    else {
        if ( inputNode.value != inputNode.defaultValue ) {
            if ( typeof(aliasName1) != 'undefined' ) {
                lookup(inputNode, aliasName, inputName, ord, aliasName1, hxp_inst_str);
            }
            else {
                lookup(inputNode, aliasName, inputName, ord, '', hxp_inst_str);
            }
            // metodo brutto per impedire il salvataggio di voci non vincolate
            inputNode.value = "";
        }
    }
    return false;
}

function editChkDate(theInput, verbose)
{
    var ret = true;
    lastChkResult = '';

    if ( theInput.value == '' )
        return true;

    ret = chkDate(theInput, true);

    if ( ret == false ){
        setTimeout(function(){theInput.focus()}, 10);
        theInput.select();
        lastChkResult = theInput;
        return false;
    }
    return ret;
}

/*
 * Created on: 04/05/2005
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Questa funzione somma alla data 'date' (espressa nel formato 'gg/mm/anno') il numero di
 * 				giorni 'days' e restituisce la data risultante.
 * 				Se 'formatDate'  true, la data risultante  nel formato 'gg/mm/anno'; se, invece, 'formatDate'
 * 				 false, la data restituita  nel formato 'annommgg'.
 */
function doSumDate(date, days, formatDate)
{
    var numericDate = RealDateToNum(date);		// numero di giorni trascorsi dall'1/1/0000
    var newNumericDate = numericDate + days;

    return NumToDate(newNumericDate, formatDate);
}

/*
 * Created on: 04/05/2005
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Questa funzione somma alla data contenuta nell'input 'theInput' (espressa nel formato 'gg/mm/anno')
 * 				il numero di giorni 'sumDays' e inserisce la data risultante nell'input 'destFieldName' (anche
 * 				questa data  nel formato 'gg/mm/anno').
 * 				Se 'theInput'  vuoto, il campo 'destFieldName' viene svuotato.
 * 				'verbose' indica alla funzione di controllo del formato della data inserita in 'theInput' se
 * 				stampare o meno un messaggio di errore.
 */
function editSumDate(theInput, verbose, sumDays, destFieldName)
{
    if (theInput.value == "" && typeof(getForm("hxpForm")[destFieldName]) != 'undefined') {
        // svuoto 'destFieldName'
        getForm("hxpForm")[destFieldName].value = "";

        return true;
    }

    // controllo della correttezza della data inserita in theInput
    if (!editChkDate(theInput, verbose)) {
        // la data inserita non  corretta
        return false;
    }

    // la data inserita  corretta --> procedo con la generazione della data da inserire in 'destFieldName'
    if (typeof(getForm("hxpForm")[destFieldName]) != 'undefined') {
        getForm("hxpForm")[destFieldName].value = doSumDate(theInput.value, sumDays, true);
    }
    else {
        alert("Campo \"" + destFieldName + "\" non trovato!");
        return false;
    }

    return true;
}

function chkField(theInput, confronto)
{
    var ret = true;
    lastChkResult = '';

    if ( theInput.value == '' )
        return true;

    ret = chkLength(theInput, confronto);

    if ( ret == false ){
        theInput.focus();
        theInput.select();
        lastChkResult = theInput;
        return false;
    }
    return ret;
}

//controllo in fase di editing del formato di un importo numerico: punti per separare le migliaia e virgola per la
//parte decimale
function editChkNumericFormat(theInput, verbose)
{
    var ret = true;
    lastChkResult = '';

    if ( theInput.value == '' )
        return true;

    ret = chkNumericFormat(theInput, verbose, '.', ',');

    if ( ret == false ){
        theInput.focus();
        theInput.select();
        lastChkResult = theInput;
        return false;
    }
    return ret;
}

function defaultTitle(theInputFile, prefix)
{

    var inputTitleName = theInputFile.name.slice(0, -5) + "@title";

    //vedi chiamata a questa funzione da parte di filelist.js
    if ( theInputFile.name.indexOf(".") != 0 && prefix.indexOf('xw:file') != -1 ) {
        var inputTitleName1 = "*" + inputTitleName;
        inputTitleName = "." + inputTitleName;
    }

    var separator = ( theInputFile.value.indexOf('\\') == -1 ) ? '/' : '\\';
    var val = theInputFile.value.substring(theInputFile.value.lastIndexOf(separator) + 1);
    var thisDad = theInputFile.parentNode;

    //simone -> non e' detto che gli elementi di una istanza siano figli... risalgo fino all'elemento
    //che contiene id=prefix cioe' quello che racchiude l'istanza... tutti gli elementi dell'istanza sono
    //suoi discendente
    while ( thisDad.id.length < prefix || thisDad.id.substring(0, prefix.length) != prefix )
        thisDad = thisDad.parentNode;

    var currInstInput = thisDad.getElementsByTagName("input");
    for (var i = 0; i < currInstInput.length; i++){
        if ( currInstInput.item(i).name == inputTitleName || currInstInput.item(i).name == inputTitleName1 )
            currInstInput.item(i).value = val;
    }

    return true;
}


var thesDad = null;
var thesField = null;
var thesTitle;

function showthesRel(inputNode, rel, keypath, startkey, field, windowTitle, db,forceradix)
{
    thesTitle = 'Gerarchica';

    if ( typeof(forceradix) == 'undefined' )
        forceradix=false;

    if ( typeof(field) != 'undefined' )
        thesField = field;

    if ( typeof(windowTitle) != 'undefined' && (! windowTitle==''))
        thesTitle = windowTitle;

    var val = null; //andr utilizzato per il seek

    if ( typeof(field) != 'undefined' && field.length > 0 ) {
        if ( field.indexOf('[$hxp_instance()]') != -1 ) {
            thesDad = inputNode.parentNode;

            var childName = thesDad.childNodes.item(0).name;
            if ( typeof(childName) == 'undefined' )	//bug fix temporaneo per mozilla
                childName = thesDad.childNodes.item(1).name;

            var instNumber = childName.substring(childName.lastIndexOf('[') + 1, childName.lastIndexOf(']'));
            field = field.replace('$hxp_instance()', instNumber);

            //caso di istanza figlia di multistanza
            if ( typeof(field.indexOf('$hxp_fatherinstance()')) != 'undefined' ) {
                var fatherInstNumber = childName.substring(childName.indexOf('[') + 1, childName.indexOf(']'));
                field = field.replace('$hxp_fatherinstance()', fatherInstNumber);
            }

            for ( var i = 0; i < thesDad.childNodes.length; i++ ) {
                if ( thesDad.childNodes.item(i).name == field)
                    val = thesDad.childNodes.item(i).value;
            }
        }
        else { //no multistanza
            thesDad = null;
            val = getForm("hxpForm")[field].value;
        }
        thesField = field;
    }

    var iForm;
    var old_target = getForm("hxpForm").target;
    var old_verbo = getForm("hxpForm").verbo.value;
    var old_xverb = getForm("hxpForm").xverb.value;
    var old_db = getForm("hxpForm").db.value;

    iForm = getForm("hxpForm");
    iForm.verbo.value = "showthes";
    iForm.xverb.value = "@" + rel; //per template in cui sfociare

    if ( typeof(db) != 'undefined' && db!='') {
        if (typeof(customGetDbShowtheRel) != 'undefined')
            db = customGetDbShowtheRel(old_db, db);
        iForm.db.value = db;
    }

    iForm.keypath.value = keypath; //canale del ths


    if ( val != null && (! forceradix))
        iForm.startkey.value = val;
    else
        iForm.startkey.value = startkey; //primo termine della relazione


    getForm("hxpForm").relation.value = rel; //relazione

    iForm.target = "thesWindow"; //iForm.target + 'lookup_titolario_child';

    /* Modifica di Federico del 06/10/2004.
     * Devo imporre l'uso delle scrollbars, se no Mozilla non le mostra mai nel thesauro gerarchico.
     */
    theTitolarioLookupWindow = window.open(staticEmptyWindow, iForm.target, "width=800,height=600,scrollbars");

    iForm.submit();
    theTitolarioLookupWindow.focus();

    getForm("hxpForm").target = old_target;
    getForm("hxpForm").verbo.value = old_verbo;
    getForm("hxpForm").xverb.value = old_xverb;
    getForm("hxpForm").db.value = old_db;

    return false;
}

function replaceLevel(nome, parteVecchia, parteNuova, level)
{

    //alert("replaceLevel "+level);

    var index = nome.indexOf("[");
    index = nome.indexOf("[", index + 1);

    if ( level == 1 && index == -1 )
        return nome;

    if ( level == 1 ) {

        //sostituisco tutti gli indici in posizione dispari
        var s = nome;
        var index = nome.indexOf("[");
        index = nome.indexOf("[", index + 1);
        while ( index != -1 ) {
            var s0 = s.substring(0, index);
            var index2 = s.indexOf("]", index);
            var s1 = s.substring(index, index2 + 1);
            var s2 = s.substring(index2 + 1);
            s1 = s1.replace(parteVecchia, parteNuova);
            s = s0 + s1 + s2;

            //alert(".... " + s)

            index = s.indexOf("[", index + 1);
            if ( index != -1 ) index = s.indexOf("[", index + 1);
        }

        //alert(nome + "->"  + s);

        return s;
    }

    else if ( level == -1 ) {

        //sostituisco tutti gli indici in posizione pari
        var s = nome;
        var index = nome.indexOf("[");
        while ( index != -1 ) {
            var s0 = s.substring(0, index);
            var index2 = s.indexOf("]", index);
            var s1 = s.substring(index, index2 + 1);
            var s2 = s.substring(index2 + 1);
            s1 = s1.replace(parteVecchia, parteNuova);
            s = s0 + s1 + s2;

            //alert(".... " + s)

            index = s.indexOf("[", index + 1);
            if ( index != -1 ) index = s.indexOf("[", index + 1);
        }

        //alert(nome + "->"  + s);

        return s;
    }

    else{//alert(nome + " parteVecchia: " +parteVecchia+" parteNuova: " +parteNuova +" risultato: "+ nome.replace(parteVecchia, parteNuova))

        //alert("trovo la stringa con parentesi graffe ad indice "+nome.indexOf(parteVecchia));

        return nome.replace(parteVecchia, parteNuova);
    }



}


function deleteWrongSubInstancesAndSetInnestedId(prefix, currInst, oldInstNumber, instNumber) {

    param_deleteWrongSubInstancesAndSetInnestedId(prefix, currInst, oldInstNumber, instNumber, "input");
    param_deleteWrongSubInstancesAndSetInnestedId(prefix, currInst, oldInstNumber, instNumber, "textarea");
    param_deleteWrongSubInstancesAndSetInnestedId(prefix, currInst, oldInstNumber, instNumber, "select");


}

function notDeleteWrongSubInstancesButSetInnestedId(prefix, currInst, oldInstNumber, instNumber) {
    // ********************************************************** //
    // Richiamata dalla removeInstance si preoccupa di rinumerare //
    // correttamente gli id interni senza rimuovere sottoistanze  //
    // ********************************************************** //
    param_SetInnestedId(prefix, currInst, oldInstNumber, instNumber, "input");
    param_SetInnestedId(prefix, currInst, oldInstNumber, instNumber, "textarea");
    param_SetInnestedId(prefix, currInst, oldInstNumber, instNumber, "select");


}


function loadIWobject(objname, filename, www) {
    //alert("Parametri in ingresso: "+ " --objname-- " + objname + " --filename-- " + filename + " --www-- " + www);
    var myurivalue=getForm('indexForm').elements["uri"].value;
    var mydbvalue=getForm('indexForm').elements["db"].value;
    var myhostvalue=getForm('indexForm').elements["host"].value;
    var myportvalue=getForm('indexForm').elements["port"].value;
    var thefilename="";

    var host = getHost();
    var port = window.location.port;
    if ( port.length > 0 ) {
        port = ":" + port;
    }
    var protocol = window.location.protocol;
    if(www) {
        if(filename!=''){
            thefilename=protocol + "//" + host + port + myurivalue + "?verbo=attach&db=" + mydbvalue + "&id="+  realEscape(filename) + "&host=" + myhostvalue + "&port=" + myportvalue;
        }
        else {
            thefilename=protocol+ "//" + host+ port+myurivalue;
            thefilename=thefilename.substring(0,thefilename.lastIndexOf("/")+1)+"logo.jpg";
            // alert("AO" +thefilename);
        }
    }
    var iw0bjects=getForm("hxpForm").getElementsByTagName("object");
    for (var i=iw0bjects.length-1;i>=0;i--) {
        if(typeof(iw0bjects.item(i).getAttribute("id"))!='undefined') {
            // alert("["+getForm("hxpForm").elements[i].id+"]==["+objname+"]");
            if(iw0bjects.item(i).getAttribute("id")==objname) {
                if(typeof(iw0bjects.item(i).GetImageInfo )=='undefined' ) {
                    // da sostituire con funzione intelligente quando la chieder cicognani...per ora sufficiente ai beni culturali
                    iw0bjects.item(i).parentNode.parentNode.parentNode.parentNode.parentNode.innerHTML="";
                    alert("INSERIMENTO MODIFICA IMMAGINI DISABILITATO ");
                    break;
                }
                else {
                    // alert("riattiva "+getForm("hxpForm").elements[i].parentNode.parentNode.parentNode.parentNode.parentNode.innerHTML);
                    // alert('TROVATO IW DA AGGIORNARE '+document.forms[1].elements[i].id);
                    if(www) {
                        iw0bjects.item(i).DownloadParam(thefilename, '', getForm("hxpForm").item(i).downloadNone);
                    }
                    else {
                        if(filename!='') {
                            thefilename=filename;
                            iw0bjects.item(i).SetFile(thefilename);
                            iw0bjects.item(i).Redraw();
                        }
                        else {
                            thefilename=protocol+ "//" + host+ port+myurivalue;
                            thefilename=thefilename.substring(0,thefilename.lastIndexOf("/")+1)+"logo.jpg";
                            iw0bjects.item(i).DownloadParam(thefilename, '', iw0bjects.item(i).downloadNone);
                        }
                    }
                    iw0bjects.item(i).LoadMenu("[menu]\n"
                            //+"1 =1001 Salva\n"
                            //+"2 =separator\n"
                            +"1 = 1011 Formato acquisizione\n"
                            +"2 = 1014 Seleziona sorgente\n"
                            +"3 = 1015 Acquisizione\n"
                            +"4 = 1013 Informazioni\n");
                    break;
                }
            } //fine controllo id non nullo
        } //fine se pu andare IW
    } //fine for elementi form
}


function letmesee (thestring)
{
    // 666's late nate idea ... i'm in the 830666 hex state ...
    var helperwin;

    helperwin=window.open('../../../formatter/html/templates/helper.html');
    helperwin.document.write(thestring);

}


function param_deleteWrongSubInstancesAndSetInnestedId(prefix, currInst, oldInstNumber, instNumber, param)
{

    var currInstInput=currInst.getElementsByTagName(param)

    //imposto id dell'istanza innestata
    for (var i=0; i<currInstInput.length; i++){
        var name = currInstInput.item(i).getAttribute("name");
        if ( name.indexOf('[', name.indexOf('[') + 1) != -1 ) { //si tratta di multistanza figlio di multistanza
            if (  name.substring(name.lastIndexOf('[') + 1, name.lastIndexOf(']')) == 0 ) { //si tratta dell'istanza innestata zero

                //				var id = name.substring(1, name.lastIndexOf('[')) + '.0';

                //ANCORA SPERIMENTALE
                var id = name.substring(name.indexOf(".") + 1, name.lastIndexOf('[')) + '.0';

                var old_id = id.replace('[' + instNumber + ']', '[' + oldInstNumber + ']');
                var el = document.getElementById(old_id);

                if ( el != null ) {
                    //alert("el.id: " + el.id)
                    nodeName = el.nodeName;
                    var els = currInst.getElementsByTagName(nodeName)
                    for ( var j = 0; j < els.length; j++ )
                        if ( els.item(j).id == old_id ){
                            //alert(els.item(j).id +" -> " +  id)
                            els.item(j).id = id;}
                }
            }
        }
    }
    var currInstInput=currInst.getElementsByTagName(param)	;
    //cancello le istanze innestate superflue
    for (var i=0; i<currInstInput.length; i++){
        var name = currInstInput.item(i).getAttribute("name");



        if ( name.indexOf('[', name.indexOf('[') + 1) != -1 ) {
            if (  name.substring(name.lastIndexOf('[') + 1, name.lastIndexOf(']')) != 0 ) {

                var prefix = name;

                //alert("prefix "+ prefix)

                if ( name.charAt(0) == '.' )
                {prefix = name.substring(1);

                }
                if( name.indexOf("*x_files.")==0)
                {
                    prefix = name.substring(9);

                }

                prefix = prefix.substring(0, prefix.indexOf('['));

                var thisDad = currInstInput.item(i).parentNode;

                //alert("prefix "+prefix);
                try{
                    while ((typeof(thisDad.id) == 'undefined' || thisDad.id.length < prefix || thisDad.id.substring(0, prefix.length) != prefix) )
                    {thisDad = thisDad.parentNode;}

                }
                catch(e)
                {alert(e); }
                thisDad.parentNode.removeChild(thisDad);
                currInstInput=currInst.getElementsByTagName(param)	;
                i--;
            }

        }
    }
}

function param_SetInnestedId(prefix, currInst, oldInstNumber, instNumber, param) {
    // alert(prefix + " " +  currInst +" " + oldInstNumber + " **> " + instNumber+" "+param);
    var currInstInput = currInst.getElementsByTagName(param);
    // imposto id dell'istanza innestata
    for (var i = 0; i < currInstInput.length; i++) {
        var name = currInstInput.item(i).getAttribute("name");
        if ( name.indexOf('[', name.indexOf('[') + 1) != -1 ) {
            // si tratta di multistanza figlio di multistanza
            if (  name.substring(name.lastIndexOf('[') + 1, name.lastIndexOf(']')) == 0 ) {
                // si tratta dell'istanza innestata zero
                // var id = name.substring(1, name.lastIndexOf('[')) + '.0';
                //ANCORA SPERIMENTALE
                var id = name.substring(name.indexOf(".") + 1, name.lastIndexOf('[')) + '.0';
                var old_id = id.replace('[' + instNumber + ']', '[' + oldInstNumber + ']');
                var el = document.getElementById(old_id);
                if ( el != null ) {
                    // alert("el.id: " + el.id);
                    nodeName = el.nodeName;
                    var els = currInst.getElementsByTagName(nodeName);
                    for ( var j = 0; j < els.length; j++ ) {
                        if ( els.item(j).id == old_id ) {
                            // alert(els.item(j).id +" -> " +  id);
                            els.item(j).id = id;
                        }
                    }
                }
            }
        }
    }
    var currInstInput = currInst.getElementsByTagName(param);
}

function addInputForTitle(newInst, prefix) {
    var elements = newInst.getElementsByTagName("input");
    var elementToCopy = null;
    var toCopy = true;
    var beforeHere = null;
    var toRemove = null;
    for ( var i = 0; i < elements.length; i++ ) {
        var name = elements.item(i).getAttribute("name");

        //se se  gi presente input di tipo file non aggiungerlo (inserimento e nuove istanze gi complete da modifica)
        if ((prefix == 'ATTACH' || prefix == 'IMGS') && name.substring(name.length - 6) == '.@name') {
            var type = elements.item(i).getAttribute("type");
            if (type == 'hidden') {
                toRemove = elements.item(i);
            }
            else if (type == 'file') {
                toCopy = false;
                break;
            }
        }

        if ( name.substring(name.length - 6) == '.@name' && ( name.indexOf("files.xw:file") == 0 || name.indexOf("immagini.xw:file") == 0 ) ) {
            toCopy = false;
            break;
        }
        if ( name.substring(name.length - 7) == '.@title' ) {
            elementToCopy =  elements.item(i);
        }
        if ( name == 'INSERT_BEFORE_HERE' )
            beforeHere = elements.item(i);
    }

    if ( toCopy == true ) {
        var newInstTitle = elementToCopy.cloneNode(true);
        newInstTitle.value = "";

        if (prefix == 'ATTACH' || prefix == 'IMGS'){//file senza IW
            newInstTitle.type = "file";
            newInstTitle.name = elementToCopy.name.replace(".@title", ".@name");
            if (toRemove != null)
                toRemove.parentNode.removeChild(toRemove);
        }
        else
            newInstTitle.name = elementToCopy.name.substring(1).replace(".@title", ".@name");

        if ( beforeHere == null )
            beforeHere = elementToCopy;

        //per compatibilit con fissaggio di width input in pixel (internet explorer bug)
        if (typeof(elementToCopy.currentStyle)!='undefined' && typeof(elementToCopy.currentStyle.hx2p_width)!='undefined') {
            newInstTitle.style.width = 0;
        }

        beforeHere.parentNode.insertBefore(newInstTitle, beforeHere);

        //per compatibilit con fissaggio di width input in pixel (internet explorer bug)
        if ( typeof(newInstTitle.currentStyle.hx2p_width) != 'undefined' ) {
            var pc_width = newInstTitle.currentStyle.hx2p_width;
            pc_width = pc_width.substring(0, pc_width.length - 1);
            anc = getAncestorTD(newInstTitle);
            if ( anc != null ) {
                var res_width = anc.clientWidth*pc_width/100;
                newInstTitle.style.width = res_width;
            }
        }


        var elements2 = newInst.getElementsByTagName("span");
        for ( var i = 0; i < elements2.length; i++ ) {
            var name = elements2.item(i).getAttribute("name");
            if ( name == 'INSERT_THIS' )
                elements2.item(i).style.display = '';
        }
    }
}

function attachAddInstance(newInst, prefix) {

    /*
    var id = newInst.getAttribute("id");

    alert(id);
    var startNumber = id.lastIndexOf(".");
    var index = parseInt(id.substring(startNumber+1, id.length), 10);
    alert(index);

	for (var j = index; document.getElementById(getInstanceId(prefix, j)) != null; j++) {
		setPageWithValue(prefix, j, +1);
	}
    */

    if ( prefix == "files.xw:file" || prefix == 'ATTACH' || prefix == 'IMGS') {
        // nel caso di file devo aggiungere campo per percorso locale di upload
        addInputForTitle(newInst, prefix);
    }
    else if ( prefix == "immagini.xw:file" ) {
        // nel caso di immagini tolgo eventuali style dovuto a immagine selezionata per iw
        addInputForTitle(newInst, prefix);
        var instNum = newInst.id.substring(newInst.id.lastIndexOf(".") + 1);
        //var selectedImage = getElementByName("immagini.xw:file[" + instNum + "].@name");
        var selectedImage = getElementByNameWithRoot(document.getElementById(getInstanceId(prefix, instNum)), "immagini.xw:file[" + instNum + "].@name");
        //var selectedImageTitle = getElementByName(".immagini.xw:file[" + instNum + "].@title");
        var selectedImageTitle = getElementByNameWithRoot(document.getElementById(getInstanceId(prefix, instNum)), ".immagini.xw:file[" + instNum + "].@title");
        if ( selectedImageTitle == null ) {
            //selectedImageTitle = getElementByName("*immagini.xw:file[" + instNum + "].@title");
            selectedImageTitle = getElementByNameWithRoot(document.getElementById(getInstanceId(prefix, instNum)), "*immagini.xw:file[" + instNum + "].@title");
        }
        selectedImageTitle.className = selectedImage.className = "input";
    }
}




function attachRemoveInstance(prefix, id, thisNode)
{
    if (typeof(getPrefix) == 'undefined')
        return;

    var l_prefix = getPrefix(prefix);

    var startNumber = id.lastIndexOf(".");
    var index = parseInt(id.substring(startNumber+1, id.length), 10);

	for (var j = index; document.getElementById(getInstanceId(prefix, j)) != null; j++) {
		setPageWithValue(prefix, j, -1);
	}

    //immagini e file allegate (senza iw): eliminazione dell'istanza zero
    if ( ( prefix == "ATTACH" || prefix == "IMGS" ) && id == "" ) {
        addInstance(prefix);
        removeInstance(prefix, thisNode);

    }

    //	in modifica immagini e file precedentemente allegate (senza iw): eliminazione dell'istanza zero
    if ( ( prefix == "existingATTACH" || prefix == "existingIMGS" ) && id == "" ) {
        var thisDad=thisNode.parentNode;
        while ( typeof(thisDad.id) == 'undefined' || thisDad.id.length < prefix || thisDad.id.substring(0, prefix.length) != prefix )
            thisDad = thisDad.parentNode;
        thisDad.parentNode.removeChild(thisDad);
    }

    //cancello istanza zero che  unica istanza di allegati tramite iw
    if ( prefix == "files.xw:file" && id == "" ) {
        addInstance(prefix);
        removeInstance(prefix, thisNode);
    }

    //nel caso di immagini devo visualizzare l'immagine successiva a quella selezionata se esiste, altrimenti la precedente
    if ( prefix == "immagini.xw:file" ) {
        var instNum = id.substring(id.lastIndexOf(".") + 1);
        //elimino l'istanza zero ed e' l'unica istanza
        if ( id == "") {
            addInstance(l_prefix);
            removeInstance(l_prefix, thisNode);
            if ( typeof(document.IW) != 'undefined' && prefix == "immagini.xw:file" )
                document.IW.setFile("");
        }
        else {
            //tento il successivo con .
            var selectedImage = getElementByName(l_prefix + "[" + instNum + "].@name");
            var selectedImageTitle = getElementByName("." + l_prefix + "[" + instNum + "].@title");

            //tento il successivo con *
            if ( selectedImageTitle == null )
                selectedImageTitle = getElementByName("*" + l_prefix + "[" + instNum + "].@title");

            //tento il precedente con .
            if ( selectedImageTitle == null ) {
                --instNum;
                selectedImage = getElementByName(l_prefix + "[" + instNum + "].@name");
                selectedImageTitle = getElementByName("." + l_prefix + "[" + instNum + "].@title");
            }

            //tento il precedente con *
            if ( selectedImageTitle == null ) {
                selectedImageTitle = getElementByName("*" + l_prefix + "[" + instNum + "].@title");
            }

            setSelectedImage(selectedImage, selectedImageTitle);

        }
    }

    if(id=="")
    {
        /*postelaborazione per rimettere la immagine di extraway quando cancello l' ultima istanza*/
        var mynodeList=document.getElementById(prefix+".0");
        if (null != mynodeList){
            var actnl=mynodeList.getElementsByTagName("OBJECT");
            for (var i = 0; i < actnl.length; i++) {
                if(actnl.item(i).getAttribute("id")!=null) {
                    if(actnl.item(i).getAttribute("id").length>8 && actnl.item(i).getAttribute("id").substring(actnl.item(i).getAttribute("id").length-8,actnl.item(i).getAttribute("id").length)=='.preview') {
                        //alert(actnl.item(i).getAttribute("id"));
                        loadIWobject(actnl.item(i).getAttribute("id"),'',true);
                    }
                }
            }
        }


        //loadIWobject(getForm("hxpForm").elements[i].id,'',true);

    }

}


function closeWin()
{
    self.close();
    return false;
}


function getistantThRadix(hxpvalue,instNumber,fatherInstNumber)
{
    var target= hxpvalue.replace('$hxp_instance()', instNumber);

    target=target.replace('$hxp_fatherinstance()', fatherInstNumber);


    for (var i=0;getForm("hxpForm").length;i++){
        if(target==getForm("hxpForm").elements[i].name){
            return getForm("hxpForm").elements[i].value;
        }
    }
    return("");

}

function thVincolato(inputNode,
        numTitles4Page,
        field,
        radice,
        relazione,
        chiave,
        insRight,
        delRight,
        windowTitle,
        iscascade)
{

    if(field.indexOf(parsedInstanceKey)==0)
    {field=field.substring(parsedInstanceKey.length);
    }

    thesTitle = 'Thesauro Vincolato';

    if ( typeof(windowTitle) != 'undefined' )
        thesTitle = windowTitle;

    var iForm, val;

    //Fabio 10/09/2004
    var sourceForm = getForm("hxpForm");
    var requestForm = getForm('indexForm');
    //var sourceForm = getForm("hxpForm");
    //var requestForm = getForm("hxpForm");

    var old_target = requestForm.target;
    var old_verbo = requestForm.verbo.value;
    var old_xverb = requestForm.xverb.value;
    var old_pageCount = requestForm.pageCount.value;
    var old_lookup_new = requestForm.lookup_new.value;
    var sold_target = sourceForm.target;
    var sold_verbo = sourceForm.verbo.value;
    var sold_xverb = sourceForm.xverb.value;
    var sold_pageCount = sourceForm.pageCount.value;
    var sold_lookup_new = sourceForm.lookup_new.value;

    // gestione del posizionamento (mantenuto per compatibilit con il posizionamento nei vocabolari)
    var old_keypath = requestForm.keypath.value;
    var sold_keypath = sourceForm.keypath.value;

    // "view" viene impiegato per trasmettere il titolo del thesauro
    var old_view = requestForm.view.value;
    var sold_view = sourceForm.view.value;
    requestForm.view.value = thesTitle;

    /* Uso dei checkbox nei thesauri vincolati.
     *
     * Modifica di Federico del 02/09/2004.
     * L'uso dei chekbox nei thesauri vincolati in inserimento/modifica deve essere a discrezione
     * dell'applicazione e non nella parte generica.
     */

    // thVOptions viene utilizzato per attivare i checkbox al posto dei radio button.
    var old_thVOptions = requestForm.thVOptions.value;
    var sold_thVOptions = sourceForm.thVOptions.value;

    // utilizzata per inizializzare correttamente getForm("hxpForm").thVOptions
    var useChkBox = false;

    /* Modifica di Federico del 13/01/2005: non  assolutamente detto che un attributo ripetibile singolo (cio
     * una riga ripetibile con un solo input al suo interno) termini con '[$hxp_instance()]'.
     * Questo, infatti,  vero solo se si tratta di un elemento del documento xml; quando, invece, il
     * valore dell'input deve essere salvato in un attributo di un elemento del doc. xml, field termina con
     * '.@nome_attributo'.
     * Il test '&& (field.indexOf('[$hxp_instance()]') + 16) == (field.length - 1)'  stato, quindi, eliminato,
     * in modo che sia il metotodo custom 'customUseChkBoxMultistDefault' a decidere come inizializzare 'useChkBox'
     * a seconda del valore di 'field'.
     */
    if (field.indexOf('[$hxp_instance()]') != -1) {
        /* Caso di attributi multistanza.
         * Se esiste, chiamo una funzione custom per inizializzare la variabile useChkBox
         * (l'applicazione potrebbe volere i checkbox anche in inserimento/modifica dei
         * campi multistanza).
         */
        if (typeof(customUseChkBoxMultistDefault) != 'undefined') {
            useChkBox = customUseChkBoxMultistDefault(field);
        }
    }

    //alert("thesTitle: " + thesTitle);

    if ( numTitles4Page == 'DEF' )
        numTitles4Page = 15;

    //multistanza - necessario poiche' non e' possibile modificare dinamicamente onclick di elemento
    if ( field.indexOf('[$hxp_instance()]') != -1 ) {
        dad = inputNode.parentNode;

        var inputName = inputNode.name;
        var prefix = inputName.substring(0, inputName.lastIndexOf('['));

        if ( prefix.charAt(0) == '.')
            prefix = prefix.substring(1);
        while ( typeof(dad.id) == 'undefined' || dad.id.indexOf(prefix + '.') == -1 )
            dad = dad.parentNode;

        var instNumber = dad.id.substring(dad.id.lastIndexOf('.') + 1);

        //caso di istanza figlia di multistanza
        if ( field.indexOf('$hxp_fatherinstance()') != -1 ) {
            var id = dad.id;
            var fatherInstNumber = id.substring(id.indexOf('[') + 1, id.indexOf(']'));
            field = field.replace('$hxp_fatherinstance()', fatherInstNumber);
        }

        field = field.replace('$hxp_instance()', instNumber);
        val = getElementByName(field).value;
    }
    else { //no multistanza
        dad = null;
        val = getForm("hxpForm")[field].value;
    }

    if(iscascade) {
        //alert (radice.substring(0,9));
        var tempradix=radice;
        radice=getistantThRadix(radice,instNumber,fatherInstNumber);
        //alert(radice);
        if(radice=="") {
            alert('Selezionare un valore per '+tempradix);
            return;
        }
    }

    //iForm = getForm("hxpForm");
    iForm=requestForm;
    iForm.lookup_campi.value = radice + "|" + relazione + "|" + chiave + "|" + field;
    iForm.lookup_fieldVal.value = val;

    if ( typeof(insRight) != 'undefined' ) {
        iForm.lookup_new.value = insRight;
        if ( typeof(delRight) != 'undefined' )
            iForm.lookup_new.value += "|" + delRight;
    }
    else
        iForm.lookup_new.value = "";

    iForm.pageCount.value = numTitles4Page;
    iForm.verbo.value = "thesauro_response";
    iForm.xverb.value = "";

    /* Modifica di Federico del 15/10/2004:
     * al posto di dbTable ora viene utilizzata la tupla 'thVOptions' per usare i checkbox al posto dei
     * radio button nel thesauro vincolato (si veda anomalia 0022367).
     * Il nome di tale tupla  volutamente generico (cio non riferito all'uso dei checkbox) in modo
     * che possa essere utilizzata per trasmettere anche altre opzioni relative ai th vincolati
     * (possibili usi futuri).
     */
    if ( useChkBox )
        /* thVOptions deve essere 'useChkBox' per attivare i checkbox al posto dei radio button.
         * Questa esigenza si ha solo nel caso di inserimento/modifica di campi multistanza
         * (esigenza di XSpring).
         */
        iForm.thVOptions.value = "useChkBox";
    else
        // thVOptions deve essere '' per attivare i radio button al posto dei checkbox
        iForm.thVOptions.value = "";

    iForm.target = iForm.target + 'thvincolato_child';
    var windowFeature = "width=620 height=520, scrollbars"; // aggiunte le scrollbars

    if ( typeof(customSetWindowFeature) != 'undefined' )
        windowFeature = customSetWindowFeature();
    theIndexWindow=window.open(staticEmptyWindow, iForm.target, windowFeature);
    theIndexWindow.focus();

    // gestione del posizionamento (mantenuto per compatibilit con il posizionamento nei vocabolari)
    iForm.keypath.value = chiave;

    // RW 0035170
    if (thNodeToSetDefault != null) {
        if (thNodeToSetDefault.name != field) {
            thNodeToSetDefault = getElementByName(field);
        }
    }
    else {
        thNodeToSetDefault = getElementByName(field);
    }

    iForm.submit();
    requestForm.target           = old_target;
    requestForm.verbo.value      = old_verbo;
    requestForm.xverb.value      = old_xverb;
    requestForm.pageCount.value  = old_pageCount;
    requestForm.lookup_new.value = old_lookup_new;
    requestForm.view.value       = old_view;
    requestForm.thVOptions.value = old_thVOptions;
    requestForm.keypath.value    = old_keypath;
    sourceForm.target            = sold_target;
    sourceForm.verbo.value       = sold_verbo;
    sourceForm.xverb.value       = sold_xverb;
    sourceForm.pageCount.value   = sold_pageCount;
    sourceForm.lookup_new.value  = sold_lookup_new;
    sourceForm.view.value        = sold_view;
    sourceForm.thVOptions.value  = sold_thVOptions;
    sourceForm.keypath.value     = sold_keypath;

    return false;
}

/* nel caso di onblur all'uscita del lookup occorre impostare il nuovo default (thesauro.js) */
var thNodeToSetDefault = null;

function onblurThVincolato(inputNode, numTitles4Page, field, radice, relazione, chiave, insRight, delRight, iscascade)
{
    thNodeToSetDefault = inputNode;
    var _inputName = field;

    if ( inputNode.value.length == 0 && inputNode.defaultValue.length != 0 )
        return false;

    if ( inputNode.value != inputNode.defaultValue ) {
        //		metodo brutto per impedire il salvataggio di voci non vincolate
        thVincolato(inputNode, numTitles4Page, field, radice, relazione, chiave, insRight, delRight, iscascade);
        inputNode.value = "";
    }

    return false;
}

/*apre la pagina di inserimento di un documento della tipologia specificata da name*/
function insTableDoc(name){
    getForm("hxpForm").verbo.value = "docEdit";
    getForm("hxpForm").xverb.value = "";
    getForm("hxpForm").physDoc.value=0;
    getForm("hxpForm").pos.value=0;
    getForm("hxpForm").selid.value = "";
    getForm("hxpForm").dbTable.value = '@' + name;
    getForm("hxpForm").submit();
    return false;
}

/*apre la pagina di inserimento di un documento di tipo repertorio:                       */
/*il repertorio appartiene alla tabella 'name' ha codice 'codRep' e descrizione 'descrRep'*/
function insTableDocRep(name,codRep,descrRep){
    getForm("hxpForm").verbo.value = "docEdit";
    getForm("hxpForm").xverb.value = "";
    getForm("hxpForm").physDoc.value=0;
    getForm("hxpForm").pos.value=0;
    getForm("hxpForm").selid.value = "";
    getForm("hxpForm").dbTable.value = '@' + name;
    if (codRep.indexOf("personalView_") == 0) {
        getForm("hxpForm").personalView.value = codRep.substring(codRep.indexOf("_") + 1);
        codRep = "";
        descrRep = "";
    }
    getForm("hxpForm").codice_rep.value = codRep;
    getForm("hxpForm").descrizione_rep.value = descrRep;
    getForm("hxpForm").submit();
    return false;
}

/**
 * Apre una nuova finestra sugli indici
 */
function openIndex(inputNode,
        qForm,   // la form con cui interagisce lo user
        keyPath, // identifica la chiave negli indici
        startKey,// posizionamento
        winAppearance, //aspetto della finestra da aprire
        shwMode, // imposta la modalit di formattazione ('dt' per data)
        common,  // parte comune (se contiene '|^|' allora la parte della chiave che precede '|^|' viene scartata)
        threl,   // opzionalmente l'indice della relazione con cui attingere
        // la descrizione associata alla chiave (classificazioni)
        theInput)// opzionalmente l'input dove depositare l'esito della selezione
{//alert("keyPath=" + keyPath + "\nstartKey=" + startKey  + "\nshwMode=" + shwMode + "\nthrel=" + threl + "\ntheInput=" + theInput);
    var iForm;
    var qKey;
    var element;
    var LocalDad;
    iForm=getForm('indexForm');
    proArch="";
    if(theInput.indexOf(parsedInstanceKey)==0) {
        theInput=theInput.substring(parsedInstanceKey.length);
    }
    // multistanza - necessario poiche' non e' possibile modificare dinamicamente onclick di elemento
    if ( theInput.indexOf('[') != -1 ) {
        LocalDad = inputNode.parentNode;
        var inputName = inputNode.name;
        var prefix = inputName.substring(0, inputName.lastIndexOf('['));
        if ( prefix.charAt(0) == '.') {
            prefix = prefix.substring(1);
        }
        while ( LocalDad && (typeof(LocalDad.id) == 'undefined' || LocalDad.id.indexOf(prefix + '.') == -1) ) {
            LocalDad = LocalDad.parentNode;
        }
    }
    if(LocalDad) {
        var instNumber = LocalDad.id.substring(LocalDad.id.lastIndexOf('.') + 1);
        // caso di istanza figlia di multistanza
        if ( theInput.indexOf('[', theInput.indexOf('[') + 1) != -1 ) {
            var id = LocalDad.id;
            var fatherInstNumber = id.substring(id.indexOf('[') + 1, id.indexOf(']'));
            theInput = theInput.substring(0, theInput.indexOf('[') + 1) + fatherInstNumber + theInput.substring(theInput.indexOf(']'));
            // theInput.replace('$hxp_fatherinstance()', fatherInstNumber);
        }
        // theInput = theInput.replace('$hxp_instance()', instNumber);
        theInput = theInput.substring(0, theInput.lastIndexOf('[') + 1) + instNumber + theInput.substring(theInput.lastIndexOf(']'));
        // alert(theInput);
        val = getElementByName(theInput).value;
        // alert(instNumber + ' ' + fatherInstNumber);
    }
    else {
        // no multistanza
        LocalDad = null;
        var hxpF = getForm("hxpForm");
        val = hxpF[theInput].value;
    }

    if("undefined"!=typeof(customGetKeyName)) {
        keyPath=customGetKeyName(keyPath);
    }
    if(("undefined"!=typeof(theInput))&&(""!=theInput)) {
        // element=theInput;
        qKey=theInput;
        // element=qForm[qKey];
        element=getElementByName(qKey);

    }
    else {
        if ("undefined"!=typeof(customGetIndexedElement)) {
            qKey=customGetIndexedElement(keyPath);
            element=qForm[qKey];
        }
        else {
            proArch="";
            if("undefined"!=typeof(getNowArch)) {
                proArch="#"+getNowArch(getForm("hxpForm").db.value);
            }
            qKey="["+keyPath+"]"+proArch;
            element=qForm[qKey];
            if(!element) {
                qKey="["+keyPath+"]";
                element=qForm[qKey];
            }
        }
    }
    /*
     * if(!element) {alert("openIndex: campo di input \""+qKey+"\" non trovato");}
     */
    if("undefined"!=typeof(qForm["iFocus"])) {
        qForm["iFocus"].value=qKey;
    }
    if(element&&element.value) {
        startKey=element.value.toUpperCase();
    }
    if(startKey.substring(0,1)=='"') {
        startKey=startKey.substring(1,startKey.length);
    }
    keyPath=chkKeyPath(keyPath);
    iForm.verbo.value='showindex';
    iForm.threl.value=checkVal(threl);
    iForm.cPath.value=checkVal(common);
    iForm.doubleKey.value=(' '==checkVal(common)?"1":"0");
    iForm.shwMode.value=checkVal(shwMode);
    iForm.sele.value='';
    iForm.startkey.value=checkVal(common)+checkVal(startKey);
    // mai ricerca spettrale
    iForm.selid.value="";
    // per riempimento da index al ritorno
    if ( theInput.charAt(0) == '[' ) {
        theInput = theInput.slice(1,-1);
    }
    if ( typeof(theInput) != 'undefined' ) {
        // elimino le parentesi '[' e ']'
        iForm.fillField.value = unescape(theInput);
    }
    else {
        iForm.fillField.value = unescape(keyPath);
    }
    iForm.keypath.value=unescape(keyPath);
    // Valorizza tupla per differenziazione comportamento indice dalla ricerca
    iForm.destPage.value = 'docEdit';

    theIndexWindow=window.open(staticEmptyWindow,iForm.target,getAppearance(winAppearance));
    iForm.submit();
    return false;
}


function getAppearance(configuration)
{
    switch(configuration){
    case 'idx1': return "width=620 height=520";
    case 'idxCustom': return customSetWindowFeature();
    case '' : default: return "width=620 height=520"
    }
}


function chkKeyPath(keyPath)
{if(keyPath.indexOf('/')!=-1&&keyPath.indexOf('@')==-1&&keyPath[keyPath.length-1]!="/")keyPath+="/";
return keyPath;
}

function checkVal(val){return(typeof(val)!='undefined'?val:'');}


function defaultFileTitle_x(theInput,thePreview) {
    //alert('heInput.value '+theInput.value);
    //alert('theInput.name '+theInput.name);
    //alert(thePreview);
    if('undefined' != thePreview) {
        //alert('aggiorno oggetto IW con ID '+thePreview);
        //thePreview.SetFile(theInput);
        for (var i=0;i<getForm("hxpForm").length;i++) {
            // alert(document.forms[0].elements[i].name + " " + document.forms[0].elements[i].id );
            if(getForm("hxpForm").elements[i].id==thePreview) {
                //alert('trovato');
                //alert(document.forms[0].elements[i].id);
                //alert(document.forms[0].elements[i].name);
                getForm("hxpForm").elements[i].SetFile(theInput.value);
                getForm("hxpForm").elements[i].Redraw();
                var imginf=getForm("hxpForm").elements[i].GetImageInfo();
                // Gregorio 22/08/2005: aggiunto test su sizeMaxImg e cio se == '' non vengono
                //                      effettuati i test sulla dimensione massima dell'immagine
                if (getForm("hxpForm").sizeMaxImg != 'undefined') {
                    if (getForm("hxpForm").sizeMaxImg.value != '') {
                        var OccupazioneImmagineCorrente = parseInt(trim_str(imginf.substr(imginf.indexOf("Occupazione")+11)), 10);
                        var MassimaOccupazioneImmagine = parseInt(getForm("hxpForm").sizeMaxImg.value, 10)*1024;
                        if(OccupazioneImmagineCorrente > MassimaOccupazioneImmagine) {
                            alert("Superata la dimensione massima consentita per l'immagine (" + OccupazioneImmagineCorrente + " KB).\rLa dimensione massima  di " + MassimaOccupazioneImmagine + " KB.");
                            loadIWobject(getForm("hxpForm").elements[i].id,'',true);
                            return false;
                        }
                    }
                }
                if(getForm("hxpForm").elements[i].ImageWidth()==-24) {
                    alert("Operazione non consentita:\ril file allegato non sembra essere una immagine.");
                    loadIWobject(getForm("hxpForm").elements[i].id,'',true);
                    return false;
                }
                if ( typeof(customcheckImage) != 'undefined' ) {
                    if(customcheckImage(getForm("hxpForm").elements[i])==false) {
                        loadIWobject(getForm("hxpForm").elements[i].id,'',true);
                        return false;
                    }
                }
                if ( typeof(georeferencedImage) != 'undefined' ) {
                    georeferencedImage(getForm("hxpForm").elements[i].id,getForm("hxpForm").elements[i]);
                }
            }
        }
    }
    var inputName = theInput.name;
    inputName = inputName.substring(0, inputName.length - 4);
    // var theInputTitle = '.' + inputName + 'title'; //alert("theInputTitle "+theInputTitle);
    var theInputTitle = inputName + 'title'; //alert("theInputTitle "+theInputTitle);
    var separator = ( theInput.value.indexOf('\\') == -1 ) ? '/' : '\\';
    var val = theInput.value.substring(theInput.value.lastIndexOf(separator) + 1);
    var inputTitle = getElementByName(theInputTitle);
    /*  if ( inputTitle == null ) {
     theInputTitle = '*x_files.' + inputName + 'title';
     var inputTitle = getElementByName(theInputTitle);
     }*/
    inputTitle.value = val;
    return true;
}


function protocolla (isRepertorio,newPne,newPnce,codRep,descrRep)
{
    l_listOfNumerics = "";
    l_codRep = codRep;
    l_descrRep = descrRep;
    OpenWaitMsg();

    //alert(newPne+"+"+newPnce);
    if ( 'undefined' != typeof(getForm("hxpForm").bozzaDaProt) ) {
        getForm("hxpForm").bozzaDaProt.value = "DOC" ;
        if ( 'true' == isRepertorio ) {
            getForm("hxpForm").bozzaDaProt.value += ".REP" ;
        }
    }
    //alert(getForm("hxpForm").bozzaDaProt.value);
    getForm("hxpForm").pne.value = newPne; //'doc';
    getForm("hxpForm").pnce.value = newPnce; //'list_of_doc';
    getForm("hxpForm").verbo.value='docEdit';
    getForm("hxpForm").xverb.value='@save';
    if ( 'undefined' != typeof(codRep) ){
        if ( 'false' == isRepertorio ){
            alert("Le informazioni per la protocollazione sono incongruenti");
        }
        else getForm("hxpForm").codice_rep.value = codRep;
    }
    if ( 'undefined' != typeof(descrRep) ){
        if ( 'false' == isRepertorio ) {
            alert("Le informazioni per la protocollazione sono incongruenti");
        }
        else getForm("hxpForm").descrizione_rep.value = descrRep;
    }
    return setTimeout("return realSaveDocument();", 10);
}


function ufficioCompleto(theInput) {
    var name = '*' + theInput.name + '.@nome_persona';
    var input1 = getElementByName(name);
    if (theInput.checked)
        input1.value = 'Tutti';
    else
        input1.value = '';
    return true;
}

//RW0047596 - fcossu - Alert per invio email a tutti
function checkTutti(chkbox) {
	var hxpS = new _hxpSession(getForm('hxpForm'));
    var allarme = hxpS.getParameter("alertForTutti");
	if (chkbox.checked && !(allarme == 'no')) {
		var dad = chkbox.parentNode;
		var prefix = chkbox.name.substring(0, chkbox.name.indexOf('['));
		while ( typeof(dad.id) == 'undefined' || dad.id.indexOf('.') == -1 )
		dad = dad.parentNode;
		inst = dad.id.substring(dad.id.lastIndexOf('.') + 1);
		//fcossu 26/04/2010 Problemi inserimento TUTTI in conferenza di servizi [EB 727]
		var ufficio = getElementByName('*' + chkbox.name + '.@nome_uff').value;
		var ret = confirm("Stai mandando un'email a tutte le persone dell'ufficio "+ufficio+".\nPremere 'OK' per non far apparire pi questo messaggio.");
    	if (ret == true) {
    		hxpS.setParameter("alertForTutti", "no");
    	}
    }
}

/*
 * Created on: 06/05/2005
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Questa funzione conta i decimali del numero passato come parametro.
 * 				'number' deve essere una stringa e deve utilizzare ',' o '.' come separatori per i
 * 				decimali.
 */
function countDecimals(number)
{
    if (number.indexOf(',') != -1) {
        return number.length - number.indexOf(',') - 1;
    }
    else if (number.indexOf('.') != -1) {
        return number.length - number.indexOf('.') - 1;
    }

    return 0;
}

/*
 * Created on: 06/05/2005
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Questa funzione determina il separatore per i decimali utilizzato nel numero passato come parametro.
 * 				'number' deve essere una stringa e deve utilizzare ',' o '.' come separatori per i
 * 				decimali.
 */
function getDecimalSeparator(number)
{
    if (number.indexOf(',') != -1) {
        return ',';
    }
    else if (number.indexOf('.') != -1) {
        return '.';
    }

    return '';
}

/*
 * Created on: 06/05/2005
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Questa funzione converte in intero il float passato come parametro.
 * 				La conversione consiste nell'eliminare l'eventuale separatore dei decimali da 'number' e
 * 				il risultato restituito  di tipo intero.
 * 				'number' deve essere una stringa e deve utilizzare 'decSep'come separatore per i
 * 				decimali.
 */
function floatToInt(number, decSep)
{
    var tmp;

    if (typeof(decSep) == 'undefined') {
        decSep = getDecimalSeparator(number);
    }

    if (decSep != '') {
        tmp = replaceAll(number, decSep, ''); // elimino il separatore dei decimali
    }
    else {
        tmp = number;
    }

    // devo eliminare gli '0' iniziali, se no 'parseInt' restituisce 0
    firstNotZeroDigit = 0;

    for (j = 0; j < tmp.length; j++) {
        if (tmp.charAt(j) != '0') {
            firstNotZeroDigit = j;
            break;
        }
    }

    tmp = tmp.substring(firstNotZeroDigit);

    return parseInt(tmp);
}

/*
 * Created on: 06/05/2005
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Questa funzione converte in float l'intero passato come parametro.
 * 				La conversione consiste nell'aggiungere il separatore dei decimali 'decSep' in
 * 				posizione opportuna, basandosi sul numero di decimali 'numDec' passato come parametro.
 * 				'number' pu essere una stringa o un intero, e il risultato restituito dalla funzione
 * 				 di tipo stringa.
 */
function intToFloat(number, numDec, decSep)
{
    var stringNum = '' + number;

    if (numDec <= 0 || decSep == "") {
        return stringNum;
    }

    var resString = "";

    // ricopio 'stringNum' in 'resString' inserendo il separatore dei decimali in posizione opportuna
    if (stringNum.length > numDec) {
        for (var j = stringNum.length - 1; j >= 0 ; j--) {
            if (numDec == 0) {
                // inserisco il separatore dei decimali
                resString = decSep + resString;
            }

            resString = stringNum.charAt(j) + resString;
            numDec--;
        }
    }
    else {
        // stringNum.length <= numDec --> devo inserire degli '0' all'inizio per avere il numero di decimali richiesto
        resString = stringNum;

        for (k = 0; k < (numDec - stringNum.length); k++) {
            resString = '0' + resString;
        }

        resString = '0,' + resString; // aggiungo lo '0,' iniziale
    }

    return resString;
}

/*
 * Created on: 06/05/2005
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Questa funzione combina i numeri 'num1' e 'num2'(che sono stringhe) secondo l'operatore
 * 				'operator'.
 * 				Lo scopo di 'combineFloats'  quello di poter effettuare operazioni tra float,
 * 				evitando gli spiacevoli inconvenienti sui decimali che si ottengono in javascript
 * 				usando i float.
 * 				Questa funzione  in grado di operare anche con semplici interi.
 * 				Gli operatori supportati sono '+', '-', '*', '/' e '%'.
 */
function combineFloats(operator, num1, num2)
{
    var decimalSep1 = getDecimalSeparator(num1);
    var decimalSep2 = getDecimalSeparator(num2);

    var intNum1; 	 		// num1 trasformato in intero
    var intNum2; 	 		// num2 trasformato in intero
    var numDec1 = 0; 		// numero di decimali di num1
    var numDec2 = 0; 		// numero di decimali di num2
    var totDec = 0;  		// numero di decimali del risultato
    var resultDecSep = "";	// separatore dei decimali nel risultato

    if (decimalSep1 != '') {
        numDec1 = countDecimals(num1);
        resultDecSep = decimalSep1;
    }

    intNum1 = floatToInt(num1, decimalSep1);

    if (decimalSep2 != '') {
        numDec2 = countDecimals(num2);
        resultDecSep = decimalSep2;
    }

    intNum2 = floatToInt(num2, decimalSep2);

    var result;

    switch (operator) {
    case '+' :  // "pareggio" il numero dei decimali
        if (numDec1 > numDec2) {
            intNum2 *= (10 * (numDec1 - numDec2));
        }
        else if (numDec1 < numDec2) {
            intNum1 *= (10 * (numDec2 - numDec1));
        }

        result = intNum1 + intNum2;
        totDec = Math.max(numDec1, numDec2);
        break;
    case '-' :  // "pareggio" il numero dei decimali
        if (numDec1 > numDec2) {
            intNum2 *= (10 * (numDec1 - numDec2));
        }
        else if (numDec1 < numDec2) {
            intNum1 *= (10 * (numDec2 - numDec1));
        }

        result = intNum1 - intNum2;
        totDec = Math.max(numDec1, numDec2);
        break;
    case '*' :  result = intNum1 * intNum2;
    totDec = numDec1 + numDec2;
    break;
    case '/' :  var div1 = Math.pow(10, numDec1);
    var div2 = Math.pow(10, numDec2);

    result = (intNum1 / div1) / (intNum2 / div2);
    // totDec deve rimanere a 0 in modo che 'intToFloat' non faccia nulla
    break;
    case '%' :  var div1 = Math.pow(10, numDec1);
    var div2 = Math.pow(10, numDec2);

    result = (intNum1 / div1) % (intNum2 / div2);
    // totDec deve rimanere a 0 in modo che 'intToFloat' non faccia nulla
    break;
    default  :  alert("combineFloats(): operatore non supportato! [" + operator + "]");
    return "";
    }

    //alert("1: " + intNum1 + " dec: " + numDec1 + "\n2: " + intNum2 + " dec: " + numDec2 + "\nresult: " + result + " totDec: " + totDec);

    if (resultDecSep == "") {
        resultDecSep = ',';
    }

    return intToFloat(result, totDec, resultDecSep);
}

function editChkHour(theInput, verbose)
{
    var ret = true;
    lastChkResult = '';

    if ( theInput.value == '' )
        return true;

    ret = chkHour(theInput, true);

    if ( ret == false ){
        setTimeout(function(){theInput.focus()}, 10);
        theInput.select();
        lastChkResult = theInput;
        return false;
    }
    return ret;
}

//DD 29/01/2005 Va in ricerca globale da un inserimento (nuovo)
function gotoRicercaGlobale(){
    form = getForm("hxpForm");
    oldTable = form.dbTable.value;
    oldVerbo = form.verbo.value;

    form.dbTable.value = "@globale";
    form.verbo.value = "query";
    form.submit();

    form.dbTable.value = oldTable;
    form.verbo.value = oldVerbo;

    return;
}

/*
 * DD 21/03/06 Gestisce l'eventuale disabilitazione checkbox invia notifica in base al valore della propery CheckboxEmailNotifica (RW:0035181)
 */
function gestCheckboxInviaNotifica(){
    //Se la propery CheckboxEmailNotifica='no' disattivo il checkbox di inoltro delle email di notifica
    if ((getForm('hxpForm') != null || getForm('theForm') != null) && typeof(getAppStringPreference) != 'undefined') {
        var prefCheckboxMail = getAppStringPreference(getForm('hxpForm').appStringPreferences.value, decodeAppStringPreference("CheckboxEmailNotifica")).toLowerCase();
        if (prefCheckboxMail == 'no') {
            gestCheckboxInviaNotifica_Unceck('hxpForm', '*sendMailRifInterni');
            gestCheckboxInviaNotifica_Unceck('theForm', '*sendMailRifInterni');
        }
    }
}

function gestCheckboxInviaNotifica_Unceck(nomeForm, nomeCampo){
    if(getForm(nomeForm) != null && typeof(getForm(nomeForm)[nomeCampo]) != 'undefined') {
        getForm(nomeForm)[nomeCampo].checked = false;
    }
}

/*
 * DD 24/03/2006 Se chiamata all'onchange di un campo dell'ultima istanza di un multiistanza, aggiunge automaticamente
 * un'altra istanza se necessario.
 */
function autoAddInstance(prefix, obj) {

    if(obj.value.length == 0) return;
    nome=obj.name;
    //Estraggo l'istanza dal nome dell'input
    var callInst = nome.split(prefix+'[')[1].split(']')[0];
    var lastInst = "" + getLastInstanceIndex(prefix);

    if(lastInst != callInst) return;

    //Dopo i controlli posso aggiungere l'istanza
    return addInstance(prefix);

}

//PER ORA realizzato e testato solo per le istanze di immagini e file allegati
function addInstanceBefore(prefix, thisObject, toFocus, retNewInst) {//non supporta livelli di innesto
    var theInstance = thisObject.parentNode;
    while ( theInstance.id.length < prefix || theInstance.id.substring(0, prefix.length) != prefix ) {
        theInstance = theInstance.parentNode;
    }
    var dad = theInstance.parentNode;
    var index = parseInt(theInstance.id.substring(theInstance.id.lastIndexOf('.') + 1));

    var newInst=theInstance.cloneNode(true);

    arrangeInstance(prefix,newInst,index,index,"11", "",false);
    var lastIndex = getLastInstanceIndex(prefix);

    var basketInst;
    for (var i=lastIndex; i>=index; i--){
        basketInst = document.getElementById(getInstanceId(prefix, i));
        arrangeInstance(prefix,basketInst,i,i+1,"01", "",false);
    }

    dad.insertBefore(newInst, theInstance);

    if(hasInputFile(newInst) && getForm('indexForm').browser.value!='IE5' && getForm('indexForm').browser.value!='Explorer') emptyInputFile(newInst);
    attachAddInstance(newInst, prefix);

    if ( typeof(customAddInstance) != 'undefined' ) {
        customAddInstance(newInst, prefix);
    }

    //do il focus al primo input
    if (typeof(toFocus) == 'undefined' || toFocus) {
        var els = newInst.getElementsByTagName("input");
        for ( var i = 0; i < els.length; i++ )
            if ( els.item(i).type != 'hidden' ) {
                els.item(i).focus();
                break;
            }
    }

    return retNewInst ? index : false;
}

//PER ORA realizzato e testato solo per le istanze di immagini e file allegati
function moveInstanceBefore(prefix, thisObject) {//non supporta livelli di innesto
    var theInstance = thisObject.parentNode;
    while ( theInstance.id.length < prefix || theInstance.id.substring(0, prefix.length) != prefix ) {
        theInstance = theInstance.parentNode;
    }
    var dad = theInstance.parentNode;
    var index = parseInt(theInstance.id.substring(theInstance.id.lastIndexOf('.') + 1));

    if (index == 0)
        return false;

    var instanceBefore = document.getElementById(getInstanceId(prefix, index-1))

    swapAttachTitle(prefix, index, index-1);

    arrangeInstance(prefix,theInstance,index,index-1,"01", "",false);
    arrangeInstance(prefix,instanceBefore,index-1,index,"01", "",false);

    dad.removeChild(theInstance);
    dad.insertBefore(theInstance, instanceBefore);

    return false;
}

//PER ORA realizzato e testato solo per le istanze di immagini e file allegati
function moveInstanceAfter(prefix, thisObject) {//non supporta livelli di innesto
    var theInstance = thisObject.parentNode;
    while ( theInstance.id.length < prefix || theInstance.id.substring(0, prefix.length) != prefix ) {
        theInstance = theInstance.parentNode;
    }
    var dad = theInstance.parentNode;
    var index = parseInt(theInstance.id.substring(theInstance.id.lastIndexOf('.') + 1));

    var lastIndex = getLastInstanceIndex(prefix);

    if (index == lastIndex)
        return false;

    var instanceAfter = document.getElementById(getInstanceId(prefix, index+1))

    arrangeInstance(prefix,theInstance,index,index+1,"01", "",false);
    arrangeInstance(prefix,instanceAfter,index+1,index,"01", "",false);

    dad.removeChild(instanceAfter);
    dad.insertBefore(instanceAfter, theInstance);

    swapAttachTitle(prefix, index, index+1);

    return false;
}

//Federica RW0040840 24/11/2006
function swapAttachTitle(prefix, index1, index2) {

	var instance1 = document.getElementById(getInstanceId(prefix, index1));
	var instance2 = document.getElementById(getInstanceId(prefix, index2));
	var prefixTitle = prefix;
	var input1;
	var input2;

	if (prefix=="IMGS") {
		prefixTitle = "IMG";
	}

	if (prefixTitle=="ATTACH" || prefixTitle=="IMG" || prefixTitle=="files.xw:file" || prefixTitle=="immagini.xw:file") {
		input1 = getElementByNameWithRoot(instance1, "*files.modify"+prefixTitle+"[" + index1 + "].@title");
		input2 = getElementByNameWithRoot(instance2, "*files.modify"+prefixTitle+"[" + index2 + "].@title");

		if (input1 == null || input2 == null) {
			input1 = getElementByNameWithRoot(instance1, "."+prefixTitle+"[" + index1 + "].@title");
			input2 = getElementByNameWithRoot(instance2, "."+prefixTitle+"[" + index2 + "].@title");

			if (input1 == null || input2 == null) {
				input1 = getElementByNameWithRoot(instance1, "*"+prefixTitle+"[" + index1 + "].@title");
				input2 = getElementByNameWithRoot(instance2, "*"+prefixTitle+"[" + index2 + "].@title");
			}
		}
	}

	if (input1 != null && input2 != null) {
		if ((input1.value.indexOf("Pagina") == 0) && (input2.value.indexOf("Pagina") == 0)) {
			var i1value = input1.value;
			input1.value = input2.value;
			input2.value = i1value;
		}
	}
}

//Federica RW0040840 24/11/2006
function setPageWithValue(prefix, index, pageValue) {

	var instance = document.getElementById(getInstanceId(prefix, index));
	var prefixTitle = prefix;
	var input;

	if (prefix=="IMGS") {
		prefixTitle = "IMG";
	}

	if (prefixTitle=="ATTACH" || prefixTitle=="IMG" || prefixTitle=="files.xw:file" || prefixTitle=="immagini.xw:file") {
		input = getElementByNameWithRoot(instance, "*files.modify"+prefixTitle+"[" + index + "].@title");

		if (input == null) {
			input = getElementByNameWithRoot(instance, "."+prefixTitle+"[" + index + "].@title");

			if (input == null) {
				input = getElementByNameWithRoot(instance, "*"+prefixTitle+"[" + index + "].@title");
			}
		}
	}

	if (input != null) {
		if (input.value.indexOf("Pagina") == 0) {
			input.value = "Pagina "+eval((input.value.substring(input.value.indexOf(" ") +1)+pageValue));
		}
	}
}

function removeAllInstances(prefix) { //non supporta i livelli... realizzato per file e immagini

    var lastIndex = getLastInstanceIndex(prefix);

    if (lastIndex > 0) {
        var ret = confirm("Confermare la rimozione di tutte le istanze?")
        if (!ret)
            return false;
    }

    var theInstance = document.getElementById(getInstanceId(prefix, 0));
    while ( theInstance.id.length < prefix || theInstance.id.substring(0, prefix.length) != prefix ) {
        theInstance = theInstance.parentNode;
    }
    var thisDad = theInstance.parentNode;

    for (var i=lastIndex; i>=0; i--) {
        var inst = document.getElementById(getInstanceId(prefix, i));
        if (i > 0)
            thisDad.removeChild(inst);
        else {
            arrangeInstance(prefix, thisDad,"","", "10",'undefined',false);

            if ( typeof(attachRemoveInstance) != 'undefined' ) {
                attachRemoveInstance(prefix, "", inst.childNodes.item(0));
            }
            if ( typeof(customRemoveInstance) != 'undefined' ) {
                customRemoveInstance(prefix, "", inst.childNodes.item(0));
            }
        }
    }

    return false;
}


//AJAX
var lookupIsBusy = false;
var lastFieldsUsedLookup = '';
var newRecordLookupFields = ''; //per inserimento nuovo record
var newRecordLookupDb = ''; //per inserimento nuovo record
var newRecordLookupTitle = ''; //per inserimento nuovo record
var selectToHideList = null;
var fieldValLookup = '';

function hideSelect() {
    if (selectToHideList == null) {
        selectToHideList = new Array();
        var els = document.getElementsByTagName('select');
        for (var i=0; i<els.length; i++) {
            els[i].style.display = 'none';
            selectToHideList[i] = els[i];
        }
    }
}

/*
 * Created on: 07/10/2007
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Nasconde l'oggetto IW quando viene mostrato il div per il lookup con ajax [RW 0047021].
 *              L'oggetto IW viene nascosto solo se contenuto in un div con id 'div_iw_container_hide'.
 */
function hideIW()
{
    var iwContainer = document.getElementById('div_iw_container_hide');

    if (iwContainer != null) iwContainer.style.display = 'none';
}

function showSelect() {
    if (selectToHideList != null) {
        for (var i=0; i<selectToHideList.length; i++)
            selectToHideList[i].style.display = '';
    }
}

/*
 * Created on: 07/10/2007
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Mostra l'oggetto IW quando viene nascosto il div per il lookup con ajax [RW 0047021].
 *              L'oggetto IW viene mostrato solo se contenuto in un div con id 'div_iw_container_hide'.
 */
function showIW()
{
    var iwContainer = document.getElementById('div_iw_container_hide');

    if (iwContainer != null) iwContainer.style.display = 'block';
}

function resetLookupVars() {
    lookupIsBusy = false;
    lastFieldsUsedLookup = '';
    newRecordLookupFields = '';
    newRecordLookupDb = '';
    newRecordLookupTitle = '';
    showSelect();

    // Federico 07/10/07: introdotta possibilita' di nascondere l'oggetto IW quando viene mostrato il div
    // per il lookup con ajax [RW 0047021].
    showIW();
    selectToHideList = null;
    fieldValLookup = null;

    if (typeof(customResetLookupVars) != 'undefined')
        customResetLookupVars();
}

function setLastFieldsUsedLookup(fields, fieldVal) {
    lastFieldsUsedLookup = fields;
    fieldValLookup = fieldVal;
}

function setNewRecordLookupVars(campi, titolo, db) {
    newRecordLookupFields = campi;
    newRecordLookupTitle = titolo;
    newRecordLookupDb = db;
}

function errorHandlerLookup(message) {
    alert("Si  verificato un errore: " + message);
    stopModalWindow(true);
    emptyFieldsLookup();
    resetLookupVars();
}

function emptyFieldsLookup() {
    var fieldsArr = lastFieldsUsedLookup.split('|');
    for (var i=0; i<fieldsArr.length; i++)
        try {
            getElementByName(fieldsArr[i]).value = '';
        }
        catch (error) {
        }
}

function emptyAndCloseContainerLookup() {
    document.getElementById('lookupDiv').style.display = 'none';
    var container1 = document.getElementById('lookupDivContainer1');
    if (container1 != null)
        container1.parentNode.removeChild(container1);

    if (typeof(customEmptyAndCloseContainerLookup) != 'undefined')
        customEmptyAndCloseContainerLookup();
//alert(document.getElementById('rifIntLookupDiv').innerHTML)
}

function fillFieldsLookup(campi) {
//  alert(campi);

  // Federico 08/10/09: ripulitura degli eventuali dati di sessione dei lookup SAP [EA 999]
  cleanSAPLookupSessionData();

  if (typeof(customFillFieldsLookup) != 'undefined')
      return customFillFieldsLookup(campi);

  var arr = campi.split('|');
  var riga;
  var index;
  for (var i=0; i<arr.length; i++) {
      riga = arr[i];
      index = riga.indexOf('=');
      try {
          if (dad == null)
              getForm('hxpForm')[riga.substring(0, index)].value = riga.substring(index + 1);
          else {
              elFoundLookup = null;
              visitaTreeLookup(dad, riga.substring(0, index));
              var el = elFoundLookup;
              if ( el != null )
                  el.value = riga.substring(index + 1);
          }

          if (nodeToSetDefault != null ) //vedi onblurLookup
              nodeToSetDefault.defaultValue = nodeToSetDefault.value;
      }
      catch (error) {
      }
  }

  resetLookupVars();

  return false;
}

var elFoundLookup;

function visitaTreeLookup(el, name)
{
    if ( elFoundLookup != null )
        return;

    if (el.name == name)
        elFoundLookup = el;

    var l = el.childNodes;
    for (var i = 0; i < l.length; i++)
        visitaTreeLookup(l.item(i), name, elFoundLookup);
}

function getFieldsWithValLookup(els) {
    var ret = '';
    var campi = els.selectNodes('campo');
    for (var i=0; i<campi.length; i++)
        ret += campi[i].getAttribute('nome') + "=" + campi[i].text + "|";
    return ret;
}

function handleLookup(text, requester) {
//alert(replaceAll(text,'\n',' '));
      var xml = jsXML.parseXMLDocument(text);

      var titoli = xml.selectNodes("/response/titolo");
      var campi = xml.selectSingleNode('/response/@lookup_campi').text;
      var count = xml.selectSingleNode('/response/@count').text;

      // Federico 08/10/09: ripulitura degli eventuali dati di sessione dei lookup SAP [EA 999]
      var _cd = xml.selectSingleNode('/response/@_cd').text;
      var pos = _cd.indexOf("&currentSAPLookupId=");

      if (pos != -1) {
          var hxpS = new _hxpSession(getForm('hxpForm'));
          hxpS.setParameter("currentSAPLookupId", _cd.substring(pos + 20, _cd.indexOf('&', pos + 1)));
      }

      var insRight = false;
      try  {
          insRight = xml.selectSingleNode('/response/funzionalita_disponibili/@ins_record').text;
      }
      catch (e) {}

      if (count == 0 && !insRight) {
          alert("Nessun valore trovato");
          emptyFieldsLookup();
      }
      else if (count == 1) {//lookup ha individuato un solo elemento
          return fillFieldsLookup(getFieldsWithValLookup(titoli[0]));
      }
      else { //piu' elementi trovati oppure nessun elemento ma diritto di inserimento di nuovo record
          emptyAndCloseContainerLookup();

          var fdiv = document.getElementById('lookupDiv');
          fdiv.style.display = '';
          hideSelect();

          // Federico 07/10/07: introdotta possibilita' di nascondere l'oggetto IW quando viene mostrato il div
          // per il lookup con ajax [RW 0047021].
          hideIW();
          Drag.init(fdiv);
          Drag.centerDiv(fdiv);
          startModalWindow(true);

          var container = document.getElementById('lookupDivContainer');
          container.style.display = 'none';

          var container1 = container.cloneNode(false);
          container1.style.display = '';
          container1.setAttribute('id', 'lookupDivContainer1');
          container.parentNode.appendChild(container1);

          //titoli
          for (var i=0; i<titoli.length; i++) {
              if (titoli[i].getAttribute('skipLoop') == 'true')//per elaborazioni particolari
                  continue;

//  alert(fieldVal)
              //anchor - selezione
              var cloned = container.cloneNode(true);
              cloned.removeAttribute('id');
              cloned.style.display = '';

              var anchor = getAnchorInElement(cloned);
              var click;
              click = "emptyAndCloseContainerLookup(); stopModalWindow(true); return fillFieldsLookup('" + jsXML.toJsParam(getFieldsWithValLookup(titoli[i])) + "')";

              try {// IE non gradisce setAttribute()...
                  anchor.attachEvent('onclick', new Function(click));
              }
              catch(err) {
                  anchor.setAttribute('onclick', click);
              }

              var txt = document.createTextNode(titoli[i].getAttribute('testo'));
              anchor.appendChild(txt);

              if (typeof(customAjaxHandleTitleLookup) != 'undefined')
                  customAjaxHandleTitleLookup(xml, cloned, titoli[i]);

              anchor.removeAttribute('id');
              addElToContainer(container1, cloned);
          }

          //pulsanti
          addAnchorLookup('lookupFirstPage', getFirstClickParamsLookup(xml)); //anchor - first
          addAnchorLookup('lookupPrevPage', getPrevClickParamsLookup(xml)); //anchor - prev
          addAnchorLookup('lookupNextPage', getNextClickParamsLookup(xml)); //anchor - next
          addAnchorLookup('lookupLastPage', getLastClickParamsLookup(xml)); //anchor - last
          addAnchorLookup('lookupClose', "_CLOSE_"); //anchor - close

          // Federico 05/10/09: personalizzazione via property del link per creare una nuova struttura esterna (finestra del lookup) [EA 999]
          var lookupNewRecordStrutturaEsterna = document.getElementById("lookupNewRecordStrutturaEsterna");

          if (lookupNewRecordStrutturaEsterna != null) {
            var _cd     = xml.selectSingleNode('/response/@_cd').text;
            var linkPos = _cd.indexOf("&lookupLinkNewRecordStrutturaEsterna=");
            var link    = "";

            if (linkPos != -1) {
                var linkEnd = _cd.indexOf("&", linkPos + 1);

                if (linkEnd != -1) {
                    link = _cd.substring(linkPos + 37, linkEnd);
                    _cd  = _cd.substring(0, linkPos) + _cd.substring(linkEnd + 1);
                }
            }

            if (link != null && link.length > 0) {
                lookupNewRecordStrutturaEsterna.href    = link;
                lookupNewRecordStrutturaEsterna.onclick = "";
                lookupNewRecordStrutturaEsterna.target  = "_blank";
            }
          }

          addAnchorLookup('lookupNewRecord', getNewRecordParamsLookup(xml)==null?null:'', getNewRecordParamsLookup(xml)); //anchor - new record

          //campi extra
          addValueTextLookup('lookupCount', count);
          addValueTextLookup('lookupCurrPage', getCurrentPageNumberLookup(xml));
          addValueTextLookup('lookupNumPages', getNumberOfPagesLookup(xml));

          if (typeof(customAjaxHandleContainerLookup) != 'undefined')
              customAjaxHandleContainerLookup(xml, fdiv);

//alert(container1.innerHTML);
      }

      lookupIsBusy = false;
}

function addElToContainer(container, cloned) {
    var els = cloned.childNodes;
    for (var i=0; i<els.length; i++)
        if (els[i].nodeType != document.TEXT_NODE)
            container.appendChild(els[i]);
}

var anchorFound;
function getAnchorInElement(el) {
    anchorFound = null;
    getAnchorInElement_(el);
    return anchorFound;
}
function getAnchorInElement_(el) {
    if (anchorFound != null)
        return;
    if (el.tagName == 'A' || el.tagName == 'a') {
        anchorFound = el;
        return;
    }
    var l = el.childNodes;
    for (var i = 0; i < l.length; i++)
        if (l[i].nodeType != document.TEXT_NODE)
            getAnchorInElement_(l[i]);
}

function getNewRecordParamsLookup(xml) {
    var insRight = '';
    try {
        insRight = xml.selectSingleNode('/response/funzionalita_disponibili/@ins_record').text;
    }
    catch (e) {}
    if (insRight != 'true')
        return null;

    return "return newRecordLookup('" + jsXML.toJsParam(xml.selectSingleNode('/response/@lookup_new').text) + "','" +
           jsXML.toJsParam(xml.selectSingleNode('/response/@lookup_fieldVal').text) + "','" +
           jsXML.toJsParam(xml.selectSingleNode('/response/@lookup_campi').text) + "','" +
           jsXML.toJsParam(xml.selectSingleNode('/response/@lookup_titolo').text) + "','" +
           jsXML.toJsParam(xml.selectSingleNode('/response/@lookup_db').text) + "')";
}

function getNumberOfPagesLookup(xml) {
    var count = parseInt(xml.selectSingleNode('/response/@count').text);
    var pageCount = parseInt(xml.selectSingleNode('/response/@pageCount').text);
    return Math.floor((count + pageCount - 1) / pageCount)
}

function getCurrentPageNumberLookup(xml) {
    var pos = parseInt(xml.selectSingleNode('/response/@pos').text);
    var pageCount = parseInt(xml.selectSingleNode('/response/@pageCount').text);
    return Math.floor(pos / pageCount + 1);
}

function getFirstClickParamsLookup(xml) {
    var posizioneAttuale = parseInt(xml.selectSingleNode('/response/@pos').text);
    if (posizioneAttuale == 0)
        return null;
    return getStandardParamsLookup(xml) + "&pos=0";
}

function getPrevClickParamsLookup(xml) {
    var posizioneAttuale = parseInt(xml.selectSingleNode('/response/@pos').text);
    if (posizioneAttuale == 0)
        return null;
    var perPagina = parseInt(xml.selectSingleNode('/response/@pageCount').text);
    var pos = (posizioneAttuale - perPagina < 0 ) ? 0 : posizioneAttuale - perPagina;
    return getStandardParamsLookup(xml) + "&pos=" + pos;
}

function getNextClickParamsLookup(xml) {
    var totaleSelezionati = parseInt(xml.selectSingleNode('/response/@count').text);
    var posizioneAttuale = parseInt(xml.selectSingleNode('/response/@pos').text);
    var perPagina = parseInt(xml.selectSingleNode('/response/@pageCount').text);
    if ( totaleSelezionati <= posizioneAttuale + perPagina )
        return null;
    var pos = posizioneAttuale + perPagina;
    return getStandardParamsLookup(xml) + "&pos=" + pos;
}

function getLastClickParamsLookup(xml) {
    var totaleSelezionati = parseInt(xml.selectSingleNode('/response/@count').text);
    var posizioneAttuale = parseInt(xml.selectSingleNode('/response/@pos').text);
    var perPagina = parseInt(xml.selectSingleNode('/response/@pageCount').text);
    if ( totaleSelezionati <= posizioneAttuale + perPagina )
        return null;
    var pos = Math.floor((totaleSelezionati - 1) / perPagina) * perPagina;
    return getStandardParamsLookup(xml) + "&pos=" + pos;
}

function getStandardParamsLookup(xml) {
    var params = buildUrlForGet("", true, true, true, true) +
    "&verbo=lookup_response&lookup_campi=" + xml.selectSingleNode('/response/@lookup_campi').text +
    "&lookup_fieldVal=" + xml.selectSingleNode('/response/@lookup_fieldVal').text +
    "&lookup_alias=" + xml.selectSingleNode('/response/@lookup_alias').text +
    "&lookup_titolo=" + xml.selectSingleNode('/response/@lookup_titolo').text +
    "&lookup_xq=" + xml.selectSingleNode('/response/@lookup_xq').text +
    "&qord=" + xml.selectSingleNode('/response/@qord').text +
    "&lookup_new=" + xml.selectSingleNode('/response/@lookup_new').text +
    "&lookup_db=" + xml.selectSingleNode('/response/@lookup_db').text +
    "&selid=" + xml.selectSingleNode('/response/@selid').text + "&count=" + xml.selectSingleNode('/response/@count').text +
    "&transformJava=ajax";
    return params;
}

function addAnchorLookup(id, params, funcS) {
    var oldAnchor = document.getElementById(id + "_cloned");
    if (oldAnchor != null)
        oldAnchor.parentNode.removeChild(oldAnchor);

    var anchor = document.getElementById(id);
    if (anchor != null) {
        anchor.style.display = 'none';
        if (params != null) {
            var cloned = anchor.cloneNode(true);
            cloned.setAttribute('id', id + "_cloned");
            anchor.parentNode.insertBefore(cloned, anchor);
            cloned.style.display = '';

            var click;
            if (params == "_CLOSE_") {
                emptyFieldsLookup();
                // Federico 08/10/09: ripulitura degli eventuali dati di sessione dei lookup SAP [EA 999]
                click = 'cleanSAPLookupSessionData(); stopModalWindow(true); resetLookupVars(); return emptyAndCloseContainerLookup()';
            }
            else if (params == '')
                click = funcS;
            else
                click = "return doAjaxReqLookup('" + jsXML.toJsParam(params) + "');";
            try {// IE non gradisce setAttribute()...
                cloned.attachEvent('onclick', new Function(click));
            }
            catch(err) {
                cloned.setAttribute('onclick', click);
            }
        }
    }
}

function addValueTextLookup(id, val) {
    var el = document.getElementById(id);
    if (el != null) {
        var childs = el.childNodes;
        for (var i=0; i<childs.length; i++) {
            childs[i].parentNode.removeChild(childs[i]);
        }
        el.appendChild(document.createTextNode(val));
    }
}

function doAjaxReqLookup(params) {
    if (!lookupIsBusy) {
//alert(params);
        lookupIsBusy = true;
        jsXML.sendAsyncPost(getForm('hxpForm').uri.value, params, handleLookup, errorHandlerLookup, null);
    }
    return false;
}

function newRecordLookup(params, fieldVal, campi, titolo, db)
{
    if (typeof(fieldVal) == 'undefined') {
        fieldVal = fieldValLookup;
        campi = newRecordLookupFields;
        titolo = newRecordLookupTitle;
        db = newRecordLookupDb;
    }
    else
        setNewRecordLookupVars(campi, titolo, db);

    params_v = params.split(';');
    var uri = params_v[0];
    var dbTable = params_v[1].substring(params_v[1].indexOf('=') + 1);
    var fillField = params_v[2].substring(params_v[2].indexOf('=') + 1);

    var r = Math.round(Math.random()*1000);

    //caso base (stesso db e stessa applicazione)
    var t_uri = getForm('hxpForm').uri.value + "?db=" + getForm('hxpForm').db.value;

    /* INIZIO ELABORAZIONE URL */
    //specificato uri di jsp (N.B - senza primo livello di path, ovvero senza xway)
    if ( uri.length > 0 ) {
        t_uri = getForm('hxpForm').uri.value.substring(0, getForm('hxpForm').uri.value.indexOf("/", 1) ) + uri;

        //occorre cambiare url se uri corrente  jsp e proiezione specifica hc.dll (e viceversa)
        var curr_uri = getForm('hxpForm').uri.value;
        var togoLastPart = t_uri.substring(t_uri.lastIndexOf("/") + 1, t_uri.lastIndexOf("?"));
        var iamLastPart = curr_uri.substring(curr_uri.lastIndexOf("/") + 1);
        if ( iamLastPart.indexOf(".dll") != -1 )
            t_uri = t_uri.replace(togoLastPart, iamLastPart);
    }

    //se db acl -> seleziono quello corrretto (multi acl)
    if (t_uri.indexOf('db=acl') != -1 && t_uri.indexOf('db=acl-') == -1 && getForm('hxpForm').aclDb.value != '')
        t_uri = t_uri.replace('db=acl','db=' + getForm('hxpForm').aclDb.value);

    var url = buildUrlForGet(t_uri, true, true, true) + '&verbo=docEdit&dbTable=@' + dbTable + '&lookup_new=' +
              realEscape(params) + '&lookup_fieldVal=' + fieldVal;

    if (typeof(customNewRecordAddUrlLookup) != 'undefined')
        url += customNewRecordAddUrlLookup();

    /*  FINE ELABORAZIONE URL */

    //var newLookupRecord = window.open(url, 'new_record' + r, "width=800,height=600,scrollbars=yes");

    //sstagni -> aggiunti nel passaggio get->post
    //fcossu - RW0051403 rimosso xverb forzato a vuoto per funzionamento lookup mittente/destinatario
    url += '&selid=&pos=&codice_rep=&physDoc=';
    
    //sstagni - fix - 18/03/2011 - se xverb non  presente nell'url lo si forza a vuoto altrimenti si ha una anomalia in inserimento comune da modifica di persone e strutture da ACL
    if (url.indexOf("xverb") == -1)
    	url += '&xverb=';
    
    var hxpForm = getForm('hxpForm');
    var oldTarget = hxpForm.target;
    hxpForm.target = 'new_record' + r;
    var oldTuples = setFormTuplesFromURL(url, hxpForm);
    var newLookupRecord = window.open(staticEmptyWindow, hxpForm.target, "width=800,height=600,scrollbars=yes");
    hxpForm.submit();
    newLookupRecord.focus();
    setFormTuplesFromURL(oldTuples, hxpForm);//restore delle tuple precedenti
    hxpForm.target = oldTarget;

    return false;
}

function reDoLookupAfterInsertLookup(physDoc) {
    emptyAndCloseContainerLookup();
    var iForm = getForm('hxpForm');

    var params = buildUrlForGet("", true, true, true, true) +
    "&selid=&verbo=lookup_response&lookup_campi=" + newRecordLookupFields +
    "&lookup_fieldVal=" + "_PHYSDOC=" + physDoc +
    "&lookup_titolo=" + newRecordLookupTitle +
    "&lookup_db=" + newRecordLookupDb +
    "&transformJava=ajax";
    jsXML.sendAsyncPost(getForm('hxpForm').uri.value, params, handleLookup, errorHandlerLookup, null);
}
