/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

 /* doc_response.js */

 /* funzioni per la pagina di gestione di doc_response */

var _senselectEnabled=null;
function senselectEnabled()
{if(_senselectEnabled==null){var theSession = new _hxpSession(getForm('hxpForm'));_senselectEnabled=(theSession.getParameter('senselect')=='1');}
 return _senselectEnabled;
}
function signingEnabled()
{return (senselectEnabled() || (typeof(document.IW)!='undefined'&&document.IW.CheckSigningModule(0)!=0));} // firma digitale se senselect o IW attivi

function loadHandler(description,instructions)
{
    startModalWindow();

    //mbussetti, 21/03/2005: recupero delle conversioni richieste sull'ultima versione per presentare i relativi
    //checkbox gi checkati
    var convAlreadyRequested = getForm('hxpForm').convReq.value;
    var extensionsRequested = convAlreadyRequested.split(";");
    for (er = 0; er < extensionsRequested.length; er++){
        var singleExt = extensionsRequested[er];
        if (singleExt.length > 0){
            var nomeDaCercare = "*agent_" + singleExt;
            var inputToCheck = document.getElementById(nomeDaCercare);
            if (null != inputToCheck && 'undefined' != typeof(inputToCheck)){
                //alert (inputToCheck.nodeType);
                inputToCheck.setAttribute("checked","checked");
            }
        }
    }
    /*
    var r;
    if (typeof(document.IW)=='undefined') {
        r = 0;
    }
    else {
        r = document.IW.CheckSigningModule(0);
    }

    if (r == 0) {
        var o = document.getElementById("fileFD");
        if (o != null) o.style.display = "none";
        var o = document.getElementById("imgFD");
        if (o != null) o.style.display = "none";
    }
    */
    if (!signingEnabled()) {
        var o = document.getElementById("fileFD");
        if (o != null) o.style.display = "none";
        o = document.getElementById("imgFD");
        if (o != null) o.style.display = "none";
    }
    if ( 'undefined' != typeof(description) ){
        getForm('theForm').fileName.value = description;
    }

    if ( 'undefined' != typeof(instructions) ){
        //alert(instructions);
    }

    if ( getForm('hxpForm').warnings.value != '' ) {
        self.focus();
        alert(getForm('hxpForm').warnings.value);
    }

    if ( typeof(getForm('hxpForm').doc_responseText) != 'undefined' &&
            getForm('hxpForm').doc_responseText.value == "_WF_" ) {  //ritorno da una modifica allegato operata da un workflow
        getForm('hxpForm').verbo.value = "showdoc";
        getForm('hxpForm').xverb.value = "";

        var impWfPosition = getForm('hxpForm').wfPos.value;
        var impWfSelId = getForm('hxpForm').wfSelId.value;
        var impWfFCount = getForm('hxpForm').wfFCount.value;

        if ( impWfPosition !='' && impWfPosition !='-1000' )
            getForm('hxpForm').pos.value = impWfPosition;
        else
            getForm('hxpForm').pos.value = getForm('hxpForm').physDoc.value - 1;

        if ( impWfSelId != '' )
            getForm('hxpForm').selid.value = impWfSelId;
        else
            getForm('hxpForm').selid.value = "";

        if ( impWfFCount !='' && impWfFCount !='-1' )
            getForm('hxpForm').count.value = impWfFCount;

        getForm('hxpForm').submit();
    }
    else if ( typeof(getForm('hxpForm').doc_responseText) != 'undefined' &&
            getForm('hxpForm').doc_responseText.value == "_CLOSE_" ) {  //ritorno da una assegnazione di CC/RPA
        self.close();
        opener.getForm('hxpForm').submit(); //ricarica la pagina del documento (rendere visibili le modifiche)
    }
    else if ( typeof(getForm('hxpForm').enableIW) != 'undefined' && getForm('hxpForm').enableIW.value == 'true'
        && getForm('hxpForm').xverb.value == '@openChkinPage' && getForm('hxpForm').loadAttach.value == 'true' ) {

        var id = realEscape(getForm('hxpForm').attach.value);
        var thecommandstring = "";
        var pos = getForm('hxpForm').attach.value.indexOf(".");
        var extension = '@' + getForm('hxpForm').attach.value.substring(pos) + '@';
        var mode = document.IW.downloadShellOcx + document.IW.downloadShellPlugin + document.IW.downloadNoLoad;

        if ( extension == '@.ziw@' )
            mode += document.IW.downloadInflate;
        //modifica di mbussetti del 09/06/05 per togliere anche estensioni p7m o p7k multiple
        else {
            mode += document.IW.downloadSetExt;
            while ( extension.indexOf(".p7m@") == extension.length - 5 || extension.indexOf(".p7k@") == extension.length - 5 ) {
                extension = extension.substring(0, extension.lastIndexOf(".")) + "@";
            }
        }

        var url = buildUrlForGet("", false, false, true) + "&verbo=attach&id=" + id;

        var ret = document.IW.DownloadParam(url, extension, mode);
        if (ret != 0) {
            alert("Si  verificato un errore nel download del file.");
        }

        buffer = new String(document.IW.buffer);
        var el = document.getElementById("fileToLoad.path");
        el.value = document.IW.GetLastFileName();
    }
}

function unloadHandler()
{
    stopModalWindow();
}

function closeDoc_response()
{
	self.close();
	return false;
}


function confirmAnnulDoc_response()
{
	if ( getForm('theForm').doc_responseTextArea.value.length == 0 )
		doc_responseMSG(noValField);
	else {
		getForm('hxpForm').verbo.value = "documento_response";
		getForm('hxpForm').xverb.value = "@annulla";
		getForm('hxpForm').doc_responseText.value = getForm('theForm').doc_responseTextArea.value;

		opener.OpenWaitMsg();
		getForm('hxpForm').submit();
	}
	return false;
}


function commitChkin()
{
    // Federico 02/08/07: introdotta possibilita' di effettuare controlli custom della pagina di chkin [RW 0046080]
    if (typeof(customCommitChkinChkForm) != 'undefined' && !customCommitChkinChkForm()) {
        return false;
    }

    // Federico 02/08/07: introdotta possibilita' di controllo dell'estensione dell'allegato
    // indicato nella pagina di chkin [RW 0046080]
    var allowedChkinExtensions = getForm('hxpForm').allowedChkinExtensions.value;

    if (allowedChkinExtensions.length > 0) {
        // c'e' un elenco di estensioni consentite --> controllo l'estensione del file indicato
        var fileToUpload = document.getElementById("fileToLoad.path");

        if (fileToUpload != null) {
            var pos = fileToUpload.value.lastIndexOf(".");
            var ext = "";

            if (pos != -1) {
                ext = fileToUpload.value.substring(pos + 1);
            }

            if (allowedChkinExtensions.toLowerCase().indexOf(ext.toLowerCase()) == -1) {
                // estensione non consentita
                alert("L'allegato indicato non e' di tipo consentito!\n\nTipi consentiti: " + allowedChkinExtensions);

                fileToUpload.focus();
                fileToUpload.select();

                return false;
            }
        }
    }

    getForm('hxpForm').verbo.value = "attach_response";
    getForm('hxpForm').xverb.value = "@commitChkin";
    //getForm('hxpForm').attach.value (usato ma impostato da xsl in creazione della pagina)
    getForm('hxpForm').name.value = document.getElementById("fileName").value;

    if ( typeof(getForm('hxpForm').enableIW) != 'undefined' && getForm('hxpForm').enableIW.value == 'true' ) { //iw

        var protocol = window.location.protocol;
        var bits = (protocol=='https:')?document.IW.uploadHttps:document.IW.uploadNone;

        //se firma digitale
        var signed = "";
        if (typeof(getForm('theForm').fileFD) != 'undefined' && getForm('theForm').fileFD.checked) {
            if(!senselectEnabled()) {
                bits |= document.IW.uploadSign;
                signed = "&signed=true";
            }
            else {
                signed = "&fileFD=fileFD";
            }
        }

        var maxSize = getForm('hxpForm').sizeMaxFile.value;
        var param = "";
        if (maxSize.length > 0) {
            param = maxSize;
            bits |= document.IW.uploadSizeThreshold;
        }

        var filePath = document.getElementById("fileToLoad.path").value;
        if ( filePath == '' )
            return false;

        var title = "&title=" + realEscape(getForm('hxpForm').name.value);

        var url = buildUrlForGet("", true, false, true) + "&verbo=Iw_response&xverb=upload" + signed + title;
        var r = document.IW.UploadParam(getHost(),
                url,
                window.location.port,
                'filename',
                filePath,
                bits ,  //mode
                document.IW.zCompressionNone,
        param); //param

        if (r == false) {
            if (document.IW.buffer == 'size threshold reached')
                alert("La dimensione del file supera la massima soglia consentita:\nimpossibile portare a termine l'operazione");
            else
                alert("Errore durante l'upload del file.\nImpossibile portare a termine l'operazione");
            return false;
        }

        var fileToLoad = document.getElementById('fileToLoad.name');
        DoneWithUpload(0, 0, 0, fileToLoad);
        getForm('hxpForm').appendChild(fileToLoad);
    }
    else { //no iw
        var ifile = document.getElementById("fileId");
        if ( ifile != null ) {
            if ( ifile.value == "" )
                return false;
            getForm('hxpForm').appendChild(ifile);
        }
    }

    if ( 'undefined' == typeof(getForm('hxpForm').doc_responseText) || "_WF_" != getForm('hxpForm').doc_responseText.value )
        opener.OpenWaitMsg();

    //aggiunta di mbussetti del 21/03/2005: possibilit di richiedere conversioni su una nuova versione
    getForm('hxpForm').convReq.value = "";
    if ('undefined' != typeof(getForm('theForm')["*agent_pdf"]) && getForm('theForm')["*agent_pdf"].checked){
        getForm('hxpForm').convReq.value += "pdf;";
    }
    if ('undefined' != typeof(getForm('theForm')["*agent_xml"]) && getForm('theForm')["*agent_xml"].checked){
        getForm('hxpForm').convReq.value += "xml;";
    }
    if (getForm('hxpForm').convReq.value.length > 0){
        getForm('hxpForm').convReq.value = getForm('hxpForm').convReq.value.substring(0,getForm('hxpForm').convReq.value.length - 1);
    }

    getForm('hxpForm').submit();
    if ( 'undefined' == typeof(getForm('hxpForm').doc_responseText) || "_WF_" != getForm('hxpForm').doc_responseText.value )
        opener.focus();

    return false;
}

function abandonChkoutFromWf(fileId)
{
  getForm('hxpForm').attach.value = fileId;
  getForm('hxpForm').verbo.value = "attach_response";
  getForm('hxpForm').xverb.value = "@abandonChkout";
  getForm('hxpForm').submit();
  return false;
}