/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

 /* document.js */

 //nome della finestra statica (vuota) che viene aperta quando c' un popup in modo che venga mantenuto il protocollo
 //corrente (http o https)
 var staticEmptyWindow = "./../formatter/html/templates/static.html";

 /* funzioni per la pagina di visualizzazione */
 var theListWindow=null;
 var thePopupWindow=null;
 var theCollectionWindow=null;
 var oldFocusHandler=window.onfocus;
 window.onfocus=focusHandler;

 // Federico 24/01/2005: finestra usata per visualizzare un documento cliccando sul link del suo NRECORD
 var newWinForShowDoc = null;

 function nuovaRicerca()
 {if(getForm("hxpForm").xverb.value.indexOf('child')>=0)
  {if(typeof(opener)!='undefined')
   {if(typeof(opener.theDocWindow)!='undefined')opener.theDocWindow=null;
    if(typeof(opener.thetitleWindow)!='undefined')opener.theTitleWindow=null;
    opener.focus();
   }
   self.close();
  }
  else
  {setGlobalFormRestore('verbo','xverb','dbTable','query','selid','personalView');
   getForm("hxpForm").verbo.value='query';
   getForm("hxpForm").dbTable.value='';
   getForm("hxpForm").query.value='';
   getForm("hxpForm").xverb.value='';
   getForm("hxpForm").selid.value='';
   getForm("hxpForm").personalView.value = '';
   getForm("hxpForm").submit();
  }
  return false;
 }


 // posizioneAttuale  un indice in base zero
function paginaTitoli(posizioneAttuale,titoliPerPagina){
    setGlobalFormRestore('verbo','pos');
    getForm("hxpForm").pos.value=Math.floor(posizioneAttuale/titoliPerPagina)*titoliPerPagina;
    getForm("hxpForm").verbo.value='showtitles';

    //aggiunta di mbussetti del 21/09/2005: le pagine di inserimento/modifica/visualizzazione sono diversificate
    //per i modelli e le istanze (dbTable=@workflow_model/@workflow_instance) ma la pagina dei titoli  comune,
    //quindi bisogna modificare il dbTable
    var wDbTable = getForm("hxpForm").dbTable.value;
    if (wDbTable.indexOf("@workflow") != -1) {
        getForm("hxpForm").dbTable.value = "@workflow";
    }

    getForm("hxpForm").submit();
    return false;
}

 function paginaBrowse(numDoc)
 {var isChild=theForm=typeof(opener)!='undefined'&&
              getForm("hxpForm").xverb.value.indexOf('child')>=0;
  var theForm;
  if(isChild)
  {if(typeof(opener.frames['inventario'])!='undefined')
   {theForm=getForm("hxpForm", opener.frames['inventario'].document);
    opener.ChangeFormToDisplay('col_1',true);
   }
   else theForm=getForm("hxpForm", opener.document);
  }
  else theForm=getForm("hxpForm", window.document);
  theForm.docStart.value=numDoc;
  theForm.verbo.value='hierBrowser';
  theForm.submit();
  if(isChild)nuovaRicerca();
  return false;
 }
 function seekDoc(docNumber, phys)
 {setGlobalFormRestore('verbo','pos','selid','count');
  getForm("hxpForm").verbo.value='showdoc';
  getForm("hxpForm").pos.value=docNumber;
  if ( typeof(phys) != 'undefined' && phys == true ) {
   getForm("hxpForm").selid.value="";
   getForm("hxpForm").count.value=1;
  }
  getForm("hxpForm").submit();
  return false;
 }
 function primaPagina(posizioneAttuale){
  if(posizioneAttuale>0){
   setGlobalFormRestore('verbo','xverb','pos');
   setXverbForViewer();
   getForm("hxpForm").verbo.value='showdoc';
   getForm("hxpForm").pos.value=0;
   getForm("hxpForm").submit();
  }
  return false;
 }
 function paginaPrecedente(posizioneAttuale){
  if(posizioneAttuale>0){
   setGlobalFormRestore('verbo','xverb','pos');
   setXverbForViewer();
   getForm("hxpForm").verbo.value='showdoc';
   getForm("hxpForm").pos.value=''+(posizioneAttuale-1);
   getForm("hxpForm").submit();
  }
  return false;
 }
 function paginaSuccessiva(posizioneAttuale,totaleSelezionati){
  if(totaleSelezionati>posizioneAttuale+1){
   setGlobalFormRestore('verbo','pos','xverb');

   getForm("hxpForm").verbo.value='showdoc';
   setXverbForViewer();
   getForm("hxpForm").pos.value=''+(posizioneAttuale+1);
   getForm("hxpForm").submit();
  }
  return false;
 }
 function ultimaPagina(posizioneAttuale,totaleSelezionati){
  if(totaleSelezionati>posizioneAttuale+1){
   setGlobalFormRestore('verbo','xverb','pos');
   getForm("hxpForm").verbo.value='showdoc';
   setXverbForViewer();
   getForm("hxpForm").pos.value=''+(totaleSelezionati-1);
   getForm("hxpForm").submit();
  }
  return false;
 }
 function openFileList(theList)
 {if(theList=='')return true;
  var verbo=getForm("hxpForm").verbo.value;
  var xverb=getForm("hxpForm").xverb.value;
  getForm("hxpForm").verbo.value='reflect';
  getForm("hxpForm").xverb.value='filelistchild';
  getForm("hxpForm").fileList.value=theList;
  var prevTarget=getForm("hxpForm").target;
  theListWindow=window.open
   ('',getForm("hxpForm").target='filelistchild',
    'status,resizable=yes,scrollbars=yes');
  getForm("hxpForm").submit();
  getForm("hxpForm").target=prevTarget;
  getForm("hxpForm").verbo.value=verbo;
  getForm("hxpForm").xverb.value=xverb;
  return false;
 }
 function getReloadPosition(f)
 {return((f.selid.value=='')?(f.physDoc.value-2):(f.pos.value-1));
 }
 function getReloadCount(f)
 {return((f.selid.value=='')?(getReloadPosition(f)+3):f.count.value);
 }
 function enableRecovery()
 {if(!confirm(_jr('conferma recovery')))
  {return false;
  }
  var f=getForm('hxpForm');
  var theSession = new _hxpSession(f);
  theSession.setParameter('recoveryEnabled','1');
  return paginaSuccessiva(getReloadPosition(f),getReloadCount(f));
 }
 function disableRecovery()
 {var f=getForm('hxpForm');
  var theSession = new _hxpSession(f);
  var theSession = new _hxpSession(f);
  theSession.setParameter('recoveryEnabled',null);
  return paginaSuccessiva(getReloadPosition(f),getReloadCount(f));
 }
 /* chiamata all'apertura della pagina */
 function loadHandler()
 {
     restoreTuple();

     // barra di navigazione titoli con numeri
     var el=document.getElementById('numdocnavbarcode');
	if(el)
	  {el.innerHTML=eval(el.innerHTML);
	   el.style.display='';
	  }
    //spostato qui da mbussetti il 25/03/2005 perch la pagina di prova non faceva apparire eventuali warning
     if ( getForm("hxpForm").warnings.value != '' ) {
         self.focus();
        alert(getForm("hxpForm").warnings.value);
     }
	//se sono sulla pagina intermedia che serve per inibire reload e tasto back
    //ricarico automaticamente la "vera" pagina
    if ( getForm("hxpForm").dbTable.value == "@reload" || 'undefined' != typeof(document.reloadForm)){
      if ( getForm("hxpForm").selid.value == '' ){
          getForm("hxpForm").pos.value = getForm("hxpForm").physDoc.value - 1;
      }
      if (getForm("hxpForm").dbTable.value == "@reload"){
          getForm("hxpForm").dbTable.value = getForm("hxpForm").oldTable.value;
      }
      getForm("hxpForm").submit();
    }
    else {
	if ( typeof(top) != 'undefined' && typeof(top.alertRaised) != 'undefined' )
		if ( top.alertRaised == false && getForm("hxpForm").view.value.indexOf("verificaDuplicati") != -1 ) {
			alert("Rilevata presenza di un documento in arrivo con gli stessi estremi");
			top.alertRaised = true;
		}

	if (trasfFascWindowOpened == 'false')
	    self.focus();

	if ( getForm("hxpForm").toDo.value == '@openChkinPage' ) {
		chkin(getForm("hxpForm").attach.value, getForm("hxpForm").name.value, "load");
		getForm("hxpForm").toDo.value = "";
	}

    if ( getForm("hxpForm").toDo.value == 'return@workflow' ) {
      //alert("dovrei far ripartire il workflow");
      //alert(getForm("hxpForm").wfId.value);
      getForm("hxpForm").verbo.value = "workflow";
      getForm("hxpForm").toDo.value = "";
      OpenWaitMsg();
      getForm("hxpForm").submit();
      getForm("hxpForm").wfId.value = "";
      getForm("hxpForm").wfAction.value = "";
      getForm("hxpForm").wfDoc.value = "";
      getForm("hxpForm").wfText.value = "";
      getForm("hxpForm").wfLock.value = "";
    }

 	//DD 29/01/06 Valorizza tutti gli attributi title delle immagini
   setAllImgTitlesFromAlt();

 	filelistLoadHandler();
 	if(typeof(customLoadHandler)!='undefined')
   customLoadHandler();
  	if(getForm("hxpForm").xverb.value=='@remove@child')
  	{//richiesta di cancellazione titoli
   getForm("hxpForm").xverb.value='child';
   //aggiornamento descrizione albero
   el=opener.document.getElementById('selCounter_'+getForm("hxpForm").selid.value);
   if(el)
   {var count=el.innerHTML;
    var pos=count.indexOf('-');
    if(pos>0)count=count.substring(0,pos);
    el.innerHTML=count+'-'+(parseInt(count)-parseInt(getForm("hxpForm").count.value));
   }
  }
 }

 }
 /* chiamata alla chiusura della pagina */
 function unloadHandler()
 {if ( theListWindow != null )
 	theListWindow.close();

  if ( thePopupWindow != null )
  	thePopupWindow.close();

  if ( theCollectionWindow != null )
  	theCollectionWindow.close();
 }

 function focusHandler()
 {if(theListWindow!=null)theListWindow.close();
  theListWindow=null;
  //if(theCollectionWindow!=null)theCollectionWindow.close();
  //theCollectionWindow=null;
  if(thePopupWindow!=null)thePopupWindow.close();
  thePopupWindow=null;

  // Federico 24/01/2005: chiusura finestra usata per visualizzare un documento cliccando sul link del suo NRECORD
  if (newWinForShowDoc != null && (typeof(window.opener) == 'undefined' || window.opener == null)) {
      // la finestra deve essere chiusa solo se il focus  passato alla finestra principale
      newWinForShowDoc.close();
      newWinForShowDoc = null;
  }
 }

 // funzione per la gestione delle raccolte
 function collection(name)
 {
 	/*
      * if(opener.getForm("hxpForm").cName.value!=''&& confirm("Aggiungere il documento alla raccolta
      * '"+getForm("hxpForm").cName.value+"' ?") )
      * {opener.collectionHandler('addDoc','',getForm("hxpForm").selid.value,1+parseInt(getForm("hxpForm").pos.value,10),this); }
      */

  /*
   * gestione delle raccolte (occorre cambiare verbo per avviare la classe relativa alle raccolte)
   */
  getForm("hxpForm").verbo.value = "collect";

  // backup delle var di hxpForm che verranno modificate da collectionHandler()
  var selid = getForm("hxpForm").selid.value;
  var keylist = getForm("hxpForm").keylist.value;
  var xDb = getForm("hxpForm").db.value;
  var oldTarget = getForm("hxpForm").target;

  var doSubmit = true;

  /*
   *  necessario cancellare temporaneamente getForm("hxpForm").selid per non avere problemi di creazione di/inserimento
   * in una nuova raccolta
   */
  getForm("hxpForm").selid.value = '';

  if( name == "insCollect" ) {
	  if ( getForm("hxpForm").cName.value == '' ) {
			  alert("Nessuna raccolta attivata. E' necessario selezionarne una.");
			  getForm("hxpForm").xverb.value = "@list";
	  }
  	  else
		if( confirm("Aggiungere il documento alla raccolta '" + getForm("hxpForm").cName.value + "' ?") )
			collectionHandler('addDoc',
							  '',
							  '',
							  getForm("hxpForm").cIsPublic.value,
							  1 + parseInt(getForm("hxpForm").pos.value,10),
							  this/*
                                   * , theTarget
                                   */);
		else
			doSubmit = false;
  }
  else
	  getForm("hxpForm").xverb.value = "@list";

  if ( doSubmit ) {
	  // apro una nuova finestra per le raccolte di documenti
	  var iForm = getForm("hxpForm");

	  iForm.target = iForm.target + "raccolte";
	  window.name = "showDocWin"; // necessario per riconoscere la finestra invocante
	  theCollectionWindow = window.open(staticEmptyWindow,iForm.target,"width=600,height=500");
	  iForm.submit();
	  theCollectionWindow.focus();

	  // ripristino le var di hxpForm modificate
	  getForm("hxpForm").target = oldTarget;
	  getForm("hxpForm").db.value = xDb;
	  getForm("hxpForm").selid.value = selid;
	  getForm("hxpForm").keylist.value = keylist;
  }

  return false;
 }

 /*
  * function collectionHandler(action,name,id,count,theWin) {opener.collectionHandler(action,name,id,count,theWin); }
  */

 function collectionHandler(action,name,id,ispublic,count,theWin,theTarget)
  { var el = document.getElementById("activeCollection");

	//debug
	//alert("document.collectionHandler(): action == " + action);

	if ( action == "open" ) {
		 if ( el != null)
			 el.innerHTML = name+' ['+count+']';

		 getForm("hxpForm").cId.value = id;
		 getForm("hxpForm").cIsPublic.value = ispublic;
		 getForm("hxpForm").cName.value = name;
		 getForm("hxpForm").cCount.value = count;
	}
	else
		 if(action == "show") {
		 }
		 else
			 if(action == "close") {
			 }
			 else
				 if( (action == "addDoc") || ("openOnly" == action) ) {
					 getForm("hxpForm").selid.value = id;
					 getForm("hxpForm").keylist.value = count;
					 getForm("hxpForm").db.value = theWin.getForm("hxpForm").db.value;
					 getForm("hxpForm").xverb.value = "@addDoc";
				 }
				 else
					 if(action == "save") {
					 }
					 else
						 if(action == "saveas") {
						 }
						 else if( action == "disable" ) {
								getForm("hxpForm").cName.value = '';
								getForm("hxpForm").cId.value = '';
								getForm("hxpForm").cIsPublic.value = ispublic;
								getForm("hxpForm").cCount.value = '';
							  }
 }

 function deselect(posizioneAttuale,totaleSelezionati)//deselezione del documento attuale
 {
  setGlobalFormRestore('verbo','xverb','pos','keylist');
  getForm("hxpForm").verbo.value='showdoc';
  getForm("hxpForm").xverb.value='@remove@child';
  getForm("hxpForm").keylist.value=(posizioneAttuale*1)+1;
  getForm("hxpForm").pos.value=posizioneAttuale;
  getForm("hxpForm").submit();
  return false;
 }

 function gotoTableQ(name, refine){
     setGlobalFormRestore('verbo','xverb','query','dbTable','selid','personalView');

     getForm("hxpForm").query.value='';

     if ( name != "collect" && name != "insCollect" && typeof(refine) != 'undefined' && refine == 'R')
         getForm("hxpForm").xverb.value = "@refine";
     else
         getForm("hxpForm").xverb.value = '';

     if ( name.length > 0 ) {
         // Federico 30/05/2005: introdotta gestione della personalView
         var index;

         if ((index = name.indexOf("#personalView=")) != -1) {
             getForm("hxpForm").dbTable.value = '@' + name.substring(0, index);
             getForm("hxpForm").personalView.value = name.substring(index + 14);
         }
         else {
             if(getForm("hxpForm").selTable.length > 0 && getForm("hxpForm").selTable.value != getForm("hxpForm").dbTable.value) {
                 if(getForm("hxpForm").selTable.value.substring(0,1)=='*') {
                     getForm("hxpForm").dbTable.value=getForm("hxpForm").selTable.value.substring(1,getForm("hxpForm").selTable.value.length);
                 }
             }
             else {
                 getForm("hxpForm").dbTable.value='@'+name;
             }

             // getForm("hxpForm").dbTable.value = '@' + name;
             getForm("hxpForm").personalView.value = "";
         }
     }
     else {
         getForm("hxpForm").dbTable.value = '';
         getForm("hxpForm").selid.value='';
         getForm("hxpForm").personalView.value = "";
     }

     if ( name == "collect" || name == "insCollect" ) {
         // gestione delle raccolte
         collection(name);
     }
     else {
         getForm("hxpForm").verbo.value = "query";
         getForm("hxpForm").submit();
     }

     return false;
 }


// Federico 02/12/08: introdotto par. booleano getHttpRequest che consente, solo quando newWin == '_NEW_', di effettuare
// una richiesta GET al posto della solita POST [RW 0055649]
function doProjection(val, aliasName, ord, uri, newWin, xq, absolute_true, getHttpRequest)
{
    // Gregorio 01/02/2006 Richiesta aggiunta 7 parametro che stabilista
	// quando presente la url assoluta su cui fare la proiezione
	// function doProjection(val, aliasName, ord, uri, newWin, xq, absolute_true)

    t_uri = getForm("hxpForm").uri.value + "?db=" + getForm("hxpForm").db.value;

    //alias
    var query = "";
    var alias_vect = aliasName.split(',');

    for ( var i = 0; i < alias_vect.length; i++ ) {
        // Modifica richiesta da Gregorio in data 14/04/2005
        query += " OR ([" + alias_vect[i] + "]=\"" + val + "\")";
        /* Codice originale
         query += " OR ([" + alias_vect[i] + "]%3d" + val + ")";
         */
    }

    query = query.substring(4);

    // Modifica richiesta da Gregorio in data 10/08/2004
    if(typeof(customDoProjectionQueryComposer)!='undefined')  {
        query = customDoProjectionQueryComposer(query, aliasName);
    }

    if ( typeof(xq) != 'undefined' && xq.length > 0 )
        // Federico 25/05/2005: aggiunte parentesi che racchiudono tutta la query. Necessario se si cercano repertori.
        query = '((' + query + ') AND ' + xq + ")";

    var t_ord = "";
    if ( typeof(ord) != 'undefined' && ord.length > 0 )
        t_ord = "&qord=" + realEscape(ord);

    /* INIZIO ELABORAZIONE URL */

    //specificato uri di jsp (N.B - senza primo livello di path, ovvero senza xway)
    if ( typeof(uri) != 'undefined' && uri.length > 0 ) {
        t_uri = getForm("hxpForm").uri.value.substring(0, getForm("hxpForm").uri.value.indexOf("/", 1) + 1) + uri;

        //occorre cambiare url se uri corrente  jsp e proiezione specifica hc.dll (e viceversa)
        var curr_uri = getForm("hxpForm").uri.value;
        var togoLastPart = t_uri.substring(t_uri.lastIndexOf("/") + 1, t_uri.lastIndexOf("?"));
        var iamLastPart = curr_uri.substring(curr_uri.lastIndexOf("/") + 1);
        if ( iamLastPart.indexOf(".dll") != -1 )
            t_uri = t_uri.replace(togoLastPart, iamLastPart);
    }


    //se db acl -> seleziono quello corretto (multi acl)
    if (t_uri.indexOf('db=acl') != -1 && t_uri.indexOf('db=acl-') == -1 && getForm("hxpForm").aclDb.value != '')
        t_uri = t_uri.replace('db=acl','db=' + getForm("hxpForm").aclDb.value);


    // var url = protocol + "//" + host + port + t_uri + '&verbo=queryplain&query=' + query + t_ord + tj + "&host=" + getForm("hxpForm").host.value;
    // Modifica richiesta da Francesco in data 16/02/2005

    var url;

    if(absolute_true)
    {
        url = buildUrlForGet(uri, true, true, true) + '&verbo=queryplain&query=' + realEscape(query) + t_ord;
    }

    else
    {
        url = buildUrlForGet(t_uri, true, true, true) + '&verbo=queryplain&query=' + realEscape(query) + t_ord;
    }

    //Devo passare anche la matricola, nel caso il login non sia univoco (RW: 0031221)
    if(typeof(getForm('hxpForm').matricola) != 'undefined' && getForm('hxpForm').matricola.value.length > 0)
    		url += "&matricola="+getForm('hxpForm').matricola.value.length;

    /* FINE ELABORAZIONE URL */
    // Modifica richiesta da Gregorio in data 10/08/2004
    if(typeof(customDoProjectionURLComposer)!='undefined')  {
        url = customDoProjectionURLComposer(url, aliasName);

    }

    if ( typeof(newWin) != 'undefined' && newWin == '_NEW_' ) { //su nuova finestra
//        var target = getForm("hxpForm").target + 'projection_child';

        var hxpForm = getForm('hxpForm');
        var oldTarget = hxpForm.target;
        hxpForm.target = hxpForm.target + 'projection_child';
        url += '&selid=&xverb=';

        // Federico 02/12/08: introdotto par. booleano getHttpRequest che consente, solo quando newWin == '_NEW_', di effettuare
        // una richiesta GET al posto della solita POST [RW 0055649]
        if (!getHttpRequest) {
            var oldTuples = setFormTuplesFromURL(url, hxpForm);

            // Modifica richiesta da Gregorio in data 10/08/2004
            if ( typeof(customSetProiezWindowFeature) != 'undefined' ) {
                var proiezWindowFeature = customSetProiezWindowFeature(aliasName);
                var theIndexWindow = window.open(staticEmptyWindow, hxpForm.target, proiezWindowFeature);
            }
            else {
                var theIndexWindow = window.open(staticEmptyWindow, hxpForm.target);
            }

            hxpForm.submit();
            hxpForm.target = oldTarget;
            theIndexWindow.focus();
            setFormTuplesFromURL(oldTuples, hxpForm);//restore delle tuple precedenti

            theIndexWindow.focus();
        }
        else {
            var theIndexWindow = window.open(url, hxpForm.target);
            theIndexWindow.focus();
        }
    }
    else {
        //window.location = url;

        url += '&selid=&xverb=';
        var hxpForm = getForm('hxpForm');
        setGlobalFormRestoreFromURL(url);//per back
        setFormTuplesFromURL(url, hxpForm);
        hxpForm.submit();
    }

    return false;
}

function modifyTableDoc(codRep,descrRep){
    setGlobalFormRestore('verbo','xverb','codice_rep','descrizione_rep','dbTable');

	getForm("hxpForm").verbo.value = "docEdit";
	getForm("hxpForm").xverb.value = "@modify";
	//getForm("hxpForm").dbTable.value = ... gia' impostato
	if ( 'undefined' != typeof(codRep) ) getForm("hxpForm").codice_rep.value = codRep;
	if ( 'undefined' != typeof(descrRep) ) getForm("hxpForm").descrizione_rep.value = descrRep;

	/*
     * modifica di Federico del 16/08/2004: spostata l'apertura forzata di una sezione di un doc. di XSpring in una
     * funzione custom.
     */
	if ( typeof(customModifyTableDoc) != 'undefined' ) {
		customModifyTableDoc();
		return false;
	}

	getForm("hxpForm").submit();

	return false;
}

function remove()
{
	if ( typeof(customConfirmRemove) != 'undefined' && customConfirmRemove() == false )
		return false;

    setGlobalFormRestore('verbo','xverb');

	getForm("hxpForm").verbo.value = "docEdit";
	getForm("hxpForm").xverb.value = "@remove";

	OpenWaitMsg();
	getForm("hxpForm").submit();
	return false;
}

function removeRifInt(cod_persona, cod_uff, diritto)
{
	if ( cod_persona == "" || cod_uff == "" || diritto == "" ) {
		alert("Si  verificato un errore");
		return false;
	}

    setGlobalFormRestore('verbo','xverb','rifInt');

	getForm("hxpForm").rifInt.value = cod_persona + '|' + cod_uff + '|'+ diritto;
	getForm("hxpForm").verbo.value = "rifint_response";
	getForm("hxpForm").xverb.value = "@removeRif";

	OpenWaitMsg();
	getForm("hxpForm").submit();
	return false;
}

var trasfFascWindowOpened = false;
function openRifInt(addType, isBozza)
{
    var iForm;
    var old_target = getForm("hxpForm").target;
    var old_verbo = getForm("hxpForm").verbo.value;
    var old_xverb = getForm("hxpForm").xverb.value;
    var old_rifint = getForm("hxpForm").rifInt.value;
    var old_toDo = getForm("hxpForm").toDo.value;

    iForm = getForm("hxpForm");
    iForm.verbo.value = "rifint_response";
    iForm.xverb.value = "@openRif";
    iForm.rifInt.value = addType;
    if (typeof(isBozza) != 'undefined' && isBozza)
        iForm.toDo.value = 'IS_BOZZA';

    iForm.target = iForm.target + 'rifint_child';
    var rifWindow=window.open(staticEmptyWindow, iForm.target, "status=yes,scrollbars=yes,width=800,height=520");
    iForm.submit();
    rifWindow.focus();
    if (addType == 'TRASF')
        trasfFascWindowOpened = true;

    getForm("hxpForm").rifInt.value = old_rifint;
    getForm("hxpForm").target = old_target;
    getForm("hxpForm").verbo.value = old_verbo;
    getForm("hxpForm").xverb.value = old_xverb;
    getForm("hxpForm").toDo.value = old_toDo;

    if ( getForm("hxpForm").selid.value.length == 0 ) //occorre aprire in base a # fisico
        getForm("hxpForm").pos.value = getForm("hxpForm").physDoc.value - 1;

    return false;
}

function removeAttach(name, tipo)
{
    setGlobalFormRestore('verbo','xverb','attach');

	getForm("hxpForm").attach.value = name;
	getForm("hxpForm").verbo.value = "attach_response";

	if ( tipo == 'file' )
		getForm("hxpForm").xverb.value = "@removeFile";
	else if ( tipo == 'immagine' )
		getForm("hxpForm").xverb.value = "@removeImmagine";

	getForm("hxpForm").submit();
	return false;
}

function checkImpronta()
{
	var iForm;
	var old_target = getForm("hxpForm").target;
	var old_verbo = getForm("hxpForm").verbo.value;
	var old_xverb = getForm("hxpForm").xverb.value;

	iForm = getForm("hxpForm");
	iForm.verbo.value = "attach_response";
	iForm.xverb.value = "@checkImpronta";


	iForm.target = iForm.target + 'chkimpronta_child';
	theIndexWindow=window.open(staticEmptyWindow, iForm.target, "width=500,height=150");
	iForm.submit();
	theIndexWindow.focus();

	getForm("hxpForm").target = old_target;
	getForm("hxpForm").verbo.value = old_verbo;
	getForm("hxpForm").xverb.value = old_xverb;

	return false;
}


function addPostit(pos, text)
{
	var iForm;
	var old_target = getForm("hxpForm").target;
	var old_verbo = getForm("hxpForm").verbo.value;
	var old_xverb = getForm("hxpForm").xverb.value;

	iForm = getForm("hxpForm");
	iForm.verbo.value = "postit_response";
	iForm.xverb.value = "@addPage";

	iForm.postitPos.value = pos;
	iForm.postitText.value = text;

	iForm.target = iForm.target + 'postit_child';
	theIndexWindow=window.open(staticEmptyWindow, iForm.target, "width=700,height=400");
	iForm.submit();
	theIndexWindow.focus();

	getForm("hxpForm").target = old_target;
	getForm("hxpForm").verbo.value = old_verbo;
	getForm("hxpForm").xverb.value = old_xverb;

	if ( getForm("hxpForm").selid.value.length == 0 ) //occorre aprire in base a # fisico
		getForm("hxpForm").pos.value = getForm("hxpForm").physDoc.value - 1;

	return false;
}


function delPostit(postitPos)
{
	// conferma aggiunta in occasione dei ritocchi interfaccia XSpring
	if ( confirm('Cancellare l\'annotazione selezionata?') ) {
        setGlobalFormRestore('verbo','xverb','postitPos');

        getForm("hxpForm").verbo.value = "postit_response";
		getForm("hxpForm").xverb.value = "remove";
		getForm("hxpForm").postitPos.value = postitPos;

		OpenWaitMsg(); // messaggio di attesa mentre si compie l'operazione
	getForm("hxpForm").submit();
	}

	return false;
}


function modPostit(pos, text)
{
	return addPostit(pos, text);
}


function insTableDoc(name){
    setGlobalFormRestore('verbo','xverb','pos','physDoc','selid','dbTable');

	getForm("hxpForm").verbo.value = "docEdit";
	getForm("hxpForm").xverb.value = "";
	getForm("hxpForm").physDoc.value=0;
	getForm("hxpForm").pos.value=0;
	getForm("hxpForm").selid.value = "";
	getForm("hxpForm").dbTable.value = '@' + name;

	/*
     * modifica di Federico del 16/08/2004: inserita l'apertura forzata di una sezione di un doc. di XSpring in una
     * funzione custom.
     */
	if ( typeof(customInsTableDoc) != 'undefined' ) {
		customInsTableDoc();
		return false;
	}

	getForm("hxpForm").submit();
	return false;
}

/*
 * Created on: 23/03/2005
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Funzione che consente di aprire la pagina di inserimento di un documento di tipo differente
 * 				da quello del documento che si sta visualizzando (RW0027037).
 * 				'callInfo' deve avere la struttura "<dbTable>|[<codice_rep>]|[<descr_rep>]|[<tipologia>]",
 * 				dove i campi tra '[...]' sono opzionali ( comunque necessario metterli vuoti; per es.
 * 				"varie|||tipol_XXX").
 * 				Viene chiamata la classe "Docedit" con xverb "@newDocFromDoc".
 */
function insDocFromDoc(callInfo)
{
    var params = callInfo.split('|');

    if (params.length != 4) {
        alert("Errore nei parametri della chiamata [" + params + "]");
        return false;
    }

    setGlobalFormRestore('verbo','xverb','pos','selid','dbTable','codice_rep','descrizione_rep','toDo');

    // Federico 27/10/05: inserita chiamata a eventuale funzione custom [RW 0027802]
    if (typeof(customInsDocFromDoc) != 'undefined') {
        customInsDocFromDoc(callInfo);
    }

    getForm("hxpForm").verbo.value = "docEdit";
	getForm("hxpForm").xverb.value = "@newDocFromDoc";
	getForm("hxpForm").pos.value=0;
	getForm("hxpForm").selid.value = "";

	// parametri che identificano il tipo di documento di cui si vuole fare l'inserimento
	getForm("hxpForm").dbTable.value = '@' + params[0];			    // dbTable
	getForm("hxpForm").codice_rep.value = params[1];				// eventuale codice di repertorio
	getForm("hxpForm").descrizione_rep.value = params[2];			// eventuale descrizione di repertorio
	getForm("hxpForm").toDo.value = "docTipologia=" + params[3];	// eventuale tipologia

	getForm("hxpForm").submit();

    return false;
}

function relSetRoot()
{
	var c = confirm(confirmSetRoot);
	if ( c ) {
        setGlobalFormRestore('xverb');
		getForm("hxpForm").xverb.value = "_SET_ROOT_";
		getForm("hxpForm").submit();
	}
	return false;
}


function scartaDoc(cod_persona, cod_uff, diritto)
{
	if ( cod_persona == "" || cod_uff == "" ) {
		alert("Si  verificato un errore");
		return false;
	}
    setGlobalFormRestore('verbo','xverb','rifInt');

	getForm("hxpForm").rifInt.value = cod_persona + '|' + cod_uff + '|' + diritto;
	getForm("hxpForm").verbo.value = "rifint_response";
	getForm("hxpForm").xverb.value = "@scartaDoc";

	OpenWaitMsg();
	getForm("hxpForm").submit();
	return false;
}


function insertSottoFasc(numero, physDoc, nome_persona, nome_uff, cod_persona, cod_uff, classif, classif_cod, tipo_uff)
{
    setGlobalFormRestore('verbo','xverb','physDoc','pos','selid','fasc_numero_sottofasc',
            'physDoc_sottofasc','nome_persona_sottofasc','nome_uff_sottofasc','cod_persona_sottofasc',
            'cod_uff_sottofasc','classif_sottofasc','classif_cod_sottofasc', 'tipo_uff_sottofasc');

	getForm("hxpForm").verbo.value = "docEdit";
	getForm("hxpForm").xverb.value = "";
	getForm("hxpForm").physDoc.value = 0;
	getForm("hxpForm").pos.value = 0;
	getForm("hxpForm").selid.value = "";

	getForm("hxpForm").fasc_numero_sottofasc.value = numero;
	getForm("hxpForm").physDoc_sottofasc.value = physDoc;
	getForm("hxpForm").nome_persona_sottofasc.value = nome_persona;
	getForm("hxpForm").nome_uff_sottofasc.value = nome_uff;
	getForm("hxpForm").cod_persona_sottofasc.value = cod_persona;
	getForm("hxpForm").cod_uff_sottofasc.value = cod_uff;

    // Federico 16/05/07: introdotto tipo del valore contenuto nei campi ufficio [RW 0043770]
    getForm("hxpForm").tipo_uff_sottofasc.value = tipo_uff;

	getForm("hxpForm").classif_sottofasc.value = classif;
	getForm("hxpForm").classif_cod_sottofasc.value = classif_cod;

	getForm("hxpForm").submit();
	return false;
}


function archiviaFascicolo()
{
    setGlobalFormRestore('verbo','xverb');
	getForm("hxpForm").verbo.value = "fascicoli_response";
	getForm("hxpForm").xverb.value = "@archivia";

	OpenWaitMsg();
	getForm("hxpForm").submit();
	return false;
}


function apriFascicolo()
{
    setGlobalFormRestore('verbo','xverb');

	getForm("hxpForm").verbo.value = "fascicoli_response";
	getForm("hxpForm").xverb.value = "@apri";

	OpenWaitMsg();
	getForm("hxpForm").submit();
	return false;
}


function annullaDoc(diritto)
{
	if ( diritto == 'false' ) {
		alert("Questa operazione pu essere effettuata solo dal Direttore del Protocollo");
		return false;
	}

	var iForm;
	var old_target = getForm("hxpForm").target;
	var old_verbo = getForm("hxpForm").verbo.value;
	var old_xverb = getForm("hxpForm").xverb.value;

	iForm = getForm("hxpForm");
	iForm.verbo.value = "documento_response";
	iForm.xverb.value = "@openAnnullaPage";


	iForm.target = iForm.target + 'postit_child';
	//RW0047596 - 23/10/2007 - fcossu
	var annullaWindow = window.open(staticEmptyWindow, iForm.target, "width=800,height=600,scrollbars=yes");
	iForm.submit();
	annullaWindow.focus();

	getForm("hxpForm").target = old_target;
	getForm("hxpForm").verbo.value = old_verbo;
	getForm("hxpForm").xverb.value = old_xverb;

	if ( getForm("hxpForm").selid.value.length == 0 ) //occorre aprire in base a # fisico
		getForm("hxpForm").pos.value = getForm("hxpForm").physDoc.value - 1;

	return false;
}

function protocolla (isRepertorio,newPne,newPnce,codRep,descrRep)
{
    OpenWaitMsg();

    setGlobalFormRestore('bozzaDaProt','pne','pnce','verbo','xverb','codice_rep','descrizione_rep');

    //alert(newPne+"+"+newPnce);
    if ( 'undefined' != typeof(getForm("hxpForm").bozzaDaProt) ) {
        getForm("hxpForm").bozzaDaProt.value = "DOC" ;
        if ( 'true' == isRepertorio ) {
            getForm("hxpForm").bozzaDaProt.value += ".REP" ;
        }
    }
    //alert(getForm("hxpForm").bozzaDaProt.value);
    getForm("hxpForm").pne.value = newPne; //'doc';
    getForm("hxpForm").pnce.value = newPnce; //'list_of_doc';
    getForm("hxpForm").verbo.value='docEdit';
    getForm("hxpForm").xverb.value='@save';
    if ( 'undefined' != typeof(codRep) ){
        if ( 'false' == isRepertorio ) alert("Le informazioni per la protocollazione sono incongruenti");
        else getForm("hxpForm").codice_rep.value = codRep;
    }
    if ( 'undefined' != typeof(descrRep) ){
        if ( 'false' == isRepertorio ) alert("Le informazioni per la protocollazione sono incongruenti");
        else getForm("hxpForm").descrizione_rep.value = descrRep;
    }
    getForm("hxpForm").submit();
    return false;
}


function validaDoc()
{
    setGlobalFormRestore('verbo','xverb');

	getForm("hxpForm").verbo.value = "documento_response";
	getForm("hxpForm").xverb.value = "@valida";

	OpenWaitMsg();
	getForm("hxpForm").submit();
	return false;
}


function chkout(fileId, fileName, conversioni)
{

    //modifica di mbussetti del 21/03/2005: viene gestito un terzo argomento per la funzione, che contiene la
    //lista delle conversioni richieste in precedenza per il file che viene prenotato
    if ('undefined' != typeof(conversioni)){
        if ('undefined' != typeof(getForm("hxpForm").convReq)){
            getForm("hxpForm").convReq.value = conversioni;
        }
    }

	if ( typeof(getForm("hxpForm").enableIW) != 'undefined' && getForm("hxpForm").enableIW.value == 'true' ) {
		doChkout(fileId, fileName);
	}
	else {
		var old_target = getForm("hxpForm").target;

		iForm = getForm("hxpForm");
		iForm.verbo.value = "attach";
		iForm.id.value = fileId;
		iForm.name.value = fileName;

		var newWindow = window.open(staticEmptyWindow, '_new');
		iForm.target = '_new';
		iForm.submit();
		getForm("hxpForm").target = old_target;
		newWindow.focus();

		doChkout(fileId, fileName);
	}

	return false;
}


function doChkout(fileId, fileName)
{
    setGlobalFormRestore('verbo','xverb','attach','name');

	getForm("hxpForm").attach.value = fileId;
	getForm("hxpForm").name.value = fileName;
	getForm("hxpForm").verbo.value = "attach_response";
	getForm("hxpForm").xverb.value = "@chkout";
	getForm("hxpForm").submit();
}


function abandonChkout(fileId)
{
    setGlobalFormRestore('verbo','xverb','attach');

	getForm("hxpForm").attach.value = fileId;
	getForm("hxpForm").verbo.value = "attach_response";
	getForm("hxpForm").xverb.value = "@abandonChkout";
	getForm("hxpForm").submit();
	return false;
}


function chkin(fileId, fileName, tipo) //apre la pagina per eseguire il chkin
{
	var old_target = getForm("hxpForm").target;
	var old_verbo = getForm("hxpForm").verbo.value;
	var old_xverb = getForm("hxpForm").xverb.value;

	iForm = getForm("hxpForm");
	iForm.attach.value = fileId;
	iForm.name.value = fileName;
	iForm.verbo.value = "attach_response";
	iForm.xverb.value = "@chkin";
	if ( typeof(tipo) != 'undefined' && tipo == 'load' )
		getForm("hxpForm").xverb.value += '@load';

	iForm.target = getForm("hxpForm").target + "_chkin";
	var newWindow = window.open(staticEmptyWindow, iForm.target, "width=600,height=400");
	iForm.submit();
	newWindow.focus();

	getForm("hxpForm").target = old_target;
	getForm("hxpForm").verbo.value = old_verbo;
	getForm("hxpForm").xverb.value = old_xverb;

	if ( getForm("hxpForm").selid.value.length == 0 ) //occorre aprire in base a # fisico
		getForm("hxpForm").pos.value = getForm("hxpForm").physDoc.value - 1;

	return false;
}


function fileVersions(fileId)
{
	var old_target = getForm("hxpForm").target;
	var old_verbo = getForm("hxpForm").verbo.value;
	var old_xverb = getForm("hxpForm").xverb.value;

	iForm = getForm("hxpForm");
	iForm.attach.value = fileId;
	iForm.verbo.value = "attach_response";
	iForm.xverb.value = "@fileVersions";

	iForm.target = getForm("hxpForm").target + "_fileversions";
	var newWindow = window.open(staticEmptyWindow, iForm.target, "width=600,height=400,toolbar=no,location=no,status=yes,scrollbars=yes");
	iForm.submit();
	newWindow.focus();

	getForm("hxpForm").target = old_target;
	getForm("hxpForm").verbo.value = old_verbo;
	getForm("hxpForm").xverb.value = old_xverb;

	return false;
}

function doProjectionWithSubmit(val, aliasName, ord, newWin)
{
	var iForm;
	var old_target = getForm("hxpForm").target;
	var old_verbo = getForm("hxpForm").verbo.value;
	var old_xverb = getForm("hxpForm").xverb.value;
	var old_query = getForm("hxpForm").query.value;
	var old_selid = getForm("hxpForm").selid.value;

	iForm = getForm("hxpForm");
	iForm.verbo.value = "queryplain";
	iForm.selid.value = "";

	//alias
	var query = "";
	var alias_vect = aliasName.split(',');

	for ( var i = 0; i < alias_vect.length; i++ ) {
		// Modifica richiesta da Gregorio in data 14/04/2005
		query += " OR ([" + alias_vect[i] + "]=\"" + val + "\")";
		/* Codice originale
		   query += " OR ([" + alias_vect[i] + "]=" + val + ")";
		*/
	}

	query = query.substring(4);
	iForm.query.value = query;
	iForm.xverb.value = "";

	if ( typeof(ord) != 'undefined' )
		iForm.qord.value = ord;


	if ( typeof(newWin) != 'undefined' && newWin == '_NEW_' ) { //su nuova finestra
		iForm.target = iForm.target + 'projection_child';
		theIndexWindow=window.open(staticEmptyWindow, iForm.target);
		theIndexWindow.focus();
	}


	iForm.submit();

	getForm("hxpForm").target = old_target;
	getForm("hxpForm").verbo.value = old_verbo;
	getForm("hxpForm").xverb.value = old_xverb;
	getForm("hxpForm").query.value = old_query;
	getForm("hxpForm").selid.value = old_selid;
	return false;
}

function checksum(content)
{
  //alert (content);
  var pointerString = "key32=";
  var errorMsg = "***";
  var start = content.indexOf(pointerString);
  if ( start != -1 ){
     var toCheck = content.substr(start+pointerString.length,errorMsg.length);
     if ( toCheck == errorMsg ) alert ("Violata integrit del documento");
  }
  return true;
}


function ripetiNuovo(name)
{
    setGlobalFormRestore('verbo','xverb','pos','selid','dbTable');

	getForm("hxpForm").verbo.value = "docEdit";
	getForm("hxpForm").xverb.value = "@ripetinuovo";
	getForm("hxpForm").pos.value=0;
	getForm("hxpForm").selid.value = "";
	if ( name.length > 0 )
		getForm("hxpForm").dbTable.value = '@' + name;
	getForm("hxpForm").submit();
	return false;

}

function setXverbForViewer()
{
	if ( getForm("hxpForm").xverb.value.indexOf("child") == -1 )
		getForm("hxpForm").xverb.value = '';
}


function modificaDocumento(pne,posizioneAttuale,totaleSelezionati,selezione,xverb)
{var cont=true;
 if(cont&&"remove"==xverb){
//	 cont=confirm("Confermi la cancellazione del documento?");
  out=prompt("Confermi la cancellazione del documento?", "no");
  out=out.toLowerCase();
  cont=(("si"==out)||(("s"+unescape("%ec"))==out)||("yes"==out));
 }
 if(cont){
  setGlobalFormRestore('verbo','xverb','revSel','selid','target','pne');

  getForm("hxpForm").verbo.value='docEdit';
  getForm("hxpForm").xverb.value=typeof(xverb)!='undefined'?xverb:'';
  if(getForm("hxpForm").revSel.value==''&&
	  getForm("hxpForm").selid.value!=''&&
	  getForm("hxpForm").selid.value!=getForm("hxpForm").cId.value)
	  getForm("hxpForm").revSel.value='1';
  getForm("hxpForm").target='_top';
  getForm("hxpForm").pne.value=pne;
  getForm("hxpForm").submit();
 }
 return false;
}


function showHistory(ordinamento)
{
	var old_target = getForm("hxpForm").target;
	var old_verbo = getForm("hxpForm").verbo.value;
	var old_xverb = getForm("hxpForm").xverb.value;
	var old_oldTable = getForm("hxpForm").oldTable.value;

	iForm = getForm("hxpForm");
	iForm.verbo.value = "storia_response";
	iForm.xverb.value = "@" + ordinamento;

	if ( iForm.oldTable.value.length == 0 )
		iForm.oldTable.value = iForm.dbTable.value;

	iForm.target = getForm("hxpForm").target + "_history";
	var newWindow = window.open(staticEmptyWindow, iForm.target, "width=800,height=600,toolbar=no,location=no,status=yes,scrollbars=yes");
	iForm.submit();
	newWindow.focus();

	getForm("hxpForm").target = old_target;
	getForm("hxpForm").verbo.value = old_verbo;
	getForm("hxpForm").xverb.value = old_xverb;
	getForm("hxpForm").oldTable.value = old_oldTable;

	if ( getForm("hxpForm").selid.value.length == 0 ) //occorre aprire in base a # fisico
		getForm("hxpForm").pos.value = getForm("hxpForm").physDoc.value - 1;

	return false;
}


function openUrl(url, typeOfLink, newWindow, specialTemplate, alias)
{
	/*
     * Federico 24/01/2005: se il tipo dell'url ('typeOfLink') indica che l'url rappresenta un nrecord (il che viene
     * determinato mediante una funzione custom), non bisogna aprire un link normale, bens occorre avviare una ricerca
     * per visualizzare il documento associato a quell'nrecord. Il parametro booleano 'newWindow' indica se aprire il
     * documento in una nuova finestra o meno. Il parametro 'specialTemplate', invece, rappresenta una stringa che viene
     * anteposta alla tupla 'view' per indicare il template da usare per la visualizzazione del documento indicato
     * (questo, per esempio, consente di invocare un template senza pulsantiera, cosa molto utile quando 'newWindow ==
     * true' per impedire all' utente di usare l'applicazione dalla nuova finestra). Quando 'newWindow == false' il
     * parametro 'specialTemplate' viene ignorato.
     */
    if (typeof(typeOfLink) != 'undefined' && typeOfLink != "") {
	    if (typeof(customLinkIsNRecord) != 'undefined' && customLinkIsNRecord(typeOfLink) && url.indexOf('/') == -1) {

            var aliasToUse = "doc_nrecord";
            if (typeof(alias) != 'undefined' && alias.length > 0)
                aliasToUse = alias;

	        // url rappresenta un nrecord --> avvio della ricerca per visualizzare il documento
	        var oldVerb = getForm("hxpForm").verbo.value;
	        var oldXVerb = getForm("hxpForm").xverb.value;
	        var oldQuery = getForm("hxpForm").query.value;
	        var oldSelId = getForm("hxpForm").selid.value;
	        var old_dest = getForm("hxpForm").target;
	        var oldView = getForm("hxpForm").view.value;

	        var tmpForm = getForm("hxpForm");
	        tmpForm.verbo.value = "queryplain";
	        tmpForm.xverb.value = "";
	        tmpForm.query.value = "[" + aliasToUse + "]=" + url;
	        tmpForm.selid.value = "";

	        if (typeof(newWindow) != 'undefined' && newWindow) {
	            if (typeof(specialTemplate) != 'undefined' && specialTemplate != "" && tmpForm.view.value.indexOf(specialTemplate) == -1) {
    	            tmpForm.view.value = specialTemplate + tmpForm.view.value;
    	        }
		        tmpForm.target = "xlinkTarget";
		        newWinForShowDoc = window.open('', tmpForm.target, "width=640,height=480,resizable=yes,scrollbars");
			    newWinForShowDoc.focus();
	        }
	        tmpForm.submit();
	        getForm("hxpForm").verbo.value = oldVerb;
	        getForm("hxpForm").xverb.value = oldXVerb;
	        getForm("hxpForm").query.value = oldQuery;
	        getForm("hxpForm").selid.value = oldSelId;
	        getForm("hxpForm").target = old_dest;
	        getForm("hxpForm").view.value = oldView;

	        return false;
	    }
	}

    // apertura di un link normale
	var win = window.open(url.indexOf('http') == 0 ? url : 'http://' + url, '_new');
	win.focus();

	return false;
}

function rigetta(confirmMsg, mustAddPostit)
{
    // Federico 26/10/07: introdotta possibilita' di inserire un'annotazione in fase di rigetto e di personalizzare
    // l'alert mostrato all'utente [RW 0047756]
    var requestConfirm = true;

    if (typeof(confirmMsg) != "undefined" && confirmMsg != null) {
        if (confirmMsg == "<NONE>") requestConfirm = false;
    }
    else {
        confirmMsg = "ATTENZIONE questa operazione restituisce il documento a chi lo ha protocollato, procedere?";
    }

    if (requestConfirm) {
        var ret = confirm(confirmMsg);

        if (ret == false) return false;
    }

    if (typeof(mustAddPostit) != "undefined" && mustAddPostit != null && mustAddPostit == "true") {
        // e' richiesto l'inserimento di un postit
        getForm("hxpForm").toDo.value += "%doRigetta%";

        return addPostit('', '');
    }
    else {
    setGlobalFormRestore('verbo','xverb');

    getForm("hxpForm").verbo.value = "rifint_response";
    getForm("hxpForm").xverb.value = "@rigetta";

    OpenWaitMsg();
    getForm("hxpForm").submit();
    return false;
}
}

function invioTelematico(pos, already)
{
    var ret = confirm("Procedere con l'invio telematico del documento?");
    if (ret == false)
        return false;

    if (already) {
        var ret = confirm("Il documento  gi stato inviato.\n\nSi  sicuri di voler procedere nuovamente all'invio?");
        if (ret == false)
            return false;
    }

    setGlobalFormRestore('verbo','xverb','postitPos');

    getForm("hxpForm").verbo.value = "documento_response";
    getForm("hxpForm").xverb.value = "@invioTelematico";
    getForm("hxpForm").postitPos.value = pos; //utilizzo postitPos perch disponibile per questa operazione

    OpenWaitMsg();
    getForm("hxpForm").submit();
    return false;
}

// Federico 08/07/09: invio multiplo ai destinatari interni (interoperabilita' con i ws) [M 0000498]
function invioTelematicoWSDestIntMultiplo(already)
{
    var ret = confirm("Procedere con l'invio telematico del documento?");

    if (ret == false) return false;

    if (already) {
        var ret = confirm("Il documento  gi stato inviato.\n\nSi  sicuri di voler procedere nuovamente all'invio?");

        if (ret == false) return false;
    }

    setGlobalFormRestore('verbo','xverb');

    getForm("hxpForm").verbo.value     = "documento_response";
    getForm("hxpForm").xverb.value     = "@invioTelematicoWSDestIntMultiplo";

    OpenWaitMsg();

    getForm("hxpForm").submit();

    return false;
}

// Federico 21/12/09: invio multiplo ai destinatari PEC [EF 492]
function invioTelematicoPECMultiplo(already)
{
    var ret = confirm("Procedere con l'invio telematico del documento a tutti i destinatari PEC?");

    if (ret == false) return false;

    if (already) {
        var ret = confirm("Il documento  gi stato inviato.\n\nSi  sicuri di voler procedere nuovamente all'invio?");

        if (ret == false) return false;
    }

    setGlobalFormRestore('verbo','xverb');

    getForm("hxpForm").verbo.value     = "documento_response";
    getForm("hxpForm").xverb.value     = "@invioTelematicoPECMultiplo";

    OpenWaitMsg();

    getForm("hxpForm").submit();

    return false;
}

/*
 * Created on: 26/10/2004
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Funzione invocata per la rimozione di un documento dalla selezione corrente.
 */
function removeDocFromSel()
{
    setGlobalFormRestore('verbo','xverb');

	getForm("hxpForm").verbo.value = 'showdoc';
	getForm("hxpForm").xverb.value = '@removeDocFromSel';

	getForm("hxpForm").submit();

   return false;
}

/*
 * Created on: 29/10/2004
 * by: Federico Grillini (fgr)
 * organization: 3D Informatica
 * description: Funzione invocata per la visualizzazione della pagina dei profili di stampa.
 */
function printProfiles()
{
    setGlobalFormRestore('verbo','dbTable');

	getForm("hxpForm").verbo.value = 'print_profiles';
	getForm("hxpForm").dbTable.value = '';

	getForm("hxpForm").submit();

	return false;
}


function assegnaIntervento(cod_persona, cod_uff, diritto)
{
    if ( cod_persona == "" || cod_uff == "" || diritto == '') {
        alert("Si  verificato un errore");
        return false;
    }
    setGlobalFormRestore('verbo','xverb','rifInt');

    getForm("hxpForm").rifInt.value = cod_persona + '|' + cod_uff + '|' + diritto;
    getForm("hxpForm").verbo.value = "rifint_response";
    getForm("hxpForm").xverb.value = "@assegnaIntervento";

    OpenWaitMsg();
    getForm("hxpForm").submit();
    return false;
}


function rimuoviIntervento(cod_persona, cod_uff, diritto)
{
    if ( cod_persona == "" || cod_uff == "" || diritto == '') {
        alert("Si  verificato un errore");
        return false;
    }
    setGlobalFormRestore('verbo','xverb','rifInt');

    getForm("hxpForm").rifInt.value = cod_persona + '|' + cod_uff + '|' + diritto;
    getForm("hxpForm").verbo.value = "rifint_response";
    getForm("hxpForm").xverb.value = "@rimuoviIntervento";

    OpenWaitMsg();
    getForm("hxpForm").submit();
    return false;
}

/*
 * Created on: 07/12/2004
 * by: Federico Grillini (fgr)
 * organization: 3D Informatica
 * description: Funzione invocata per l'apertura di un thesauro mediante le molliche della pagina di visualizzazione.
 */
function showthesRel(rel, keypath, startkey, alias, cPath, nodo)
{
    // Federico 24/01/2005: chiusura finestra usata per visualizzare un documento cliccando sul link del suo NRECORD
    if (typeof(window.opener) != 'undefined' && window.opener != null) {
        /*
         * Mi trovo in una finestra aperta per visualizzare un doc. tramite il link sul suo nrecord --> navigazione
         * disabilitata --> chiudo la finestra ed esco.
         */
        this.close();

        return false;
    }

    var lastPipe = 1;

	// posizionamento sullo slash dell'ultimo nodo da mantenere.
	for (var i = 0; i <= nodo; i++) {
		lastPipe = cPath.indexOf("|", lastPipe + 1);
	}

	if (lastPipe != -1) {
		cPath = cPath.substring(0, lastPipe);
	}

    setGlobalFormRestore('verbo','xverb','cPath','keypath','startkey','relation','xMode','toDo','selid');

	getForm("hxpForm").cPath.value = cPath.substring(0, cPath.lastIndexOf("|"));

	// apertura del thesauro nella stessa finestra
	getForm("hxpForm").verbo.value = "showthes";
	getForm("hxpForm").xverb.value = "@" + rel;      //per template in cui sfociare
	getForm("hxpForm").keypath.value = keypath;      //canale del ths
	getForm("hxpForm").startkey.value = startkey;    //primo termine della relazione
	getForm("hxpForm").relation.value = rel;         //relazione
	getForm("hxpForm").xMode.value = alias;          //alias da utilizzare quando si arriva alla foglia

	// Federico 21/06/05:  opportuno svuotare 'selid' perch potrebbe invalidare ricerche successive fatte con il th.
	getForm("hxpForm").selid.value = "";

	/*
     * Modifica di Federico del 21/12/2004: la tupla 'toDo' viene utilizzata per indicare alla classe generica
     * 'Showthes.java' di mostrare tutti i figli di un termine del th secondo una certa relazione, che hanno una
     * frequenza maggiore o uguale a quella indicata nella var. 'thMinFreq' (che deve essere definita a livello
     * specifico). Settare la tupla 'toDo' in questa funzione consente di navigare il thesauro a partire dalle molliche,
     * senza visualizzare i termini con frequenze inferiori a 'thMinFreq'.
     */
	if (typeof(thMinFreq) != 'undefined' && typeof(getForm("hxpForm").toDo) != 'undefined' &&
		thMinFreq != '' && getForm("hxpForm").view.value != '') {
		getForm("hxpForm").toDo.value = "set_minFreq_for_TH_navigation:" + thMinFreq;
	}

	getForm("hxpForm").submit();

	return false;
}


function archiviaRaccoglitore()
{
    setGlobalFormRestore('verbo','xverb');

    getForm("hxpForm").verbo.value = "fascicoli_response";
    getForm("hxpForm").xverb.value = "@archiviaRaccoglitore";

    OpenWaitMsg();
    getForm("hxpForm").submit();
    return false;
}


function apriRaccoglitore()
{
    setGlobalFormRestore('verbo','xverb');

    getForm("hxpForm").verbo.value = "fascicoli_response";
    getForm("hxpForm").xverb.value = "@apriRaccoglitore";

    OpenWaitMsg();
    getForm("hxpForm").submit();
    return false;
}
/*
 * Created on: 07/04/2005
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Funzione che consente di recuperare dei documenti collegati a quello che si sta per visualizzare
 * 				con la Showdoc mediante la query indicata da 'query'.
 * 				'info' contiene, invece, delle informazioni generiche che e' possibile mostrare in visualizzazione
 * 				(per es. un titolo da mostrare prima dell'elenco dei documenti trovati).
 *              'queryBehaviour' indica se restituire i titoli sempre oppure solo nel caso in cui vengano trovati
 *              pi documenti (valori possibili "forceShowTitles" o "normal"; il default  "normal").
 * 				Viene chiamata la classe "Showdoc" con xverb "@getLinkedDocs".
 */
function getLinkedDocs(query, info, queryBehaviour)
{
    if (typeof(query) != 'undefined' && query.length > 0) {
        setGlobalFormRestore('verbo','xverb', 'query', 'toDo', 'pos');

	    getForm("hxpForm").verbo.value = "showdoc";
	    getForm("hxpForm").xverb.value = "@getLinkedDocs";
	    getForm("hxpForm").query.value = query;

	    if (typeof(info) != 'undefined' && info.length > 0) {
	        // la tupla 'toDo' potrebbe contenere informazioni per altri scopi --> vado in append
	        getForm("hxpForm").toDo.value += "setLinkedDocsInfo(" + info + ")";
	    }

        /* Federico 22/06/05: introdotta possibilit di indicare il comportamento della query da effettuare
         * per recuperare i doc. collegati. 'queryBehaviour' indica se restituire i titoli sempre oppure
         * solo nel caso in cui vengano trovati pi documenti.
         */
        if (typeof(queryBehaviour) != 'undefined' && queryBehaviour.length > 0) {
            // la tupla 'toDo' potrebbe contenere informazioni per altri scopi --> vado in append
            getForm("hxpForm").toDo.value += "queryBehaviour(" + queryBehaviour + ")";
        }

	    // Federico 30/05/2005: se 'selid'  vuoto, 'pos' indica il numero fisico del documento da visualizzare
	    if ( getForm("hxpForm").selid.value == '' ) {
	        getForm("hxpForm").pos.value = getForm("hxpForm").physDoc.value - 1;
	    }

        // Federico 26/10/05: introdotta chiamata a un'eventuale funzione custom
        if (typeof(customGetLinkedDocs) != 'undefined') {
            customGetLinkedDocs(query, info, queryBehaviour);
        }

	    OpenWaitMsg();
	    getForm("hxpForm").submit();
    }
    else {
        // query non  definito o  vuoto --> notifico l'errore al programmatore
        alert("Il parametro 'query' non  definito o  vuoto!");
    }

    return false;
}

/*
 * Created on: 11/04/2005
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Funzione che consente di visualizzare i documenti collegati a quello visualizzato.
 *
 * 				'posizione' rappresenta la posizione del doc. da visualizzare nella selezione a cui appartengono
 * 							i doc. collegati;
 * 				'tipo' 		rappresenta il db usato;
 * 				'asText' 	indica se aggiungere in coda a xverb la stringa '@asText' (i valori possibili sono '0' e
 * 							'1');
 * 				'xdoc' 		contiene, infine, le eventuali estensioni da utilizzare per caricare il documento
 * 							indicato da 'posizione'.
 *
 * 				La selezione dei documenti collegati e il loro numero vengono prelevati dalla tupla
 * 				'hxpForm.showLinkedDocsInfo', che ha la struttura "selId|count".
 */
function showLinkedDoc(posizione, tipo, asText, xdoc)
{
    if (typeof(getForm("hxpForm").showLinkedDocsInfo) != 'undefined' && getForm("hxpForm").showLinkedDocsInfo.value != "") {
        setGlobalFormRestore('verbo','xverb','pos','db','xDoc', 'selid', 'count');

        var iForm = getForm("hxpForm");
	    var old_verbo = iForm.verbo.value;
	    var old_pos = iForm.pos.value;
	    var old_db = iForm.db.value;
	    var old_xverb = iForm.xverb.value;
	    var old_xDoc = iForm.xDoc.value;
	    var old_selid = iForm.selid.value;
	    var old_count = iForm.count.value;

	    iForm.pos.value = posizione;
	    iForm.db.value = tipo;

	    // lettura tupla 'hxpForm.showLinkedDocsInfo'
	    var showLinkedDocsInfo = getForm("hxpForm").showLinkedDocsInfo.value.split("|");

	    if (showLinkedDocsInfo.length == 2) {
	        // impostazione della selezione dei doc. collegati e del loro numero
	        iForm.selid.value = showLinkedDocsInfo[0];
	        iForm.count.value = showLinkedDocsInfo[1];

	        var asTextCmd = '@asText';

		    if (asText == 1) {
		        if(iForm.xverb.value.indexOf(asTextCmd) < 0) {
		            iForm.xverb.value += asTextCmd;
		        }
		    }
		    else {
		        iForm.xverb.value = iForm.xverb.value.replace(asTextCmd, '');
		    }

		    if (typeof(xdoc) != 'undefined') {
		        iForm.xDoc.value = xdoc;
		    }

		    // Federico 26/10/05: introdotta chiamata a un'eventuale funzione custom
            if (typeof(customShowLinkedDocs) != 'undefined') {
                customShowLinkedDocs(posizione, tipo, asText, xdoc);
            }

		    OpenWaitMsg();
		    iForm.submit();
	    }
	    else {
	        // la tupla 'hxpForm.showLinkedDocsInfo' non contiene le informazioni necessarie per proseguire
	        alert("La tupla \"showLinkedDocsInfo\" non contiene le informazioni necessarie per proseguire!");
	    }

	    iForm.verbo.value = old_verbo;
	    iForm.pos.value = old_pos;
	    iForm.db.value = old_db;
	    iForm.xverb.value = old_xverb;
	    iForm.xDoc.value = old_xDoc;
	    iForm.selid.value = old_selid;
	    iForm.count.value = old_count;
    }
    else {
        // la tupla 'showLinkedDocsInfo' non esiste o  vuota
        alert("La tupla \"showLinkedDocsInfo\" non esiste o  vuota!");
    }

 return false;
}
//DD 03/05/2006 Gestisce tutti i pulsanti per la visualizzazione dei CC raggruppati per ufficio (RW: 0035918)
// Federico 18/05/09: introdotto parametro 'isCCFasc' che vale true per i CC ereditati dai fascicoli (gestione dei CC nei fascicoli) [M 0000378]
// Federico 21/05/09: introdotto parametro 'fasc_prefix' per gestione raggruppamento CC per ufficio (gestione dei CC dei fascicoli collegati/minuta) [M 0000378]
function hideShowCC(ufficio, allComand, isCCFasc, fasc_prefix)
{
   if (isCCFasc == null || typeof(isCCFasc) == 'undefined') isCCFasc = false;

   if (typeof(fasc_prefix) == 'undefined' || fasc_prefix == null || fasc_prefix.length == 0) {
        fasc_prefix = '-';
   }
   else if (fasc_prefix != 'M') {
        fasc_prefix = '.' + fasc_prefix + '-';
   }
   else {
        fasc_prefix += '-';
   }

   var prefix = (!isCCFasc ? 'CCdiv-' : 'CCdivFasc' + fasc_prefix) + ufficio;

   var typeToShow = '';
   var forceClose = false;

   // Federico 18/05/09: aggiunti test "allComand == null || allComand == ''" (gestione dei CC nei fascicoli) [M 0000378]
   if(typeof(allComand) == 'undefined' || allComand == null || allComand == '') {
      //Prima di tutto cerco di capire se devo mostrare o nascondere.
      var oClosedDiv = document.getElementById(prefix + '-closed');
      if(oClosedDiv == null) return; //ERRORE
      //bShow = true se devo mostrare, false se devo nascondere
      bShow = oClosedDiv.style.display.indexOf("none")==-1 ? true:false;
      typeToShow = 'closed';
      if(bShow) typeToShow = 'open';
   } else {
      //Pulsante generale
      if(allComand=='expand'){
         typeToShow = 'open'
         hideShowCC_ShowAllButton('min', isCCFasc, fasc_prefix);
         //Chiudo il pulsante precedente
      }else if(allComand=='compact'){
         typeToShow = 'close';
         hideShowCC_ShowAllButton('exp', isCCFasc, fasc_prefix);
      }else if(allComand=='minimize'){
         forceClose = true;
         hideShowCC_ShowAllButton('compact', isCCFasc, fasc_prefix);
      } else {
         alert('debug: errore allComand non riconosciuto:' + allComand);
      }
   }

   // Show/hide degli elementi
   var elements = document.getElementsByTagName("tr");
	for (var i = 0; i < elements.length; i++ ){
		if(elements[i].id.indexOf(prefix) == 0){
		   if(elements[i].id.indexOf('-' + typeToShow) != -1 && !forceClose){
		      //Visualizzo questo
		      //alert('debug VIS:'+ elements[i].id);
		      setVisibility(elements[i], '');
			} else {
			   //Nascondo questo
			   //alert('debug HIDE:'+ elements[i].id);
			   setVisibility(elements[i], 'none');
			}
		}
	}
	//Visualizzo/Nascondo la stringa di riassunto
	var el = document.getElementById((!isCCFasc ? 'divCC-totale' : 'divCCFasc' + fasc_prefix + 'totale'));

	if(el != null)
	   if(forceClose){
	      setVisibility(el, '');
	   } else {
	      setVisibility(el, 'none');
	   }

 return false;
}
//DD 03/05/2006 Gestisce tutti i pulsanti "tristate" dell'intestazione dei CC(RW: 0035918)
// Federico 18/05/09: introdotto parametro 'isCCFasc' che vale true per i CC ereditati dai fascicoli (gestione dei CC nei fascicoli) [M 0000378]
// Federico 21/05/09: introdotto parametro 'fasc_prefix' per gestione raggruppamento CC per ufficio (gestione dei CC dei fascicoli collegati) [M 0000378]
function hideShowCC_ShowAllButton(name, isCCFasc, fasc_prefix) {
   var ccDivName = (!isCCFasc ? 'CCdiv--all_' : 'CCdivFasc' + fasc_prefix + '-all_');

   //alert(ccDivName);

   tagList = "td|tr";
   tags = tagList.split("|");
   for (var t=0; t < tags.length; t++ ){
       // Show/hide degli elementi tr e td
      var elements = document.getElementsByTagName(tags[t]);
   	for (var i = 0; i < elements.length; i++ ){
   	   if(elements[i].id.indexOf(ccDivName) == 0 ){
      		if(elements[i].id == ccDivName + name){
      	      //Visualizzo questo
      	      //alert('debug VIS:'+ elements[i].id);
      	      setVisibility(elements[i], '');
      		} else {
      		   //Nascondo questo
      		   //alert('debug HIDE:'+ elements[i].id);
      		   setVisibility(elements[i], 'none');
            }
       }
   	}
   }
}

 function numdocnavbarcode(pos,count)
 {
  var ret="";
  var startprint,endprint;

  startprint=0;
  endprint=count;

  if (count<=10)
  {
    startprint=0;
    endprint=count;
  }
  else
  {
   if((pos-5)>0)
   {startprint=pos-5}
   else
   {startprint=0;}

   if((pos+5)<count)
   {endprint=pos+5;}
   else
   {endprint=count;}

   //eventuale allargamento a destra
   if(endprint-startprint<10)
   {
    while((endprint+1<=count) && endprint-startprint<10)
    { endprint++;
    }

   }
   //eventuale allargamento a sinistra
   if(endprint-startprint<10)
   {
       while((startprint-1>0) && endprint-startprint<10)
    { startprint--;
    }
   }

  }

  for(var i= startprint;i<endprint;i++)
  {
  if(i==pos)
  ret+='<span class="evidence_number">'+(i+1)+'</span>';
  else

 ret+='<a href="#" onclick="numnav2pagefd('+i+')">'+(i+1)+'</a>';
  ret+='&#160;';
  }
  return ret;
 }

function numnav2pagefd(navPos)
 {
  getForm('hxpForm').verbo.value='showdoc';
  getForm('hxpForm').pos.value=navPos;
  getForm('hxpForm').submit();
  return false;
 }

 /*
 * Created on: 03/10/2008
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Funzione per il confronto tra l'ultima e la prima versione di un allegato [RW 0054369]
 */
 function showDiffBetweenVersions(fileId, expType)
 {
    getForm('hxpForm').verbo.value = 'attach';
    getForm('hxpForm').xverb.value = '@showDiffFirst&LastVer#' + getForm('hxpForm').physDoc.value + "#" + expType;
    getForm('hxpForm').id.value    = fileId;
    getForm('hxpForm').submit();

    return false;
 }

/*
 * Created on: 08/04/2009
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Funzione per l'avviamento di un import da file excel [RW 0057587]
 */
function avviaImportXls(confirmMsg, importClassName, importMethodName, xlsXwFileId, loadingbarDbTable, loadingbarTitle, loadingbarCustomDataOffset)
{
    if (confirm(confirmMsg)) {
        if (importClassName == null || typeof(importClassName) == 'undefined') {
            alert("Parametro 'importClassName' non definito!");
            return false;
        }

        if (importMethodName == null || typeof(importMethodName) == 'undefined') {
            alert("Parametro 'importMethodName' non definito!");
            return false;
        }

        if (xlsXwFileId == null || typeof(xlsXwFileId) == 'undefined') {
            alert("Parametro 'xlsXwFileId' non definito!");
            return false;
        }

        setGlobalFormRestore('verbo','xverb', 'dbTable');

        var iForm       = getForm("hxpForm");
        var old_verbo   = iForm.verbo.value;
        var old_xverb   = iForm.xverb.value;
        var old_dbTable = iForm.dbTable.value;
        var old_target  = iForm.target;

        iForm.verbo.value   = "apps.generic.utils.excel_import.LaunchXlsImport";
        iForm.xverb.value   = "@" + importClassName + "|" + importMethodName;

        if (loadingbarDbTable != null && typeof(loadingbarDbTable) != 'undefined' && loadingbarDbTable.length > 0) {
            iForm.dbTable.value = loadingbarDbTable;
        }

        var hxpS = new _hxpSession(iForm);
        hxpS.setParameter("xls_import_xwfile_id", xlsXwFileId);

        if (loadingbarTitle != null && typeof(loadingbarTitle) != 'undefined' && loadingbarTitle.length > 0) {
            hxpS.setParameter("xls_import_loadingbar_title", loadingbarTitle);
        }

        if (loadingbarCustomDataOffset != null && typeof(loadingbarCustomDataOffset) != 'undefined' && loadingbarCustomDataOffset.length > 0) {
            hxpS.setParameter("xls_import_loadingbar_customDataOffset", loadingbarCustomDataOffset);
        }

        iForm.target = iForm.target + "_xls_import";
        var newWin   = window.open(staticEmptyWindow, iForm.target);
        newWin.focus();
        iForm.submit();

        iForm.verbo.value   = old_verbo;
        iForm.xverb.value   = old_xverb;
        iForm.dbTable.value = old_dbTable;
        iForm.target        = old_target;
    }

    return false;
}

//fcossu 29/12/2009 Scarto vaschetta ruoli [EA 501]
function scartaRuoli()
{
    setGlobalFormRestore('verbo','xverb','rifInt');

	getForm("hxpForm").verbo.value = "rifint_response";
	getForm("hxpForm").xverb.value = "@scartaRuoli";

	OpenWaitMsg();
	getForm("hxpForm").submit();
	return false;
}
