/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

 /* errorMsg.js */

 // funzioni per la pagina di visualizzazione errori

function back(newVerbo, handType)
{
	if (handType == "history") {
		// Utile se per esempio eseguo una ricerca in una nuova finestra

		/* Modifica di Federico del 30/09/2004: Al test dell'if  stato aggiunto un controllo sul tipo
		 * di browser dato che 'window.opener'  sempre definito con Mozilla (che da un errore javascript)
		 * e Opera (che si chiude premendo il pulsante indietro a causa dell'istruzione self.close()).
		 */
		/* DD 23/09/05 Anche se  definito un opener, torno indietro se ci sono pagine precedenti nell'history
		 * Infatti potrei avere l'opener definito semplicemente perch vengo dal protocollo, e in questo caso
		 * l'errore potrebbe essere visualizzato anche dopo diverse pagine, e non ha senso chiudere la finestra.
		 */
		if (history.length == 0 && typeof(window.opener)!='undefined' && navigator.userAgent.indexOf('MSIE') != -1) {
			self.close();
		}
		else {
			history.back();

			return false;
		}
	}
	else if (handType == "CLOSE")
		self.close();
	else {
		getForm('hxpForm').verbo.value = newVerbo;
		getForm('hxpForm').submit();
		return false;
	}
}

function loadHandler()
{
	if ( typeof(customLoadHandler) != 'undefined' )
		customLoadHandler();

	//DD 29/01/06 Valorizza tutti gli attributi title delle immagini
   setAllImgTitlesFromAlt();

}

function unloadHandler()
{
}