/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/
 /* filelist_x.js */

//nome della finestra statica (vuota) che viene aperta quando c' un popup in modo che venga mantenuto il protocollo
//corrente (http o https)
var staticEmptyWindow = "./../formatter/html/templates/static.html";



function getFiles_x(element, buffer, Titolo, Estensioni, Params ,thePreview) {
        var dad;
        var inst_prefix;
        var prefix;
        var suffix;
        var destinationName = '';
        var myresult;

        // esempio di name --> x_files.csm_def.DO.DRA[$hxp_instance()].DRA_FILE.xw:file.@button
        var elementName = element.name;

        if ( elementName.indexOf('[') != -1 ) {
                if (elementName.indexOf('@link') != -1) {
                        prefix = elementName.substring(0, elementName.lastIndexOf('['));
                        if (prefix.substring(0, 8) == 'x_files.') {
                                inst_prefix = prefix.substring(8);
                        }
                        else {
                                inst_prefix = prefix;
                        }
                        if ( inst_prefix.charAt(0) == '.') {
                                inst_prefix = inst_prefix.substring(1);
                        }
                        dadInstNumber = getFatherDotName(element, inst_prefix);
                        suffix = elementName.substring(elementName.lastIndexOf(']')+1);
                        elementName = prefix + '[' + dadInstNumber + ']' + suffix;
                }
                else if (elementName.indexOf('@button') != -1) {
                        prefix = elementName.substring(0, elementName.lastIndexOf('['));
                        if (prefix.substring(0, 8) == 'x_files.') {
                                inst_prefix = prefix.substring(8);
                        }
                        else {
                                inst_prefix = prefix;
                        }
                        if ( inst_prefix.charAt(0) == '.') {
                                inst_prefix = inst_prefix.substring(1);
                        }
                        dadInstNumber = getFatherDotName(element, inst_prefix);
                        suffix = elementName.substring(elementName.lastIndexOf(']')+1);
                        elementName = prefix + '[' + dadInstNumber + ']' + suffix;
                }
                else {
                        elementName = element.name;
                }
        }
        else {
                elementName = element.name;
        }

        if (elementName.indexOf('@') != -1) {
                if (element.name.substring(0, 8) == 'x_files.') {
                        destinationName = '*' + elementName.split('@')[0] + '@name';
                }
                else {
                        destinationName = elementName.split('@')[0] + '@name';
                }
        }
        else {
                if (element.name.substring(0, 8) == 'x_files.') {
                        destinationName = '*' + elementName + '@name';
                }
                else {
                        destinationName = '*' + elementName + '@name';
                }
        }

        elementName = destinationName; 

        // default  selezione multipla e spacchettamento dei TIFF multipagina
        var bits = 2 + 4;
        if ( typeof(Params) != 'undefined' ) {
                bits = Params;
        }
        if (document.IW.GetFile(Titolo, Estensioni, bits)) { 
                buffer = new String(document.IW.buffer);
        }
        //annulla
        if(buffer=='') {
                return false;
        }
        if( buffer != '' ) {
                var pos = buffer.indexOf('"""');
                var valore = '';
                if ( pos == 0 ) {
                        valore = buffer.substring(3);
                }
                if ( pos == -1 ) {
                        valore = buffer;
                }
                var element = getElementByName(elementName);
                if ( element != null ) {
                        element.value = valore;
                }
                myresult=defaultFileTitle_x(element,thePreview);
        }
        if(typeof(customDestination)!='undefined' && myresult) {
                customDestination("false", element.name, thePreview);
        }
        else if (! myresult && (element.value!="Sfoglia..." && element.value!="Browse...")) {
                // alert("deleteSingleImstance_x "+element.name);
                deleteSingleImstance_x(element,thePreview);
                if(typeof(customDelete)!='undefined') {
                        customDelete(element,thePreview);
                }
        }
        return false;
}

function isNewFiles_x(fporid)
{

var result=false;
if(fporid.indexOf('\\')!=-1)
{result=true;}
return result;
}


//per il riferimento srn incrociato nella thumb
//var myfilehandle = '';

function uploadFiles_x()
{	   for ( var i = 0; i < getForm("hxpForm").length; i++ ) {
        var fileObject = getForm("hxpForm").elements[i];
        var elName = fileObject.name;
        
        //upload tramite iw di ogni file (che non sia gi stato uplodato perch file/immgine standard)
        if ( typeof(elName) != 'undefined' &&  elName.indexOf('xw:file') != -1 && endsWith(elName,'.@name') && 
                /*elName.charAt(0) != '.' && elName.charAt(0) != '*'*/ elName.indexOf('.thumb.xw:file') == -1 && elName.charAt(0) == '*' && elName.indexOf('immagini.xw:file') == -1 && elName.indexOf('files.xw:file') == -1 ) {
            //alert("elName "+elName);alert("da que a pas???");
            //alert("fileObject.value "+fileObject.value);
            if ( fileObject.value.length > 0 && isNewFiles_x(fileObject.value) ) { //se pieno
                //alert("il file  pieno ed  nuovo");
                
                var host = getHost();
                var url = buildUrlForGet("", true, false, true) + "&verbo=Iw_response&xverb=upload";
                
                //per thumbnail
                //var thumbName = "." + elName.replace('.xw:file.@name','.thumb.xw:file.@name');
                var thumbName =elName.replace('.xw:file.@name','.thumb.xw:file.@name');
                //alert("thumbName "+thumbName);			
                var thumbInput = getElementByName(thumbName);
                /*
                if ( thumbInput == null )
                    thumbInput = getElementByName('*x_files' + thumbName);
                */
                var x_maxsize;

                
                if ( thumbInput != null )
                    {
                    
                    x_maxsize=getForm("hxpForm").sizeMaxImg.value;
                    //alert("handleTumbnail_x");            
                    handleTumbnail_x(fileObject.value, thumbInput, host, url, window.location.port);

                    
                    }
                //fine thumbnail
                
                else
                
                   x_maxsize=getForm("hxpForm").sizeMaxFile.value;
                               
                var protocol = window.location.protocol;
                
                //myfilehandle="";
                
                //alert("sono ancora in esecuzione ???");
                
                var param;
                var bits = (protocol=='https:')?document.IW.uploadHttps:document.IW.uploadNone;

                if (typeof(x_maxsize) != 'undefined' && x_maxsize.length > 0) {
            		param = x_maxsize;
            		bits |= document.IW.uploadSizeThreshold;
        		}

                var r = document.IW.UploadParam(getHost(),
                        url, 
                        window.location.port, 
                        'filename',
                        fileObject.value, 
                        bits ,  //mode
                                document.IW.zCompressionNone, 
                        param); //param
                
                
                if ( r == false )
                return (document.IW.buffer == 'size threshold reached') ? -1 : false;
                
                /*
                var element = getElementByName('.' + elName);
                
                if ( element == null )
                    element = getElementByName('*x_files.' + elName);
                */
                var element = getElementByName(elName);
                
                //alert(elName);					
               	//alert("faccio immagine");
		//alert(element);	
                
                if ( DoneWithUpload(0, 0, 0, element) == false ) {
                    return false;
                }
               /* 
                if ( thumbInput != null )
                {
                    
                    if(getElementByName(thumbName.replace('@name','@srn'))!=null)
                    	{alert("aggiornamento dell' srn !!!");
                        getElementByName(thumbName.replace('@name','@srn')).value=myfilehandle;
                        }  
                }
                */
            }
            
        }	                        	   
        
    }
    return true;
}


function endsWith(stringa, pattern)
{
	if ( stringa.length < pattern.length )
		return false;
	if ( stringa.indexOf(pattern) == stringa.length - pattern.length )
		return true;
}



//creazione di thumb, suo upload e valorizzazione del name
function handleTumbnail_x(filename, thumbInput, host, url, port)
{
   
	var index = thumbInput.id.lastIndexOf(".");
	var params = thumbInput.id.substring(index + 1);
	var paramsArray = params.split(',');

	//var width = getParameter(paramsArray, "width");
	//var height = getParameter(paramsArray, "height"); 

	//var width = getParameter(paramsArray, "width");
	//var height = getParameter(paramsArray, "height"); 

	// Gregorio 22/08/2005: aggiunto test su thumbMaxDim e cio se == '' viene utilizzata
	//                      la dimensione di default e cio 120 (altezza e larghezza)
	//
	// var width=getForm("hxpForm").thumbMaxDim.value;

	var Iw_resize_width = 120;

	if (getForm("hxpForm").thumbMaxDim != 'undefined') {
		if (getForm("hxpForm").thumbMaxDim.value != '') {
			Iw_resize_width = parseInt(getForm("hxpForm").thumbMaxDim.value, 10);
		}
	}

	var Iw_resize_height = Iw_resize_width;

	// alert(Iw_resize_width);
	// alert(Iw_resize_height);
	
	var flags = document.IW[getParameter(paramsArray, "flags")];
	var format = document.IW.imageTypeTrueColor;// document.IW[getParameter(paramsArray, "format")];
	var compression = document.IW.imageCompressionJpeg;// document.IW[getParameter(paramsArray, "compression")];
	var currimg;

document.IW.SetFile(filename);

// alert("creazione thumb "+document.IW.GetImageType());

   if(document.IW.GetImageType()== document.IW.imageTypeBw ||
   document.IW.GetImageType()== document.IW.imageTypeBwDithered ||
   document.IW.GetImageType()== document.IW.imageTypeGray16)
{
//alert("converto la immagine a 256 grigi");

document.IW.Convert("",currimg,document.IW.imageTypeGray256,document.IW.imageCompressionJpeg,document.IW.convertNone);
currimg=document.IW.buffer;
document.IW.SetFile(currimg);

}

/*
	var r = document.IW.Resize('',
					 filename,
					 format,
					 compression,
					 width,
					 height,
					 flags);
*/					 
	var r = document.IW.Resize('', filename, format, compression, Iw_resize_width, Iw_resize_height, document.IW.convertNone);
					 
	if ( r!= 0 )
		return false;
	
	var thumbFile = document.IW.buffer; //filename del thumb

    var protocol = window.location.protocol;

	var r = document.IW.UploadParam(host,
							url,
							port, 
							'filename',
							thumbFile, 
                            (protocol=='https:')?document.IW.uploadHttps:document.IW.uploadNone ,  //mode
							document.IW.zCompressionNone, 
							""); //param

	if ( r == false )
		return false;											
	//alert("faccio thumbnail");								
	if ( DoneWithUpload(0, 0, 0, thumbInput) == false )
		return false;
	
	return true;
}


function openInNewWindow_x(theObject, listaDeigliIdGrandi, selPositionForTitles)
{
	var theOption = getOption(theObject);
	var listaDeigliIdGrandiArray = listaDeigliIdGrandi.substring(1).split('|');
	var selIndex = '*' + listaDeigliIdGrandiArray[theOption.selectedIndex];
	var iForm;
	var old_target = getForm("hxpForm").target;
	var old_verbo = getForm("hxpForm").verbo.value;
	var old_pos = getForm("hxpForm").pos.value;
	iForm = getForm("hxpForm");
	iForm.verbo.value = "showdoc";
	iForm.extraView.value = "@imgs";
	iForm.selectedIndex.value = selIndex;
	if ( getForm("hxpForm").selid.value.length == 0 ) {
		//occorre aprire in base a # fisico
		getForm("hxpForm").pos.value = getForm("hxpForm").physDoc.value - 1;
	}
	else if ( typeof(selPositionForTitles) != 'undefined') {
		getForm("hxpForm").pos.value = selPositionForTitles;
	}
	else {
	}
	iForm.target = "imgsWindow";
	var windowFeature = 'width=800,height=600';
	if ( typeof(customSetWindowFeature) != 'undefined' ) {
		windowFeature = customSetWindowFeature();
	}
	imgsWindow = window.open(staticEmptyWindow, iForm.target, windowFeature);
	iForm.submit();
	imgsWindow.focus();
	getForm("hxpForm").target = old_target;
	getForm("hxpForm").verbo.value = old_verbo;
	getForm("hxpForm").pos.value = old_pos;
	getForm("hxpForm").extraView.value = '';
	getForm("hxpForm").selectedIndex.value = 0;
	return false;
}

function openInNewWindow_xpreview(listaDeigliIdGrandi,selector,selPositionForTitles)
{
	var listaDeigliIdGrandiArray;
	var selIndex;
	if(selector!=null) {
		var theselector="selezionaImmagine-"+selector;
		var elements = document.getElementsByTagName("select");
		for (var i = 0; i < elements.length; i++ ) {
			if ( elements[i].id == theselector ) {
				var selecttarget=elements[i];
				break;
			}
		}
		listaDeigliIdGrandiArray = listaDeigliIdGrandi.substring(1).split('|');
		selIndex = '*'+listaDeigliIdGrandiArray[selecttarget.selectedIndex] ;
		if(getForm("hxpForm").verbo.value=="showtitles") {
			getForm("hxpForm").pos.value=selector;
		}
	}
	else {
		listaDeigliIdGrandiArray = listaDeigliIdGrandi.substring(1).split('|')[0];
		selIndex = '*'+listaDeigliIdGrandiArray;
	}
	var iForm;
	var old_target = getForm("hxpForm").target;
	var old_verbo = getForm("hxpForm").verbo.value;
	var old_pos = getForm("hxpForm").pos.value;
	if (old_verbo=="showtitles" && selector==null) {
		listaDeigliIdGrandiArray = listaDeigliIdGrandi.substring(1).split('|')[0];
		selIndex = '*'+listaDeigliIdGrandiArray ;
		getForm("hxpForm").pos.value=1;
	}
	iForm = getForm("hxpForm");
	iForm.verbo.value = "showdoc";
	iForm.extraView.value = "@imgs";
	iForm.selectedIndex.value = selIndex;
	if(old_verbo=="showtitles" && selector!=null) {
		iForm.pos.value=iForm.pos.value-1;
	}
	if ( getForm("hxpForm").selid.value.length == 0 ) {
		// alert("occorre aprire in base a # fisico");
		getForm("hxpForm").pos.value = getForm("hxpForm").physDoc.value -1;
	}
	else if ( typeof(selPositionForTitles) != 'undefined') {
		// alert("di qui non devo passare");
		getForm("hxpForm").pos.value = selPositionForTitles-1;
	}
	else {
	}
	iForm.target = "imgsWindow";
	var windowFeature = 'width=800,height=600';
	if ( typeof(customSetWindowFeature) != 'undefined' ) {
		windowFeature = customSetWindowFeature();
	}
	imgsWindow = window.open(staticEmptyWindow, iForm.target, windowFeature);
	iForm.submit();
	imgsWindow.focus();
	getForm("hxpForm").target = old_target;
	getForm("hxpForm").verbo.value = old_verbo;
	getForm("hxpForm").pos.value = old_pos;
	getForm("hxpForm").extraView.value = '';
	getForm("hxpForm").selectedIndex.value = 0;
	return false;
}


function deleteSingleImstance_x(element,thePreview)
{
    if('undefined' == typeof(thePreview))
    {
        var result=confirm("Confermi cancellazione allegato ?");
        if (! result)
        {
            return;
        }
        
        
    }
    
    var elName = element.name;
    
    //alert("PIPPERO "+elName);
    
    /*
    var newElName = elName.replace('.@delete','.@name');
   var newElName =elName.indexOf('.@delete')==-1 ? elName : elName.replace('.@delete','.@name');
    
    var newEl = getElementByName(newElName);
    if ( newEl != null )		
    {
        try{
            newEl.value = "";
        }
        catch(e)
        {
            //   alert('value '+newElName+' non definito');
        }
        
    }
    else alert('non trovo '+newElName);
    */
    
   // var newElName = "." + elName.replace('.@delete','.@name');
   //  var newElName = "*" + elName.replace('.@delete','.@name');
       var newElName =elName.indexOf('.@delete')==-1 ? elName : "*" + elName.replace('.@delete','.@name');
    
    var newEl = getElementByName(newElName);
    if ( newEl != null )		
    {
        try{
            newEl.value = "";
        }
        catch(e)
        {
            // alert('value '+newElName+' non definito');
        }
        
    }
    else alert('non trovo '+newElName);
    
   // newElName = '*'+elName.replace('.@delete','.@title');
    //newElName = '.'+elName.replace('.@delete','.@title');
     var newElName =elName.indexOf('.@delete')==-1 ? elName.replace('.@name','.@title') : "*" + elName.replace('.@delete','.@title');
    newEl = getElementByName(newElName);
    if(newEl !=null) 
    {
        try{
            newEl.value = "";
        }
        catch(e)
        {
            //alert('value '+newElName+' non definito');
        }
        
    }
    else alert('non trovo '+newElName);
    
    /*
    
    var newElName = "*x_files." + elName.replace('.@delete','.@name');
    
    var newEl = getElementByName(newElName);
    if ( newEl != null )		
    {
        try{
            newEl.value = "";
        }
        catch(e)
        {
            //alert('value '+newElName+' non definito');
        }
        
    }
    else alert('non trovo '+newElName);
    
    newElName = '*x_files.'+elName.replace('.@delete','.@title');
    newEl = getElementByName(newElName);
    if(newEl !=null) 
    {
        try{
            newEl.value = "";
        }
        catch(e)
        {
            //alert('value '+newElName+' non definito');
        }
        
    }
    else alert('non trovo '+newElName);
    */
    
    //ctsep sperimentale...cerco ta thumb e cancello anche questa	
    
    
     var newElName =elName.indexOf('.@delete')==-1 ? elName.replace('.xw:file.@name','.thumb.xw:file.@name') : "*" + elName.replace('.xw:file.@delete','.thumb.xw:file.@name');
    //newElName = elName.replace('.@delete','.thumb.xw:file.@name');
    //newEl = getElementByName('.'+newElName);
    //newEl = getElementByName('*'+newElName);
    //alert(newElName);
    newEl = getElementByName(newElName);
    if(newEl !=null) 
        
        if(newEl !=null) 
        {
            try{
                newEl.value = "";
            }
            catch(e)
            {
                // alert('value '+newElName+' non definito');
            }
            
        }
        else alert('non trovo '+newElName);
        
        //ctsep sperimentale...cerco ta thumb e cancello anche questa	
   /*     
    newElName = elName.replace('.@delete','.thumb.xw:file.@srn');
    //newEl = getElementByName('.'+newElName);
    //newEl = getElementByName('*'+newElName);
    newEl = getElementByName(newElName);
    if(newEl !=null) 
        
        if(newEl !=null) 
        {
            try{
                newEl.value = "";
            }
            catch(e)
            {
                //alert('value '+newElName+' non definito');
            }
            
        }
        else alert('non trovo '+newElName);
    */    
        
        
    if('undefined' != typeof(thePreview))
    {
       // alert("devo cancellare il preview se collegato "+thePreview);
      //  for (var i=0;getForm("hxpForm").length;i++)
      //  { 
      
      //      if(getForm("hxpForm").elements[i].id!=null && thePreview==getForm("hxpForm").elements[i].id)
            var prevtorest=document.getElementById(thePreview);
            if(prevtorest!=null)
            {
                 
                 
                //  alert('TROVATO ID ' + getForm('indexForm').elements[i].id);
               // alert("prevtorest "+prevtorest.id);
                var host = getHost();
                var port = window.location.port;
                if ( port.length > 0 )
                    port = ":" + port;
                
                //id = realEscape(id);
                var protocol = window.location.protocol;
                
                //     getForm("hxpForm").elements[i].SetFile('');
                
                
                
                var myurivalue="";
                
                for (var k=0;getForm('indexForm').length;k++)
                {
                    
                    if(getForm('indexForm').elements[k].name=='uri') 
                    {myurivalue=getForm('indexForm').elements[k].value;break;}
                    
                }
                
                var   thefilename=protocol+ "//" + host+ port+myurivalue;
                
                thefilename=thefilename.substring(0,thefilename.lastIndexOf("/")+1)+"logo.jpg";
                
                //alert(thefilename);
                
                //getForm("hxpForm").elements[i].DownloadParam(thefilename, '', getForm("hxpForm").elements[i].downloadNone);      
                prevtorest.DownloadParam(thefilename, '', prevtorest.downloadNone);      
                //getForm("hxpForm").elements[i].Redraw();
                prevtorest.Redraw();
                //break;
            }
        }
        
 //   }
    
}

function deleteSingleImstance_xpreview(element,thePreview)
{
var result=confirm("Confermi cancellazione immagine ?");
//alert(element.name);
//alert(thePreview);
if (result)
{

if(typeof(customDeleteImage)!='undefined')
customDeleteImage(element,thePreview);
deleteSingleImstance_x(element,thePreview);
}

}