/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/
/* floatingbar.js */
var DivObj = null;
var WaitMsg = null;

function wFBRefresh() {
    
	var theTop;
	var i = posY;
	if ( document.layers )
		i += window.pageYOffset;
	else  {
		if ( document.all )
		    i += document.body.scrollTop;
		else
			if (document.getElementById) 					
				i = window.pageYOffset + 'px';
		} 

	if ( parseInt(wMark.top) != i ) {
		wMark.top = i;
		if ( WaitMsg != null )
			WaitMsg.style.top = i;
	}
}

function setVals() {
	if ( typeof(old_onresize)!='undefined' )
		old_onresize();
		
	barW = 0; // scrollbar compensation for PC Nav
	barH = 0;
	
	navDOM = window.innerHeight; // Nav DOM flag
	
    if( typeof(document.body)!='undefined') {
		innerWidth = document.body.clientWidth;
		innerHeight = document.body.clientHeight;
	}
		
	posX = 10;
	posY = 0;
	markW = 82;       // pixels wide
	markH = 400;            // pixels high
	markRefresh = 20; // milliseconds
	 
	wMark = document.getElementById('BBar').style;				
	DivObj = document.getElementById('BBar');
	
	WaitMsg = document.getElementById('WaitMsg');
	
	wMark.width = markW;
	wMark.height = markH;
	wMark.left = posX;
}

function ShowFloatingBar() {
	setVals();
	var old_onresize = window.onresize;
	window.onresize = setVals;
	wMark.left = posX;
	wMark.top = 0;
	wFBRefresh();
    markID = window.setInterval("wFBRefresh()", markRefresh);
}
		
