/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/
function setGlobalFormRestore() {
    var s = '';
    for (var i=0; i<arguments.length;i++) {
        if (getForm("hxpForm")[arguments[i]])
            //mbussetti, 19/05/2005 sostituito '' con '' per problemi di IE sul viewer (RW28202)
            s += '' + arguments[i] + "" + getForm("hxpForm")[arguments[i]].value;
    }    
    getForm("hxpForm").globalFormRestore.value  = s.substr(1);
}

function restoreTuple() {
    var s = getForm("hxpForm").globalFormRestore.value;
    if (s.length > 0) {
        //mbussetti, 19/05/2005 sostituito '' con '' per problemi di IE sul viewer (RW28202)
        var v = s.split('');
        var name, val, index;
        for (var i=0; i<v.length; i++) {
            index = v[i].indexOf('');
            name = v[i].substring(0, index);
            val = v[i].substr(index + 1);
            if (getForm("hxpForm")[name])
                getForm("hxpForm")[name].value = val;        
        }
    }
    getForm("hxpForm").globalFormRestore.value = '';
}

function setGlobalFormRestoreFromURL(url) {
    var s = '';
    if (url.indexOf('?') != -1)
        url = url.substring(url.indexOf('?') + 1);
    var v = url.split('&');
    var el, name;
    for (var i=0; i<v.length; i++) {
        el = v[i];
        name = el.substring(0, el.indexOf('='));
        s += '' + name + "" + getForm("hxpForm")[name].value;
    }
    getForm("hxpForm").globalFormRestore.value  = s.substr(1);
}