/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

 /* index.js */
var i_operation = '';

function checkRadioSele(theRadio,theEvent){
	var currentIndex=findCheckBoxIndex(theRadio);
	if(typeof(theEvent)=='undefined'|| typeof(theEvent.shiftKey)=='undefined'|| theEvent.shiftKey==false || (lastClickedIndex==-1)){
		lastClickedIndex=currentIndex;
	}
	getForm('hxpForm').keylist.value = theRadio.form[currentIndex].value;
	updateList(theRadio.form,theRadio.form[currentIndex].value,theRadio.checked);
	lastClickedIndex=currentIndex;
}

 // funzioni per le pagine di vocabolario/thesaurus (richiede keylist.js)

 function loadHandler()
 {
	startModalWindow();
	/* Modifica di Federico del 06/10/2004.
	 * Sono stati aggiunti i test opener != null && typeof(opener.theIndexWindow) != 'undefined'
	 * poich in Opera e Mozilla opener  null quando non si apre una nuova finestra per il
	 * thesauro/vocabolario (il secondo test  stato effettuato per precauzione).
	 */
	if (typeof(opener) != 'undefined' && opener != null && typeof(opener.theIndexWindow) != 'undefined') {
		try{opener.theIndexWindow=window;}catch(e){;}
	}
	if(getForm('vocab')!=null)
		checkList(getForm('vocab'),getForm('hxpForm').keylist.value);

	if(typeof(getForm('seek').minRes) != 'undefined') {
		if(getForm('seek').minRes.type == "text") {
    		getForm('seek').minRes.value = getForm('hxpForm').minRes.value;
		}
   		else if(getForm('seek').minRes.type == "select-one") {
				for (var index=0; index < getForm('seek').minRes.options.length; index++) {
				     if(getForm('seek').minRes.options[index].value == getForm('hxpForm').minRes.value) {
				     	getForm('seek').minRes.options[index].selected = true;
				      	break;
				     }
				}
			 }
	}

	if (typeof(thesLoadHandler) != 'undefined') {
   		thesLoadHandler();
	}

	if(typeof(customLoadHandler) != 'undefined') {
		customLoadHandler();
	}

	// titolo vocabolario
	// Ha senso impostarlo sovrascrivendo quello impostato nel templates ?
	if (document.title == '') {
		if (typeof(opener) != 'undefined' && typeof(opener.vocTitle) != 'undefined') {
		   try{document.title = opener.vocTitle;}catch(e){;}
		}
	}

	//DD 29/01/06 Valorizza tutti gli attributi title delle immagini
   setAllImgTitlesFromAlt();
 }

 function unloadHandler()
 {
  /* Modifica di Federico del 21/12/2004:
   * la tupla 'toDo' viene utilizzata per indicare alla classe generica 'Showthes.java' di mostrare tutti i
   * figli di un termine del th secondo una certa relazione, che hanno una frequenza maggiore o uguale a quella
   * indicata nella var. 'thMinFreq' (che deve essere definita a livello specifico).
   * In fase di unload della pagina del thesauro  necessario svuotare 'toDo', affinch non vengano propagate
   * informazioni "dannose".
   */
        if (getForm('hxpForm').toDo.value.indexOf("set_minFreq_for_TH_navigation:") != -1) {
                var page;
                if (typeof(opener) != 'undefined' && opener != null) {
                        page = opener.document;
                }
                else {
                        page = document;
                }
                page.hxpForm.toDo.value = "";
        }
        // A cosa serve parent.theIndexWindow=null ????
        parent.theIndexWindow=null;
        if (i_operation != 'NOCLOSE') {
                if (typeof(opener) != 'undefined' && opener != null && typeof(opener.theIndexWindow) != 'undefined') {
                        opener.theIndexWindow = null;
                }
                stopModalWindow();
        }
 }

 function commitSele()
 {
 //alert('commitSele');
 var l_keypath=getForm('hxpForm').fillField.value;
 var thisForm = opener.getForm('theForm');
 var isDocedit = getForm('hxpForm').destPage ? getForm('hxpForm').destPage.value : '';
 if ( opener.getForm('theForm') == null ) {
    // si proviene da inserimento/modifica
    thisForm = opener.getForm('hxpForm');
 }
  var keys=getForm('hxpForm').keylist.value.split(separator);
  var queryValue="";

  if (isDocedit == 'docEdit'){
	var InString=getForm('hxpForm').keylist.value;
	var OutString=getForm('hxpForm').keylist.value;
	for (var Count=0; Count < InString.length; Count++)  {
	 TempChar=InString.substring (Count, Count+1);
	 if (TempChar!=" ") {
	  OutString=InString.substring (Count, InString.length)
	  break;
	 }
	}
	queryValue = OutString;
  }
  else {
	  for(var i=0;i<keys.length;++i)
	  {if(keys[i].length>0)
	   if(typeof(customSeleBuilder)!='undefined')
	    queryValue=customSeleBuilder(queryValue,keys[i]);
	   else
	   {if(keys[i].indexOf(' ')>=0||keys[i].indexOf('\t')>=0)
//sstagni: per ora xw ci impone di eliminare le virgolette
	     queryValue+=(queryValue.length>0?' or ':'')+'"'+replaceAll(keys[i],'"', '')+'"';
	    else queryValue+=(queryValue.length>0?' or ':'')+keys[i];
	   }
	  }
  }
  if (typeof(customParseValue)!="undefined") queryValue = customParseValue(l_keypath,queryValue);

  if(queryValue.length>0)
 // {opener.getForm('theForm')["[" + keypath + "]"].value = queryValue;
 // la riga precedente e' stata commentata e sostituita dal 'with'
 // seguente poiche' alcuni nomi dei campi di input sono ora preceduti
 // da un identificativo di gruppo di adiacenza racchiuso tra parentesi
 // graffe
  {
   if(null!=getForm('hxpForm')['xMode'].value.match(/^preserve\:/))

    queryValue=getForm('hxpForm')['xMode'].value.replace(/^preserve\:/,"")+"("+queryValue+")";

   with(thisForm){

    if (("undefined"!=typeof(iFocus))&&(""!=iFocus.value)){
     /*
     // nel caso il campo di destinazione venga modificato nel
     // corso della richiesta come da grande voce a piccola voce
     if(iFocus.value.indexOf(keypath)<0)
     {
     }
     */
//alert("ifocus:"+iFocus.value);
//alert("ifocus2:"+("undefined"==typeof(opener.getForm('theForm')[iFocus.value])));
     thisForm[iFocus.value].value=queryValue;
     if(typeof(customIFocusHandler)!='undefined')
      queryValue=customIFocusHandler(thisForm,iFocus.value,queryValue);
//alert("pre1["+iFocus.value+"]");
     opener.Qbe_To_Ql(thisForm[iFocus.value]);
//alert("post1");
    }else{

     if(l_keypath.indexOf('/')>0&&l_keypath.charAt(l_keypath.length-1)=='/')
      l_keypath=l_keypath.substring(0,l_keypath.length-1);

     //simone - in test
     var exclam = l_keypath.indexOf("!") == 0 ? true : false;
     if ( opener.getForm('hxpForm').verbo.value != 'docEdit' && !exclam)
        l_keypath = "[" + l_keypath + "]" ;
     if (exclam)
        l_keypath = l_keypath.substring(1);

     for(i=0;i<length;i++)
     {// aggiunto controllo sulle select....

      if((elements[i].type=="text"||
          elements[i].type=="textarea" ||
          elements[i].type=="select-one" ||
          elements[i].type=="select-multiple")&&
         0<=elements[i].name.indexOf(l_keypath) && (elements[i].name.length - l_keypath.length) <= 2)
      {elements[i].value=queryValue;
//alert("'"+elements[i].name+"'\n"+elements[i].type+"\n"+queryValue);
       if(null!=opener.Qbe_To_Ql){
//alert("pre2");
        opener.Qbe_To_Ql(elements[i]);
//alert("post2");
       }
       break;
      }
     }
    }
   }
  }
 }

 function closeOnly()
 {opener.theIndexWindow = null;
  opener.focus();
  window.close();
 }

function riportaFromIndex(){
	// Verifica contenuto di 'keylist' e se diverso da vuoto richiamo funzione opportuna
	var InString = getForm('hxpForm').keylist.value;
	var OutString = InString;
	var TempChar = '';
	for (var Count=0; Count<InString.length; Count++)  {
		TempChar = InString.substring(Count, Count+1);
		if (TempChar != ' ') {
			OutString = InString.substring(Count, InString.length);
			break;
		}
	}
	if (OutString.length > 0) {
		closeIndex(false);
	}
}

 function closeIndex(cancel)
 {if(cancel==false)
   commitSele();
  opener.theIndexWindow = null;
  opener.focus();
  if( ('undefined' != typeof(opener._QUERY_LANG_ID_)) &&
      ('undefined' != typeof(opener.makeBaseQuery)) ) {

      if ( opener.getForm('hxpForm').dbTable.value == '@repertorio' ) opener.makeBaseQuery(true);
      else opener.makeBaseQuery();
      var tArea = opener.document.getElementById(opener._QUERY_LANG_ID_);
      if(null != tArea) tArea.value = opener.getForm('hxpForm').query.value;
  }
  window.close();
 }
 function idxSubmit()
 {if(typeof(getForm('seek').minFreq)!='undefined')getForm('hxpForm').minFreq.value=getForm('seek').minFreq.value;
  if(typeof(getForm('seek').maxFreq)!='undefined')getForm('hxpForm').maxFreq.value=getForm('seek').maxFreq.value;
  if(typeof(getForm('seek').minRes)!='undefined')
  {if(getForm('seek').minRes.type=="text")
    getForm('hxpForm').minRes.value=getForm('seek').minRes.value;
   else if(getForm('seek').minRes.type=="select-one")
    getForm('hxpForm').minRes.value=getForm('seek').minRes.options[getForm('seek').minRes.selectedIndex].value;
  }
  getForm('hxpForm').submit();
 }
 function aggiornaPagina(chiavePosizionamento)
 {
  if(getForm('seek')!=null && getForm('seek').seektext.value!='')
   return posiziona(getForm('seek').seektext.value,getForm('hxpForm').keypath.value,true);
  if(""==getForm('hxpForm')["cPath"])
   chiavePosizionamento=chiavePosizionamento.replace(/^\s*\b(\w*)\b.*$/, "$1");
  else
   chiavePosizionamento=chiavePosizionamento.replace(/^\s/, "");
  getForm('hxpForm').startkey.value=chiavePosizionamento;
  getForm('hxpForm').keylower.value='';
  //getForm('hxpForm').submit();
  idxSubmit();
  return false;
 }
 function paginaPrecedente(chiavePosizionamento,posizioneAttuale,relazione,secondotermine)
 {i_operation = 'NOCLOSE';
  if(posizioneAttuale>0)
  {getForm('hxpForm').startkey.value=chiavePosizionamento;
   getForm('hxpForm').keylower.value='1';
   //getForm('hxpForm').submit();
  idxSubmit();
  }
  return false;
 }
 function paginaSuccessiva(chiavePosizionamento,posizioneAttuale,totaleSelezionati,relazione,secondotermine)
 {i_operation = 'NOCLOSE';
  if(totaleSelezionati>posizioneAttuale+1)
  {getForm('hxpForm').startkey.value=chiavePosizionamento;
   getForm('hxpForm').keylower.value='';
   //getForm('hxpForm').submit();
  idxSubmit();
  }
  return false;
 }
 function sSeparator(ch)
 {return(ch==' '||ch=='\t'||ch=='\r'||ch=='\n');
 }
 function sTrim(s)
 {while(s.length>0&&sSeparator(s.charAt(0)))s=s.substring(1);
  while(s.length>0&&sSeparator(s.charAt(s.length-1)))s=s.substring(0,s.length-1);
  return s;
 }
 function fillWith(s,ch,len)
 {while(s.length<len)s=ch+s;
  return s;
 }
 function getDateYear(s)
 {s=sTrim(s);
  var pos=s.lastIndexOf('/');
  if(pos<0)pos=s.lastIndexOf('-');
  if(pos<0)pos=s.lastIndexOf(' ');
  return fillWith(sTrim(s.substring(pos+1)),'0',4);
 }
 function getDateMonth(s)
 {s=sTrim(s);
  var stop=s.lastIndexOf('/');
  if(stop<0)stop=s.lastIndexOf('-');
  if(stop<0)stop=s.lastIndexOf(' ');
  if(stop<0)return'00';
  var start=s.lastIndexOf(s.charAt(stop),stop-1);
  return fillWith(sTrim(s.substring(start+1,stop)),'0',2);
 }
 function getDateDay(s)
 {s=sTrim(s);
  var pos=s.indexOf('/');
  if(pos<0)pos=s.indexOf('-');
  if(pos<0)pos=s.indexOf(' ');
  if(pos<0)return'00';
  if(s.indexOf(s.charAt(pos),pos+1)<0)
  return'00';
  return fillWith(sTrim(s.substring(0,pos)),'0',2);
 }
 function usr2XwKey(mode,key)
 {if(mode=='dt')key=getDateYear(key)+getDateMonth(key)+getDateDay(key); // yyyymmdd
  if(mode=='dt1')key=getDateYear(key)+' '+getDateMonth(key)+' '+getDateDay(key); // yyyy mm dd
  return key;
 }
 function posiziona(chiavePosizionamento,nomeChiave)
 {
  if(chiavePosizionamento=='')return false;

  i_operation = 'NOCLOSE';
  if(getForm('hxpForm').shwMode.value!='') // yyyymmdd
   chiavePosizionamento=usr2XwKey(getForm('hxpForm').shwMode.value,chiavePosizionamento);

  chiavePosizionamento=getForm('hxpForm').cPath.value+chiavePosizionamento;
  getForm('hxpForm').startkey.value=chiavePosizionamento.toUpperCase();
  getForm('hxpForm').keylower.value='';
  getForm('hxpForm').keypath.value=nomeChiave;
  //getForm('hxpForm').submit();
  idxSubmit();
  return false;
 }
 function submitOnEnter(event)
 {var key=document.layers?event.which:event.keyCode;
  if(key==13)
  {event.cancelBubble=true;
   event.returnValue=false;
   posiziona(getForm('seek').seektext.value,getForm('hxpForm').keypath.value);
  }
  return key;
 }




/* unused
 function posiziona_data(valGG, valMM, valAA, nomeChiave)
 {var  ret=true;
  var  chiave ;
  if ( ret && ("" == valAA) && ("" == valMM) && ("" == valGG) ) {
     alert("inserire un valore almeno nel campo anno") ;
     ret = false ;
  }
  if ( ret && ("" == valAA) ) {
     alert("inserire un valore anche nel campo anno") ;
     ret = false ;
  }
  if ( ret && (4 != valAA.length) ) {
     alert("inserire un valore di quattro cifre nel campo anno") ;
     ret = false ;
  }
  if ( ret && ("" == valMM) && ("" != valGG) ) {
     alert("inserire un valore anche nel campo mese o toglietelo dal campo giorno") ;
     ret = false ;
  }
  if ( ret ) {
     chiave = valAA ;
     for ( i = valMM.length ; i < 2 ; i++ )
        chiave += "0" ;
     chiave += valMM ;
     for ( i = valGG.length ; i < 2 ; i++ )
        chiave += "0" ;
     chiave += valGG ;
     ret = posiziona(chiave, nomeChiave, verbo) ;
  }
  return(ret);
 }
*/
/*
function posiziona(desiredValue, keyName)
{
  if (getForm('seek').seektext.value.length > 0) with (getForm('hxpForm'))
  {
    startkey.value = desiredValue;
    verbo.value = "showindex";
    keylower.value = "";
    keypath.value = keyName;
    submit();
  }

  return false;
}
*/

function longKeys(el){
  getForm('hxpForm')["cPath"].value=(el.checked?" ":"");
}


function totalizzaChiavi()
{getForm('hxpForm').startkey.value='';
 getForm('hxpForm').keylower.value='';
 getForm('hxpForm').xverb.value='@total';
 idxSubmit();
 return false;
}


function listaCompleta()
{getForm('hxpForm').startkey.value='';
 getForm('hxpForm').keylower.value='';
 getForm('hxpForm').xverb.value='@full';
 idxSubmit();
 return false;
}

function closeIndexForViewer(cancel)
{if(cancel==false)
  commitSeleForViewer();
 opener.theIndexWindow = null;
 opener.focus();
 window.close();
}
function commitSeleForViewer()
 {if(typeof(opener.lookupHandler)!='undefined')
	return opener.lookupHandler(getForm('hxpForm').keylist.value,getForm('hxpForm').keypath.value);
  var keypath=getForm('hxpForm').keypath.value;
  var keys=getForm('hxpForm').keylist.value.split(separator);
  var queryValue="";
  for(var i=0;i<keys.length;++i)
  {if(keys[i].length>0) {
	  /**
	  * DATA: 03/03/2003
	  * Se ci sono degli &quot; risolti....
	  * vengono escapati anteponendo il carattere "\"
	  */
	  //alert("chiavePrima="+keys[i]);
	  regularExpQuot = /\"/g;
	  keys[i] = keys[i].replace(regularExpQuot, "\\\"");
	  //alert("chiaveDopo="+keys[i]);
	  if(typeof(customSeleBuilder)!='undefined'){
		  queryValue=customSeleBuilder(queryValue,keys[i],keypath);
		  //alert("queryValue="+queryValue);
	  }
	  else {
		//alert("ciao da fuori");
		if(null!=keys[i].match(/[\s\-]/)){
		  //alert("ciao da dentro");
		  queryValue+=(queryValue.length>0?' or ':'')+'"'+keys[i]+'"';
		}
		else queryValue+=(queryValue.length>0?' or ':'')+keys[i];
	  }
	}
  }
  if(queryValue.length>0)
 // {opener.getForm('theForm')["[" + keypath + "]"].value = queryValue;
 // la riga precedente e' stata commentata e sostituita dal 'with'
 // seguente poiche' alcuni nomi dei campi di input sono ora preceduti
 // da un identificativo di gruppo di adiacenza racchiuso tra parentesi
 // graffe
  {
	if(null!=getForm('hxpForm')['xMode'].value.match(/^preserve\:/))
	  queryValue=getForm('hxpForm')['xMode'].value.replace(/^preserve\:/,"")+"("+queryValue+")";
	//alert("queryValue="+queryValue);
	with(opener.getForm('theForm')){
	 if (("undefined"!=typeof(iFocus))&&(""!=iFocus.value)){
	  /*
	  // nel caso il campo di destinazione venga modificato nel
	  // corso della richiesta come da grande voce a piccola voce
	  if(iFocus.value.indexOf(keypath)<0)
	  {
	  }
	  */
//alert("ifocus:"+iFocus.value);
//alert("ifocus2:"+("undefined"==typeof(opener.getForm('theForm')[iFocus.value])));
	  if(typeof(customKeyHandler)!='undefined')
		 queryValue=customKeyHandler(queryValue);
	  /* code by Mario */
	  /* introdotto perch se il valore pescato dal vocabolario deve andare a finire in una select             */
	  /* il fatto che sia racchiuso tra "" fa s che l'assegnamento successivo al mio codice non abbia effetto */
	  if (opener.getForm('theForm')[iFocus.value].type=="select-one"){
		  queryValue = queryValue.replace("\\X","X");
		  if (queryValue.charAt(0)=='"') {queryValue=queryValue.substring(1,queryValue.length);}
		  if (queryValue.charAt(queryValue.length-1)=='"') {queryValue=queryValue.substring(0,queryValue.length-1);}
	  }
	  /* introdotto per gestire il caso di valori 'trascinati' dal vocabolario in una select-multiple */
	  if (opener.getForm('theForm')[iFocus.value].type=="select-multiple"){
		 queryValue = queryValue.replace("\\X","X");
		 completeList=getForm('theForm')[iFocus.value].childNodes;
		 for(var p=0;p<completeList.length;p++){
			if (completeList.item(p).selected) completeList.item(p).selected=false;
		 }
		 //alert(queryValue);
		 listOfValues=queryValue.split(' or ');
		 //alert(listOfValues);
		 var k;
		 for(k=0;k<listOfValues.length;k++){
			 // tolgo gli spazi in testa e in coda ai possibili valori della chiave
			 // corrige: lascio gli spazi perch sono significativi per la ricerca
			 //if (listOfValues[k].charAt(0)==' ') listOfValues[k]=listOfValues[k].substring(1,listOfValues[k].length);
			 //if (listOfValues[k].charAt(listOfValues[k].length-1)==' ') listOfValues[k]=listOfValues[k].substring(0,listOfValues[k].length-1);
			 var currKeyValue=listOfValues[k];
			 //alert(currKeyValue);
			 if (currKeyValue.charAt(0)=='"') {currKeyValue=currKeyValue.substring(1,currKeyValue.length);}
			 if (currKeyValue.charAt(currKeyValue.length-1)=='"') {currKeyValue=currKeyValue.substring(0,currKeyValue.length-1);}
			 //alert("'"+currKeyValue+"'");
			 var optionsList=opener.getForm('theForm')[iFocus.value].childNodes;
			 for(var i=0;i<optionsList.length;i++){
				 if (optionsList.item(i).nodeName=='option' || optionsList.item(i).nodeName=='OPTION'){
					 if (optionsList.item(i).value==currKeyValue) optionsList.item(i).selected='selected';
				 }
			 }
		 }
	  }
	  /* end code by Mario*/
	  else opener.getForm('theForm')[iFocus.value].value=queryValue;
	  //alert(opener.getForm('theForm')[iFocus.value].type+"="+opener.getForm('theForm')[iFocus.value].value);
//alert("queryValue["+queryValue+"]");
	  if(typeof(customIFocusHandler)!='undefined')
		queryValue=customIFocusHandler(opener.getForm('theForm'),iFocus.value,queryValue,keypath);
//alert("pre1["+iFocus.value+"]");
	  opener.Qbe_To_Ql(opener.getForm('theForm')[iFocus.value]);
//alert("post1");
	 }else{
	  if(keypath.indexOf('/')>0&&keypath.charAt(keypath.length-1)=='/')
		keypath=keypath.substring(0,keypath.length-1);
	  keypath = "[" + keypath + "]" ;
	  for(i=0;i<length;i++)
	  {// aggiunto controllo sulle select....

		if((elements[i].type=="text"||
			 elements[i].type=="textarea" ||
			 elements[i].type=="select-one" ||
			 elements[i].type=="select-multiple")&&
			0<=elements[i].name.indexOf(keypath))
		{elements[i].value=queryValue;
alert(elements[i].name+"\n"+elements[i].type);
		 if(null!=opener.Qbe_To_Ql){
//alert("pre2");
		  opener.Qbe_To_Ql(elements[i]);
//alert("post2");
		 }
		 break;
		}
	  }
	 }
	}
  }
 }

function PosizionamentoTermineVocabolario()   {
	var TermineSuCuiPosizionarsi = prompt('Dove ti vuoi posizionare ??', '');
	if (TermineSuCuiPosizionarsi != null)   {
		if (TermineSuCuiPosizionarsi.length > 0 && TermineSuCuiPosizionarsi.split(' ').join('') != '')   {
			if (getForm('seek')!= null)   {
				if (getForm('seek')['seektext'])   {
                                        getForm('seek')['seektext'].value = TermineSuCuiPosizionarsi;
					return posiziona(TermineSuCuiPosizionarsi, getForm('hxpForm').keypath.value);
				}
				else   {
					alert('Errore di configurazione:\rnon trovato input "seektext"');
				}
			}
			else   {
				alert('Errore di configurazione:\rnon trovata form "seek"');
			}
		}
	}
	return '';
}

