/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

 /* iw.js */
 /*
 function checkpluginversion()
 {if(navigator.appName=='Netscape' && 
     parseInt(navigator.appVersion.substring(0,1))>3) 
  {var newVI = new netscape.softupdate.VersionInfo(1,3,0,0);
   var existingVI = netscape.softupdate.Trigger.GetVersionInfo
                     ("plugins/Highway Imaging Control Plug-in"); 
   if(existingVI == null || existingVI.compareTo(newVI)<0 ) {
		var protocol = window.location.protocol;
    if(confirm('Installing Highway Imaging Control Plug-in version '+newVI))
     netscape.softupdate.Trigger.StartSoftwareUpdate
      (protocol + '//'+window.location.host+'/code/iw/npiw.jar',
       netscape.softupdate.Trigger.DEFAULT_MODE);
   }
  }
 }
 */
 function checkpluginversion(silent)
 {if(typeof(silent)=='undefined')
   silent=true;
  if(navigator.platform=="Win32")
  {if(navigator.appName=='Netscape')
   {if(navigator.appVersion.substring(0,1)>=5)
    {trigger=InstallTrigger;
     if(trigger.enabled())
     {var PLID='@3di.it/npmiw,version=1.0';
      // do not edit the following line, it is automatically updated building MPiw Win32 Release
      if(trigger.compareVersion(PLID,1,0,36,136)<0)
      {if(silent||confirm("Starting setup"))
       {var resource='../../../formatter/html/data/iw/npmiw.xpi';
        xpi={'Highway Imaging Control Plug-in':resource};
        if(!trigger.install(xpi,xpinstallCallback))
         alert('install failed (resource: '+resource+')');
       }
      }
      else if(!silent)alert("Plugin is up-to-date");
     }
     else alert("Enable Software Installation before running this script.");
    }
    else
    {if(navigator.javaEnabled())
     {trigger=netscape.softupdate.Trigger;
      if(trigger.UpdateEnabled())
      {vi=new netscape.softupdate.VersionInfo(1,3,0,0);
       var registryName="plugins";
 	  var jarurl=location.protocol+'//'+location.host+location.pathname.substring(0,location.pathname.lastIndexOf('/')+1)+'../../../formatter/html/data/iw/npiw.jar';
       if(trigger.CompareVersion(registryName,vi)<0)
       {if(silent||confirm("Starting setup"))
         trigger.ConditionalSoftwareUpdate(jarurl,registryName,vi,trigger.DEFAULT_MODE);
       }
       else if(!silent)alert("Plugin is up-to-date");
      }
      else alert("Enable SmartUpdate before running this script.");
     }
     else alert("Enable Java before running this script.");
    }
   }
   else alert("Sorry, this plug-in requires a Netscape/Mozilla based browser.");
  }
  else alert("Sorry, this plug-in only runs on MS Windows.")
 }
 function OnProgress(context,  // tipo di operazione: decompressione o download
                     subject,  // nome del file
                     udm,      // unit di misura dei numerelli a seguire 
                               // ad es: bytes (se applicabile)
                     stotpass, // numero totale di passi
                     scompass, // numero di passi completati
                     spassmax, // massimo valore per il passo corrente
                     spasscur) // valore corrente per il passo corrente
 {var passmax=parseInt(spassmax);
  var passcur=parseInt(spasscur);
  var totpass=parseInt(stotpass);
  var compass=parseInt(scompass);
  if (passcur==passmax && totpass==compass)
   window.status='';
  else 
  {var current=passcur,total=passmax;
   if(totpass>1) 
   {current+=compass*passmax;
    total*=totpass;
   }
   window.status=context+' '+Math.ceil((current*100)/total)+'% ';
   return true;
  }
 }
 var docWrapper     = 
 {  doneWithAcquire : function(data){window.DoneWithAcquire(data);},
     doneWithUpload : function(data,param,status){window.DoneWithUpload(data,param,status);},
   doneWithDownload : function(param,fileout,status){window.DoneWithDownload(param,fileout,status);},
      doneWithPrint : function(param,fileout,status){window.DoneWithPrint(param,fileout,status);},
  onDownloadStarted : function(param,url){window.OnDownloadStarted(param,url);},
         onProgress : function(context,subject,udm,stotpass,scompass,spassmax,spasscur){window.OnProgress(context,subject,udm,stotpass,scompass,spassmax,spasscur);},
         onNextFile : function(path,filename,data,count){window.OnNextFile(path,filename,data,count);}
 };
 function registerIW()
 {if(navigator.appName=='Netscape' && 
     parseInt(navigator.appVersion.substring(0,1))>3 &&
     typeof(getiw())=='object')
  {checkpluginversion();
   if(parseInt(navigator.appVersion.substring(0,1))<5)
    document.applets['IWObserver'].Register();
   else getiw().document=docWrapper;
  }
 }
 function writeTheApplet()
 {if(navigator.appName=='Netscape'&&parseInt(navigator.appVersion.substring(0,1))>3&&parseInt(navigator.appVersion.substring(0,1))<5)
   document.write('<applet code="IWObserver.class" mayscript width=2 height=0 name="IWObserver"></applet>');
 }
 function getiw() 
 {if(navigator.appName=='Netscape')
   return document.plugins['IW'];
  return document.all.IW;
 }