/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

 /* lookup.js */

 var theIndexWindow=null;
 
 //nome della finestra statica (vuota) che viene aperta quando c' un popup in modo che venga mantenuto il protocollo
 //corrente (http o https)
 var staticEmptyWindow = "./../formatter/html/templates/static.html";

 function getFeatures()
 {var keyCount=0+getForm('indexForm').keyCount.value;
  var features="status,resizable=yes,alwaysRaised=yes";
  var w=80+(keyCount>20?
            Math.ceil(Math.min(720,screen.availWidth*0.8)):
            Math.ceil(Math.min(360,screen.availWidth*0.5)));
  var h=60+Math.ceil(Math.min(444,screen.availHeight*0.7));
  var sb=navigator.appName=='Netscape'?true:false;
  return(features+",width="+w+",height="+h+(sb?",scrollbars=yes":""));
 }
 function chkKeyPath(keyPath)
 {if(keyPath.indexOf('/')!=-1&&keyPath.charAt(keyPath.length-1)!='/')keyPath+="/";
  if(keyPath.charAt(0)=='.')keyPath="XML,/"+getForm('hxpForm').pne.value+"/"+keyPath.substring(1);
  return keyPath;
 }
 function checkVal(val){return(typeof(val)!='undefined'?val:'');}
 /**
  * Apre una nuova finestra sulle relazioni
  */
 function openThes(qForm,   // la form con cui interagisce lo user
                   keyPath, // identifica la chiave negli indici
                   vRels,   // elenco degli indici di relazione visibili (comma delimited)
                   xRels,   // elenco degli indici di relazione espandibili (comma delimited)
                   startKey,// posizionamento
                   cPath,   // percorso comune
                   lRel,    // relazione da leggere comunque sull'ultimo termine di un percorso
                   theInput,// opzionalmente l'input dove depositare l'esito della selezione
                   presOper,// operatore opzionale da mettere in relazione con l'eventuale operatore del campo
                   maxLen)// operatore opzionale che indica la lunghezza massima della chiave di posizionamento
 {var iForm;
  var qKey;
  var element;
  var prOpr;
  var preStart;
  var lenKey;
  iForm=getForm('indexForm');
  proArch="";
  prOpr="";

  if(("undefined"!=typeof(theInput))&&(""!=theInput))
  {element=theInput;
   qKey=theInput.name;
  }
  else
  {if ("undefined"!=typeof(customGetIndexedElement)){
    qKey=customGetIndexedElement(keyPath);
    element=qForm[qKey];
   }
   else
   {proArch="";
    if("undefined"!=typeof(getNowArch))
     proArch="#"+getNowArch(getForm('hxpForm').db.value);
    qKey="["+keyPath+"]"+proArch;
    element=qForm[qKey];
    if(!element)
    {qKey="["+keyPath+"]";
     element=qForm[qKey];
    }
   }
  }
  if(!element)alert("openThes: campo di input \""+qKey+"\" non trovato");

  if("undefined"!=typeof(qForm["iFocus"]))
   qForm["iFocus"].value=qKey;
   
  if(("undefined"!=typeof(presOper))&&presOper&&element&&element.value)
   prOpr="preserve:("+element.value+") "+presOper+" ";
  if(/*startKey==''&&*/element&&element.value){
   preStart="";
   if(null!=startKey.match(/.*\@R\d\d\s*.*/))
    preStart=startKey.replace(/(.*\@R\d\d\s*).*/,"$1");
   startKey=element.value.toUpperCase();
   if(startKey.substring(0,1)=='"')
    startKey=startKey.substring(1,startKey.length);
   if(("undefined"!=typeof(maxLen))&&(""!=maxLen)){
    lenKey=1*maxLen;//trasformiamo la (possibile) stringa 'maxLen' nel numero 'lenKey'
    if(0<lenKey)
     startKey=startKey.substring(0,lenKey);
   }
   startKey=preStart+startKey;
  }
   
  keyPath=chkKeyPath(keyPath);
  iForm.verbo.value='showthes';
  iForm.keypath.value=unescape(keyPath);
  iForm.vRels.value=vRels;
  iForm.xRels.value=checkVal(xRels);
  iForm.cPath.value=checkVal(cPath);
  iForm.sele.value='';
  iForm.xMode.value=prOpr;
  iForm.startkey.value=checkVal(cPath)+checkVal(startKey);
  iForm.lRel.value=checkVal(lRel);
  iForm.selid.value=uid2id(getForm('hxpForm').selid.value,true);
  theIndexWindow=window.open(staticEmptyWindow,iForm.target,getFeatures());
  iForm.submit();
  return false;
 }
 /**
  * Apre una nuova finestra sugli indici
  */
 function openIndex(qForm,   // la form con cui interagisce lo user
                    keyPath, // identifica la chiave negli indici
                    startKey,// posizionamento
                    shwMode, // imposta la modalit di formattazione ('dt' per data)
                    common,  // parte comune
                    threl,   // opzionalmente l'indice della relazione con cui attingere
                             // la descrizione associata alla chiave (classificazioni)
                    theInput)// opzionalmente l'input dove depositare l'esito della selezione
 {//alert("keyPath=" + keyPath + "\nstartKey=" + startKey  + "\nshwMode=" + shwMode + "\nthrel=" + threl + "\ntheInput=" + theInput);
  var iForm;
  var qKey;
  var element;
  iForm=getForm('indexForm');
  proArch="";

if(getForm('indexForm').db.value.indexOf(',')>=0)
 return false;

  if("undefined"!=typeof(customGetKeyName))
   keyPath=customGetKeyName(keyPath);

  if(("undefined"!=typeof(theInput))&&(""!=theInput))
  {//element=theInput;
   qKey=theInput;
   element=qForm[qKey];
  }
  else
  {if ("undefined"!=typeof(customGetIndexedElement))
   {qKey=customGetIndexedElement(keyPath);
    element=qForm[qKey];
   }
   else
   {proArch="";
    if("undefined"!=typeof(getNowArch))
     proArch="#"+getNowArch(getForm('hxpForm').db.value);
    qKey="["+keyPath+"]"+proArch;
    element=qForm[qKey];
    if(!element){
     qKey="["+keyPath+"]";
     element=qForm[qKey];
    }
   }
  }

//  if("{"==keyPath.charAt(0)){
//   i=keyPath.indexOf("}");
//   prePath=keyPath.substr(0, i+1);
//   keyPath=keyPath.substr(i+1);
//  }
//  if("undefined"!=typeof(getNowArch))
//   proArch="#"+getNowArch(getForm('hxpForm').db.value);
//  qKey=prePath+"["+keyPath+"]"+proArch;
//  element=qForm[qKey];
//  if(!element)qKey=prePath+"["+keyPath+"]"+proArch;

  if(!element)
  {if(typeof(theLookupTarget)!='undefined')element=theLookupTarget;
   else alert("openIndex: campo di input \""+qKey+"\" non trovato");
  }
  if("undefined"!=typeof(qForm["iFocus"]))
   qForm["iFocus"].value=qKey;
  if(element&&element.value)
   startKey=element.value.toUpperCase();
  if(startKey.substring(0,1)=='"')
   startKey=startKey.substring(1,startKey.length);
  if( (shwMode=='dt') || (shwMode=='dt2') ) startKey=resumeDate(startKey);
  keyPath=chkKeyPath(keyPath);
  iForm.verbo.value='showindex';
  iForm.keypath.value=unescape(keyPath);
  iForm.threl.value=checkVal(threl);
  iForm.cPath.value=checkVal(common);
  iForm.doubleKey.value=(' '==checkVal(common)?"1":"0");
  iForm.shwMode.value=checkVal(shwMode);
  iForm.sele.value='';
  iForm.startkey.value=checkVal(common)+checkVal(startKey);
  iForm.selid.value=uid2id(getForm('hxpForm').selid.value,true);
  theIndexWindow=window.open(staticEmptyWindow,iForm.target,getFeatures());
  theIndexWindow.focus();
  iForm.submit();
  return false;
 }
 // usate dalla finestra di lookup per il posizionamento
 var theQueryTemplate; // template per query se chiave disponibile
 var theCriteriaTemplate; // template addizionale usato se theListCriteria!=''
 var theEmptyKeyQuery; // query in assenza di chiave
 var theListCriteria;  // regole da soddisfare per il contenuto degli elementi
 // chiamata anche dalla finestra di lookup per il posizionamento
 function getQuery(queryKey)
 {var result=(queryKey==''||queryKey=='*')?theEmptyKeyQuery:theQueryTemplate.replace(/\%k/g,queryKey);
  if(theListCriteria!='')result+=theCriteriaTemplate.replace(/\%k/g,theListCriteria);
  return result;
 }                                                           
 /**
  * Apre una nuova finestra per lookup da selezione
  */
 // lette dalla finestra di lookup per la generazione della lista
 var theListElements; // elenco elementi da prelevare
 var theListInput;
 function queryLookup(theInput,
                      db, // il db destinazione
                      queryKey, // da sostituire nel template
                      queryTemplate, // sostituisce %k con queryKey
                      emptyKeyQuery, // in caso queryKey==''
                      listElements, // attributi da prelevare
                      criteriaTemplate, // da aggiungere alla query in caso listCriteria!='' (sostituisce %k con listCriteria)
                      listCriteria) // criteri
 {var prevTarget=getForm('hxpForm').target;
  var prevDb=getForm('hxpForm').db.value;
  theListInput=theInput;
  theQueryTemplate=queryTemplate;
  theCriteriaTemplate=criteriaTemplate;
  theEmptyKeyQuery=emptyKeyQuery;
  theListElements=listElements;
  theListCriteria=listCriteria;
  getForm('hxpForm').db.value=db;
  getForm('hxpForm').query.value=getQuery(queryKey);
  theIndexWindow=window.open(staticEmptyWindow,getForm('hxpForm').target='titlechild',getFeatures());
  sendRequest('query','titlechild');
  getForm('hxpForm').target=prevTarget;
  getForm('hxpForm').db.value=prevDb;
  return false;
 }
 
 function lookupFocusHandler()
 {if(theIndexWindow!=null)theIndexWindow.close();
  theIndexWindow=null;
 }

 function resumeDate(startKey) {
    var startKeySplitted = startKey.split("/");
    /* ...serve per "trimmare" i singoli token che ricompongono la chiave...**/
    var re = /\s/g;
    if(startKeySplitted.length == 3) startKey = startKeySplitted[2].replace(re, "") +  startKeySplitted[1].replace(re, "") + startKeySplitted[0].replace(re, "");
    return startKey;
 }