/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

 /* navbar.js */

 /* funzioni per la barra di navigazione tra documenti */

 //numero massimo di linguette
 var maxHits = 10;

 function titnavbarcode(pos,count,pageCount,path)
 {if(typeof(path)=='undefined')
   path="../formatter/html/data/common/images/titles/";
  var numPages=Math.floor((count+pageCount-1)/pageCount);
  var curPage=Math.floor(pos/pageCount); // zero based
  if(numPages<=4)return '';
  var totHits= (maxHits>numPages?numPages:maxHits);
  var pagesPerHit=(1.+numPages)/totHits;
  var result='';
  var firstR=true;
  for(var index=0;index<totHits;index++)
  {var hitPage=Math.floor(index*pagesPerHit);
   if(index==0&&curPage==0)
    /*result+='<img src="../formatter/html/data/common/images/titles/a_rl.gif"/>'*/;
   else if(index==totHits-1&&curPage==numPages-1)
    result+='<img src="' + path + 'a_rr.gif"/>';
   else if(hitPage>curPage)
   {if (firstR)
    {firstR=false;
     result+='<img src="' + path + 'a_rl.gif"/>';
    }
    result+='<img onclick="nav2page('+index+','+pos+','+count+','+pageCount+',true)" src="' + path + 'a_gr.gif" title="pagina '+(1+hitPage)+'"/>';
   }
   else if (hitPage==curPage && index==totHits-1)
    result+='<img src="' + path + 'a_rr.gif"/>';
   else if (hitPage==curPage)
    /*result+='<img src="' + path + 'a_rr.gif"/>'*/;    
   else
    result+='<img onclick="nav2page('+index+','+pos+','+count+','+pageCount+',false)" src="' + path + 'a_gl.gif" title="pagina '+(1+hitPage)+'"/>';
  }
  return result;
 }

 function numtitnavbarcode(pos,count,pageCount)
 {
  var numPages=Math.floor((count+pageCount-1)/pageCount);
  var curPage=Math.floor(pos/pageCount); // zero based
   
  var ret="";
   var startprint,endprint;
  
  if (numPages<=10) 
  {
    startprint=0;
    endprint=numPages;
  }
  else 
  {
   if((curPage-5)>0)
   {startprint=curPage-5}
   else
   {startprint=0;}
   
   if((curPage+5)<numPages)
   {endprint=curPage+5;}
   else
   {endprint=numPages;}
  
   
   //eventuale allargamento a destra 
   if(endprint-startprint<10)
   {
    while((endprint+1<numPages) && endprint-startprint<10)
    { endprint++;
    }
   
   }
   //eventuale allargamento a sinistra
   if(endprint-startprint<10)
   {
       while((startprint-1>0) && endprint-startprint<10)
    { startprint--;
    }
   }
     
  }
  
  
  
  
  for(var i= startprint;i<endprint;i++)
  {
  if(i==curPage)
  ret+='<span class="evidence_number">'+(i+1)+'</span>';
  else

 ret+='<a href="#" onclick="numnav2page('+i*pageCount+')">'+(i+1)+'</a>';
  ret+='&#160;';
  }
  return ret;
 }

function numnav2page(navPos)
 {
  getForm('hxpForm').verbo.value='showtitles';
  getForm('hxpForm').pos.value=navPos;
  getForm('hxpForm').submit();
  return false;
 } 

 
 function nav2page(index,pos,count,pageCount,fwd)
 {var numPages=Math.floor((count+pageCount-1)/pageCount);
  var curPage=Math.floor(pos/pageCount); // zero based
  var totHits=(maxHits>numPages?numPages:maxHits);
  var pagesPerHit=(1.+numPages)/totHits;
  var navPos=Math.floor(pagesPerHit*pageCount*index);
  navPos=Math.floor(navPos/pageCount)*pageCount;
  if(navPos==pos)
   navPos+=fwd?pageCount:-pageCount;
  getForm('hxpForm').verbo.value='showtitles';
  getForm('hxpForm').pos.value=navPos;
  getForm('hxpForm').submit();
  return false;
 } 