/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

 /* qlist.js */

 var OPTPROFILEPUSHJOBNONE=0x100000;
 var OPTPROFILEHASPUSHJOB =0x080000;
 var OPTPROFILEHASPUSHANY =(OPTPROFILEHASPUSHJOB|OPTPROFILEPUSHJOBNONE);
 var qTitleINDEX=0;
 var  qDataINDEX=1;
 var   qExtINDEX=2;
 var   qOptINDEX=3;
 var   qAdjINDEX=4;
 var    qDbINDEX=5;
 var qParmsINDEX=6;

 function loadHandler()
 {if(typeof(opener)!='undefined')
   opener.thePopupWindow=window;
  fillData();
  fillSelect();
  if(qlist_count>0)
  {document.qList.qTitle.selectedIndex=0;
   selectHasChanged();
  }
  if(getForm('hxpForm').query.value!='')
  {document.qList.qData.value=getForm('hxpForm').query.value;
   getForm('hxpForm').query.value='';
   newQuery();
  }
  getForm('hxpForm').opt.value=parseInt(getForm('hxpForm').opt.value,10)&~OPTPROFILEHASPUSHANY;
 }
 function unloadHandler()
 {parent.thePopupWindow=null; 
 }
 function PushHasChanged()
 {var currentIndex=document.qList.qTitle.selectedIndex;
  if(document.qList.qPush)
  {if(currentIndex<0)
   {document.qList.qPush.checked=false;
   }
   else
   {if(document.qList.qPush.checked)
     qlist_Parms[currentIndex]='1';
    else qlist_Parms[currentIndex]='';
   }
  }
 }
 function selectHasChanged()
 {var currentIndex=document.qList.qTitle.selectedIndex;
  if(currentIndex<0)
  {document.qList.qData.value='';
   if(document.qList.qPush)document.qList.qPush.checked=false;
  }
  else
  {document.qList.qData.value=qlist_Data[currentIndex];
   if(opener.xw2app)document.qList.qData.value=opener.xw2app(document.qList.qData.value);
   if(document.qList.qPush)document.qList.qPush.checked=qlist_Parms[currentIndex]!='';
  }
 }
 var qlist_Title=new Array('');
 var qlist_Data=new Array('');
 var qlist_Ext=new Array('');
 var qlist_Opt=new Array('');
 var qlist_Adj=new Array('');
 var qlist_Db=new Array('');
 var qlist_Parms=new Array('');
 var qlist_count=0;
 var hasPush=false;
 function fillData()
 {if(getForm('hxpForm').appData.value!='')
  {var fq=getForm('hxpForm').appData.value.split('\n');
   for(var i=0;i<fq.length;i++)
   {if(fq[i]!='')
    {var row=fq[i].split('\t');
     qlist_Title[qlist_count]=row[qTitleINDEX].split("_").join(" ");
     qlist_Data [qlist_count]=row[qDataINDEX];
     qlist_Ext  [qlist_count]=row[qExtINDEX];
     qlist_Opt  [qlist_count]=row[qOptINDEX];
     qlist_Adj  [qlist_count]=row[qAdjINDEX];
     qlist_Db   [qlist_count]=row[qDbINDEX];
     qlist_Parms[qlist_count]=(row.length>qParmsINDEX?row[qParmsINDEX]:'');
     if(row[qParmsINDEX]!='')hasPush=true;
     qlist_count++;
    }
   }
   //qlist_count=qlist_Title.length;
  }
 }
 function checkPush()
 {for(var i=0;i<qlist_Parms.length;i++)
   if(qlist_Parms[i]=='1')return true;
  return false;
 }
 function NomeRicercaUnivoco(NomeNuovaRicerca)   
 {for(var i=0;i<qlist_count;i++)   
   if(qlist_Title[i]==NomeNuovaRicerca)   
    return false;
  return true;
 }
 function removeWhitespace(s){return s;}
 function fillSelect()
 {for(var i=0;i<qlist_count;i++)
  {populate(document.qList.qTitle,qlist_Title[i]);
  }
 }
 function populate(theSelect,theOptionValue)
 {theSelect.options[theSelect.options.length]=new Option(theOptionValue,theOptionValue);
 }
 function eraseQuery()
 {var currentIndex=document.qList.qTitle.selectedIndex;
  if(currentIndex<0)return;
  for(var index=currentIndex+1;index<qlist_count;index++)
  {qlist_Title[index-1]=qlist_Title[index];
   qlist_Data[index-1]=qlist_Data[index];
   qlist_Ext[index-1]=qlist_Ext[index];
   qlist_Opt[index-1]=qlist_Opt[index];
   qlist_Adj[index-1]=qlist_Adj[index];
   qlist_Db[index-1]=qlist_Db[index];
   qlist_Parms[index-1]=qlist_Parms[index];
  }
  document.qList.qTitle.options[currentIndex]=null;
  qlist_count--;
  if(qlist_count>0)
   document.qList.qTitle.selectedIndex=currentIndex<qlist_count?currentIndex:qlist_count-1;
  selectHasChanged();
 }
 function newQuery()
 {if(document.qList.qData.value!='')
  {NomeNuovaRicerca=prompt("Immettere una descrizione da associare alla ricerca!","Nome Nuova Ricerca Frequente");
   if(NomeNuovaRicerca!=null)
   {NomeNuovaRicerca = removeWhitespace(NomeNuovaRicerca.replace(/\x27/gi,"\\'"));
    if(NomeNuovaRicerca.length>0)
    {if(NomeRicercaUnivoco(NomeNuovaRicerca)) 
     {addQuery(NomeNuovaRicerca,getForm('hxpForm').qext.value,getForm('hxpForm').qopt.value,getForm('hxpForm').qadj.value,getForm('hxpForm').db.value,'');
     }else alert('Il nome specificato per la ricerca non  univoco.');
    }else alert('Nome ricerca non valido.');//\rOperazione annullata.');
   }//else alert('Operazione annullata dall\'utente.');
  }else alert('Nessuna ricerca impostata!')
  selectHasChanged();
 }
 function qlist2String()
 {var result='';
  for(var index=0;index<qlist_count;index++)
   result+=qlist_Title[index]+'\t'+
           qlist_Data[index]+'\t'+
           qlist_Ext[index]+'\t'+
           qlist_Opt[index]+'\t'+
           qlist_Adj[index]+'\t'+
           qlist_Db[index]+'\t'+
           qlist_Parms[index]+'\t'+
           '\n';
  return result;
 }
 function addQuery(title,ext,opt,adj,db,parms)
 {qlist_Title[qlist_count]=title;
  qlist_Data[qlist_count]=document.qList.qData.value;
  if(opener.app2xw)qlist_Data[qlist_count]=opener.app2xw(qlist_Data[qlist_count]);
  qlist_Ext[qlist_count]=ext;
  qlist_Opt[qlist_count]=opt;
  qlist_Adj[qlist_count]=adj;
  qlist_Db[qlist_count]=db;
  qlist_Parms[qlist_count]=parms;
  populate(document.qList.qTitle,qlist_Title[qlist_count]);
  document.qList.qTitle.selectedIndex=qlist_count++;
  selectHasChanged();
 }
 function isDbAvailable(dbList,qDb)
 {var pos=0;
  if(dbList)
  {for(;;)
   {pos=dbList.indexOf(qDb,pos);
    if(pos<0)return false;
    if((pos==0||dbList.charAt(pos-1)==',')&&
       (pos+qDb.length==dbList.length||(pos+qDb.length<dbList.length&&dbList.charAt(pos+qDb.length)==',')))
     return true;
    pos+=qDb.length;
   }
   return false;
  }
  return true;
 }
 function GoTo_(NomeRichiesta)
 {var NomeNuovaRicerca = '';
  if(NomeRichiesta == 'cancel')
  {opener.focus();
   this.window.close();
  }else if (NomeRichiesta == 'confirm')
  {PushHasChanged();
   getForm('hxpForm').xverb.value="@set";
   getForm('hxpForm').appData.value=qlist2String();
   var push=checkPush();
   if(push!=hasPush)
    getForm('hxpForm').opt.value=
     (parseInt(getForm('hxpForm').opt.value,10)&~OPTPROFILEHASPUSHANY)
     |(push?OPTPROFILEHASPUSHJOB:OPTPROFILEPUSHJOBNONE);
   getForm('hxpForm').submit();
  }else if(NomeRichiesta=='show')
  {var currentIndex=document.qList.qTitle.selectedIndex;
   if(currentIndex>=0)
   {if(isDbAvailable(opener.dbList,qlist_Db[currentIndex]))
    {var query=opener.getForm('hxpForm').query.value;
     var qext =opener.getForm('hxpForm').qext.value;
     var qopt =opener.getForm('hxpForm').qopt.value;
     var qadj =opener.getForm('hxpForm').qadj.value;
     var db   =opener.getForm('hxpForm').db.value;
     opener.getForm('hxpForm').query.value=qlist_Data[currentIndex];
     opener.getForm('hxpForm').qext.value=qlist_Ext[currentIndex];
     opener.getForm('hxpForm').qopt.value=qlist_Opt[currentIndex];
     opener.getForm('hxpForm').qadj.value=qlist_Adj[currentIndex];
     opener.getForm('hxpForm').db.value=qlist_Db[currentIndex];
     opener.svuotaSelezione();
     if(opener.emptyUndo)opener.emptyUndo();
     opener.sendQuery();
     opener.getForm('hxpForm').query.value=query;
     opener.getForm('hxpForm').qext.value =qext ; 
     opener.getForm('hxpForm').qopt.value =qopt ; 
     opener.getForm('hxpForm').qadj.value =qadj ; 
     opener.getForm('hxpForm').db.value   =db   ;
     opener.focus();
     this.window.close();
    }else alert(opener.dbList+'  '+qlist_Db[currentIndex])
   }
  }else if(NomeRichiesta=='add') // Devo richiedere il nome
  {newQuery();
  }else if(NomeRichiesta=='erase')
  {var CurrentSelectIndex=document.qList.qTitle.selectedIndex;
   if(CurrentSelectIndex>=0)
   {var CurrentSelectValue=document.qList.qTitle.options[CurrentSelectIndex].value; //.split(" ").join("_");
    if(confirm('Ricerca: "'+CurrentSelectValue.split("_").join(" ")+'".\rConfermi la cancellazione ?'))   
     eraseQuery();
   }
  }else alert('unhandled request: '+NomeRichiesta);
 }

