/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

 /* thEdit.js */

 //nome della finestra statica (vuota) che viene aperta quando c' un popup in modo che venga mantenuto il protocollo
 //corrente (http o https)
 var staticEmptyWindow = "./../formatter/html/templates/static.html";

 function salvaNodo()
 {if(document.thNode.nodeName.value=='')
   return true;
  getForm('hxpForm').name.value=document.thNode.nodeName.value;
  getForm('hxpForm').verbo.value='thEdit';
  getForm('hxpForm').xverb.value='@save';
  getForm('hxpForm').submit();
  return false;
 }
 function nuovoNodo()
 {getForm('hxpForm').name.value='';
  getForm('hxpForm').rels.value='';
  getForm('hxpForm').prev.value='';
  getForm('hxpForm').next.value='';
  document.thNode.nodeName.value='';
  document.thNode.nodeTo.value='';
  document.thNode.nodeName.focus();
 }
 function chiudiNodo()
 {if(typeof(opener)!='undefined'&&
     typeof(opener.theIndexWindow)!='undefined')
  {opener.theIndexWindow=null;
   opener.focus();
   self.close();
  }
  else
  {getForm('hxpForm').verbo.value='query';
   getForm('hxpForm').xverb.value='';
   getForm('hxpForm').query.value='';
   getForm('hxpForm').submit();
  }
  return false;
 }
 function cercaNodo()
 {return cambiaNodo(document.thNode.nodeName.value);
 }
 function impostaCanale(nome)
 {if(nome=='')return true; 
  getForm('hxpForm').keypath.value=nome;
  return true;
  //return cambiaNodo(document.thNode.nodeName.value);
 }
 function impostaFonte(nome)
 {if(nome=='')return true; 
  getForm('hxpForm').db.value=nome;
  return true;
  //return cambiaNodo(document.thNode.nodeName.value);
 }
 function cambiaNodo(nome)
 {if(nome=='')return true; 
  getForm('hxpForm').verbo.value='thEdit';
  getForm('hxpForm').xverb.value='';
  getForm('hxpForm').rels.value='';
  getForm('hxpForm').name.value=nome;
  getForm('hxpForm').submit();
  return false;
 }
 function getFeatures()
 {var keyCount=0+getForm('hxpForm').keyCount.value;
  var features="status,resizable=yes,alwaysRaised=yes";
  var w=80+(//keyCount>20?
            Math.ceil(Math.min(720,screen.availWidth*0.8))
            //:Math.ceil(Math.min(360,screen.availWidth*0.5))
            );
  var h=60+Math.ceil(Math.min(540,screen.availHeight*0.7));
  var sb=navigator.appName=='Netscape'?true:false;
  return(features+",width="+w+",height="+h+(sb?",scrollbars=yes":""));
 }
 var theIndexWindow=null;
 function nodeHier()
 {getForm('hxpForm').verbo.value='showthes';
  //getForm('hxpForm').keypath.value=unescape(keyPath);
  getForm('hxpForm').vRels.value='1,2,3,4,5,6,7,8,9,10,11,13,14,15,16';
  getForm('hxpForm').xRels.value='1';
  ///getForm('hxpForm').cPath.value='. @R01 ';
  //getForm('hxpForm').cPath.value='';
  getForm('hxpForm').startkey.value=document.thNode.nodeName.value;
  //getForm('hxpForm').lRel.value='';
  //getForm('hxpForm').sele.value='';
  xtarget=getForm('hxpForm').target;
  getForm('hxpForm').target='thesWindow';
  theIndexWindow=window.open(staticEmptyWindow,getForm('hxpForm').target,getFeatures());
  getForm('hxpForm').submit();
  getForm('hxpForm').target=xtarget;
  return false;
 }
 function isDigit(ch)
 {return '0123456789'.indexOf(ch)>=0;
 }
 function findRelStop(where,from)
 {var pos,result;
  for(;;)
  {pos=where.indexOf(',',from);
   if(pos<0)return pos;
   result=pos;
   from=pos+1;
   if(!isDigit(where.charAt(from)))
    continue;
   while(isDigit(where.charAt(from)))
    from++;
   if(where.charAt(from)==' ')
    return result;
  }
 }
 var currentRelIndex=0;
 function form2rels(theText)
 {theText=theText.replace(/[\r\$]/g,'');
  var theRel=currentRelIndex+1;
  var seek=''+theRel+' ';
  var start,stop;
  if(getForm('hxpForm').rels.value.substring(0,seek.length)==seek)
   start=0;
  else start=getForm('hxpForm').rels.value.indexOf(','+seek);
  if(start>=0)
  {var pos;
   if(start>0)start++;
   stop=start;
   for(;;)
   {pos=findRelStop(getForm('hxpForm').rels.value,stop+seek.length)
    //pos=getForm('hxpForm').rels.value.indexOf(',',stop+seek.length);
    if(pos<0)
    {stop=getForm('hxpForm').rels.value.length;
     break;
    }
    stop=pos+1;
    if(getForm('hxpForm').rels.value.substring(stop,stop+seek.length)!=seek)
     break;
   }
  }
  else start=stop=0;
  var theLines=theText.split('\n');
  var relString='';
  for(var index=0;index<theLines.length;index++)
   if(theLines[index].length)
    relString+=''+theRel+' '+theLines[index]+',';
  getForm('hxpForm').rels.value=getForm('hxpForm').rels.value.substring(0,start)+relString+getForm('hxpForm').rels.value.substring(stop);
  if(getForm('hxpForm').rels.value.length>0&&getForm('hxpForm').rels.value.substring(getForm('hxpForm').rels.value.length-1)==',')
   getForm('hxpForm').rels.value=getForm('hxpForm').rels.value.substring(0,getForm('hxpForm').rels.value.length-1);
 }
 function cambiaRelazione(theSelect)
 {form2rels(document.thNode.nodeTo.value);
  rels2form(document.thNode.nodeRel);
  getForm('hxpForm').relIndex.value=document.thNode.nodeRel.selectedIndex;
 }
 function rels2form(theSelect)
 {currentRelIndex=theSelect.selectedIndex;
  var theRel=theSelect.selectedIndex+1;
  var toData='';
  var seek=''+theRel+' ';
  var start;
  if(getForm('hxpForm').rels.value.substring(0,seek.length)==seek)
   start=0;
  else start=getForm('hxpForm').rels.value.indexOf(','+seek);
  if(start>=0)
  {if(start>0)start++;
   var stop=start,pos;
   for(;;)
   {pos=findRelStop(getForm('hxpForm').rels.value,stop+seek.length)
    //pos=getForm('hxpForm').rels.value.indexOf(',',stop+seek.length);
    if(pos<0)
    {stop=getForm('hxpForm').rels.value.length;
     break;
    }
    stop=pos;

    if(getForm('hxpForm').rels.value.substring(stop+1,stop+1+seek.length)!=seek)
     break;
   }
   /*
   var toList=getForm('hxpForm').rels.value.substring(start,stop).split(',');
   for(var index=0;index<toList.length;index++)
    toData+=toList[index].substring(toList[index].indexOf(' ')+1)+'\n';
   */
   var toList=getForm('hxpForm').rels.value.substring(start+seek.length,stop).split(','+seek);
   for(var index=0;index<toList.length;index++)
    toData+=toList[index]+'\n';
   
  }
  document.thNode.nodeTo.defaultValue=document.thNode.nodeTo.value=toData;
 }
 function docId2Elem(id){return document.getElementById(id);}
 function checkSelect(theSelect,theValue)
 {for(var index=0;index<theSelect.options.length;index++)
   if(theSelect.options[index].value==theValue)
   {theSelect.selectedIndex=index;
    break;
   }
 }
 function loadHandler()
 {var relDescr=getForm('hxpForm').relDescr.value.split(',');
  for(var index=0;index<relDescr.length;index++)
   document.thNode.nodeRel.options[index]=new Option(relDescr[index],relDescr[index]);
  //document.thNode.nodeRel.options[0].selected=true;
  currentRelIndex=document.thNode.nodeRel.selectedIndex=getForm('hxpForm').relIndex.value;
  rels2form(document.thNode.nodeRel);
  if(typeof(document.thNode.nodeSource)!='undefined')
   checkSelect(document.thNode.nodeSource,getForm('hxpForm').db.value);
  if(typeof(document.thNode.nodeChannel)!='undefined')
   checkSelect(document.thNode.nodeChannel,getForm('hxpForm').keypath.value);
  document.thNode.nodeRel.focus();
 }
 function unloadHandler()
 {}
 var oldFocusHandler=window.onfocus;
 window.onfocus=focusHandler;
 function focusHandler()
 {} 
