<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<%@ page session="false" %>
<%@ page isThreadSafe="true" %>
<%@ page isErrorPage="true" %>
<html>
<head>
<link rel="stylesheet" href="../formatter/html/data/styles/generic.css" type="text/css"/>
<title>eXtraWay Viewer - Exception</title>
<script>
function isOpened(){return(window.name.indexOf('queryIFrame')<0);}
function historyback(){if(history.length>0)history.back();else window.location.reload();return false;}
function errDialog(message)
{if(!isOpened())
 {var el=document.getElementById("errortext");
  if(el!=null)
  {if(confirm(message+'\n\nShow details'))
    alert(el.innerHTML);
  }
  else alert(message);
  parent.loadIframe();
 }
 return false;
}
function recover(from)
{try
 {if(typeof(opener.document.hxpForm)!='undefined')
   self.close();
  else throw new Exception();
 }
 catch (e)
 {return historyback();
 }
 //if(isOpened()&&typeof(opener)!='undefined'&&typeof(opener.document)!='undefined'&&typeof(opener.document.hxpForm)!='undefined')self.close();else return historyback();
}
</script>
</head>
<% 
 response.setStatus(500);
 String description=exception.getMessage();
 exception.printStackTrace();
 if(description!=null&&description.indexOf("Invalid key name ")>=0)
 {
  %>
   <body style="margin:50;">
    <table>
    <tr>
    <td valign="middle" class="messaggio"><a onmouseover="window.status='Torna';return true" onmouseout="window.status=''" onclick="return recover();" href="javascript:void(0)"><img src="../formatter/html/data/images/index/torna.gif" border="0" alt="Back" title="Back"/></a></td>
    <td>&#160;</td>
    <td valign="middle" class="messaggio">Empty Index.</td>
    </tr>
    </table>
   </body>
  <% 
 }
 else 
 if(description!=null&&description.indexOf("tente non trovato nel file")>=0)
 {
  %>
   <body style="margin:50;" onload="errDialog('User already used. Use a persona User ID to access the system.');">
    <table>
    <tr>
    <td valign="middle" class="messaggio"><a onmouseover="window.status='Torna';return true" onmouseout="window.status=''" onclick="return recover();" href="javascript:void(0)"><img src="../formatter/html/data/images/index/torna.gif" border="0" alt="Back" title="Back"/></a></td>
    <td>&#160;</td>
    <td valign="middle" class="messaggio">User already used. Use a persona User ID to access the system.</td>
    </tr>
    </table>
   </body>
  <% 
 }
 else 
 if(description!=null&&description.indexOf("Errore sintattico")>=0)
 {
  %>
   <body style="margin:50;" onload="errDialog('Search expression contains a term combination that violate the syntax.')">
    <table>
    <tr>
    <td valign="middle" class="messaggio"><a onmouseover="window.status='Torna';return true" onmouseout="window.status=''" onclick="return recover();" href="javascript:void(0)"><img src="../formatter/html/data/images/index/torna.gif" border="0" alt="Back" title="Back"/></a></td>
    <td>&#160;</td>
    <td valign="middle" class="messaggio">Search expression contains a term combination that violate the syntax.</td>
    </tr>
    </table>
   </body>
  <% 
 }
 else 
 if(description!=null&&description.indexOf("Troppe parole chiave")>=0)
 {
  %>
   <body style="margin:50;" onload="errDialog('Search resoult should be to wide.')">
    <table>
    <tr>
    <td valign="middle" class="messaggio"><a onmouseover="window.status='Torna';return true" onmouseout="window.status=''" onclick="return recover();" href="javascript:void(0)"><img src="../formatter/html/data/images/index/torna.gif" border="0" alt="Back" title="Back"/></a></td>
    <td>&#160;</td>
    <td valign="middle" class="messaggio">Search resoult should be to wide.</td>
    </tr>
    </table>
   </body>
  <% 
 }
 else 
 if(description!=null&&description.indexOf("Protezione file non riuscita")>=0)
 {
  %>
   <body style="margin:50;" onload="errDialog('Required document is already locked by another user or can't be modified.')">
    <table>
    <tr>
    <td valign="middle" class="messaggio"><a onmouseover="window.status='Torna';return true" onmouseout="window.status=''" onclick="return historyback()" href="javascript:void(0)"><img src="../formatter/html/data/images/index/torna.gif" border="0" alt="Back" title="Back"/></a></td>
    <td>&#160;</td>
    <td valign="middle" class="messaggio">Required document is already locked by another user or can't be modified.</td>
    </tr>
    </table>
   </body>
  <% 
 }
 else 
 if(description!=null&&description.indexOf("Connection refused")>=0)
 {
  %>
   <body style="margin:50;" onload="errDialog('Server Unavailable.')">
    <table>
    <tr>
    <td valign="middle" class="messaggio"><a onmouseover="window.status='Torna';return true" onmouseout="window.status=''" onclick="return historyback()" href="javascript:void(0)"><img src="../formatter/html/data/images/index/torna.gif" border="0" alt="Back" title="Back"/></a></td>
    <td>&#160;</td>
    <td valign="middle" class="messaggio">Server Unavailable.</td>
    </tr>
    </table>
   </body>
  <% 
 }
 else 
 if(description!=null&&description.indexOf("Tempo esaurito in ricerca")>=0)
 {
  %>
   <body style="margin:50;" onload="errDialog('Operation run over maximum time.')">
    <table>
    <tr>
    <td valign="middle" class="messaggio"><a onmouseover="window.status='Torna';return true" onmouseout="window.status=''" onclick="return historyback()" href="javascript:void(0)"><img src="../formatter/html/data/images/index/torna.gif" border="0" alt="Back" title="Back"/></a></td>
    <td>&#160;</td>
    <td valign="middle" class="messaggio">Operation run over maximum time.</td>
    </tr>
    </table>
   </body>
  <% 
 }
 else 
 if(description!=null&&description.indexOf("Attenzione: la frase di ricerca comprende")>=0)
 {
  %>
   <body style="margin:50;" onload="errDialog('Wrong syntax in search expression.')">
    <table>
    <tr>
    <td valign="middle" class="messaggio"><a onmouseover="window.status='Torna';return true" onmouseout="window.status=''" onclick="return historyback()" href="javascript:void(0)"><img src="../formatter/html/data/images/index/torna.gif" border="0" alt="Back" title="Back"/></a></td>
    <td>&#160;</td>
    <td valign="middle" class="messaggio">Wrong syntax in search expression.</td>
    </tr>
    </table>
   </body>
  <% 
 }
 else 
 if(description!=null&&(description.indexOf("access denied (db=")>=0 || description.indexOf("access denied: ")>=0))
 {
  %>
   <body style="margin:50;" onload="errDialog('Unavailable operation')">
    <table>
    <tr>
    <td valign="middle" class="messaggio"><a onmouseover="window.status='Torna';return true" onmouseout="window.status=''" onclick="return historyback()" href="javascript:void(0)"><img src="../formatter/html/data/images/index/torna.gif" border="0" alt="Back" title="Back"/></a></td>
    <td>&#160;</td>
    <td valign="middle" class="messaggio">Unavailable operation.</td>
    </tr>
    </table>
   </body>
  <% 
 }
 else 
 if(description!=null&&(description.indexOf("essun documento selezionato")>=0))
 {
  %>
   <body style="margin:50;" onload="errDialog('Empty selection.')">
    <table>
    <tr>
    <td valign="middle" class="messaggio"><a onmouseover="window.status='Torna';return true" onmouseout="window.status=''" onclick="return recover();" href="javascript:void(0)"><img src="../formatter/html/data/images/index/torna.gif" border="0" alt="Back" title="Back"/></a></td>
    <td>&#160;</td>
    <td valign="middle" class="messaggio">Empty selection.</td>
    </tr>
    </table>
   </body>
  <% 
 }
 else
 {
  %>
   <body bgcolor="#44eedd" onload="errDialog('Exception.')">
    <p>
     <h3><font face="verdana">Exception</font></h3>
    </p>
    <p>
     <code>
     <div>
      <% 
       java.io.ByteArrayOutputStream bOut=new java.io.ByteArrayOutputStream();
       exception.printStackTrace(new java.io.PrintStream(bOut));
      %>
      <%= it.highwaytech.util.Text.tohtml(exception.toString()) %>
      
      <p><a href="javascript:void(0);" onclick="var theElem=document.getElementById('errortext');theElem.style.display=('none'==theElem.style.display?'':'none');return true;">Show details</a></p>
      <p>
       <div id="errortext" style="display:none">
        <pre><%= it.highwaytech.util.Text.tohtml(bOut.toString()).toString() %></pre>
       </div>
      </p>
     </code>
    </p>
   
   </body>
  <% 
 }

%>

</html>
