<?xml version="1.0" encoding="iso-8859-1"?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
  xmlns:xw="http://www.3di.it/ns/xw-200203121136" exclude-result-prefixes="xw">
 <xsl:variable name="_docname" select="/response/@verbo"/>
 <xsl:variable name="hxptemplate" 
               select="document(concat('../html/templates/',concat($_docname,'.html')))"/>
 <xsl:include href="../../../../formatter/factory/docEdit.xsl"/>

 <xsl:template name="customcontent">
  <xsl:text>must implement customcontent</xsl:text>
 </xsl:template>
 <!--
 <xsl:template match="newLine">
  <xsl:text disable-output-escaping="yes">&lt;newLine/></xsl:text>
 </xsl:template>
 -->

	<xsl:template name="containerConditional">
		<xsl:param name="tempName" select="''"/>
		<xsl:param name="blockData" select="''"/>
	</xsl:template>

	<xsl:template name="contextcustom">
		<xsl:param name="blockData" select="''"/>
		<xsl:param name="specName" select="''"/>
	</xsl:template>	
 
 <xsl:template match="*[@id='hxp-custom-dbform']">
  <xsl:variable name="_doctype" select="$hxpdata/@db"/>
  <xsl:variable name="dbtemplate" select="document(concat('../html/templates/',$_docname,'.html'))"/>
  <xsl:apply-templates select="$dbtemplate/html/body/*" mode="template"/>
 </xsl:template>

 <xsl:template match="*[@id='hxp-custom-filehandler']">
  <xsl:variable name="filetemplate" select="document('../html/templates/filehandler.html')"/>
  <xsl:apply-templates select="$filetemplate/html/body/form/*" mode="template"/>
 </xsl:template>

 <xsl:output method="html" indent="yes" encoding="iso-8859-1" />
</xsl:stylesheet>
