<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<%@ page import = "java.sql.*" %>
<%@ page import = "java.util.*" %>
<%@ include file = "resource.jsp" %>
<% 
 final String pageTitle = "connection list";
%>

<%@ page import = "it.highwaytech.broker.Broker" %>
<%@ page import = "it.highwaytech.broker.ConnectionInfo" %>
<%@ page import = "it.highwaytech.apps.JRequest" %>

<html>
<head>
 <%@ include file = "head.jsp" %>
</head>
<body> 
  <table class="pageframe" style="width:100%;height:100%" cellpadding="8" cellspacing="10">
  <tbody>
  <tr class="pageframe" height="2%">
   <td class="pageframe" height="2%"><%@ include file = "top.jsp" %></td>
  </tr>   
  <tr class="pageframe" height="100%">
  <td class="pageframe" valign="top">
<small>
<%
Broker broker = null;
JRequest rq = null;

try 
{rq=new JRequest(request);
 broker=new Broker();
 int connIndex=rq.readIntParameter("kill",-1);
 if(connIndex>=0)
 {broker.closeConnection(connIndex);
 }
 ArrayList ciList=broker.getConnectionInfo();
 %>
 <form name="theForm" method="post" enctype="multipart/form-data" action="<%= rq.hwScript %>">
 <%   
 if(ciList.size()>0)
 {
  %>
  <script>
   function _kill(connIndex)
   {document.theForm.kill.value=connIndex;
    document.theForm.submit();
    return false;
   }
  </script>
  <table width="100%" class="brick" cellpadding="4" cellspacing="4">
   <thead>
   <tr><td class="brick">#</td><td class="brick">host</td><td class="brick">port</td><td class="brick">db</td><!-- <td class="brick">user</td> --><td class="brick">last address</td><td class="brick">last name</td><td class="brick">lock count</td><td class="brick">options</td><td class="brick">closing</td><td class="brick">ctrl</td></tr> 
   </thead>
   <tbody>
   <%
   for(int index=0;index<ciList.size();index++)
   {ConnectionInfo ci = (ConnectionInfo)ciList.get(index);
    %><%= "<tr><td class=\"brick\">"+index+"</td><td class=\"brick\">"+ci.host+"</td><td class=\"brick\">"+ci.port+"</td><td class=\"brick\">"+ci.db.toString()+"</td><!-- <td class=\"brick\">"+(ci.user.length()>0?ci.user:"&#160;")+"</td> --><td class=\"brick\">"+((int)(((((long)((ci.lastUserAddr>>8)&0xff0000))<<8)&0xff000000)>>24))+"." + ((int)((ci.lastUserAddr&0x00ff0000)>>16))+"." + ((int)((ci.lastUserAddr&0x0000ff00)>>8))+"." + ((int)((ci.lastUserAddr&0x000000ff)))+"</td><td class=\"brick\">"+ci.lastUserName+"</td><td class=\"brick\">"+ci.lockCount+"</td><td class=\"brick\">"+ci.options+"</td><td class=\"brick\">"+ci.invalidate+"</td><td><input value=\"close\" type=\"button\" style=\"width:100%;height:100%;\" class=\"typeButton\" onclick=\"return _kill('"+index+"')\"></td></tr>" %><%
   }
   %>
   </tbody>
  </table>
  
  <%
 }
 else
 {%> empty list <%
 }
 %>
 <input type="hidden"   name="host"      value="<%= rq.keyVal("host") %>">
 <input type="hidden"   name="port"      value="<%= rq.keyVal("port") %>">                               
 <input type="hidden"   name="user"      value="<%= rq.keyVal("user") %>">  
 <input type="hidden"   name="db"        value="<%= rq.keyVal("db")   %>">
 <input type="hidden"   name="skin"      value="<%= rq.readStringParameter("skin","jsp") %>">
 <input type="hidden"   name="menublock" value="<%= rq.readStringParameter("menublock",defaultMenuItem) %>">
 <input type="hidden"   name="kill"      value="">
 </form>
 <%
}
catch(Throwable t) 
{t.printStackTrace();
 %><%= "<br>Sorry, an exception occurred: <br><b>"+t.toString()+"</b><br>" %><%
}
finally 
{if(rq!=null)rq.close(); 
 %> 
 </small>
  </td>
  </tr> 
  </tbody>  
  </table>
 </body> 
 </html> 
 <%
}

%>

