<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

  <!-- console/content.jsp -->

     <table>

      <%@ include file = "connData.jsp" %>

      <!-- database -->
      <tbody style="display:<%= (theMenublock.equals(menuitems[0])?"":"none") %>" id="panel_<%= menuitems[0] %>">
      <tr>
       <td><input class="typeButton" type="submit" style="width:146" name="verbo" value="<%= verbo_riapertura_archivio %>"></td>
       <td><input class="typeButton" type="submit" style="width:146" name="verbo" value="<%= verbo_elenco_chiavi_XML %>"></td>
       <td><input class="typeButton" type="button" style="width:146" name="verbo" value="<%= verbo_XMLCommand %>" onclick="changeLocation(this.value,'<%= menuitems[0] %>')"></td>
       <td><input class="typeButton" type="submit" style="width:146" name="verbo" value="<%= verbo_rigenerazione_titoli %>"></td>
      </tr>
      <tr>
       <td><input class="typeButton" type="submit" style="width:146" name="verbo" value="<%= verbo_compattamento_db %>" onclick="return askForceCompact(this);"><script>function askForceCompact(theInput){theInput.form.forcecompact.value=(confirm('Non forzare il compattamento in presenza di incongruenze')?'0':'1');return true;}</script></td>
       <td><input class="typeButton" type="submit" style="width:146" name="verbo" value="<%= verbo_riorganizzazione_unita_informative %>" onclick="if(this.form.db.value!='')return askApplyDTD(this);" title="<%= relocateTitle %>"><script>function askApplyDTD(theInput){if(theInput.form.db.value==''){return false;}theInput.form.applydtd.value=(confirm("Eseguire la conversione alla DTD piu' recente?")?'1':'0');return true;}</script></td>
       <td><input class="typeButton" type="submit" style="width:146" name="verbo" value="<%= verbo_staticizzazione_db %>"></td>
       <!-- <td><input class="typeButton" type="button" style="width:146" name="verbo" value="<%= verbo_model %>" onclick="changeLocation(this.value,'<%= menuitems[0] %>')"></td> -->
      </tr>
      <tr>
       <td><input class="typeButton" type="submit"   name="verbo"    value="<%= verbo_crea_azzera_archivio %>" title="<%= submitInitTitle %>" style="width:146"></td>
       <td colspan="3"><input type="text" name="dbPath"   value="<%= theDbPath.length()>0?theDbPath:"" %>" title="<%= inputInitTitle %>" size="71" style="width:446"></td>
      </tr>
      <tr>
       <td><input class="typeButton" type="submit"   name="verbo"    value="<%= verbo_catalogazione_XML %>" title="<%= submitCatTitle %>" style="width:146"></td>
       <td colspan="3"><input type="text"     name="path"     value="<%= thePath.length()>0?thePath:"" %>" title="<%= inputCatTitle %>" size="71" style="width:446"></td>
      </tr>
      <tr>
       <td></td>
       <td style="font-size:80%" colspan="3" valign="top">
        <input style="width:1em;background-color:white" type="checkbox" name="cattitle" checked="checked" value="1" title="<%= checkCatTitleTitle %>"    > make cache &#160; &#160;
        <input style="width:1em;background-color:white" type="checkbox" name="cmpindex" value="1" title="<%= checkCatCmpIndexTitle %>" > compact index &#160; &#160;
        <div style="display:none"><input style="width:1em;background-color:white" type="checkbox" name="owner"    value="1" checked="checked" title="<%= checkCatOwnerTitle %>"    > set ownership</div>
        <input type="hidden" name="reindexwcmp" value=""><input type="hidden" name="applydtd" value=""><input type="hidden" name="forcecompact" value="">
       </td>
      </tr>
      </tbody>

      <!-- record -->

      <tbody style="display:<%= (theMenublock.equals(menuitems[1])?"":"none") %>" id="panel_<%= menuitems[1] %>">
      <tr>
       <td><input class="typeButton" type="button" style="width:146" name="verbo" value="<%= verbo_viewer %>" onclick="changeLocation(this.value,'<%= menuitems[1] %>')"></td>
       <td><input class="typeButton" type="button" style="width:146" name="verbo" value="<%= verbo_doc %>" onclick="changeLocation(this.value,'<%= menuitems[1] %>')"></td>
       <td><input class="typeButton" type="button" style="width:146" name="verbo" value="<%= verbo_elimina_doc %>" onclick="changeLocation(this.value,'<%= menuitems[1] %>')" title="record deletion"></td>
       <!-- Federico 05/02/09: integrato jsp per rimozione di piu' documenti nei tools [RW 0056678] -->
       <td><input class="typeButton" type="button" style="width:146" name="verbo" value="<%= verbo_elimina_doc_multi %>" onclick="changeLocation(this.value,'<%= menuitems[1] %>')" title="records deletion"></td>
       <td>&#160;</td>
      </tr>
      <tr>
       <td><input class="typeButton" type="button" style="width:146" name="verbo" value="<%= verbo_hier_browser %>" onclick="changeLocation(this.value,'<%= menuitems[1] %>')"></td>
       <td><input class="typeButton" type="button" style="width:146" name="verbo" value="<%= verbo_hier_root %>" onclick="changeLocation(this.value,'<%= menuitems[1] %>')"></td>
       <td><input class="typeButton" type="button" style="width:146" name="verbo" value="<%= verbo_desCipher %>" onclick="changeLocation(this.value,'<%= menuitems[1] %>')"></td>
       <td><input class="typeButton" type="button" style="width:146" name="verbo" value="<%= verbo_docImport %>" onclick="changeLocation(this.value,'<%= menuitems[1] %>')"></td>
      </tr>
      <tr>
          <td colspan="4">&#160;</td>
      </tr>
      <tr>
       <td><input class="typeButton" type="submit" style="width:146" name="verbo" value="<%= verbo_calcola_impronta %>"></td>
       <td colspan="3"><input class="inputLabel" id="hash_query" type="text" name="hash_query" value=""><label for="hash_query">query phrase</label></td>
      </tr>
      <!--
        Federico 10/07/08: introdotto recupero delle informazioni sugli allegati testuali prodotti dal File Conversion Service
        nell'estrazione del testo [RW 0053061]
      -->
      <tr>
          <td colspan="4">&#160;</td>
      </tr>
      <tr>
       <td><input class="typeButton" type="submit" style="width:146" name="verbo" value="<%= verbo_fcs_txt_info %>"></td>
       <td colspan="3"><input class="inputLabel" id="fcstxt_query" type="text" name="fcstxt_query" value=""><label for="fcstxt_query">query phrase</label></td>
      </tr>
      </tbody>

      <!-- index -->

      <tbody style="display:<%= (theMenublock.equals(menuitems[2])?"":"none") %>" id="panel_<%= menuitems[2] %>">
      <tr>
       <td><input class="typeButton" type="submit" style="width:146" name="verbo" value="<%= verbo_indicizzazione %>"></td>
       <td><input class="typeButton" type="submit" style="width:146" name="verbo" value="<%= verbo_rigenerazione_indici %>" title="Index erase and rebuild" onclick="return askCompact(this);"></td>
       <td><input class="typeButton" type="submit" style="width:146" name="verbo" value="<%= verbo_compattamento_indici %>"><script>function askCompact(theInput){theInput.form.reindexwcmp.value=(confirm('Pack indexes after index rebuild?')?'1':'0');return true;}</script></td>
       <td><input class="typeButton" type="submit" style="width:146" name="verbo" value="<%= verbo_checkvoc %>"></td>
      </tr>
      <tr>
       <td><input class="typeButton" type="button" style="width:146" name="verbo" value="<%= verbo_keylist %>" onclick="changeLocation(this.value,'<%= menuitems[2] %>')"></td>
       <td><input class="typeButton" type="button" style="width:146" name="verbo" value="<%= verbo_elimina_chiave %>" onclick="changeLocation(this.value,'<%= menuitems[2] %>')"></td>
       <td><input class="typeButton" type="button" style="width:146" name="verbo" value="<%= verbo_confronta_chiavi %>" onclick="changeLocation(this.value,'<%= menuitems[2] %>')"></td>
       <td></td>
      </tr>
      </tbody>

      <!-- thesaurus -->

      <tbody style="display:<%= (theMenublock.equals(menuitems[3])?"":"none") %>" id="panel_<%= menuitems[3] %>">
      <tr>
       <td><input class="typeButton" type="button" style="width:146" name="verbo" value="<%= verbo_thimport %>" onclick="changeLocation(this.value,'<%= menuitems[3] %>')"></td>
       <td><input class="typeButton" type="button" style="width:146" name="verbo" value="<%= verbo_thexport %>" onclick="changeLocation(this.value,'<%= menuitems[3] %>')"></td>
       <td><input class="typeButton" type="button" style="width:146" name="verbo" value="<%= verbo_thsex %>" onclick="changeLocation(this.value,'<%= menuitems[3] %>')"></td>
       <td></td>
      </tr>
      </tbody>

      <!-- connection -->

      <tbody style="display:<%= (theMenublock.equals(menuitems[4])?"":"none") %>" id="panel_<%= menuitems[4] %>">
      <tr>
       <td><input class="typeButton" type="button" style="width:146" name="verbo" value="<%= verbo_watch %>" onclick="changeLocation(this.value,'<%= menuitems[4] %>')"></td>
       <td><input class="typeButton" type="button" style="width:146" name="verbo" value="<%= verbo_connessioni %>" onclick="changeLocation(this.value,'<%= menuitems[4] %>')" title="riepilogo dati connessioni"></td>
       <td><input class="typeButton" type="button" style="width:146" name="verbo" value="<%= verbo_server_info %>" onclick="changeLocation(this.value,'<%= menuitems[4] %>')"></td>
       <td><input class="typeButton" type="button" style="width:146" name="verbo" value="<%= verbo_headers %>" onclick="changeLocation(this.value,'<%= menuitems[4] %>')"></td>
      </tr>
      <tr>
       <td><input class="typeButton" type="button" style="width:146" name="verbo" value="<%= verbo_getmail %>" onclick="changeLocation(this.value,'<%= menuitems[4] %>')"></td>
       <td><input class="typeButton" type="button" style="width:146" name="verbo" value="<%= verbo_sendmail %>" onclick="changeLocation(this.value,'<%= menuitems[4] %>')"></td>
       <td><input class="typeButton" type="button" style="width:146" name="verbo" value="<%= verbo_properties %>" onclick="changeLocation(this.value,'<%= menuitems[4] %>')"></td>
       <td></td>
      </tr>
      </tbody>

     </table>

