<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<%@ page import = "java.sql.*" %>
<%@ page import = "java.util.*" %>
<%@ include file = "resource.jsp" %>
<% 
 final String pageTitle = "doc";
%>
<html>
<head>
 <%@ include file = "head.jsp" %>
</head>
<body> 
  <table class="pageframe" style="width:100%;height:100%" cellpadding="8" cellspacing="10">
  <tbody>
  <tr class="pageframe" height="2%">
   <td class="pageframe" height="2%"><%@ include file = "top.jsp" %></td>
  </tr>   
  <tr class="pageframe" height="100%">
  <td class="pageframe" valign="top">
<%
it.highwaytech.broker.Broker broker = null;
int connection=-1;
it.highwaytech.apps.JRequest rq = null;

try
{rq=new it.highwaytech.apps.JRequest(request);
 String theDb       = rq.keyVal("db");
 String theHost     = rq.keyVal("host");
 String thePort     = rq.keyVal("port");
 String theUser     = rq.keyVal("user");
 String thePassword = rq.keyVal("pwd");
 String thePne      = rq.keyVal("pne");
 String thePnce     = rq.keyVal("pnce");
 String theContent  = rq.keyVal("content");
 String theFile     = rq.keyVal("file");
 String theDoc      = rq.keyVal("doc");
 String theAction   = rq.keyVal("xAction");
 String theLock     = rq.keyVal("lock");
 byte[] theData     = rq.keyFile("file");
 String theSkin     = rq.readStringParameter("skin","jsp");
 boolean writeForm=true;
 if(theAction.length()>0&&theDb.length()>0)
 {broker=new it.highwaytech.broker.Broker();
  int iPort=(thePort.length()>0)?Integer.parseInt(thePort):-1;
  connection=broker.acquireConnection(theHost,iPort,theDb,"","",-1);
  if(connection>=0&&broker.Connect(connection,theHost,iPort,theDb,-1,theUser,thePassword))
  {if(theAction.compareTo("save")==0)
   {if(theContent.length()>0||theData!=null)
    {if(theContent.length()>0)
     {it.highwaytech.broker.XMLCommand theCommand=new it.highwaytech.broker.XMLCommand(3,4,theDoc.length()>0?Integer.parseInt(theDoc):0,theContent,thePne,thePnce,theLock.length()>0?theLock:null);
      %><%= "<pre><b>"+it.highwaytech.util.Text.tohtml(theCommand.toString())+"</b><br></pre>" %><%
      String result=broker.XMLCommand(connection,theDb,theCommand.toString());
      %><%= "<pre><b>"+it.highwaytech.util.Text.tohtml(result)+"</b></pre>" %><%
     }
     if(theData!=null)
     {it.highwaytech.broker.XMLCommand theCommand=new it.highwaytech.broker.XMLCommand(3,4,0,new String(theData),thePne,thePnce);
      String result=broker.XMLCommand(connection,theDb,theCommand.toString());
      %><%= ""+it.highwaytech.util.Text.tohtml(new String(theData)) %><%
      %><%= "<b>"+it.highwaytech.util.Text.tohtml(result)+"</b>" %><%
     }
     broker.updateDbInfo(connection,theDb);
     writeForm=false;
    }
    else{%><b>No data!<b><%;}
   }
   else if(theAction.compareTo("load")==0)
   {if(theDoc.length()>0)
    {it.highwaytech.db.Doc dbDoc=broker.getDoc(connection,theDb,Integer.parseInt(theDoc),0);
     StringBuffer xmlData=dbDoc.fields("XML").getBuffer();
     String head="<?x>",tail="<?/x>";
     int start,stop;
     if((start=it.highwaytech.util.Text.indexOf(xmlData,head))>=0&&(stop=it.highwaytech.util.Text.lastIndexOf(xmlData,tail))>start)
     {theContent=xmlData.substring(start+head.length(),stop);
      if(start!=0||stop!=xmlData.length()-tail.length())
      {%><%= "Found extra content '"+xmlData.substring(0,start+head.length())+" ... "+xmlData.substring(stop)+"'" %><%;}
     }
     else{%><%= "No XML in \"" + xmlData.toString() + "\"" %><%;}
    }
    else{%><b>doc number needed<b><%;}
   }
   else if(theAction.compareTo("&lock")==0)
   {if(theDoc.length()>0)
    {it.highwaytech.broker.XMLCommand theCommand=new it.highwaytech.broker.XMLCommand(2,1,Integer.parseInt(theDoc));
     %><%= it.highwaytech.util.Text.tohtml(theCommand.toString()) %><%;
     String xresponse=broker.XMLCommand(connection,theDb,theCommand.toString());
     theLock=theCommand.getLockCode(xresponse);
     theContent=xresponse.substring(theCommand.getBstContentStartOffset(xresponse),theCommand.getBstContentStopOffset(xresponse));
    }
    else{%><b>Enter doc number before hitting that button!<b><%;}
   }
   else{%><b>Unknown action!<b><%;}
  }
  else{%><b>Cannot connect!<b><%;}
 }
 if(writeForm)
 {%>
   <form name="theForm" method="post" enctype="multipart/form-data" action="<%= rq.hwScript %>">
   <table>
   <%@ include file = "console/connData.jsp" %>  
   <tbody>
   <tr>
    <td><input type="text"     name="doc"     value="<%= theDoc %>"></td>
    <td><input class="typeButton" type="submit"   name="xAction" value="load"></td>                                          
    <td><input class="typeButton" type="submit"   name="xAction" value="&lock"></td>
    <td> by #</td>
   </tr>
   <tr>
    <td><input type="text"     name="pne"     value="<%= thePne %>"></td>
    <td>primary node</td>
    <td><input type="text"     name="pnce"    value="<%= thePnce %>"></td>
    <td>primary node container</td>
   </tr>
   <tr>
    <td colspan="4">
     <textarea style="width:100%" rows="12" name="content"><%= theContent %></textarea>
    </td>
   </tr>
   <tr>
    <td colspan="4"><input type="file"     name="file"    value="<%= theFile %>" size="71" style="width:446"></td>
   </tr>
   <tr><td colspan="4"></td></tr>
   <tr>
    <td><input class="typeButton" type="submit" name="xAction" value="save"></td>
    <td colspan="3"></td>
   </tr> 
   </table>     
   <input type="hidden" name="lock" value="<%= theLock %>">
   </form>
  <%
 }
}catch(Throwable t)
{t.printStackTrace();
 %><%= "<br>Sorry, an exception occurred: <br><b>"+t.toString()+"</b><br>" %><%
}finally
{if(broker!=null&&connection>=0)broker.releaseConnection(connection);
 if(rq!=null)rq.close(); 
 %> 
  </td>
  </tr> 
  </tbody>  
  </table>
 </body> 
 </html> 
 <%
}

%>

