<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<%@ page import = "java.sql.*" %>
<%@ page import = "java.util.*" %>
<%@ include file = "resource.jsp" %>
<% 
 final String pageTitle = "hier browser";
%>
<html>
<head>
 <%@ include file = "head.jsp" %>
</head>
<body> 
  <table class="pageframe" style="width:100%;height:100%" cellpadding="8" cellspacing="10">
  <tbody>
  <tr class="pageframe" height="2%">
   <td class="pageframe" height="2%"><%@ include file = "top.jsp" %></td>
  </tr>   
  <tr class="pageframe" height="100%">
  <td class="pageframe" valign="top">
    
<%
it.highwaytech.broker.Broker broker = null;
int conn=-1;
it.highwaytech.apps.JRequest rq = null;

try 
{rq=new it.highwaytech.apps.JRequest(request);
 String theDb      =rq.keyVal("db");
 String theHost    =rq.keyVal("host");
 String thePort    =rq.keyVal("port");
 String theUser    =rq.keyVal("user");
 String thePassword=rq.keyVal("pwd");
 int    docStart   =rq.readIntParameter("docStart",0);
 int    docToggle  =rq.readIntParameter("docToggle",0);
 int    docCount   =rq.readIntParameter("docCount",4096);
 String hierStatus =rq.readStringParameter("hierStatus","2,0,0");
 boolean backward  =rq.readBooleanParameter("backward",false);
 boolean isStart   =rq.readBooleanParameter("start",false);

 if(!isStart&& 
    rq.numTuples>0&&
    theDb!=null&&theDb.length()>0)
 {broker = new it.highwaytech.broker.Broker();
  int iPort = (thePort!=null && thePort.length()>0)?Integer.parseInt(thePort):-1;
  conn = broker.acquireConnection(theHost,iPort,theDb,"","",-1);
  if (conn>=0 && broker.Connect(conn,theHost,iPort,theDb,-1,theUser,thePassword)) {

   java.util.Vector result = null;
   it.highwaytech.broker.BrowseExtras bExtras=new it.highwaytech.broker.BrowseExtras(hierStatus,docToggle);

   result=broker.hierList(conn,theDb,docStart,
                          backward?it.highwaytech.broker.ServerCommand.browse_MOVEUP:it.highwaytech.broker.ServerCommand.browse_MOVEDOWN,
                          docCount,bExtras);
   hierStatus=bExtras.readStatus();

   boolean upEnabled=false, downEnabled=false;
   if(result!=null)
   {upEnabled  =!(((it.highwaytech.db.HierTitle)(result.firstElement())).isFirst());
    downEnabled=!(((it.highwaytech.db.HierTitle)(result.lastElement() )).isLast());
   }
   %><small><form method="post" name="seek" action="#current"><%
   %><table width=100%><tr><td nowrap><% ////// barra dei link
   %><%= "<a href=\"javascript:void(0);\" onclick=\"document.seek.start.value='1';document.seek.submit();return false;\"><big><b>browse</b></big></a></td><td nowrap align=right><i><small>  " %><%
   if (result!=null&&upEnabled)  {%><%= "<a href=\"javascript:void(0);\" onclick=\"document.seek.docStart.value='"+((it.highwaytech.db.HierTitle)(result.firstElement())).docNumber()+"';document.seek.backward.value='1';document.seek.submit();return false;\">Previous Page</a> | " %><%;} else {%><%= "Previous Page | " %><%;}
   if (result!=null&&downEnabled){%><%= "<a href=\"javascript:void(0);\" onclick=\"document.seek.docStart.value='"+((it.highwaytech.db.HierTitle)(result.lastElement())).docNumber()+"';document.seek.backward.value='' ;document.seek.submit();return false;\">Next Page</a>" %><%;} else {%><%= "Next Page | " %><%;}
   %></td></tr></table><hr><% 
   %><input type="hidden" name="skin"       value="<%= rq.readStringParameter("skin","jsp") %>"><%
   %><input type="hidden" name="host"       value="<%= theHost %>"><%
   %><input type="hidden" name="port"       value="<%= thePort %>"><%
   %><input type="hidden" name="user"       value="<%= theUser %>"><%
   %><input type="hidden" name="pwd"        value="<%= thePassword %>"><%
   %><input type="hidden" name="db"         value="<%= theDb   %>"><%
   %><input type="hidden" name="docStart"   value=""><%
   %><input type="hidden" name="docToggle"  value=""><%
   %><input type="hidden" name="backward"   value=""><%
   %><input type="hidden" name="hierStatus" value="<%= hierStatus %>"><%
   %><input type="hidden" name="start"      value=""><%
   %><input type="hidden" name="docCount"   value="<%= Integer.toString(docCount) %>"><%
   %></form></small><%

   if(result!=null)
   {if(docToggle==0){%><a name="current"></a><%}
    %><table width="90%"><%
    for(int index=0; index<result.size(); index++)
    {it.highwaytech.db.HierTitle theTitle=((it.highwaytech.db.HierTitle)(result.get(index)));
     %><tr><td nowrap title="<%= it.highwaytech.util.Text.tohtml(theTitle.getHier(theDb,broker.getServerConnection(conn),"&#10;")) %>"><%
     if(docToggle!=0&&theTitle.docNumber()==docToggle){%><a name="current"></a><%}
     %><%= "<span id=\""+theTitle.docNumber()+"\"/>" %><%
     for(int j=1;j<theTitle.depth();j++){%><font face="courier">&nbsp;&nbsp;</font><%}
     if(theTitle.hasSons())
     {%><%= "<a href=\"javascript:void(0);\" onclick=\"document.seek.docToggle.value='"+theTitle.docNumber()+"';document.seek.docStart.value='"+((it.highwaytech.db.HierTitle)(result.firstElement())).docNumber()+"';document.seek.backward.value='';document.seek.submit();return false;\">" %><%
      %><font face="courier"><%
      if(theTitle.isOpened()){%>-<%}else{%>+<%}
      %></font><%
      %></a><%
     }
     else{%><font face="courier">&#183;</font><%}
     %><font face="courier">&nbsp;</font><%= it.highwaytech.util.Text.tohtml(theTitle.getTitle()) %><%
     %></td></tr><%
    }
    %></table><%
   }
  }
  else {%><b>Cannot connect!<b><%;}
 }
 else
 {%>
   <form name="theForm" method="post" action="<%= rq.hwScript %>">
   <table>
   <%@ include file = "console/connData.jsp" %>  
   <tbody>
   <tr>
    <td><input type="text" name="docStart" value="<%= Integer.toString(docStart) %>"></td>
    <td>doc Number</td>
    <td><input type="text" name="docCount" value="<%= Integer.toString(docCount) %>"></td>
    <td># of titles</td>
   </tr>
   <tr><td colspan="4"></td></tr>
   <tr>
    <td><input class="typeButton" type="submit" value="submit"></td>
    <td colspan="3"></td>
   </tr> 
   </table>     
   </form>
  <%
 }
}catch(Throwable t) {
 t.printStackTrace();
 %><%= "<br>Sorry, an exception occurred: <br><b>"+t.toString()+"</b><br>" %><%
}finally {
 if(broker!=null&&conn>=0)broker.releaseConnection(conn);
 if(rq!=null)rq.close(); 
 %> 

  </td>
  </tr> 
  </tbody>  
  </table>
 </font> 
 </body> 
 </html> 
 <%
}

%>

