/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

 /* jsp.js */

 var menuvalues = ["database","record","index","thesaurus","connection"];
 function getLocation(verb,menuvalue)
 {var result='';
  var prefix='';
  if(window.location.pathname.indexOf('application/generic/')>0)prefix='../../../engine/';
  if(window.location.pathname.indexOf('mail/')>0)prefix='../';
  // see also: console.jsp
  //                    0         1        2         3           4
  if(                verb=='tools'||verb=='console'         )result=prefix+'console.jsp';
  else if(menuvalue==menuvalues[0]&&verb=='model'           )result=prefix+'model.jsp';
  else if(menuvalue==menuvalues[0]&&verb=='xml command'     )result=prefix+'XMLCommand.jsp';
  else if(menuvalue==menuvalues[1]&&verb=='search and view' )result='../application/generic/engine/genericadm.jsp';
  else if(menuvalue==menuvalues[1]&&verb=='modify'          )result=prefix+'doc.jsp';
  else if(menuvalue==menuvalues[1]&&verb=='delete'          )result=prefix+'removeDoc.jsp';
  // Federico 05/02/09: integrato jsp per rimozione di piu' documenti nei tools [RW 0056678]
  else if(menuvalue==menuvalues[1]&&verb=='multiple delete' )result=prefix+'removeMultipleDoc.jsp';
  else if(menuvalue==menuvalues[1]&&verb=='hier browser'    )result=prefix+'hierBrowser.jsp';
  else if(menuvalue==menuvalues[1]&&verb=='hier root'       )result=prefix+'hierRoot.jsp';
  else if(menuvalue==menuvalues[1]&&verb=='des cipher'      )result=prefix+'desCipher.jsp';
  else if(menuvalue==menuvalues[1]&&verb=='import'          )result=prefix+'import.jsp';
  else if(menuvalue==menuvalues[2]&&verb=='delete'          )result=prefix+'idxdelete.jsp';
  else if(menuvalue==menuvalues[2]&&verb=='compare'         )result=prefix+'keyCompare.jsp';
  else if(menuvalue==menuvalues[2]&&verb=='list'            )result=prefix+'keyList.jsp';
  else if(menuvalue==menuvalues[3]&&verb=='import'          )result=prefix+'th_imp.jsp';
  else if(menuvalue==menuvalues[3]&&verb=='export'          )result=prefix+'th_exp.jsp';
  else if(menuvalue==menuvalues[3]&&verb=='list'            )result=prefix+'thsex.jsp';
  else if(menuvalue==menuvalues[4]&&verb=='watch'           )result=prefix+'watch.jsp';
  else if(menuvalue==menuvalues[4]&&verb=='list'            )result=prefix+'connectionInfo.jsp';
  else if(menuvalue==menuvalues[4]&&verb=='server info'     )result=prefix+'getInfo.jsp';
  else if(menuvalue==menuvalues[4]&&verb=='headers'         )result=prefix+'headers.jsp';
  else if(menuvalue==menuvalues[4]&&verb=='properties'      )result=prefix+'properties.jsp';
  else if(menuvalue==menuvalues[4]&&verb=='get mail'        )result=prefix+'mail/getMail.jsp';
  else if(menuvalue==menuvalues[4]&&verb=='send mail'       )result=prefix+'mail/sendMail.jsp';
  else if(verb=='')result='';
  if(result!='')
  {result+='?';
   if(typeof(document.theForm)!='undefined')
   {if(typeof(document.theForm.skin)!='undefined')result+='skin='+document.theForm.skin.value+'&';
    if(typeof(document.theForm.menublock)!='undefined')result+='menublock='+document.theForm.menublock.value+'&';
   }
  }
  return result;
 }
 function changeLocation(verb,menuvalue)
 {/* cambiato in post per non trasmettere la password su riga comando
  var theLocation=getLocation(verb)+'?';
  for(var index=0;index<document.theForm.elements.length;index++)
   if(document.theForm.elements[index].type=='text'||document.theForm.elements[index].type=='hidden')
    theLocation+=escape(document.theForm.elements[index].name)+'='+escape(document.theForm.elements[index].value)+'&';
  window.location=theLocation;
  */
  if(typeof(document.theForm)!='undefined')
  {var oldAction=document.theForm.action;
   document.theForm.action=getLocation(verb,menuvalue);
   document.theForm.submit();
   document.theForm.action=oldAction;
  }
  else window.location=getLocation(verb,menuvalue);
  return false;
 }
 /*
  * abilta / disabilita dopo la contestualizzazione
  */
 function checkInputNodeList(nodes,enable)
 {for(var index=0;nodes.length>index;index++)
  {nodes.item(index).disabled=!enable;
   //nodes.item(index).tabIndex=(enable?1:0);
  }
 }
 function checkEnabled(node,enable)
 {checkInputNodeList(node.getElementsByTagName('input'),enable);
 }
 function consoleLoadHandler() // MSIE back
 {var elMenuData=document.getElementById('menublock');
  if(elMenuData!=null)
  {var currentMenuItem=elMenuData.value;
   if(currentMenuItem=='')currentMenuItem='database';
   var elMenuButton=document.getElementById('button_'+currentMenuItem);
   if(elMenuButton!=null)
   {menuselected(elMenuButton,currentMenuItem);
   }
  }
 }
 function menuselected(el,title)
 {
   for(var i=0;menuvalues.length>i;i++)
   {var menuvalue=menuvalues[i];
    var enabled = (title==menuvalue);
    var elem = document.getElementById('panel_'+menuvalue);
    //elem.style.display = (enabled?'':'none');
    elem.style.display = 'none';
    checkEnabled(elem,enabled);
    document.getElementById('button_'+menuvalue).className = (enabled?'typeButtonSelected':'typeButton');
    //document.getElementById('menu_'+menuvalue).className = (enabled?'menuselected':'menunormal');
   }
   document.getElementById('panel_'+title).style.display = '';
   document.theForm.menublock.value = title;
 }
 function checkSubmit(event)
 {var key=document.layers?event.which:event.keyCode;
  if(key==13)
  {var elem=event.target?event.target:event.srcElement;
   if(!elem||elem.nodeName.toUpperCase()=='INPUT')
   {if(elem&&elem.onchange)elem.onchange(elem);
    event.cancelBubble = true;
    event.returnValue = false;
    if(event.stopPropagation)event.stopPropagation();
    if(event.preventDefault)event.preventDefault();
   }
  }
  return key;
 }
