<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<%@ page import = "java.sql.*" %>
<%@ page import = "java.util.*" %>
<%@ include file = "resource.jsp" %>
<% 
 final String pageTitle = "index list";
 it.highwaytech.broker.Broker broker = null;
 int conn=-1;
 it.highwaytech.apps.JRequest rq = null;

try {

 rq = new it.highwaytech.apps.JRequest(request,response);
 String theDb       = rq.keyVal("db");
 String theHost     = rq.keyVal("host");
 String thePort     = rq.keyVal("port");
 String theUser     = rq.keyVal("user");
 String thePassword = rq.keyVal("pwd");
 String theField    = rq.keyVal("field");
 String theTable    = rq.keyVal("tablename");
 String theSkin     = rq.readStringParameter("skin","jsp");

 if (rq.numTuples>0 &&
     theDb!=null && theDb.length()>0 &&
     theField!=null && theField.length()>0) {
  broker = new it.highwaytech.broker.Broker();
  int iPort = (thePort!=null && thePort.length()>0)?Integer.parseInt(thePort):-1;
  conn = broker.acquireConnection(theHost,iPort,theDb,"","",-1);
  if (conn>=0 && broker.Connect(conn,theHost,iPort,theDb,-1,theUser,thePassword)) {
   rq.setContentType("text/plain");
   int keyCounter = 0;
   int keyStep = 100;
   java.util.Vector result = null;
   String theStart = "";
   %><%= "\r\n"+theField+"\r\n\r\n" %><%
   for(;;){
    result = broker.getIdxKeys(conn,theDb,theTable,theField,theStart,"",keyStep,
                               it.highwaytech.broker.ServerCommand.btree_NEXTKEY,
                               it.highwaytech.broker.ServerCommand.btree_FREQUENZE);
    if(result==null)
     break;
    for(int index=keyCounter!=0?1:0;index<result.size();index++)
    {int f;it.highwaytech.db.DbKey theKey=(it.highwaytech.db.DbKey)result.get(index);
     %><%= " "+((f=theKey.getFrequency(theDb,broker.getServerConnection(conn)))<0?0:f)+"\t"+theKey.toString()+"\r\n" %><%
    }

    keyCounter=keyCounter!=0?keyCounter+result.size()-1:result.size();
    if(result.size()<keyStep)
     break;
    theStart=((it.highwaytech.db.DbKey)result.get(result.size()-1)).toString();
   }
   %><%= "\r\nTotal: "+keyCounter+" keys." %><%
  }
  else {%>Cannot connect!<%;}
 }
 else {
  %>
  <html>
  <head>
  <%@ include file = "head.jsp" %>
  </head>
  <body> 
  <table class="pageframe" style="width:100%;height:100%" cellpadding="8" cellspacing="10">
  <tbody>
  <tr class="pageframe" height="2%">
   <td class="pageframe" height="2%"><%@ include file = "top.jsp" %></td>
  </tr>   
  <tr class="pageframe" height="100%">
  <td class="pageframe" valign="top">
  <form name="theForm" method="post" action="<%= rq.hwScript %>">
   <table>
   <%@ include file = "console/connData.jsp" %>  
   <tbody>
   <tr>
   <td><input type="text" name="field" value="<%= theField.length()>0?theField:"" %>"></td>
   <td>field</td>
   <td><input type="text" name="tablename" value="<%= theTable.length()>0?theTable:"tabella" %>"></td>
   <td>table</td>
   </tr>
   <tr><td colspan="4"></td></tr>
   <tr>
    <td><input class="typeButton" type="submit" value="submit"></td>
    <td colspan="3"></td>    
   </tr>
   </tbody>
   </table>    
  </form>
  </td>
  </tr> 
  </tbody>  
  </table>
  </body> 
  </html> 
  <%
 }
}catch(Throwable t) {
 t.printStackTrace();
 %><%= "<br>Sorry, an exception occurred: <br><b>"+t.toString()+"</b><br>" %><%
}finally {
 if(broker!=null&&conn>=0)broker.releaseConnection(conn);
 if(rq!=null)rq.close(); 
}

%>

