<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<%@ include file = "resource.jsp" %>
<% 
 final String pageTitle = "LIB";
 it.highwaytech.broker.Broker broker = null;
 it.highwaytech.apps.JRequest rq = null;
 int conn=-1;
 try 
 {rq = new it.highwaytech.apps.JRequest(request);
  String theSkin  =rq.readStringParameter("skin","jsp");
  String theHost  =rq.keyVal("host");
  String thePort  =rq.keyVal("port");
  String theUser  =rq.readStringParameter("user","");
  String thePassword   =rq.keyVal("pwd");
  String theDb    =rq.keyVal("db");
  String theLib=rq.keyVal("lib");
  String theFunc=rq.keyVal("func");
  String theParams=rq.keyVal("params");
%>
 <html>
 <head>
  <%@ include file = "head.jsp" %>
 </head>
 <body> 
  <table class="pageframe" style="width:100%;height:100%" cellpadding="8" cellspacing="10">
  <tbody>
  <tr class="pageframe" height="2%">
   <td class="pageframe" height="2%"><%@ include file = "top.jsp" %></td>
  </tr>   
  <tr class="pageframe" height="100%">
  <td class="pageframe" valign="top">
 <form method="post" name="theForm" action="<%= rq.hwScript %>">
<%
  broker = new it.highwaytech.broker.Broker();
  if(rq.numTuples>0&&theDb.length()>0&&theLib.length()>0&&theFunc.length()>0)
  {int iPort = (thePort.length()>0)?Integer.parseInt(thePort):-1;
   conn = broker.acquireConnection(theHost,iPort,theDb,"","",-1);
   if(conn>=0 && broker.Connect(conn,theHost,iPort,theDb,-1,theUser,thePassword))
   {java.util.Vector result=broker.lib(conn,theDb,theLib,theFunc,theParams);
    for(int index=0;index<result.size();index++)
    {%><%= "<pre>"+it.highwaytech.util.Text.tohtml((String)result.get(index))+"</pre>" %><%}
   }
   else {%><b>Cannot connect!<b><%;}
  }
  else
  {%>
    <table border="0">
   <%@ include file = "console/connData.jsp" %>  
   <tbody>
    <tr>
     <td>
      <input type="text" name="lib">
     </td>
     <td>library</td>
     <td>
      <input type="text" name="func">
     </td>
     <td>function</td>
    </tr>
    <tr>
     <td colspan="3">
      <input type="text" style="width:100%" name="params">
     </td>
     <td>parameters</td>
    </tr>
    <tr>
     <td colspan="4">
     </td>   
    </tr>
    <tr>
     <td>
      <input class="typeButton" type="submit" name="verbo" value="send" style="width:100%">
     </td>
     <td colspan="3">
     </td>
    </tr>
    </table>
   <%
  }
  %>
  </form>
  <%
 }
 catch(Throwable t) 
 {t.printStackTrace();
  %><%= "<br>Sorry, an exception occurred: <br><b>"+t.toString()+"</b><br>" %><%
 }finally 
 {if(broker!=null&&conn>=0)broker.releaseConnection(conn);
  if(rq!=null)rq.close(); 
%> 
  </td>
  </tr> 
  </tbody>  
  </table>
 </body> 
 </html> 
<%
 }
%>

