<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<%@ page import = "java.sql.*" %>
<%@ page import = "java.util.*" %>

<html>
<head>
<title>reopen</title>
<link rel="stylesheet" href="jsp.css" type="text/css"/>
</head>
<body> 
<h2>reopen</h2>

<%
it.highwaytech.broker.Broker broker = null;
int conn=-1;
it.highwaytech.apps.JRequest rq = null;

try 
{rq=new it.highwaytech.apps.JRequest(request);
 String theList  = rq.keyVal("dbList");
 //String theHost  = rq.readStringParameter("host","");//rq.keyVal("host");
 String theHost  = rq.readStringParameter("host","");
 String thePort  = rq.keyVal("port");
 String theUser  = rq.readStringParameter("user","");
 String thePassword   = rq.keyVal("pwd");
 String theField = rq.keyVal("field");
 String theTable = rq.keyVal("tablename");

 if(rq.numTuples>0/*&&theList.length()>0*/) 
 {broker=new it.highwaytech.broker.Broker();
  int iPort=(thePort.length()>0)?Integer.parseInt(thePort):-1;
  broker.invalidateHost(theHost,iPort); // Fabio 26/12/2003  
  // nb: '<done/>' as arbiter ACK 
  /*
  %><b>done with invalidateHost!</b><done/><br><%
  */
  /*
  java.util.Vector dbList=it.highwaytech.util.Text.split(theList,",");
  conn=broker.acquireConnection(theHost,iPort,"","","",-1);
  if(conn>=0&&broker.Connect(conn,theHost,iPort,null,-1,theUser,thePassword))
  {for(int index=0;index<dbList.size();index++)
   if(((String)dbList.get(index)).length()!=0)
    broker.updateDbInfo(conn,(String)dbList.get(index));
   %><b>done!</b><done/><%
  }
  else {%><b>Cannot connect!<b><%;}
  */
  java.util.Vector dbList=it.highwaytech.util.Text.split(theList,",");
  conn=broker.acquireConnection(theHost,iPort,"","","",-1);
  if(conn>=0&&broker.Connect(conn,theHost,iPort,null,-1,theUser,thePassword))
  {for(int index=0;index<dbList.size();index++)
   {if(((String)dbList.get(index)).length()!=0)
    {try
     {it.highwaytech.apps.Request.invalidateDbSubset((String)dbList.get(index),broker,conn);
     }
     catch(SQLException e){
      e.printStackTrace();
     }
    }
   }
   /*
   %><b>done with invalidateDbSubset!</b><done/><%
   */
   %><b>done!</b><done/><%
  }
  else {%><b>Cannot connect!<b><%;}
 }
 else 
 {
  %>
   <form method="post" action="<%= rq.hwScript %>">
<!--
        <input type="text"     name="host"     value="<%= theHost.length()>0?theHost:"localhost" %>"> host
-->
        <input type="text"     name="host"     value="<%= theHost.length()>0?theHost:"" %>">          host
    <br><input type="text"     name="port"     value="<%= thePort.length()>0?thePort:"" %>">          port
    <br><input type="text"     name="user"     value="<%= theUser.length()>0?theUser:"" %>">   username
    <br><input type="password" name="pwd"      value="<%= thePassword.length()>0?thePassword:"" %>">            password
<!--
    <br><input type="text"     name="dbList"   value="<%= theList.length()>0?theList:"" %>">          db[List (comma separated)]
-->
    <br><br><input type="submit" value="submit">
   </form>
  <%
 }
}
catch(Throwable t) 
{t.printStackTrace();
 %><%= "<br>Sorry, an exception occurred: <br><b>"+t.toString()+"</b><br>" %><%
}
finally 
{if(broker!=null&&conn>=0)broker.releaseConnection(conn);
 if(rq!=null)rq.close(); 
 %> 
 </font> 
 </body> 
 </html> 
 <%
}

%>

