<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<%@ page import = "java.sql.*" %>
<%@ page import = "java.util.*" %>

<html>
<head>
<title>thesaurus</title>
<link rel="stylesheet" href="jsp.css" type="text/css"/>
</head>
<body> 
<h2>thesaurus</h2>
<%
it.highwaytech.broker.Broker broker = null;
int conn=-1;
it.highwaytech.apps.JRequest rq = null;

try {

 rq = new it.highwaytech.apps.JRequest(request);
 String theDb    = rq.keyVal("db");
 String theHost  = rq.keyVal("host");
 String thePort  = rq.keyVal("port");
 String theUser  = rq.keyVal("user");
 String thePassword = rq.keyVal("pwd");
 String theField = rq.keyVal("field");
 String theTable = rq.keyVal("tablename");
 String editMode = rq.keyVal("editMode");
 boolean isEdit  = rq.keyVal("edit").length()>0 && Integer.parseInt(rq.keyVal("edit"))==1?true:false;
 boolean isStart = rq.keyVal("start").length()>0 && Integer.parseInt(rq.keyVal("start"))==1?true:false;

 if (!isStart && rq.numTuples>0 &&
     theDb!=null && theDb.length()>0 &&
     theField!=null && theField.length()>0) {
  broker = new it.highwaytech.broker.Broker();
  int iPort = (thePort!=null && thePort.length()>0)?Integer.parseInt(thePort):-1;
  conn = broker.acquireConnection(theHost,iPort,theDb,"","",-1);
  if (conn>=0 && broker.Connect(conn,theHost,iPort,theDb,-1,theUser,thePassword)) {

   if(editMode.compareTo("insert")==0)
    broker.insertThsKey(conn,theDb,new it.highwaytech.db.ThsKey
                                             (broker.keyString2ThsNumber
                                               (conn,theDb,theTable,theField),
                                              rq.keyVal("et1").getBytes(),
                                              rq.readIntParameter("erl",0),
                                              rq.readIntParameter("edomain",0xff),
                                              rq.keyVal("et2").getBytes()),null);
   else
   if(editMode.compareTo("delete")==0)
    broker.deleteThsKey(conn,theDb,new it.highwaytech.db.ThsKey
                                             (broker.keyString2ThsNumber
                                               (conn,theDb,theTable,theField),
                                              rq.keyVal("et1").getBytes(),
                                              rq.readIntParameter("erl",0),
                                              rq.readIntParameter("edomain",0xff),
                                              rq.keyVal("et2").getBytes()),null);

   int domain = rq.readIntParameter("domain",0xff);
   it.highwaytech.db.ThsKey theKey;
   String t2 = rq.keyVal("t2");
   //int thsMode = 0; 
   int thsMode = it.highwaytech.broker.ServerCommand.btree_FREQUENZE;
   java.util.Vector result = null;
   int keyCount = rq.readIntParameter("keyCount",isEdit?16:20);
   int relNumber = rq.readIntParameter("rl",0);

   result = broker.getThsKeys(conn,theDb,theTable,theField,rq.keyVal("t1"),relNumber,domain,t2,"",keyCount,
                              (rq.keyVal("keylower").length()>0?it.highwaytech.broker.ServerCommand.btree_PREVKEY:it.highwaytech.broker.ServerCommand.btree_NEXTKEY),
                              thsMode);
   boolean upEnabled=false, downEnabled=false;
   if(result!=null){
    upEnabled = (broker.readThsKey(conn,theDb,(it.highwaytech.db.ThsKey)result.get(0),thsMode) &&
                 broker.getNextThsKey(conn,theDb,theTable,theField,null,it.highwaytech.broker.ServerCommand.btree_PREVKEY,thsMode));
    downEnabled = (broker.readThsKey(conn,theDb,(it.highwaytech.db.ThsKey)result.get(result.size()-1),thsMode) &&
                 broker.getNextThsKey(conn,theDb,theTable,theField,null,it.highwaytech.broker.ServerCommand.btree_NEXTKEY,thsMode));
   }

   %><small><form method="post" name="seek"><%
   %><table width=100%><tr><td nowrap><% ////// barra dei link
   %><%= "<a href=\"javascript:void(0);\" onclick=\"document.seek.start.value='1';document.seek.submit();return false;\"><b><big><font color=#ffffff>thesaurus</font></big></b></a></td><td nowrap align=right><i><small>  " %><%
   if (result!=null&&upEnabled)  {theKey=(it.highwaytech.db.ThsKey)result.get(0);              %><%= "<a href=\"javascript:void(0);\" onclick=\"document.seek.t1.value='"+it.highwaytech.util.Text.qString(theKey.getParent())+"';document.seek.rl.value='"+theKey.getRel()+"';document.seek.t2.value='"+it.highwaytech.util.Text.qString(theKey.getChild())+"';document.seek.keylower.value='1';document.seek.submit();return false;\">Previous Page</a> | " %><%;} else {%><%= "Previous Page | " %><%;}
   if (result!=null&&downEnabled){theKey=(it.highwaytech.db.ThsKey)result.get(result.size()-1);%><%= "<a href=\"javascript:void(0);\" onclick=\"document.seek.t1.value='"+it.highwaytech.util.Text.qString(theKey.getParent())+"';document.seek.rl.value='"+theKey.getRel()+"';document.seek.t2.value='"+it.highwaytech.util.Text.qString(theKey.getChild())+"';document.seek.keylower.value='' ;document.seek.submit();return false;\">Next Page</a> | " %><%;} else {%><%= "Next Page | " %><%;}
   %><%= "<a href=\"javascript:void(0);\" onclick=\"if(document.seek.seektext.value=='')return false;document.seek.t1.value=document.seek.seektext.value;document.seek.keylower.value='';document.seek.submit();return false;\">Posiziona</a>" %><%
   %></i></small></td><td nowrap><small><input type="text" name="seektext"></small><%
   %></td></tr></table><hr><% 
   %><input type="hidden" name="host"  value="<%= theHost %>"><%
   %><input type="hidden" name="port"  value="<%= thePort %>"><%
   %><input type="hidden" name="user"  value="<%= theUser %>"><%
   %><input type="hidden" name="pwd"   value="<%= thePassword %>"><%
   %><input type="hidden" name="db"    value="<%= theDb   %>"><%
   %><input type="hidden" name="tablename" value="<%= theTable %>"><%
   %><input type="hidden" name="field" value="<%= theField %>"><%
   %><input type="hidden" name="keylower" value=""><%
   %><input type="hidden" name="t1" value=""><%
   %><input type="hidden" name="rl" value=""><%
   %><input type="hidden" name="t2" value=""><%
   %><input type="hidden" name="start" value=""><%
   %><input type="hidden" name="edit" value="<%= ""+(isEdit?1:0) %>"><%
   %></form></small><%

   if(result!=null){
    %><table width="90%"><%
    for(int index=0; index<result.size(); index++){
     int f;
     theKey = (it.highwaytech.db.ThsKey)result.get(index);
     if(index==0||(((it.highwaytech.db.ThsKey)(result.get(index-1))).getParent().compareTo(theKey.getParent())!=0)){
      %><%= "<tr><td width=90% colspan=2><b>" + theKey.getParent() + "</b></td><td width=10% align=right><small>["+((f=theKey.getParentFrequency(theDb,broker.getServerConnection(conn)))<0?0:f)+"]</small></td></tr>" %><%
     }
     %><%= "<tr><td width=5% align=right><small><i>" + ((index==0||(((it.highwaytech.db.ThsKey)(result.get(index-1))).getParent().compareTo(theKey.getParent())!=0)||(((it.highwaytech.db.ThsKey)(result.get(index-1))).getRel()!=theKey.getRel()))?(""+theKey.getRel()):"") + "</small></i>&nbsp;&nbsp;</td><td width=85% ><a href=\"javascript:void(0);\" onclick=\"document.seek.t1.value=unescape('"+it.highwaytech.util.Text.qString(theKey.getChild())+"');document.seek.keylower.value='';document.seek.submit();return false;\">" + theKey.getChild() + "</a></td><td width=10% align=right><small>["+((f=theKey.getChildFrequency(theDb,broker.getServerConnection(conn)))<0?0:f)+"]</small></td></tr>" %><%
    }
    %></table><%
   }

//(index==0 || (((it.highwaytech.db.ThsKey)(result.get(index-1))).getRel()==theKey.getRel()))

   if (isEdit){
    %><form method="post" name="edit"><%
    %><hr><table><tr><td nowrap><% ////// barra di edit
    %> <input type="text" name="erl" size="2"></td><td nowrap>&nbsp;<i> <% 
    %> <input type="text" name="et1"></td><td nowrap>&nbsp;<i> <% 
    %> <input type="text" name="et2"></td><td nowrap>&nbsp;<i> <% 
    %><%= "<a href=\"javascript:void(0);\" onclick=\"if((document.edit.et1.value!=''||document.edit.et2.value!='')&&document.edit.erl.value!=''){document.edit.editMode.value='insert';document.edit.submit();}return false;\">Inserisci</a> | " %><%
    %><%= "<a href=\"javascript:void(0);\" onclick=\"if((document.edit.et1.value!=''||document.edit.et2.value!='')&&document.edit.erl.value!=''){document.edit.editMode.value='delete';document.edit.submit();}return false;\">Elimina</a> " %><%
    %> </i></td></tr></table><hr> <% 
    %> <input type="hidden" name="host"  value="<%= theHost %>"><%
    %> <input type="hidden" name="port"  value="<%= thePort %>"><%
    %> <input type="hidden" name="user"  value="<%= theUser %>"><%
    %> <input type="hidden" name="pwd"   value="<%= thePassword %>"><%
    %> <input type="hidden" name="db"    value="<%= theDb   %>"><%
    %> <input type="hidden" name="tablename" value="<%= theTable %>"><%
    %> <input type="hidden" name="field" value="<%= theField %>"><%
    %> <input type="hidden" name="keylower" value=""><%
    %> <input type="hidden" name="editMode" value=""><%
    %> <input type="hidden" name="t1" value=""><%
    %> <input type="hidden" name="rl" value=""><%
    %> <input type="hidden" name="t2" value=""><%
    %> <input type="hidden" name="edit" value="<%= ""+(isEdit?1:0) %>"><%
    %> </form> <%
   }
  }
  else {%><b>Cannot connect!<b><%;}
 }
 else {
  %>
   <form method="post" action="<%= rq.hwScript %>">
        <input type="text" name="host"  value="<%= theHost!=null&&theHost.length()>0?theHost:"" %>">   host
    <br><input type="text" name="port"  value="<%= thePort!=null&&thePort.length()>0?thePort:"" %>">            port
    <br><input type="text" name="user"  value="<%= theUser!=null&&theUser.length()>0?theUser:"" %>">     username
    <br><input type="password" name="pwd"  value="<%= thePassword!=null&&thePassword.length()>0?thePassword:"" %>"> password
    <br><input type="text" name="db"    value="<%= theDb!=null&&theDb.length()>0?theDb:"" %>">                  db
    <br><input type="text" name="tablename" value="<%= theTable!=null&&theTable.length()>0?theTable:"tabella" %>"> table
    <br><input type="text" name="field" value="<%= theField!=null&&theField.length()>0?theField:"generico" %>"> field
    <input type="hidden" name="t1" value="">
    <input type="hidden" name="rl" value="">
    <input type="hidden" name="t2" value="">
    <input type="hidden" name="edit" value="<%= ""+(isEdit?1:0) %>">
    <br><br><input type="submit" value="submit">
   </form>
  <%
 }
}catch(Throwable t) {
 t.printStackTrace();
 %><%= "<br>Sorry, an exception occurred: <br><b>"+t.toString()+"</b><br>" %><%
}finally {
 if(broker!=null&&conn>=0)broker.releaseConnection(conn);
 if(rq!=null)rq.close(); 
 %> 
 </font> 
 </body> 
 </html> 
 <%
}

%>

