<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<%@ page import = "java.sql.*" %>
<%@ page import = "java.util.*" %>
<%@ include file = "resource.jsp" %>
<%
 final String pageTitle = "Watching Observer";

it.highwaytech.broker.Broker broker = null;
it.highwaytech.apps.JRequest rq = null;
try 
{rq = new it.highwaytech.apps.JRequest(request);
 String theSkin=rq.readStringParameter("skin","jsp");
 String theDb    =rq.keyVal("db");
 String theHost  =rq.keyVal("host");
 String thePort  =rq.keyVal("port");
%>
 <html>
 <head>
  <%@ include file = "head.jsp" %>
 </head>
 <body> 
  <table class="pageframe" style="width:100%;height:100%" cellpadding="8" cellspacing="10">
  <tbody>
  <tr class="pageframe" height="2%">
   <td class="pageframe" height="2%"><%@ include file = "top.jsp" %></td>
  </tr>   
  <tr class="pageframe" height="100%">
  <td class="pageframe" valign="top">
<%

 broker=new it.highwaytech.broker.Broker();
 int theObserverId;
 String theId = rq.keyVal("id");
 int observerCount=broker.getObserverCount();
 if(observerCount>0&&theId.length()>0/*&&
    (theObserverId=Integer.parseInt(theId))>0&&
    theObserverId<=observerCount*/)
 {theObserverId=Integer.parseInt(theId);
  boolean fullList=!(theObserverId>0&&theObserverId<=observerCount);
  boolean hasRefresh=false;
  for(int observerIndex=(fullList?1:theObserverId);observerIndex<=(fullList?observerCount:theObserverId);observerIndex++)
  {
   %><h3><a href="javascript:void(0)" onmouseover="window.status='aggiorna...';return true" onmouseout="window.status='';return true" onclick="document.watch.submit();return false;"><%= (fullList?"":"watching ")+"observer #"+observerIndex %></a></h3><%
   it.highwaytech.broker.ServerObserver o=broker.getObserver(observerIndex);
   %><%= o.title+"<br>" %><%
   %><%= "<br>Job started at "+(new java.text.SimpleDateFormat("yyyy.MM.dd HH:mm:ss")).format(o.start)+"<br><br>" %><%
   /*if(o.step!=-1){% ><%= "step="+o.step+"<br>" % ><%}*/
   /*
   if(o.stop1!=-1&&o.stop2!=-1){% ><%= ""+o.stop1+"/"+o.stop2+"<br>" % ><%}
   else
   {if(o.stop1!=-1){% ><%= "stop1="+o.stop1+"<br>" % ><%}
    if(o.stop2!=-1){% ><%= "stop2="+o.stop2+"<br>" % ><%}
   }
   if(o.nStat!=-1&&o.nDoc!=-1){% ><%= ""+o.nDoc+"/"+o.nStat+" documenti processati<br>" % ><%}
   else
   {if(o.nStat!=-1){% ><%= "nStat="+o.nStat+"<br>" % ><%}
    if(o.nDoc!=-1){% ><%= "nDoc="+o.nDoc+"<br>" % ><%}
   }
   if(o.nKey!=-1){% ><%= ""+o.nKey+" chiavi processate<br>" % ><%}
   */
   %><%= o.jobStatus %><%
   if(o.stop==null)
   {String progress=o.getProgressString();
    %><%= ""+(progress.length()>0?progress:"in corso...")  %><%
    
    String info = o.getInfo();
    if(info!=null)
    {
      %><%= "<br>"+info  %><%
    }
   }
   if(o.warnings!=null){%><%= ""+o.warnings+"<br>" %><%}
   if(o.exceptions!=null){%><%= ""+o.exceptions+"<br>" %><%}
   if(o.stop==null)hasRefresh=true;
   else{%><%= "<br>End of Job at "+(new java.text.SimpleDateFormat("yyyy.MM.dd HH:mm:ss")).format(o.stop)+"<br><br>" %><%}
  }
  %><form method="post" name="watch" action="<%= rq.hwScript %>"><input type="hidden" name="id" value="<%= theId %>"><input type="hidden" name="skin" value="<%= theSkin %>"></form><%
  if(hasRefresh){%><script>window.setTimeout("document.watch.submit()",10000);</script><%}
 }
 else 
 {
  if(observerCount>0)
  {
   %>
    <form method="post" action="watch.jsp">
     Observer #
     <select name="id">
     <%
      for(int job=1;job<=observerCount;job++)
      {int maxTitleLen=80;
       String title=broker.getObserver(job).title;
       %><option <%= ""+(job==observerCount?"selected":"") %> value="<%= ""+job %>"><%= ""+job+" "+(title.length()>maxTitleLen?(title.substring(0,maxTitleLen)+"..."):title) %></option><%}
     %>
     <%
      if(observerCount>1)
      {%><option value="-1">* All of the above</option><%}
     %>
     </select> 
     &nbsp;<input class="typeButton" type="submit" value="watch...">
     <input type="hidden" name="skin" value="<%= theSkin %>">
    </form>
   <%
  }
  else
  {
   %>
    Job not found.
   <%
  }
 }
 %>
   <form method="post" name="theForm">
    <input type="hidden" name="skin" value="<%= rq.readStringParameter("skin","jsp") %>">
    <input type="hidden" name="menublock" value="<%= rq.readStringParameter("menublock",defaultMenuItem) %>">
    <input type="hidden" name="host"  value="<%= theHost.length()>0?theHost:"" %>">
    <input type="hidden" name="db"  value="<%= theDb %>">
    <input type="hidden" name="port"  value="<%= thePort %>">
   </form>
 <%
}
catch(Throwable t) 
{t.printStackTrace();
 %><%= "<br>Sorry, an exception occurred: <br><b>"+t.toString()+"</b><br>" %><%
}finally 
{if(rq!=null)rq.close(); 
 %> 
  </td>
  </tr> 
  </tbody>  
  </table>
 </body> 
 </html> 
 <%
}

%>

