<?xml version="1.0" encoding="iso-8859-1"?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<!--
	* Created on........: 13/10/2004
	* by................: Federico Grillini
	* organization......: 3D Informatica
	*
	* Questo file contiene un template che consente di mantenere i tag html eventualmente contenuti
	* nel codice html prodotto dall'editor js quando viene salvato come frammento xml nei documenti.
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" 
				xmlns:fo="http://www.w3.org/1999/XSL/Format"
				xmlns:xw="http://www.3di.it/ns/xw-200203121136"
				xmlns:h="http://www.w3.org/HTML/1998/html4"
				exclude-result-prefixes="fo xw h">
	<!--
		* @author Federico Grillini
		*
		* Created on 13/10/2004
		*
		* @version 1.0
		*
		* Questo template consente di mantenere i tag html eventualmente contenuti nel codice html
		* prodotto dall'editor js quando viene salvato come frammento xml nei documenti.
		* Il matching di questo template avviene in fase di highlighting delle parole cercate in una
		* query (trasformazione delle processing instruction di Extraway in tag <span>).
		*
		* ATTENZIONE: Il presente template entra in conflitto con i template contenuti nel file 'xhtml-to-xslfo.xsl'
		*             che consentono di trasformare un documento in pdf con FOP.
		*             Per questa ragione esso deve essere incluso solo in visualizzazione dei documenti nel file
		*             'xspringPresentation/formatter/factory/xspringdoc/document.xsl' (che  quello pi specifico)
		*             e non in 'xspringPresentation/formatter/factory/document.xsl', dato che questo file viene
		*             utilizzato anche in fase di trasformazione in formato pdf.
	-->
	<xsl:template match="br|p|table|td|tr|font|a|div|strong|u|ol|ul|em|span|li|tbody|ins">
		<xsl:copy>
	  		<xsl:copy-of select="@*"/>
	  		<xsl:apply-templates select="*|text()"/>
	   	</xsl:copy>
	</xsl:template>
</xsl:stylesheet>
	