/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/
 /* filelist.js */

 /*
  N.B - Per gestire correttamente il cambio di style degli input corrispondenti all'immagine
  selezionata occorre definire due 'class' chiamate 'input' e 'inputselezionato'
  */

 //nome della finestra statica (vuota) che viene aperta quando c' un popup in modo che venga mantenuto il protocollo
 //corrente (http o https)
 var staticEmptyWindow = "./../formatter/html/templates/static.html";

 //mbussetti, 17/05/2005
 //variabili globali che separano le varie informazioni nei 'value' delle options della tendina dei pdf ottenuti
 //dai tif
 var id_delimiter = "%ID|";
 var href_delimiter = "%HREF|";
 var der_delimiter = "%DER|";

 // funzioni per la pagina di file impliciti

 function listClose()
 {if(getForm("hxpForm").xverb.value.indexOf('child')>=0)
 {if(typeof(opener)!='undefined')
 {if(typeof(opener.theListWindow)!='undefined')
     opener.theListWindow = null;
 opener.focus();
 }
 self.close();
 }
 else
 {getForm("hxpForm").verbo.value='query';
 getForm("hxpForm").xverb.value='';
 getForm("hxpForm").query.value='';
 getForm("hxpForm").submit();
 }
 return false;
 }
 var thePages;
 var theGroups=new Array();//indice della prima pagina
 var totalePagine=0;
 var totaleGruppi=0;
 //indici base zero
 var paginaAttuale=0;//su tutte le pagine e non relativamente al gruppo
 var gruppoAttuale=0;
 function page2URI(thePage)
 {return '/'+thePage.substring(0,1).toLowerCase()+thePage.substring(thePage.indexOf('/'),thePage.indexOf(',')==-1?thePage.length:thePage.indexOf(',')).toUpperCase();
 }
 function onPageInputChange(theInput)
 {var theValue=theInput.value;
 if(theValue<1||theValue>totalePagine)
     theInput.value=''+(paginaAttuale+1);
 else impostaPagina(indicePagina=theValue-1);
 }
 function impostaPagina(indicePagina)
 {//document.IW.SetFile(location.protocol+'//'+location.host+getForm("hxpForm").uri.value+'?host='+getForm("hxpForm").host.value+'&port='+getForm("hxpForm").port.value+'&db='+getForm("hxpForm").db.value+'&verbo=...&page='+thePages[indicePagina]);
     //document.IW.SetFile(location.protocol+'//'+location.host+location.pathname.substring(0,location.pathname.lastIndexOf('/')+1)+'impliedFile.jsp?host='+getForm("hxpForm").host.value+'&port='+getForm("hxpForm").port.value+'&db='+getForm("hxpForm").db.value+'&page='+page2URI(thePages[indicePagina]));
     // 14/06/2005 Gregorio
     try {
         document.IW.SetFile(location.protocol+'//'+location.host+page2URI(thePages[indicePagina]));
     }
     catch(e) {
     }
     if(getForm("theForm") != null && typeof(getForm("theForm").thePage) != 'undefined')
         getForm("theForm").thePage.value=''+(indicePagina+1);
 }
 function pagina2Gruppo(indicePagina)
 {//torna l'indice di gruppo corrispondente alla pagina parametro
     for(var index=0;index<totaleGruppi;index++)
     {if(theGroups[index]==indicePagina)return index;
     if(theGroups[index]>indicePagina)return index-1;
     }
     return(totaleGruppi-1);
 }
 function gruppo2Pagina(indiceGruppo)
 {//torna l'indice di pagina corrispondente al gruppo parametro
     return theGroups[indiceGruppo];
 }
 function primaPagina()
 {if(paginaAttuale>0)
 {paginaAttuale=0;
 gruppoAttuale=0;
 impostaPagina(paginaAttuale);
 }
 return false;
 }
 function gruppoPrecedente()
 {if(gruppoAttuale>0)
     impostaPagina(paginaAttuale=gruppo2Pagina(--gruppoAttuale));
 return false;
 }
 function gruppoSuccessivo()
 {if(totaleGruppi>gruppoAttuale+1)
     impostaPagina(paginaAttuale=gruppo2Pagina(++gruppoAttuale));
 return false;
 }
 function paginaPrecedente()
 {if(paginaAttuale>0)
 {gruppoAttuale=pagina2Gruppo(--paginaAttuale);
 impostaPagina(paginaAttuale);
 }
 return false;
 }
 function paginaSuccessiva()
 {if(totalePagine>paginaAttuale+1)
 {gruppoAttuale=pagina2Gruppo(++paginaAttuale);
 impostaPagina(paginaAttuale);
 }
 return false;
 }
 function ultimaPagina()
 {if(totalePagine>paginaAttuale+1){
     gruppoAttuale=totaleGruppi-1;
     paginaAttuale=totalePagine-1;
     impostaPagina(paginaAttuale);
 }
 return false;
 }

 //solo se usato standalone
 function loadHandler(descr,marcatura)
 {
     if ('undefined' != typeof(marcatura)){
         //alert(marcatura);
     }
     if (getForm("hxpForm").xverb.value == '@download'){
         document.IW.CheckSigningModule(0);
         download4sign();
     }
     else {
         filelistLoadHandler();
     }
 }


 function fixIWSize(offset)
 {
     if (typeof(offset) == 'undefined')
         offset = 4;

     if ( typeof(document.IW) == 'undefined' ) {
         return;
     }

     if ( document.documentElement && document.documentElement.clientHeight )  {
         document.IW.style.height = Math.max(10, document.documentElement.clientHeight - offset);
         if (document.getElementById('iwtab')) {
             document.getElementById('iwtab').height = document.IW.style.height + offset;
         }
     }
     else if (document.all) {
         document.IW.style.height = Math.max(10, document.body.clientHeight - offset);
         if (document.getElementById('iwtab')) {
             var el = document.getElementById('iwtab');
             if ( el != null ) {
                 el.height = document.IW.style.height + offset;
             }
         }
     }

     if ( typeof(window.iwInsDoc_OldOnResize) == 'function' )
         window.iwInsDoc_OldOnResize();
 }

 function iwInsDoc_SetResizeHandle()
 {
     window.iwInsDoc_OldOnResize = window.onresize;
     window.onresize = fixIWSize;
 }

function filelistLoadHandler() {
        var selIndex = "i0";
        if ( typeof(getForm("hxpForm").selectedIndex) != 'undefined' && getForm("hxpForm").selectedIndex.value != '' ) {
                selIndex = getForm("hxpForm").selectedIndex.value;
                if ( selIndex.charAt(0) != '*' ) {
                        selIndex = 'i' + selIndex;
                }
        }
        var iwtab = document.getElementById("iwtab");
        if ( typeof(document.IW) != 'undefined' ) {
                if ( typeof(customIwInsDoc_SetResizeHandle) != 'undefined' ) {
                        customIwInsDoc_SetResizeHandle();
                }
                else {
                        iwInsDoc_SetResizeHandle();
                }
                if ( iwtab != null ) {
                        document.IW.fill();
                }
                setGlobalVars();
                if ( iwtab != null ) {
                        fixIWSize();
                }
                registerIW();
                thePages=getForm("hxpForm").fileList.value.split(' ');
                theGroups[0]=0;
                if(totalePagine=thePages.length) {
                        impostaPagina(paginaAttuale=0);
                        totaleGruppi=1; // at least one
                        for(var index=0;index<totalePagine;index++) {
                                if(thePages[index].charAt(thePages[index].length-1)==',') {
                                        theGroups[totaleGruppi++]=index+1;
                                }
                        }
                }
                // Federico 20/09/05: meglio testare anche la nullit di 'theForm' dato che 'getForm' pu restituire null
                if ( theForm != null && 'undefined' != typeof(theForm) && typeof(theForm.selezionaImmagine) != 'undefined' ) {
                        selectImage(theForm.selezionaImmagine, selIndex);
                }
        }
        var iws = document.getElementsByTagName("object"); //per thumbnail nei titoli
        for ( var i = 0; i < iws.length; i++ ) {
                var elName = iws.item(i).id;
                var index = elName.indexOf(".");
                if ( index != -1 && elName.substring(0, index) == 'IW' ) {
                        selectImage(getForm("theForm")['selezionaImmagine' + elName.substring(index)], selIndex);
                }
        }
}


 function unloadHandler()
 {
     parent.theListWindow=null;
 }


 //input type file attualmente selezionato
 var selectedImage = null;

 //input del titolo corrispondente all'input type file attualmente selezionato
 var selectedImageTitle = null;

 function iw_setFile(fileObject)
 {
     if ( typeof(document.IW) == 'undefined' )
         return;

     var name = fileObject.name;
     var fileObjectTitle;

     if ( name.indexOf('.@title') != -1 ) { //click sul titolo
         name = name.replace(new RegExp('.@title'), '.@name').substring(1);
         fileObjectTitle = fileObject;
         fileObject = getElementByName(name);
     }
     else
     {
         name = "." + name.replace(new RegExp('.@name'), '.@title');
         fileObjectTitle = getElementByName(name);
         if ( fileObjectTitle == null ) {
             name = "*" + name.substring(1);
             fileObjectTitle = getElementByName(name);
         }
     }

     if ( fileObjectTitle.name.indexOf("immagini.xw:file") != -1 )
         setSelectedImage(fileObject, fileObjectTitle);
 }


 function setSelectedImage(fileObject, fileObjectTitle)
 {/*
 var msg = "";
 if ( fileObject == null )
 msg = "null ";
 else
 msg = fileObject.name + " ";
 if ( fileObjectTitle == null )
 msg += " null";
 else
 msg += " " + fileObjectTitle.name;
 alert(msg)*/
     //imposto ex object selezionato al default
     if ( ( selectedImage != null || selectedImageTitle != null ) && fileObjectTitle != null &&
             fileObjectTitle.value.length > 0 ) {
         if ( selectedImageTitle != null )
             selectedImageTitle.className = "input";
         if ( selectedImage != null )
             selectedImage.className = "input";
     }

     //imposto style per object selezionato
     if ( fileObjectTitle != null && fileObjectTitle.value.length > 0 ) {
         selectedImage = fileObject;
         selectedImageTitle = fileObjectTitle;
         fileObjectTitle.className = "inputselezionato";
         if ( fileObject != null )
             fileObject.className = "inputselezionato"
     }

     if ( typeof(document.IW) != 'undefined' )
         if ( fileObject != null && fileObject.value != '' )
             document.IW.setFile(fileObject.value);

     if( fileObject == null ) {
         var id = getElementByName(fileObjectTitle.name.replace(".@title", ".@name")).value;
         id = realEscape(id);
         callSetTifPageButtons = false;
         var url = buildUrlForGet("", false, false, true) + "&verbo=attach&db=" + getForm("hxpForm").db.value + "&id=" + id;
         document.IW.DownloadParam(url, '', document.IW.downloadNone);
     }
 }


 /*
  function updateimage(iw,image)
  {
  //iw.Setfile(image);

   if (image.length) {
   var netaddr = image//getiwfilename(image);
   if (!ImgGestitaDaIW(netaddr))
   iw.Setfile(''); //window.location = netaddr;
   else if (iw.Setfile(netaddr))
   alert(netaddr+':'+iw.buffer + ' (updateimage)');
   }
   else iw.Close();
   self.status = self.defaultStatus;
   }
   */


 function scan(type, obj)
 {
	 if (typeof(setEndorscanString()) != 'undefined')
		 setEndorscanString();
	 
     var scan_const = 0+32;

     if ( type == "quick" )
         scan_const = 12+32;

     if (typeof(obj) != 'undefined')
         globalThisObject = obj;
     else
         globalThisObject = null;

     document.IW.Acquire(scan_const,'temp');
 }

 var globalThisObject = null;

 function DoneWithAcquire(filelist,inptoref,iworigin)
 {
	 if (typeof(resetEndorscanString()) != 'undefined')
		 resetEndorscanString();
	 
     if('undefined' != typeof(inptoref))
     {
         //alert('acquisito !!! '+inptoref);
         //alert('iw origine !!! '+iworigin);
         //alert('filelist.length '+filelist.length);
         //alert ('filelist '+filelist);

         var newfile="";
         //if(inptoref.indexOf("*x_files.")==0)
         //var ritr1=replaceSubstring(inptoref,"*x_files.","");
         //else
         //var ritr1=inptoref.substring(1,inptoref.length);
         var ritr1=inptoref

         //var ritr2=replaceSubstring(inptoref,"@name","@title");
         var ritr2=replaceSubstring(inptoref,"@name","@title");

         for(var k=0;k<getForm("hxpForm").length;k++)

         {if(getForm("hxpForm").elements[k].id==iworigin)
         {//alert ("TROVATO IW ORIGIN");

             // var result= getForm("hxpForm").elements[k].Save();
             //getForm("hxpForm").elements[k].Redraw();
             // alert('Salvataggio '+result);

             newfile=filelist;//getForm("hxpForm").elements[k].GetLastFileName();



             //alert("NOME FILE "+newfile);
             getForm("hxpForm").elements[k].setFile(newfile);

             getForm("hxpForm").elements[k].Redraw();

             if ( typeof(georeferencedImage) != 'undefined' ) {
                 georeferencedImage(getForm("hxpForm").elements[k].id,getForm("hxpForm").elements[k]);

             }
             break;
         }

         }

         for(var k = 0;k < getForm("hxpForm").length; k++) {

             if(getForm("hxpForm").elements[k].name == ritr1) {
                 //alert("TROVATO CAMPO NOME DA AGG "+getForm("hxpForm").elements[k].value);
                 getForm("hxpForm").elements[k].value = newfile;
             }
         }


         for(var k=0;k<getForm("hxpForm").length;k++)

         {if(getForm("hxpForm").elements[k].name==ritr2)
         {
             //alert("TROVATO CAMPO MODIFICA DA AGG "+getForm("hxpForm").elements[k].value);
             getForm("hxpForm").elements[k].value=newfile.substring(newfile.lastIndexOf("\\")+1,newfile.length);

         }

         //alert('file ',filelist);
         }

     }
     else
     {
         var sListaImg = new String(filelist);
         var files = sListaImg.substring(sListaImg.indexOf('"""') + 3).split('"');

         //Prendo riga precedente e guardo se ha pagina spazio allora imposto offset
         var offset = getLastNumPage();
         for ( var i = 0; i < files.length; i++ ) {
             var ip = i + 1 + offset;             
             if (globalThisObject != null)
                 aggiungiIstanzaImmaginePrima(files[i], i==files.length - 1, '', "Pagina " + ip, globalThisObject);
             else
                 aggiungiIstanzaImmagine(files[i], i==files.length - 1, '', "Pagina " + ip);
         }

     }

     if(typeof(customDestination)!='undefined')
     {customDestination("true",ritr1,iworigin);}

     globalThisObject = null;
 }

 function GetImages(buffer, Titolo, Estensioni, thisObject)
 {
     if (document.IW.GetFile(Titolo,Estensioni,2+4)) // selezione multipla e spacchettamento dei TIFF multipagina
         buffer = new String(document.IW.buffer);
     var offset = getLastNumPage();
     //alert(buffer)

     if ( buffer.indexOf('"""') == 0 ) { //un solo file selezionato (normale o TIFF multipagina)
         var files = buffer.substring(3).split('"');
         for ( var i = 0; i < files.length; i++ )
             aggiungiIstanzaImmaginePre(files[i], i==files.length - 1, thisObject);
     }
     else if ( buffer.length > 0 ) {	//piu' file selezionati (normali o tif multipagin)
         var path = buffer.substring(0, buffer.indexOf('""'));
         var files = buffer.substring(buffer.indexOf('""') + 2).split('"');

         for ( var i = 0; i < files.length; i++ ) {
             if ( files[i].indexOf('iw@') != -1 ) aggiungiIstanzaImmaginePre(files[i], i==files.length - 1, thisObject);
             else aggiungiIstanzaImmaginePre(path + "\\" + files[i], i==files.length - 1, thisObject);
         }
     }
     return false;
 }


 function GetFiles(buffer, Titolo, Estensioni, Params, thisObject)
 {
     var bits = 2 + 4; // default  selezione multipla e spacchettamento dei TIFF multipagina
     if ( typeof(Params) != 'undefined' && Params != null) {
         bits = Params;
     }

     if (document.IW.GetFile(Titolo, Estensioni, bits))
         buffer = new String(document.IW.buffer);

     if ( buffer.indexOf('"""') == 0 ) { //un solo file selezionato
         aggiungiIstanzaFile(buffer.substring(3), false, thisObject);
     }
     else if ( buffer.length > 0 ) {
         var path = buffer.substring(0, buffer.indexOf('""'));
         var files = buffer.substring(buffer.indexOf('""') + 2).split('"');

         for ( var i = 0; i < files.length; i++ )
             aggiungiIstanzaFile(path + "\\" + files[i], false, thisObject);
     }
     return false;
 }


// Federico 06/03/09: aggiunto par. 'inputId' per consentire di indicare l'id dell'input da riempire [M 0000174]
function simpleGetFiles(buffer, Titolo, Estensioni, inputId)
 {
     if (document.IW.GetFile(Titolo, Estensioni, 0)) { // selezione singola
         buffer = new String(document.IW.buffer);

         if (inputId == null || typeof(inputId) == 'undefined' || inputId.length == 0) inputId = "fileToLoad.path";

         var el = document.getElementById(inputId);

         if (el != null) el.value = buffer;
         else            alert("Input con id '" + inputId + "' non trovato!");
     }

     return false;
 }


 function aggiungiIstanzaImmagine(value, toSelect, p_prefix, p_title)
 {
     //alert(value + " " +  toSelect + " " + p_prefix + " " + p_title);

     //cambio di nome in caso di tiff multipagina o acquisizione da scanner
     if ( value.indexOf("iw@") != -1 && typeof(p_title) == 'undefined' )
         p_title = value.substring((value.lastIndexOf('@') + 1)).replace("p", "Pagina ").replace(".tif", "");

     var l_prefix = getPrefix(p_prefix);

     var index;
     var name = l_prefix + '[0].' + '@name';
     //var fileObject = getElementByName(name);
     var fileObject = getElementByNameWithRoot(document.getElementById(getInstanceId(l_prefix, 0)), name);

     if ( fileObject == null )
         //fileObject = getElementByName("*" + name);
         fileObject = getElementByNameWithRoot(document.getElementById(getInstanceId(l_prefix, 0)), "*" + name);

     if ( fileObject.value.length == 0 )
         index = 0;
     else {
         addInstance(l_prefix);
         index = getLastInstanceIndex(l_prefix);
     }

     name = l_prefix + '[' + index + '].' + '@name';
     //fileObject = getElementByName(name);
     fileObject = getElementByNameWithRoot(document.getElementById(getInstanceId(l_prefix, index)), name);
     fileObject.value = value;

     var title = '.' + l_prefix + '[' + index + '].' + '@title';
     //var fileObjectTitle = getElementByName(title);
     var fileObjectTitle = getElementByNameWithRoot(document.getElementById(getInstanceId(l_prefix, index)), title);
     if ( fileObjectTitle == null ) {
         title = '*' + l_prefix + '[' + index + '].' + '@title';
         //fileObjectTitle = getElementByName(title);
         fileObjectTitle = getElementByNameWithRoot(document.getElementById(getInstanceId(l_prefix, index)), title);
     }

     if ( typeof(p_title) != 'undefined' )
         fileObjectTitle.value = p_title;
     else
         defaultTitle(fileObject, l_prefix);

     if ( toSelect == true )
         setSelectedImage(fileObject, fileObjectTitle);
 }


 function aggiungiIstanzaFile(value, toSelect, thisObject)
 {
     if (typeof(thisObject) == 'undefined')
         aggiungiIstanzaImmagine(value, toSelect, "FILES");
     else
         aggiungiIstanzaImmaginePrima(value, toSelect, "FILES", null, thisObject);
 }

 function aggiungiIstanzaImmaginePre(value, toSelect, thisObject)
 {
     if (typeof(thisObject) == 'undefined')
         aggiungiIstanzaImmagine(value, toSelect);
     else
         aggiungiIstanzaImmaginePrima(value, toSelect, getPrefix(), null, thisObject);
 }

 var prefix;
 var prefix_files;
 var theForm;

 function setGlobalVars()
 {
     if ( getForm("hxpForm").verbo.value == "docEdit" )
         theForm = getForm("hxpForm");
     else
         theForm = getForm("theForm");

     prefix = "immagini.xw:file";
     prefix_files = "files.xw:file";
 }

 var _senselectEnabled=null;
 function senselectEnabled()
 {if(_senselectEnabled==null){var theSession = new _hxpSession(getForm('hxpForm'));_senselectEnabled=(theSession.getParameter('senselect')=='1');}
  return _senselectEnabled;
 }
 function encryptionEnabled(){return senselectEnabled();}
 // firma digitale se senselect o IW attivi
 function signingEnabled(){return (senselectEnabled() || (typeof(document.IW)!='undefined'&&document.IW.CheckSigningModule(0)!=0));}
 /**
  * evento da checkbox x firma / crittografia file
  * nel caso senselect inibisce le funzionalit fcs
  */
 function fileOptionChanged(o,p) {
     if(!senselectEnabled())return;
     var f=getForm('hxpForm');
     var cx=f['*agent_xml'];
     var cp=f['*agent_pdf'];
     if(cx&&o.checked)cx.checked=false;
     if(cp&&o.checked)cp.checked=false;
     if(cx)cx.disabled=(o.checked||(p&&p.checked));
     if(cp)cp.disabled=(o.checked||(p&&p.checked));
 }
 /**
  * evento da checkbox x firma / crittografia immagine
  * nel caso senselect inibisce le funzionalit fcs
  */
 function imgOptionChanged(o,p) {
     if(!senselectEnabled())return;
     var f=getForm('hxpForm');
     var co=f['*agent_ocr'];
     var cp=f['*iagent_pdf'];
     if(co&&o.checked)co.checked=false;
     if(cp&&o.checked)cp.checked=false;
     if(co)co.disabled=(o.checked||(p&&p.checked));
     if(cp)cp.disabled=(o.checked||(p&&p.checked));
 }
 function signImageEnabled(){return (typeof(getForm("hxpForm").imgFD )!='undefined' && getForm("hxpForm").imgFD.checked );}
 function signFileEnabled() {return (typeof(getForm("hxpForm").fileFD)!='undefined' && getForm("hxpForm").fileFD.checked);}
 function hasUploadData(inputPrefix,instancePrefix)
 {var index = getLastInstanceIndex(instancePrefix);
  for ( var i = 0 ; i <= index ; i++ ) {
   var fileObject = getElementByNameWithRoot(document.getElementById(getInstanceId(instancePrefix, i)), inputPrefix + '[' + i + '].' + '@name');
   if (fileObject!= null && fileObject.value.length > 0) return true;
  }
  return false;
 }
 function hasImageData(){return hasUploadData((typeof(getForm('hxpForm').IW)=='undefined')?'*files.modifyIMG':prefix,(typeof(getForm('hxpForm').IW)=='undefined')?'IMGS':prefix);}
 function hasFileData(){return hasUploadData((typeof(getForm('hxpForm').IW)=='undefined')?'*files.modifyATTACH':prefix_files,(typeof(getForm('hxpForm').IW)=='undefined')?'ATTACH':prefix_files);}
 function hasSignData(){return ((signImageEnabled()&&hasImageData())||(signFileEnabled()&&hasFileData()));}
 function uploadFiles(p_prefix, maxSize)
 {
     var l_prefix = getPrefix(p_prefix);
     var param = "";

     if ( typeof(theForm.IW) == "undefined" )
         return;

     var index = getLastInstanceIndex(l_prefix);
     name = l_prefix + '[' + index + '].' + '@name';

     for ( var i = 0 ; i <= index ; i++ ) {
         name = l_prefix + '[' + i + '].' + '@name';
         //fileObject = getElementByName(name);
         fileObject = getElementByNameWithRoot(document.getElementById(getInstanceId(l_prefix, i)), name);

         var protocol = window.location.protocol;
         var bits = (protocol=='https:')?document.IW.uploadHttps:document.IW.uploadNone;

         if (typeof(maxSize) != 'undefined' && maxSize.length > 0) {
             param = maxSize;
             bits |= document.IW.uploadSizeThreshold;
         }

         //se firma digitale
         var signed = "";
         var tipo = "";
         if (l_prefix == prefix) {//immagini
             if (signImageEnabled()) {
                 if (!senselectEnabled()) {
                     bits |= document.IW.uploadSign;
                     signed = "&signed=true";
                 }
                 else {
                     signed = "&imgFD=imgFD";
                 }
             }
             if (typeof(getForm("hxpForm").imgENC) != 'undefined' && getForm("hxpForm").imgENC.checked) {
                 signed += "&imgENC=imgENC";
             }
             tipo = "&tipo=immagini";
         }
         else if (l_prefix == prefix_files) {//files
             if (signFileEnabled()) {
                 if (!senselectEnabled()) {
                     bits |= document.IW.uploadSign;
                     signed = "&signed=true";
                 }
                 else {
                     signed = "&fileFD=fileFD";
                 }
             }
             if (typeof(getForm("hxpForm").fileENC) != 'undefined' && getForm("hxpForm").fileENC.checked) {
                 signed += "&fileENC=fileENC";
             }
         }

         if ( fileObject!= null && fileObject.value.length > 0 ) {//upload tramite iw di ogni file

             var url = buildUrlForGet("", true, false, true) + "&verbo=Iw_response&xverb=upload" + signed + tipo;

             if (senselectEnabled()) { // aggiunge i dati sui riferimenti
                 var rif='';
                 for (var j=0; j<getForm("hxpForm").length; j++)
                 {var name=getForm("hxpForm").elements[j].name;
                  if(name.indexOf('.@nome_persona')>0 && name.indexOf('*rif_interni.assegnazione')==0 && getForm("hxpForm").elements[j].value!='') {
                   rif+='&';
                   rif+=escape(getForm("hxpForm").elements[j].name);
                   rif+='=';
                   rif+=escape(getForm("hxpForm").elements[j].value);
                  }
                 }
                 url += rif;
             }

             //per thumbnail (solo per upload di immagini)
             if ( typeof(p_prefix) == 'undefined' ) {
                 var thumbName = "." + l_prefix + '[' + i + '].' + 'thumb.@name';
                 var thumbInput = getElementByName(thumbName);
             }
             else
                 thumbInput = null;
             if ( thumbInput != null )
                 handleTumbnail(fileObject.value, thumbInput, host, url, window.location.port);
             //fine thumbnail

             setStatus('upload in corso di ' + fileObject.value);

             var r = document.IW.UploadParam(getHost(),
                     url,
                     window.location.port,
                     'filename',
                     fileObject.value,
                     bits ,  //mode
                     document.IW.zCompressionNone,
                     param);

             setStatus('');

             if ( r == false )
                 return (document.IW.buffer == 'size threshold reached') ? -1 : false;

             //var element = getElementByName("." + l_prefix + '[' + i + '].' + '@name');
             var element = getElementByNameWithRoot(document.getElementById(getInstanceId(l_prefix, i)), "." + l_prefix + '[' + i + '].' + '@name');

             if ( element == null )
                 //element = getElementByName("*" + l_prefix + '[' + i + '].' + '@name');
                 element = getElementByNameWithRoot(document.getElementById(getInstanceId(l_prefix, i)), "*" + l_prefix + '[' + i + '].' + '@name');

             if ( DoneWithUpload(0, 0, 0, element) == false )
                 return false;
         }

     }
     return true;
 }

 function DoneWithUpload(output, param, status, fileObject)
 {
     window.status = '';
     var filehandle = document.IW.buffer;
     if ( filehandle.indexOf("<--remotefile:") == -1 )
         return false;

     var index;
     if (filehandle.indexOf("<--remotefile:WithSize:") != -1) {
         index = filehandle.indexOf("<--remotefile:") + 23;
         var index1 = filehandle.indexOf(";", index);
         var index2 = filehandle.indexOf(";", index1 + 1);
         getForm("hxpForm").filesWithSize.value += filehandle.substring(index1 + 1, index2) + "\n";
         filehandle = myfilehandle = filehandle.substring(index, index1);
     }
     else {
         index = filehandle.indexOf("<--remotefile:") + 14;
         filehandle = filehandle.substring(index, filehandle.indexOf(";", index));myfilehandle=filehandle;//alert(myfilehandle);
     }
     //alert(filehandle);
     if ( filehandle == "UPLOAD_ERROR" )
         return false;

     //alert("fileObject "+fileObject);
     if ('undefined' != typeof(fileObject)) fileObject.value = filehandle;
     return true;
 }


 function getPrefix(p_prefix)
 {
     if ( typeof(p_prefix) == 'undefined' )
         return(prefix);
     else if ( p_prefix == "FILES" )
         return(prefix_files);
     else
         return(prefix);
 }


 function getIW(el)
 {
     var elName = el.name;
     if ( elName.indexOf(".") != -1 )
         iw = document['IW' + elName.substring(elName.indexOf("."))];
     else
         iw = document.IW;
     return iw;
 }


 function getOption(el)
 {
     //var elName = el.name;
     var elName = el.id;


     //  alert("getOption("+el+")");

     // Federico 03/08/05: introdotta funzione per il recupero delle form della pagina
     var form = getForm("theForm");

     if ( elName.indexOf("-") != -1 )
         theOption = form['selezionaImmagine' + elName.substring(elName.indexOf("-"))];
     else
         theOption = form.selezionaImmagine;
     return theOption;
 }

 function selectImage(theOption, pos)
 {
     // alert("theOption.id "+theOption.id);
     var iw = getIW(theOption);
     // alert("iw.id "+iw.id);
     var theOption = getOption(theOption);
     //  alert("theOption.id "+theOption.id);

     var id;

     if ( typeof(pos) == 'undefined' )
         pos = "";


     if ( pos.length > 0 && pos.charAt(0) == 'i' && theOption.length > 0 ) { //selezione tramite indice (onload)
         var n_pos = pos.substring(1);
         id = theOption.options[n_pos].value;
         theOption.selectedIndex = n_pos;
     }
     if ( pos.length > 0 && pos.charAt(0) == '*' && theOption.length > 0 ) { //selezione tramite valore (onload)
         id = pos.substring(1);
         for ( var k = 0; k < theOption.options.length; k++ )
             if ( theOption.options[k].value == id ) {
                 theOption.options[k].selected = true;
                 var n_pos = k;
             }
     }
     else {
         switch (pos) {
         case "" : id = theOption.value; break;
         case "F" : id = theOption.options[0].value; theOption.selectedIndex = 0; break;
         case "L" : var last = theOption.length - 1;
         id = theOption.options[last].value; theOption.selectedIndex = last; break;
         case "P" : var n_pos = theOption.selectedIndex - 1;
         if ( n_pos < 0 ) n_pos = 0;
         id = theOption.options[n_pos].value; theOption.selectedIndex = n_pos; break;
         case "N" : var n_pos = theOption.selectedIndex + 1;
         if ( n_pos > theOption.length -1 ) n_pos = theOption.length - 1;
         id = theOption.options[n_pos].value; theOption.selectedIndex = n_pos; break;
         }
     }

     unescapedId = id;
     id = realEscape(id);

     //asincrono
     callSetTifPageButtons = true;
     if(typeof(iw)!='undefined')
     {
         var url = buildUrlForGet("", false, false, true) + "&verbo=attach&id=" + id;
         iw.DownloadParam(url, '', iw.downloadAsync);
         global_tiff_current_page = 1;
         setTimeout("setTifPageCount('prevTifImg', true)", 1500);
     }
     else
     {
         noIWselectImage(theOption, pos,"");
     }

     //aggiunta di mbussetti del 17/05/2005: se c' la tendina dei pdf ottenuti, cliccando su un tif essa si
     //posiziona sul pdf che lo contiene
     var pdfTent = getElementByName("selezionaPdf","select");
     if (null != pdfTent){
         for (po = 0; po < pdfTent.options.length; po++){
             var currentOption = pdfTent.options[po];
             var currentOptionValue = currentOption.value;
             //alert(currentOptionValue + "-_-_-" + unescapedId);
             var inizioZonaDerivati = currentOptionValue.indexOf(der_delimiter);
             if (der_delimiter != -1){
                 var zonaDerivati = currentOptionValue.substr(der_delimiter + der_delimiter.length);
                 if (zonaDerivati.indexOf(unescapedId + ";") != -1){
                     currentOption.selected = true;
                 }
             }
         }
     }

     //aggiunta di mbussetti del 26/05/2005: vengono nascosti tutti gli eventuali div dei metadati aperti
     var divs = document.getElementsByTagName("div");
     var metaDiv;
     for (d = 0; d < divs.length; d++){
         if (divs[d].getAttribute('id')){
             if (divs[d].getAttribute('id').indexOf('metaView_') == 0){
                 metaDiv = divs[d];
                 var displayStyle = metaDiv.style.display;
                 if (displayStyle == 'block'){
                     metaDiv.style.display = 'none';
                 }
             }
         }
     }

     return false;
 }

 function ctsep(theelem,theact)
 {
     //alert("sono l' asino che vola !!!");
 }

 function cursorOn(theelem)
 {
     var tempc=theelem.parentNode.parentNode.innerHTML;

     tempc=tempc.replace("default","hand");
     tempc=tempc.replace("ctsep","noIWselectImage");

     theelem.parentNode.parentNode.innerHTML=tempc;

 }

 function cursorOff(theelem)
 {

     var tempc=theelem.parentNode.parentNode.innerHTML;

     tempc=tempc.replace("hand","default");
     tempc=tempc.replace("style=\"\"","style=\"CURSOR:default\"");
     tempc=tempc.replace("noIWselectImage","ctsep");

     theelem.parentNode.parentNode.innerHTML=tempc;

 }



 function noIWselectImage(theOption, pos,theelem)
 {
     //  alert("theOption.name "+theOption.name);
     //  alert("theOption.id "+theOption.id);

     //var theimgelemname="noIwImage."+theOption.name.substring(theOption.name.indexOf(".")+1,theOption.name.length);
     //var theimgelemname="noIwImage."+theOption.id.substring(theOption.id.indexOf(".")+1,theOption.id.length);
     var theimgelemname="noIwImage-"+theOption.id.substring(theOption.id.indexOf("-")+1,theOption.id.length);


     var elements = document.getElementsByTagName("img");
     for (var i = 0; i < elements.length; i++ ) {
         if ( elements[i].id == theimgelemname ) {
             var imagetarget=elements[i];break;
         }
     }

     //	var iw = getIW(theOption);
     var swapOption=theOption;
     var theOption = getOption(theOption);

     var id;

     if ( typeof(pos) == 'undefined' )
         pos = "";


     if ( pos.length > 0 && pos.charAt(0) == 'i' && theOption.length > 0 ) { //selezione tramite indice (onload)
         var n_pos = pos.substring(1);
         id = theOption.options[n_pos].value;
         theOption.selectedIndex = n_pos;
     }
     if ( pos.length > 0 && pos.charAt(0) == '*' && theOption.length > 0 ) { //selezione tramite valore (onload)
         id = pos.substring(1);
         for ( var k = 0; k < theOption.options.length; k++ )
             if ( theOption.options[k].value == id ) {
                 theOption.options[k].selected = true;
                 var n_pos = k;
             }
     }
     else {
         switch (pos) {
         case "" : id = theOption.value; break;
         case "F" : id = theOption.options[0].value; theOption.selectedIndex = 0; break;
         case "L" : var last = theOption.length - 1;
         id = theOption.options[last].value; theOption.selectedIndex = last; break;
         case "P" : var n_pos = theOption.selectedIndex - 1;
         if ( n_pos < 0 ) n_pos = 0;
         id = theOption.options[n_pos].value; theOption.selectedIndex = n_pos; break;
         case "N" : var n_pos = theOption.selectedIndex + 1;
         if ( n_pos > theOption.length -1 ) n_pos = theOption.length - 1;
         id = theOption.options[n_pos].value; theOption.selectedIndex = n_pos; break;
         }
     }

     id = realEscape(id);

     //asincrono
     callSetTifPageButtons = true;


     var filename = buildUrlForGet("", false, false, true) + "&verbo=attach&id=" + id;

     imagetarget.src=filename;

     // alert(theOption.selectedIndex+" di "+theOption.length);
     switch (pos) {

     case "N" :


         if(theOption.selectedIndex==theOption.length-1)
         {
             //alert("disabilita tasto avanti");
             var imgsons=swapOption.getElementsByTagName("img");


             if(imgsons.length>0)
             {
                 //alert("disabito immagine avanti");
                 imgsons[0].setAttribute("src",imgsons[0].getAttribute("src").split('_on_').join('_off_'));
                 cursorOff(imgsons[0]);
             }
             else
             {
                 //alert("disabito link avanti");
                 //alert(swapOption.style);

             }
         }
         //riabilita il tasto indietro
         if(theOption.selectedIndex>0)
         {//alert("riabilita il tasto indietro "+swapOption.id.substring(1,swapOption.id.length));
             var eltarget=document.getElementById("P"+swapOption.id.substring(1,swapOption.id.length));
             var imgsons=eltarget.getElementsByTagName("img");
             if(imgsons.length>0)
             {
                 imgsons[0].setAttribute("src",imgsons[0].getAttribute("src").split('_off_').join('_on_'));
                 cursorOn(imgsons[0]);
             }
             else
             {
                 //alert("riabilito link indietro");
                 //alert(swapOption.style);

             }

         }

         break;
     case "P" :
         // alert(theOption.selectedIndex+" di "+theOption.length);
         if(theOption.selectedIndex==0) {
             //alert("pulsante indietro disabilitato");
             var imgsons=swapOption.getElementsByTagName("img");
             if(imgsons.length>0)
             {
                 imgsons[0].setAttribute("src",imgsons[0].getAttribute("src").split('_on_').join('_off_'));
                 cursorOff(imgsons[0]);
             }
             else
             {
                 //alert("disabito link indietro");
                 //alert(swapOption.style);
             }
         }

         if(theOption.selectedIndex>=0)
         {//alert("riabilita il tasto avanti "+swapOption.id.substring(1,swapOption.id.length));
             var eltarget=document.getElementById("N"+swapOption.id.substring(1,swapOption.id.length));
             var imgsons=eltarget.getElementsByTagName("img");
             if(imgsons.length>0)
             {
                 imgsons[0].setAttribute("src",imgsons[0].getAttribute("src").split('_off_').join('_on_'));
                 cursorOn(imgsons[0]);
             }
             else
             {
                 //alert("riabilito link avanti");
                 //alert(swapOption.style);
             }
         }


         break;

     default : //alert("da tendina");
         //alert(swapOption.name.split(".")[[1]]);

         //var elemN=document.getElementById("NnoIwImg"+swapOption.id.split("-")[[1]]);
         //var elemP=document.getElementById("PnoIwImg"+swapOption.id.split("-")[[1]]);
         var elemN=document.getElementById("NnoIwImg"+swapOption.id.substring(swapOption.id.indexOf("-"),swapOption.id.length));
     var elemP=document.getElementById("PnoIwImg"+swapOption.id.substring(swapOption.id.indexOf("-"),swapOption.id.length));

     if(theOption.selectedIndex>0 && theOption.selectedIndex!=theOption.length-1) {
         //alert("entrambi i pulsanti attivi");

         var imgsons=elemN.getElementsByTagName("img");
         if(imgsons.length>0)
         {
             imgsons[0].setAttribute("src",imgsons[0].getAttribute("src").split('_off_').join('_on_'));
             cursorOn(imgsons[0]);
         }
         else
         {
             //alert("riabilito link avanti");
             //alert(swapOption.style);
         }
         imgsons=elemP.getElementsByTagName("img");
         if(imgsons.length>0)
         {
             imgsons[0].setAttribute("src",imgsons[0].getAttribute("src").split('_off_').join('_on_'));
             cursorOn(imgsons[0]);
         }
         else
         {
             //alert("riabilito link avanti");
             //alert(swapOption.style);
         }

     }

     if(theOption.selectedIndex==0)
     {
         //alert("pulsante indietro disabilitato");
         var imgsons=elemP.getElementsByTagName("img");
         if(imgsons.length>0)
         {
             imgsons[0].setAttribute("src",imgsons[0].getAttribute("src").split('_on_').join('_off_'));
             cursorOff(imgsons[0]);
         }
         else
         {
             //alert("disabito link indietro");
             //alert(swapOption.style);
         }
     }

     if(theOption.selectedIndex==theOption.length-1)
     {
         //alert("pulsante avanti disabilitato");
         var imgsons=elemN.getElementsByTagName("img");
         if(imgsons.length>0)
         {
             imgsons[0].setAttribute("src",imgsons[0].getAttribute("src").split('_on_').join('_off_'));
             cursorOff(imgsons[0]);
         }
         else
         {
             //alert("disabito link avanti");
             //alert(swapOption.style);
         }
     }

     if(theOption.selectedIndex!=theOption.length-1)
     {
         //alert("pulsante avanti abilitato");
         var imgsons=elemN.getElementsByTagName("img");
         if(imgsons.length>0)
         {
             imgsons[0].setAttribute("src",imgsons[0].getAttribute("src").split('_off_').join('_on_'));
             cursorOn(imgsons[0]);
         }
         else
         {
             //alert("riabilito link avanti");
             //alert(swapOption.style);
         }
     }

     if(theOption.selectedIndex>0)
     {
         //alert("pulsante indietro abilitato");
         var imgsons=elemP.getElementsByTagName("img");
         if(imgsons.length>0)
         {
             imgsons[0].setAttribute("src",imgsons[0].getAttribute("src").split('_off_').join('_on_'));
             cursorOn(imgsons[0]);
         }
         else
         {
             //alert("riabilito link indietro");
             //alert(swapOption.style);
         }
     }



     break;
     }


     return false;
 }


 function getHost()
 {
     /* DD 19/12/2005 - RW: 0031529
      var host = window.location.host;
      if ( host.indexOf(':') != -1 )
      host = host.substring(0, host.indexOf(':'));
      return host;
      */
     return window.location.hostname;
 }


 function zoom(oggetto, tipo)
 {
     if ( tipo == "OUT" )
         document.IW.Reduce();
     else
         document.IW.Enlarge();
     return false;
 }


 function fill()
 {
     document.IW.Fill();
     return false;
 }


 function fit()
 {
     document.IW.Fit();
     return false;
 }


 function rotate(degree)
 {
     document.IW.Rotate(degree);
     setTifePageButton("nextTifImg", "disable");
     setTifePageButton("prevTifImg", "disable");
     return false;
 }


 function saveAs()
 {
     document.IW.SaveAs();
 }


 function saveMultiAs()
 {
     var result;
     if ( document.IW.GetFile("Salva tutte le immagini",
             "Immagine in formato TIFF (*.tif;*.tiff)|*.tif;*.tiff;|TIFF (*.tif;*.tiff)|*.tif;*.tiff|",
             document.IW.getFileWrite) == 0 )  {
         return;
     }
     theoutfile = document.IW.buffer;

     var id;
     var thecommandstring = "";

     for ( var i = 0; i < theForm.selezionaImmagine.length; i++ ) {
         id = theForm.selezionaImmagine.options[i].value;
         id = realEscape(id);
         var protocol = window.location.protocol;
         url = buildUrlForGet("", false, false, true) + "&verbo=attach&id=" + id;
         callSetTifPageButtons = false;
         document.IW.DownloadParam(url,'multipage',document.IW.downloadNoLoad);
         thecommandstring += document.IW.getLastFilename() + '"';
     }
     thecommandstring = thecommandstring.slice(0, -1);
     result = document.IW.BuildMultiPage(theoutfile,thecommandstring);
     if ( result == 0)
         filelistMSG(fileOK);
     else
         filelistMSG(fileKO);
 }


 function print()
 {
    if ( document.IW.numPages() < 2 ) {
        var theRangeWindow = window.open('../../../formatter/html/templates/rangeWin.html', 'rangeWindow', 'resizable=no,scrollbars=no,width=200,height=80');
        WinWidth = Math.max(0, (screen.availWidth - 200) / 2);
        WinHeight = Math.max(0, (screen.availHeight - 24 - 80) / 2);
        theRangeWindow.moveTo(WinWidth, WinHeight);
        theRangeWindow.focus();
    }
    else rangeExec(null);
 }


 function iwRemoveImmagine(listaDeigliIdGrandi)
 {
     //alert(listaDeigliIdGrandi)
     var listaDeigliIdGrandiArray = listaDeigliIdGrandi.substring(1).split('|');
     var id = listaDeigliIdGrandiArray[theForm.selezionaImmagine.selectedIndex];
     //alert(id)

     //var id = theForm.selezionaImmagine.options[theForm.selezionaImmagine.selectedIndex].value;

     getForm("hxpForm").attach.value = id;
     getForm("hxpForm").verbo.value = "attach_response";

     getForm("hxpForm").xverb.value = "@removeImmagine";

     getForm("hxpForm").submit();
     return false;
 }


 function rangeWinLoaded(p_theForm)
 {
     p_theForm.A.value = theForm.selezionaImmagine.length;
 }


 function rangeExec(p_theForm)
 {
     var da = ( (null != p_theForm) ? p_theForm.DA.value : 1 );
     var a = ( (null != p_theForm) ? p_theForm.A.value : 1 );
     var sTit = "";

     var thecommandstring = "";

     document.IW.StartPrintJob("", 1);

     for ( var i = da - 1; i < a; i++ ) {

         if ( typeof(customPrintTitle) != 'undefined' )	//la costruzione del titolo e' custom
             sTit = customPrintTitle(i);
         //simone - 7 Ott 2004
         //download necessario per le immagini firmate
         var retval = download(theForm.selezionaImmagine.options[i].value);
         if (retval) {
             var url = document.IW.GetLastFileName();
             retval = document.IW.PrintWithText(url, -10, 0,
                     90 * 10, // Rotazione
                     0, 300, 0, 0, 0, 0, 0, 0, 0, 0,
                     "Arial",
                     0, //Opaco
                     0, 0, 0, //RGB
                     "0",
                     "pagesizey",//"pagesizey - pagesizey / 4",
                     sTit);
         }
         if (retval != 0) {
             var x = i + 1;
             alert("Impossibile proseguire l'operazione: errore nella stampa dell'immagine numero " + x);
             break;
         }
     }

     document.IW.StopPrintJob();
 }


 function openInNewWindow(theObject, posizione)
 {
     var theOption = getOption(theObject);
     var selIndex = theOption.selectedIndex;

     var iForm;
     var old_target = getForm("hxpForm").target;
     var old_verbo = getForm("hxpForm").verbo.value;
     var old_pos = getForm("hxpForm").pos.value;

     iForm = getForm("hxpForm");
     iForm.verbo.value = "showdoc";
     iForm.extraView.value = "@imgs";
     iForm.selectedIndex.value = selIndex;


     if ( old_verbo == 'showtitles')
         getForm("hxpForm").pos.value = posizione;
     else if ( getForm("hxpForm").selid.value.length == 0 ) //occorre aprire in base a # fisico
         getForm("hxpForm").pos.value = getForm("hxpForm").physDoc.value - 1;

     iForm.target = "imgsWindow";
     var windowFeature = 'width=800,height=600';
     if ( typeof(customSetWindowFeature) != 'undefined' ) {
          windowFeature = customSetWindowFeature();
     }
     imgsWindow = window.open(staticEmptyWindow, iForm.target, windowFeature);
     iForm.submit();
     imgsWindow.focus();

     getForm("hxpForm").target = old_target;
     getForm("hxpForm").verbo.value = old_verbo;
     getForm("hxpForm").pos.value = old_pos;
     getForm("hxpForm").extraView.value = '';
     getForm("hxpForm").selectedIndex.value = 0;

     return false;
 }


 function getParameter(paramsArray, paramName)
 {
     for ( var i = 0; i < paramsArray.length; i++ ) {
         var name_val = paramsArray[i];
         var index = name_val.indexOf("=");
         if ( name_val.substring(0, index) == paramName )
             return name_val.substring(index + 1);
     }
     return "";
 }


 //creazione di thumb, suo upload e valorizzazione del name
 function handleTumbnail(filename, thumbInput, host, url, port)
 {
     var index = thumbInput.id.lastIndexOf(".");
     var params = thumbInput.id.substring(index + 1);
     var paramsArray = params.split(',');

     var width = getParameter(paramsArray, "width");
     var height = getParameter(paramsArray, "height");
     var flags = document.IW[getParameter(paramsArray, "flags")];
     var format = document.IW[getParameter(paramsArray, "format")];
     var compression = document.IW[getParameter(paramsArray, "compression")];

     var r = document.IW.Resize('',
             filename,
             format,
             compression,
             width,
             height,
             flags);

     if ( r != 0 )
         return false;

     var thumbFile = document.IW.buffer; //filename del thumb

     var protocol = window.location.protocol;

     r = document.IW.UploadParam(host,
             url,
             port,
             'filename',
             thumbFile,
             (protocol=='https:')?document.IW.uploadHttps:document.IW.uploadNone ,  //mode
                     document.IW.zCompressionNone,
     ""); //param
     if ( r == false )
         return false;

     if ( DoneWithUpload(0, 0, 0, thumbInput) == false )
         return false;

     return true;
 }


 // Federico 28/11/05: funzione spostata in 'varie.js' generico
 /*function realEscape(id)
  {
  ret = escape(id);
  ret = ret.replace(/\+/g, '%2B');*/
 //ret = ret.replace(/\*/g, '%2A');
 /*ret = ret.replace(/\@/g, '%40');
  ret = ret.replace(/\-/g, '%2D');
  ret = ret.replace(/\_/g, '%5F');
  ret = ret.replace(/\./g, '%2E');
  return ret;
  }*/

 var theStatus;
 function setStatus(msg)
 {
     theStatus = window.status;
     window.status = msg;
 }

 function restoreStatus()
 {
     window.status = theStatus;
 }

 function senselectSignatureInfo(id)
 {
     var theSession = new _hxpSession(getForm('hxpForm'));
     var result = theSession.getServerResponse('attach','senselect@signerInfo',false,[['id',id]]);
     if(result.status==200)alert('il file  firmato da:\n\n'+result.responseText+'\n');
     else alert('unexpected error: '+result.statusText+' ('+result.status+')');
     return false;
 }

 function mostraLettori(bImg, id, verbose)
 {
     if(bImg)id=theOption.options[theOption.selectedIndex].value;
     if (id.indexOf('.c@s')>0)
     {var theSession = new _hxpSession(getForm('hxpForm'));
      var result = theSession.getServerResponse('attach','senselect@encryptionInfo',false,[['id',id]]);
      if(result.status==200)alert('il file  leggibile da:\n\n'+result.responseText+'\n');
      else alert('unexpected error: '+result.statusText+' ('+result.status+')');
      return false;
     }
 }

 function mostraFirma(bFirmaImg, id, verbose)
 {
     if (bFirmaImg)id=theOption.options[theOption.selectedIndex].value;
     if (id.indexOf('.s@s')>0)return senselectSignatureInfo(id);
     var theIW = document.IW;
     var sFirma = '';
     if ( bFirmaImg )  {//per immagini con viewer di iw
         if(download(theOption.options[theOption.selectedIndex].value))
             sFirma = new String(theIW.lastcertdescr);
         else {
             if (typeof(verbose) == 'undefined' || verbose)
                 alert ("Si  verificato un errore nel download del file. \nLa firma digitale non e' verificabile.");
             return false;
         }
     }
     else if ( !theIW /*|| theIW.CheckSigningModule(0) == 0*/ ) {
         if (typeof(verbose) == 'undefined' || verbose)
             alert ("La firma digitale non e' verificabile.");
         return false;
     }
     else  {//per file e immagini
         //download di file
         if(download(id))
             sFirma = new String(theIW.lastcertdescr);
         else {
             if (typeof(verbose) == 'undefined' || verbose)
                 alert ("Si  verificato un errore nel download del file. \nLa firma digitale non e' verificabile.");
             return false;
         }
     }
     if ( sFirma == '' ) {
         if (typeof(verbose) == 'undefined' || verbose) {
             if ( !theIW || theIW.CheckSigningModule(0) == 0 )
                 alert ("La firma digitale non e' verificabile.");
             else alert ("Il file e' privo di certificato.");
         }
         return false;
     }
     else  {
         if ( sFirma.indexOf('Trusted:') >= 0 )  {
             if (typeof(verbose) == 'undefined' || verbose)  {
                 //alert(sFirma.substring(0,sFirma.indexOf('Version:')));
             }
             sFirma = 'Certificate:\n' + sFirma.substring(sFirma.indexOf('Version:'));
         }
         if ( sFirma.indexOf('Certificate:') == 0 )  {
             if (typeof(verbose) == 'undefined' || verbose)  {
                 alert(ds2certinfo(sFirma));
                 return false;
             }
             else  {
                 return ds2certinfo(sFirma);
             }
         }

         var sBuff = "";
         var vect = sFirma.split("<certboundary/>");
         if (vect.length == 1)
             sBuff = "Il file e' stato firmato da: \n\n";
         else
             sBuff = "File firmato in sequenza da: \n\n";
         for(var i=vect.length-1; i>=0; i--) {
             sFirma = vect[i];
             if (i!=vect.length-1)sBuff += "\n\n";

             //var sBuff = "Il file e' stato firmato da: \n\n";
             var Pos = 0;
             var PosEnd = 0;
             var sCF = '';

             // Firmatario
             Pos = sFirma.indexOf('/CN=');
             PosEnd = sFirma.indexOf('/G=');
             if ( Pos >= 0 )  {
                 if ( PosEnd >= 0 )
                     sBuff += sFirma.substring(Pos + 4, PosEnd) + '\n';
                 else  {
                     // Cognome
                     PosEnd = sFirma.indexOf('/', Pos + 1);
                     sBuff += sFirma.substring(Pos + 4, PosEnd) + ' ';
                     // Nome
                     Pos = PosEnd + 1;
                     PosEnd = sFirma.indexOf('/', Pos);
                     sBuff += sFirma.substring(Pos, PosEnd);
                     // Codice Fiscale
                     Pos = PosEnd + 1;
                     PosEnd = sFirma.indexOf('/', Pos);
                     sCF = '\nCodice Fiscale: ' + sFirma.substring(Pos, PosEnd);
                     // Data di nascita
                     Pos = sFirma.indexOf('/D', PosEnd + 1);
                     Pos = sFirma.indexOf('/D=', Pos + 1);
                     //PosEnd = sFirma.indexOf('/', Pos + 1);
                     PosEnd = findPosEnd(sFirma,Pos+3);
                     sDNasc = '\nData di nascita: ' + sFirma.substring(Pos + 3, PosEnd);
                     sBuff += sDNasc + sCF;
                 }
             }
             if (vect.length > 1)
                 continue;

             // Organizzazione
             Pos = sFirma.indexOf('/O=');
             //PosEnd = sFirma.indexOf('/CN=', Pos);
             PosEnd=findPosEnd(sFirma,Pos+3);
             if ( Pos >= 0 && PosEnd > 0 )
                 sBuff += '\nOrganizzazione: ' + sFirma.substring(Pos + 3, PosEnd);

             // Dipartimento
             Pos = sFirma.indexOf('/OU=');
             //PosEnd = sFirma.indexOf('/D=', Pos);
             PosEnd=findPosEnd(sFirma,Pos+4);
             if ( Pos >= 0 && PosEnd > 0 )
                 sBuff += '\nDipartimento: ' + sFirma.substring(Pos + 4, PosEnd);

             // Paese
             Pos = sFirma.indexOf('/C=');
             //PosEnd = sFirma.indexOf('/O=');
             //<fabio-28-04-2004> x certificato postecert
             PosEnd = sFirma.indexOf('/',Pos+1);
             var checkPos=sFirma.indexOf('\n',Pos);
             if(PosEnd<Pos||PosEnd<0||(checkPos>0&&checkPos>Pos&&checkPos<PosEnd))
                 PosEnd=checkPos;
             //</fabio-28-04-2004>
             if ( Pos >= 0 && PosEnd > 0 )  {
                 sBuff += '\nPaese: ';
                 if ( sFirma.substring(Pos + 3, PosEnd) == 'IT' )
                     sBuff += 'Italia';
                 else
                     sBuff += sFirma.substring(Pos + 3, PosEnd);
             }

             // EMail
             Pos = sFirma.indexOf('/Email=');
             if ( Pos >= 0 )  {
                 PosEnd=findPosEnd(sFirma,Pos+7);
                 sBuff += '\nE-mail: ' + sFirma.substring(Pos + 7,PosEnd);
             }
             else  {
                 Pos = sFirma.indexOf('/E=');
                 if ( Pos >= 0 )  {
                     PosEnd=findPosEnd(sFirma,Pos+3);
                     sBuff += '\nE-mail: ' + sFirma.substring(Pos + 3,PosEnd);
                 }
             }
             // Validit dal...
             var Valid = '';
             Pos = sFirma.indexOf('notBefore=');
             if(Pos>0)  {
                 PosEnd = sFirma.indexOf('\n', Pos);
                 var Da = new Date(sFirma.substring(Pos+10,PosEnd));
                 Valid += '\nda ' + Da.toLocaleString();
                 // al...
                 Pos = sFirma.indexOf('notAfter=');
                 PosEnd = sFirma.indexOf('\n',Pos+1);
                 var A = new Date(sFirma.substring(Pos+9, PosEnd));
                 Valid += '\n a ' + A.toLocaleString();
                 delete Da;
                 delete A;
             }
             // Altre informazioni
             Pos = sFirma.indexOf('/D=');
             PosEnd = sFirma.indexOf('/Email=');
             if ( Pos >= 0 && PosEnd > 0 )  {
                 sBuff += '\n\nAltre informazioni:\n';
                 sFirma = sFirma.substring(Pos + 3, PosEnd);

                 // Codice fiscale
                 Pos = sFirma.indexOf('FiscalCode=');
                 PosEnd = sFirma.indexOf(';', Pos);
                 if ( Pos >= 0 && PosEnd > 0 )  {
                     sBuff += '\nCodice Fiscale: ' + sFirma.substring(Pos + 11, PosEnd);
                     sFirma = sFirma.substring(0, Pos) + sFirma.substring(PosEnd + 1);
                 }

                 // Data di nascita
                 Pos = sFirma.indexOf('BirthDate=');
                 if ( Pos >= 0 )  {
                     sBuff += '\nData di nascita: '
                         + sFirma.substring(Pos + 10 + 6, Pos + 10 + 8) + '/'
                         + sFirma.substring(Pos + 10 + 4, Pos + 10 + 6) + '/'
                         + sFirma.substring(Pos + 10, Pos + 10 + 4);
                     sFirma = sFirma.substring(0, Pos) + sFirma.substring(Pos + 10 + 8 + 1);
                 }

                 // Smart card id
                 Pos = sFirma.indexOf('SmartCardID=');
                 PosEnd = sFirma.indexOf(';', Pos);
                 if ( Pos >= 0 && PosEnd > 0 )  {
                     sBuff += '\nIdentificativo di Smart Card: ' + sFirma.substring(Pos + 12, PosEnd);
                     sFirma = sFirma.substring(0, Pos) + sFirma.substring(PosEnd + 1);
                 }

                 // Smart card S/N
                 Pos = sFirma.indexOf('Smartcard S/N:');
                 if ( Pos >= 0 )  {
                     sBuff += '\nSmart Card S/N: ' + sFirma.substring(Pos + 14);
                     sFirma = sFirma.substring(0, Pos);
                 }

                 // Inserisco gli altri elementi non noti, uno per riga
                 sBuff += '\n\n';
                 var i = 0;
                 while ( (Pos = sFirma.indexOf(';')) >= 0 )  {
                     for ( i = 0; i < Pos; ++i )  {
                         if ( sFirma.charAt(i) != ' ' )
                             break;
                     }
                     sBuff += sFirma.substring(i, Pos);
                     sBuff += '\n';
                     sFirma = sFirma.substring(Pos + 1);
                 }
             }
             if(Valid!='')sBuff+='\n\nValidit certificato: '+Valid;
         }

         if (typeof(verbose) == 'undefined' || verbose)
             alert(sBuff);
         else
             return sBuff;
     }
     return false;
 }

 function ds2certinfo(descr)
 {
     var n = 0;
     var retStr = '';
     var description = new String(descr);
     var SingleDescr = '';

     for (;;)  {
         n = description.indexOf('<certboundary/>\r\n');
         if ( n <= 0 )
             break;
         SingleDescr = description.substring(0, n);
         description = description.substr(n + 17);

         if ( retStr.length > 0 )
             retStr = GetSingleInfo(SingleDescr) + '\n\n- ' + retStr;
         else
             retStr = GetSingleInfo(SingleDescr);
     }
     if ( retStr.length > 0 )  {
         retStr = 'File firmato in sequenza da:\n\n- ' + GetSingleInfo(description) + '\n\n- ' + retStr;
         var re = /\n/gi;
         retStr = retStr.replace(re, '\n   ');
         var re = /\n   -/gi;
         retStr = retStr.replace(re, '\n-');
     }
     else
         retStr = 'File firmato da:\n' + GetSingleInfo(description);

     return(retStr);
 }

 function GetSingleInfo(description)
 {
     var re = /CN=[^(,|\r|\n)]+(,|\r|\n)/gi;
     description=description.replace(re,'');
     re = /Certificate:(\r|\n)/;
     description = description.replace(re,'');
     re = /Subject Public Key Info(\r|\n|.)+/;
     description = description.replace(re,'');
     return(ds2certinfo_translate(description));
 }

 function ds2certinfo_translate(SignInfo)
 {
     var retStr = '';
     var Pos    = SignInfo.indexOf('Validity'),
     PosEnd = 0;
     var Valid = '';
     if ( Pos > 0 )  {
         // Validit dal...
         Pos = SignInfo.indexOf('Not Before: ', Pos + 1);
         PosEnd = SignInfo.indexOf('\n', Pos + 1);
         var Da = new Date(SignInfo.substring(Pos + 12, PosEnd));
         Valid += ' da ' + Da.toLocaleString();
         // al...
         Pos = SignInfo.indexOf('Not After : ', Pos + 12);
         PosEnd = SignInfo.indexOf('\n', Pos + 1);
         var A = new Date(SignInfo.substring(Pos + 12, PosEnd));
         Valid += ' a ' + A.toLocaleString();
         delete Da;
         delete A;
     }

     Pos      = SignInfo.indexOf('Subject: ');
     SignInfo = SignInfo.substr(Pos + 9);

     // Cognome
     Pos = SignInfo.indexOf('D=C=');
     if (Pos>=0) {
         PosEnd = SignInfo.indexOf(', N=', Pos + 1);
         retStr += SignInfo.substring(Pos + 4, PosEnd);
         // Nome
         Pos = PosEnd;
         PosEnd = SignInfo.indexOf(', D=', Pos + 1);
         retStr += ' ' + SignInfo.substring(Pos + 4, PosEnd);
         Pos = PosEnd;
     }
     else {
         Pos = SignInfo.indexOf(', SURNAME=');
         PosEnd = SignInfo.indexOf(', OU=', Pos + 1);
         retStr += SignInfo.substring(Pos + 10, PosEnd);
         Pos = SignInfo.indexOf('GIVENNAME=');
         PosEnd = SignInfo.indexOf(', SUR', Pos + 1);
         retStr += ' ' + SignInfo.substring(Pos + 10, PosEnd);
         Pos = SignInfo.indexOf('BirthDate=') + 6;
     }
     // Data Nascita
     PosEnd = findPosEnd(SignInfo,Pos+4);
     retStr += ' (nato/a il ' + SignInfo.substring(Pos + 4, PosEnd) + ')';
     // Organizzazione
     Pos = SignInfo.indexOf(', O=');
     //PosEnd = SignInfo.indexOf(', D=', Pos + 1);
     PosEnd = findPosEnd(SignInfo,Pos+4);
     retStr += '\nOrganizzazione: ' + SignInfo.substring(Pos + 4, PosEnd);
     // Paese
     Pos = SignInfo.indexOf('C=');
     PosEnd = SignInfo.indexOf(', O=', Pos + 1);
     var Paese = SignInfo.substring(Pos + 2, PosEnd);
     if ( Paese != 'C=' )
         retStr += ' (' + ((Paese == 'IT') ? 'Italia' : Paese) + ')';
     // E-mail
     Pos = SignInfo.indexOf(', E=');
     if(Pos>0)
     {PosEnd = findPosEnd(SignInfo,Pos+4);
     retStr += '\nE-mail: ' + SignInfo.substring(Pos+4,PosEnd);
     //retStr += '\nE-mail: ' + SignInfo.substr(Pos + 4);
     }
     if ( Valid.length > 0 )
         retStr += '\nValidit certificato: ' + Valid;

     return retStr;
 }

 function findPosEnd(SignInfo,Pos)
 {var p1=SignInfo.indexOf(', ',Pos);
 if(p1<0)p1=SignInfo.length;
 var p2=SignInfo.indexOf('\r',Pos);
 if(p2<0)p2=SignInfo.length;
 if(p2<p1)p1=p2;
 var p3=SignInfo.indexOf('\n',Pos);
 if(p3<0)p3=SignInfo.length;
 if(p3<p1)p1=p3;
 var p4=SignInfo.indexOf('/',Pos);
 if(p4<0)p4=SignInfo.length;
 if(p4<p1)p1=p4;
 var p5=SignInfo.indexOf('\\;',Pos);
 if(p5<0)p5=SignInfo.length;
 if(p5<p1)p1=p5;
 return p1;
 }


 function download(id)
 {
     var iw = document.IW;
     var mode = iw.downloadNoLoad;
     var ext = id.substring(id.lastIndexOf('.') + 1);
     if (ext == 'ziw')
         mode += iw.downloadInflate;
     //DD 07/11/05 - Spostata l'istruzione da sotto
     id = realEscape(id);
     var url = buildUrlForGet("", false, false, true) + "&verbo=attach&id=" + id;
     //DD 07/11/05 - Spostata sopra l'istruzione: id = realEscape(id);
     callSetTifPageButtons = false;
     var r = iw.DownloadParam(url, '', mode);
     if (r != 0)
         return false;
     return true;
 }

 function getLastNumPage()
 {
     var ret = 0;
     var l_prefix = getPrefix('');
     index = getLastInstanceIndex(l_prefix);
     if(index > 0)
         index--;
     var title = '.' + l_prefix + '[' + index + '].' + '@title';
     //fileObject = getElementByName(title);
     fileObject = getElementByNameWithRoot(document.getElementById(getInstanceId(l_prefix, index)), title);
     if ( fileObject == null ) {
         title = '*' + l_prefix + '[' + index + '].' + '@title';
         //fileObject = getElementByName(title);
         fileObject = getElementByNameWithRoot(document.getElementById(getInstanceId(l_prefix, index)), title);
     }
     if (fileObject != null) {
         var val = fileObject.value;
         if (val.indexOf("Pagina ") == 0) {
             ret = eval(val.substring(val.indexOf(" ") +1));
         }
     }
     return ret;
 }

 var global_tiff_current_page = 1;

 function nextTifPage() {
    var numPages = document.IW.numPages();
    if ( numPages > global_tiff_current_page ) global_tiff_current_page++;
    if ( numPages <= global_tiff_current_page ) setTifePageButton("nextTifImg", "disable");
    if ( numPages > 1 ) setTifePageButton("prevTifImg", "enable");
    setTifPageCount('nextTifImg', true);
    document.IW.nextPage();
    return false;
 }

 function prevTifPage() {
    if (global_tiff_current_page>1) global_tiff_current_page--;
    if (global_tiff_current_page<=1) setTifePageButton("prevTifImg", "disable");
    if (document.IW.numPages()>global_tiff_current_page) setTifePageButton("nextTifImg", "enable");
    //document.IW.nextPage();
    setTifPageCount('prevTifImg', true);
    document.IW.prevPage();
    return false;
 }

 function setTifPageCount(id, recall) {
    var numPages = document.IW.numPages();
    if ( (numPages < 2) && recall ) setTimeout("setTifPageCount('prevTifImg', false)", 1500);
    else {
        var td = document.getElementById('tifPageCount');
        if ( null == td ) {
            td = document.createElement('td');
            var img = document.getElementById(id);
            td.setAttribute('id', 'tifPageCount');
            td.setAttribute('align', 'right');
            img.parentNode.parentNode.parentNode.appendChild(td);
        }
        if ( numPages > 1) td.innerHTML = '<span style=\"font-weight:bold;padding-right:10px;\">pag. '+global_tiff_current_page+' di '+numPages+'</span>';
        else td.innerHTML = '<span style=\"font-weight:bold;padding-right:10px;\"></span>';
    }
 }

 function DoneWithDownload(param,filename,status)
 {
     if (callSetTifPageButtons)
         setTifPageButtons();
     //predisposizione per modalit asincrona
     if (param == 'download4sign'){
         var filelist;
         filelist[0] = filename;
         upload4sign(filelist);
     }
     return false;
 }


 var callSetTifPageButtons = false;

 function setTifPageButtons() {//quando si carica nuova immagine
    if (document.IW.numPages() > 1) setTifePageButton("nextTifImg", "enable")
    else setTifePageButton("nextTifImg", "disable")
    setTifePageButton("prevTifImg", "disable")
    return false;
 }


 function setTifePageButton(id, set) {
     var img = document.getElementById(id);
     if (img == null) return;
     src = img.src;
     if (set == "disable" && src.indexOf("_off.") == -1)
         img.src = src.substring(0,src.lastIndexOf(".")) + "_off" + src.substring(src.lastIndexOf("."));
     else if (set == "enable" && src.indexOf("_off.") != -1)
         img.src = src.replace("_off.", ".");
 }

 function printParameters() {
     document.IW.printParms();
     return false;
 }

 //le funzioni download4sign e upload4sign sono state introdotte da mbussetti il 22/03/2005 per consentire il
 //download e la firma di un allegato direttamente da workflow
 function download4sign(){
     //alert(getForm("hxpForm").attach.value);

     var iw = document.IW;
     var id;

     // Federico 27/07/06: introdotta gestione firma allegati di piu' documenti [RW 0037104]
     var listOfDocsAttachIds = getForm("hxpForm").attach.value.split("%$%");
     var listOfDocsAttachIdsResults = new Array(listOfDocsAttachIds.length);

     for (var j = 0; j < listOfDocsAttachIds.length; j++) {
         var listOfIds = listOfDocsAttachIds[j].split(" ");
         var listOfResults = new Array(listOfIds.length);

         for (var ii = 0; ii < listOfIds.length; ii++){
             setStatus('download in corso di ' + listOfIds[ii]);
             id = realEscape(listOfIds[ii]);
             //alert(id);
             var url = buildUrlForGet("", false, false, true) + "&verbo=attach&id=" + id;
             callSetTifPageButtons = false;
             var estensione = '@' + listOfIds[ii].substr(listOfIds[ii].indexOf(".")) + '@';
             //alert(listOfIds[ii] + " " + estensione);
             var checkstart = iw.DownloadParam(url, estensione + 'download4sign', iw.downloadNoLoad|iw.downloadNoUnsign|iw.downloadSetExt);
             //alert(checkstart);
             listOfResults[ii] = iw.GetLastFileName();
             //alert(listOfResults[ii]);
         }

         listOfDocsAttachIdsResults[j] = listOfResults;
     }

     return upload4sign(null, listOfDocsAttachIdsResults);
 }

 function upload4sign(filelist, listOfDocsAttachIdsResults){
     // Federico 27/07/06: introdotta gestione firma allegati di piu' documenti [RW 0037104]
     if (typeof(listOfDocsAttachIdsResults) == 'undefined' || listOfDocsAttachIdsResults == null) {
         listOfDocsAttachIdsResults = new Array(1);
         listOfDocsAttachIdsResults[0] = filelist;
     }

     var protocol = window.location.protocol;
     var bits = (protocol=='https:')?document.IW.uploadHttps:document.IW.uploadNone;

     //firma
     var signed = "";
     bits |= document.IW.uploadSign;
     signed = "&signed=true";

     var url = buildUrlForGet("", true, true, true) + "&verbo=Iw_response&xverb=upload" + signed;
     //alert(url);

     var r = '1';
     var fileHandlerList = "";

     for (var j = 0; j < listOfDocsAttachIdsResults.length; j++){
         filelist = listOfDocsAttachIdsResults[j];

         for (var ir = 0; ir < filelist.length; ir++){
             setStatus('upload in corso di ' + filelist[ir]);

             r |= document.IW.UploadParam(getHost(),
                     url,
                     window.location.port,
                     'filename',
                     filelist[ir],
                     bits,  //mode
                     document.IW.zCompressionNone,
                     "upload4sign"); //param

             var filehandle = document.IW.buffer;

             if ( filehandle.indexOf("<--remotefile:") == -1 ){
                 r = 0;
                 break;
             }

             var index = filehandle.indexOf("<--remotefile:") + 14;
             filehandle = filehandle.substring(index, filehandle.indexOf(";", index));

             if ( filehandle == "UPLOAD_ERROR" ){
                 r = 0;
                 break;
             }

             fileHandlerList += filehandle;

             if (ir < filelist.length - 1) fileHandlerList += "$%$";
         }

         if (r == 0) break;

         if (j < listOfDocsAttachIdsResults.length - 1) fileHandlerList += "%$%";
     }

     //alert ('r=' + r);
     //alert ('fh= ' + fileHandlerList);
     //alert(document.IW.buffer);

     if ( r == '1' ){
         //return false;
         setStatus('Ripresa del workflow');
         getForm("hxpForm").wfText.value = fileHandlerList;
         fileHandlerList = "";
         return goOnWorkflow(getForm("hxpForm").wfId.value,getForm("hxpForm").wfAction.value,getForm("hxpForm").wfDoc.value,getForm("hxpForm").wfSelId.value,getForm("hxpForm").wfPos.value,getForm("hxpForm").wfFCount.value,getForm("hxpForm").db.value,"iw");
     }

     return true;
 }

 /*
  * Funzione realizzata da mbussetti
  * Mostra la sezione dei metadati relativi al file avente id 'currentFileTitle'
  */
 function showMetadata(currentFileTitle){
     var attachId;
     //caso dei file allegati o delle immagini senza iw
     if ('undefined' != typeof(currentFileTitle)){
         attachId = currentFileTitle;
     }
     //caso delle immagini con iw
     else {
         var imagesSelect = null;
         imagesSelect = getElementByName("selezionaImmagine","select");

         if (null != imagesSelect) {
             var selectedOption = null;
             selectedOption = getSelectedOption(imagesSelect);

             if (null == selectedOption) {
                 docMSG(noSelectedImage);
                 return false;
             }

             var veroTitle;
             parenthesisIndex = selectedOption.text.lastIndexOf(' (');
             if (parenthesisIndex != -1){
                 veroTitle = selectedOption.text.substring(0,parenthesisIndex);
             }
             else {
                 veroTitle = selectedOption.text;
             }

             attachId = veroTitle;
         }
     }

     var metaDiv = null;
     metaDiv = document.getElementById('metaView_' + attachId,"div");

     if (null == metaDiv) {
         docMSG(noMetadata);
         return false;
     }

     //aggiunta di mbussetti del 31/05/2005: se il div  all'interno di un <tr> nascosto, devo modificare lo
     //stile anche di quest'ultimo
     var trStyle = null;
     var tdFather = metaDiv.parentNode;
     var trGrandFather = null;
     if (null != tdFather){
         var trGrandFather = tdFather.parentNode;
         if (null != trGrandFather){
             if (trGrandFather.nodeName.toLowerCase() == 'tr' && null != trGrandFather.style){
                 trStyle = trGrandFather.style.display;
             }
         }
     }

     var displayStyle = metaDiv.style.display;

     if (displayStyle == 'block'){
         metaDiv.style.display = 'none';
     }
     else if (displayStyle == 'none'){
         metaDiv.style.display = 'block';
     }

     //aggiunta di mbussetti del 31/05/2005: se il div  all'interno di un <tr> nascosto, devo modificare lo
     //stile anche di quest'ultimo
     if (null != trStyle && trStyle == displayStyle){
         trGrandFather.style.display = metaDiv.style.display;
         //alert("nuovo stile: " + trGrandFather.style.display);
     }

     return false;
 }

 /*
  * Funzione realizzata da mbussetti
  * Allinea la tendina delle immagini allegate (visualizzazione con iw) con quella dei pdf corrispondenti prodotti dal
  * FCS, nel senso che scegliendo un pdf da quest'ultima nell'area di iw (e quindi nella tendina delle immagini) appare
  * il primo dei tif che esso contiene
  */
 function allineaSelect(nomeTendinaPartenza,nomeTendinaArrivo){
     //alert("allinea");
     var pdfTent = getElementByName(nomeTendinaPartenza,"select");
     if (null != pdfTent){
         var pdfSelected = getSelectedOption(pdfTent);
         if (null != pdfSelected.value){
             //il valore della option contiene - in un'unica stringa - una serie di informazioni delimitate da
             //separatori: vado ad estrarle
             var id_index = pdfSelected.value.indexOf(id_delimiter);
             var href_index = pdfSelected.value.indexOf(href_delimiter);
             var der_index = pdfSelected.value.indexOf(der_delimiter);
             var id_a,href_a,der_a;
             if (id_index != -1){
                 id_a = (href_index == -1) ? pdfSelected.value.substring(id_index+id_delimiter.length) : pdfSelected.value.substring(id_index+id_delimiter.length,href_index);
             }
             if (href_index != -1){
                 href_a = (der_index == -1) ? pdfSelected.value.substring(href_index+href_delimiter.length) : pdfSelected.value.substring(href_index+href_delimiter.length,der_index);
             }
             if (der_index != -1){
                 der_a = pdfSelected.value.substring(der_index+der_delimiter.length);
             }

             var tendinaArrivo = getElementByName(nomeTendinaArrivo,"select");
             valoreDaSelezionare = der_a.substring(0,der_a.indexOf(";"));
             //alert (valoreDaSelezionare);
             var exit = selectByValue(tendinaArrivo,valoreDaSelezionare);
             if (!exit){
                 docMSG(notFoundImageInSelect);
             }
             else {
                 tendinaArrivo.onchange.call(tendinaArrivo);
             }
         }
     }
     return false;
 }

 /*
  * Funzione realizzata da mbussetti
  * Apre il pdf selezionato tramite la relativa tendina
  */
 function showFileInSelect(nomeTendina){
     //alert("mostra");
     var pdfTent = getElementByName(nomeTendina,"select");
     if (null != pdfTent){
         var pdfSelected = getSelectedOption(pdfTent);
         if (null != pdfSelected.value){
             //il valore della option contiene - in un'unica stringa - una serie di informazioni delimitate da
             //separatori: vado ad estrarle
             var id_index = pdfSelected.value.indexOf(id_delimiter);
             var href_index = pdfSelected.value.indexOf(href_delimiter);
             var der_index = pdfSelected.value.indexOf(der_delimiter);
             var id_a,href_a,der_a;
             if (id_index != -1){
                 id_a = (href_index == -1) ? pdfSelected.value.substring(id_index+id_delimiter.length) : pdfSelected.value.substring(id_index+id_delimiter.length,href_index);
             }
             if (href_index != -1){
                 href_a = (der_index == -1) ? pdfSelected.value.substring(href_index+href_delimiter.length) : pdfSelected.value.substring(href_index+href_delimiter.length,der_index);
             }
             if (der_index != -1){
                 der_a = pdfSelected.value.substring(href_index+href_delimiter.length);
             }

             var ancoraAbbinata = getElementByName("mostrA","a");
             //alert (ancoraAbbinata.name);
             if (null != ancoraAbbinata){
                // Federico 28/07/08: l'URL va escapato [RW 0053358]
                id_index = href_a.indexOf(id_a);

                if (id_index != -1) {
                    var dot_index = id_a.indexOf(".");
                    var id_code   = id_a.substring(0, dot_index);
                    var id_ext    = id_a.substring(dot_index + 1);
                    href_a = href_a.substring(0, id_index) + realEscape(id_code) + "." + id_ext + href_a.substring(id_index + id_a.length);
                }

                ancoraAbbinata.href = href_a;
                //alert (ancoraAbbinata.href);
             }
         }
     }
     return false;
 }

 function iwGetFile(id, wantSaveAs, toDoValues)
 {
     var ext = '@.' + id.substring(id.indexOf(".") + 1) + '@';
     id = realEscape(id);
     var url = buildUrlForGet("", false, false, true) + "&verbo=attach&id=" + id;

     // Federico 14/09/07: introdotta visualizzazione contenuto xml delle conversioni in xml [RW 0046316]
     if (typeof(toDoValues) != 'undefined' && toDoValues != null && toDoValues.length > 0) {
        url += "&toDo=" + toDoValues;
     }

     var theIW = document.IW;

     var mode = theIW.downloadNoLoad;
     if ( typeof(wantSaveAs) != 'undefined' && wantSaveAs )
         mode += document.IW.downloadSaveAs;
     else
         mode += theIW.downloadShellOcx + theIW.downloadShellPlugin;

     if (ext == '@.ziw@')
         mode += document.IW.downloadInflate;
     else {
         mode += document.IW.downloadSetExt;

         // Federico 29/10/09: in caso di 'Save as', invece di eliminare la firma dai file firmati,  pi corretto salvare il file
         // cos com' [EB 326]
         if (typeof(wantSaveAs) == 'undefined' || !wantSaveAs) {
             while ( ext.indexOf(".p7m@") == ext.length - 5 || ext.indexOf(".p7k@") == ext.length - 5 ||
                     ext.indexOf(".c@s@") == ext.length - 5 || ext.indexOf(".s@s@") == ext.length - 5) {
                 ext = ext.substring(0, ext.lastIndexOf(".")) + "@";
             }
         }
         else {
             mode += document.IW.downloadNoUnsign;
         }
     }

     if ( theIW.DownloadParam(url, ext, mode) )  {
         alert ("Si  verificato un errore nel download del file.");
         window.status = window.defaultStatus;
     }
     else if (document.all) {
         DoneWithDownload(null, null, null);
     }
 }

 function iwGetfileIns(prefix, el) {
     var dad = el.parentNode;
     while ( typeof(dad.id) == 'undefined' || dad.id.indexOf(prefix + '.') == -1 )
         dad = dad.parentNode;
     var instNumber = dad.id.substring(dad.id.lastIndexOf('.') + 1);

     var starFileEl = getElementByName('*' + prefix + '[' + instNumber + '].@name');
     if (starFileEl != null && starFileEl.value.length > 0)
         return iwGetFile(starFileEl.value, false);

     var fileEl = getElementByName(prefix + '[' + instNumber + '].@name');
     if (fileEl == null)
         return false;

     fileElValue = fileEl.value;
     if (fileElValue.length == 0)
         return false;

     document.IW.ShellFile(fileElValue, "open", 1);
     return false;
 }

 function aggiungiIstanzaImmaginePrima(value, toSelect, p_prefix, p_title, thisObject)
 {
     //alert(value + " " +  toSelect + " " + p_prefix + " " + p_title);

     //cambio di nome in caso di tiff multipagina o acquisizione da scanner
     if ( value.indexOf("iw@") != -1 && (typeof(p_title) == 'undefined' || p_title == null) )
         p_title = value.substring((value.lastIndexOf('@') + 1)).replace("p", "Pagina ").replace(".tif", "");

     var l_prefix = getPrefix(p_prefix);

     var index = addInstanceBefore(l_prefix, thisObject, true, true);

     var name = l_prefix + '[' + index + '].' + '@name';
     fileObject = getElementByNameWithRoot(document.getElementById(getInstanceId(l_prefix, index)), name);
     fileObject.value = value;

     var title = '.' + l_prefix + '[' + index + '].' + '@title';
     var fileObjectTitle = getElementByNameWithRoot(document.getElementById(getInstanceId(l_prefix, index)), title);
     if ( fileObjectTitle == null ) {
         title = '*' + l_prefix + '[' + index + '].' + '@title';
         fileObjectTitle = getElementByNameWithRoot(document.getElementById(getInstanceId(l_prefix, index)), title);
     }

     if ( typeof(p_title) != 'undefined' && p_title != null)
         fileObjectTitle.value = p_title;
     else
         defaultTitle(fileObject, l_prefix);

     if ( toSelect == true )
         setSelectedImage(fileObject, fileObjectTitle);
 }
