/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

 /* hierBrowser.js */

 function nuovaRicerca(){
  getForm('hxpForm').verbo.value='query';
  getForm('hxpForm').xverb.value='';
  getForm('hxpForm').query.value='';
  getForm('hxpForm').pos.value='0';
  getForm('hxpForm').selid.value='';
  getForm('hxpForm').dbTable.value='';  
  getForm('hxpForm').submit();
  return false;
 }
 function paginaPrecedente(lastDoc)
 {getForm('hxpForm').verbo.value='hierBrowser';
  getForm('hxpForm').docStart.value=lastDoc;
  getForm('hxpForm').backward.value='1';
  getForm('hxpForm').submit();
  return false;
 }
 function paginaSuccessiva(firstDoc)
 {getForm('hxpForm').verbo.value='hierBrowser';
  getForm('hxpForm').docStart.value=firstDoc;
  getForm('hxpForm').backward.value=0;
  getForm('hxpForm').submit();
  return false;
 }
 function docToggle(docNumber,docStart)
 {getForm('hxpForm').verbo.value='hierBrowser';
  getForm('hxpForm').docToggle.value=docNumber;
  getForm('hxpForm').docStart.value=docStart;
  getForm('hxpForm').submit();
  return false;
 }
 function mostraDocumento(docNumber)
 {getForm('hxpForm').verbo.value='showdoc';
  getForm('hxpForm').xverb.value='@hierBrowser';
  getForm('hxpForm').pos.value=docNumber;
  getForm('hxpForm').selid.value='';
  getForm('hxpForm').submit();
  return false;
 }
 var theDocWindow=null;
 function apriDocumento(docNumber)
 {var verbo=getForm('hxpForm').verbo.value;
  var xverb=getForm('hxpForm').xverb.value;
  getForm('hxpForm').verbo.value='showdoc';
  getForm('hxpForm').xverb.value='hierchild';
  getForm('hxpForm').pos.value=docNumber;
  getForm('hxpForm').selid.value='';
  var prevTarget=getForm('hxpForm').target;
  theDocWindow=window.open
   ('',getForm('hxpForm').target='hierchild',
    'status,resizable=yes,scrollbars=yes');
  getForm('hxpForm').submit();
  getForm('hxpForm').target=prevTarget;
  getForm('hxpForm').verbo.value=verbo;
  getForm('hxpForm').xverb.value=xverb;
  return false;
 }
 function mostraSelezione()
 {getForm('hxpForm').verbo.value='showdoc';
  getForm('hxpForm').pos.value=getForm('hxpForm').docCurrent.value-1;
  getForm('hxpForm').selid.value='';
  getForm('hxpForm').submit();
  return false;
 }


 ////////////////////////////
 function showtip(e,text)
 {if(text=='')return;
  text=unescape(text);
  var theObject=docId2Elem('tooltip')
  if(typeof(theObject)=='undefined') 
   return;
  {var thetitle=text.split('')
   var thetextbegin = '<div style="background-color:beige; padding:3px; width:auto; border:1px solid black;font-family:arial;font-size:11px;">'
   var thetextend = '</div>';
   var thetitles = '';
   if (thetitle.length>1) 
   {for(i=0;i<thetitle.length;i++)
    {for(var j=0;j<i;j++)
      thetitles+='&nbsp;';
     if(i)thetitles+='<br>';
     thetitles+=thetitle[i];
    }
   }
   else thetitles+=text;
   theObject.style.width = 'auto';
   theObject.innerHTML = thetextbegin + thetitles + thetextend;
   theObject.style.left=8;
   theObject.style.top=e.clientY+6;
   if(theObject.style.top<0)
    theObject.style.top=0;
   theObject.style.visibility='visible';
  }
 }
 function hidetip()
 {var theObject=docId2Elem('tooltip');
  if(typeof(theObject)=='undefined')return;
  theObject.style.visibility = 'hidden';
 }
 ///////////////////////////////

 function docId2Elem(id){return document.getElementById(id);}
 function customDocChangeHandler(thepreviousdocnumber,thecurrentdocnumber)
 {var itemid;
  if(thepreviousdocnumber>0)
  {itemid=docId2Elem('_doc_'+thepreviousdocnumber);
   if(itemid)itemid.style.backgroundColor='#ffffff';
   else alert('_sel_'+thepreviousdocnumber)
  }
  itemid=docId2Elem('_doc_'+thecurrentdocnumber);
  if(itemid)itemid.style.backgroundColor='#efefef';
//  else alert('_doc_'+thecurrentdocnumber)
 }

 var currentHierTitle='';
 function impostaDocumentoCorrente(docNumber,docTitle)
 {var thepreviousdocnumber=getForm('hxpForm').docCurrent.value;
  currentHierTitle=docTitle;
  getForm('hxpForm').docCurrent.value=docNumber;
  if(typeof(customDocChangeHandler)!='undefined')
   customDocChangeHandler(thepreviousdocnumber,docNumber);
  return false;
 }
 function loadHandler()
 {impostaDocumentoCorrente(getForm('hxpForm').docToggle.value>0
                           ?getForm('hxpForm').docToggle.value:
                            getForm('hxpForm').docStart.value,
                            getForm('hxpForm').docTitle.value);
  if(typeof(customLoadHandler)!='undefined')
   customLoadHandler();
  getForm('hxpForm').docToggle.value=0;
  parent.getForm('hxpForm').docStart.value=getForm('hxpForm').docStart.value;
  parent.getForm('hxpForm').hierCount.value=getForm('hxpForm').hierCount.value;
  parent.getForm('hxpForm').hierStatus.value=getForm('hxpForm').hierStatus.value;
 }
 function unloadHandler()
 {if(theDocWindow!=null)theDocWindow.close();
 }
 var oldFocusHandler=window.onfocus;
 window.onfocus=focusHandler;
 function focusHandler()
 {if(theDocWindow!=null)
   theDocWindow.close();
  theDocWindow=null;
 } 
