/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/
 function db2uid(db)
 {if(db=='')return'';
  var sele=getForm("hxpForm").sele.value;
//alert("sele in db2uid["+sele+"]");
  var start,stop,pos=0;
  for(;;)
  {start=sele.indexOf(' '+db,pos);
   if(start<0)break;
   pos=start+1;
   for(var i=pos+db.length;i<sele.length;i++)
   {if(sele.charAt(i)==';')
    {pos=sele.lastIndexOf(',',start)+1;
     return sele.substring(pos,sele.indexOf(' ',pos));
    }
    if(sele.charAt(i)!=' ')break;
   }
  }
  return'';
 }
 function oneuid2id(uid,sele,strict)
 {var start=sele.indexOf(','+uid+' ');
  if(start<0){return uid;}
  start=sele.lastIndexOf(';',start);
  start=sele.indexOf(' ',start+1);
  start=sele.indexOf(' ',start+1);
  var result=sele.substring(start+1,sele.indexOf(',',start+1));
  return(result!=''||strict?result:uid);
 }
 function uid2id(uid,strict)
 {if(uid=='')return uid;
  var result='';
  var arrayOfUid=uid.split(',');
  var sele=getForm("hxpForm").sele.value;
  for(var index=0;index<arrayOfUid.length;index++)
  {if(index)result+=',';
   result+=oneuid2id(arrayOfUid[index],sele,strict);
  }
  return result;
 }
 function oneid2uid(id,sele)
 {var start=sele.indexOf(' '+id+',');
  if(start<0){return id;}
  start=sele.indexOf(',',start+id.length+2);
  return sele.substring(start+1,sele.indexOf(' ',start+1));
 }
 function id2uid(id)
 {if(id=='')return id;
  var result='';
  var arrayOfId=id.split(',');
  var sele=getForm("hxpForm").sele.value;
  for(var index=0;index<arrayOfId.length;index++)
  {if(index)result+=',';
   result+=oneid2uid(arrayOfId[index],sele);
  }
  return result;
 }
 