/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

 /* keyNav.js */

 function loadHandler()
 {
 }
 function unloadHandler()
 {
 }
 function hideShowBranch(elem,theId)
 {var isHidden=document.getElementById(theId).style.display=='none';
  elem.innerHTML=(isHidden?'-':'+');
  document.getElementById(theId).style.display=(isHidden?'':'none');
  return false;
 }
 function translateList(theList)
 {theList=theList.replace(/\}\{\}\{/g,'" OR "');
  theList=theList.replace(/\}\{/g,'"');
  theList=theList.replace(/^\ /,'');
  return theList;
 }
 function lookupHandler(keyList,keyPath)
 {keyList=translateList(keyList);
  if(keyList!='')
  {if(getForm('theForm').qlphrase.value!='')
   {getForm('theForm').qlphrase.value+=' AND ';
   }
   // rimozione del prefisso
   if(keyPath.indexOf('XML,')==0||keyPath.indexOf('xml,')==0)
   {keyPath=keyPath.substring(4);
   }
   getForm('theForm').qlphrase.value+='(['+keyPath+']='+keyList+')';
  }
 }
 function exEscape(str)
 {var ret="";
  for(i=0;i<str.length;i++)
   ret+=str.charCodeAt(i).toString(16);
  return(ret);
 }
 function checkRefine()
 {if(typeof(getForm('theForm').lastqueryid)!='undefined'&&
     getForm('theForm').lastquerycheck.checked)
  {getForm('hxpForm').selid.value=getForm('theForm').lastqueryid.value;
   return true;
  }
  getForm('hxpForm').selid.value='';
  return false;
 }
 function resetOutputSelector()
 {if(typeof(getForm('theForm').queryoutput)!='undefined')
  {var theSelect=getForm('theForm').queryoutput;
   for(var index=0;index<theSelect.length;index++)
   {if(theSelect.options[index].value=='sel')
    {theSelect.selectedIndex = index;
     break;   
    }
   }
  } 
 }
 function onSQLSyntaxChecked(check)
 {if(!check.checked)
  {if(typeof(getForm('theForm').queryoutputxml)!='undefined')
   {getForm('theForm').queryoutputxml.checked=false;
   }
   resetOutputSelector();
  }
 }
 function onXMLOutputChecked(check)
 {if(check.checked&&typeof(getForm('theForm').querysqlsyntax)!='undefined')
  {getForm('theForm').querysqlsyntax.checked=true;
  }
 }
 function onOutputChecked(theSelect)
 {var value=theSelect.options[theSelect.selectedIndex].value;
  if(value!='sel') // output XML o CSV needs SQL
  {if(typeof(getForm('theForm').querysqlsyntax)!='undefined')
   {getForm('theForm').querysqlsyntax.checked=true;
   }
  } 
 }
 function onQueryProbChecked(check)
 {if(check.checked&&typeof(getForm('theForm').queryprob)!='undefined')
  {getForm('theForm').queryprob.checked=true;
  }
 }
 function onTextLikeChecked(check)
 {if(check.checked&&typeof(getForm('theForm').textlike)!='undefined')
  {getForm('theForm').textlike.checked=true;
  }
  if(typeof(getForm('theForm').lastquerycheck)!='undefined')getForm('theForm').lastquerycheck.disabled=check.checked;
  if(typeof(getForm('theForm').queryoutputxml)!='undefined')getForm('theForm').queryoutputxml.disabled=check.checked;
  if(typeof(getForm('theForm').queryoutput   )!='undefined')getForm('theForm').queryoutput.disabled   =check.checked;
  if(typeof(getForm('theForm').queryprob     )!='undefined')getForm('theForm').queryprob.disabled     =check.checked;
  if(typeof(getForm('theForm').querysqlsyntax)!='undefined')getForm('theForm').querysqlsyntax.disabled=check.checked;
 }
 function onSoTitlesChecked(check)
 {getForm('hxpForm').soTitles.value=(check.checked?'1':'');
 }
 function openTitles(query)
 {getForm('hxpForm').pos.value='0';
  getForm('hxpForm').query.value=query;
  getForm('hxpForm').nextVerb.value='showtitles';
  getForm('hxpForm').nextXVerb.value='@child';
  getForm('hxpForm').verbo.value='query';
  getForm('hxpForm').xverb.value='';
  var nameWin="win#"+escape(getForm('theForm').qlphrase.value);
  getForm('hxpForm').target=exEscape(nameWin);
  theTitleWindow=window.open
   ('', getForm('hxpForm').target,"status,resizable=yes,scrollbars=yes,width=800,height=600,top=0,left=0");
  theTitleWindow.focus();
  getForm('hxpForm').submit();
 }
 function getTitles()
 {if(getForm('theForm').qlphrase.value=='')
   return false;
  var sqlSyntax=false;
  var querystring;
  if(typeof(getForm('theForm').textlike)!='undefined'&&getForm('theForm').textlike.checked==true)
  {var result=prompt('Please set the search field (or fields separed by | )','');
   if(result==null)return;  
   getForm('hxpForm').qopt.value=0;
   querystring='[?XMLCMD]<?xml version="1.0" encoding="iso-8859-1"?><cmd c="xe" bits="0" key="'+result+'"><bst>'+getForm('theForm').qlphrase.value+'</bst></cmd>';
  }
  else
  {if(typeof(getForm('theForm').querysqlsyntax)!='undefined')
   {if(getForm('theForm').querysqlsyntax.checked)getForm('hxpForm').qopt.value|=0x100;else getForm('hxpForm').qopt.value&=~0x100;
   }
   if(typeof(getForm('theForm').queryoutputxml)!='undefined')
   {if(getForm('theForm').queryoutputxml.checked)getForm('hxpForm').qopt.value|=0x200;else getForm('hxpForm').qopt.value&=~0x200;
   }
   if(typeof(getForm('theForm').queryoutput)!='undefined')
   {var value=getForm('theForm').queryoutput.options[getForm('theForm').queryoutput.selectedIndex].value;
    if(value=='xml')getForm('hxpForm').qopt.value|=0x200;else getForm('hxpForm').qopt.value&=~0x200;
    if(value=='csv')getForm('hxpForm').qopt.value|=0x400;else getForm('hxpForm').qopt.value&=~0x400;
   }
   if(typeof(getForm('theForm').queryprob)!='undefined')
   {if(getForm('theForm').queryprob.checked)getForm('hxpForm').qopt.value|=1;else getForm('hxpForm').qopt.value&=~1;
   }
   if(typeof(getForm('theForm').qord)!='undefined')
   {getForm('hxpForm').qord.value=getForm('theForm').qord.value;
    if(getForm('hxpForm').qord.value!='')getForm('hxpForm').qopt.value|=16;
   }
   else getForm('hxpForm').qopt.value&=~16;
   querystring=((checkRefine()&&getForm('hxpForm').selid.value!='')?'([?SEL]="'+getForm('hxpForm').selid.value+'") AND ':'')+getForm('theForm').qlphrase.value;
  }
  getForm('hxpForm').pos.value='0';
  getForm('hxpForm').query.value=querystring;
  getForm('hxpForm').nextVerb.value='showtitles';
  getForm('hxpForm').nextXVerb.value='@child';
  getForm('hxpForm').verbo.value='query';
  getForm('hxpForm').xverb.value='';
  var nameWin="win#"+escape(getForm('theForm').qlphrase.value);
  getForm('hxpForm').target=exEscape(nameWin);
  theTitleWindow=window.open
   ('', getForm('hxpForm').target,"status,resizable=yes,scrollbars=yes,width=800,height=600,top=0,left=0");
  theTitleWindow.focus();
  getForm('hxpForm').submit();
  return false;
 }
 function keynavOpenIndex(qForm,   // la form con cui interagisce lo user
                          keyPath, // identifica la chiave negli indici
                          startKey,// posizionamento
                          shwMode, // imposta la modalit di formattazione ('dt' per data)
                          common,  // parte comune
                          threl,   // opzionalmente l'indice della relazione con cui attingere
                                   // la descrizione associata alla chiave (classificazioni)
                          theInput)// opzionalmente l'input dove depositare l'esito della selezione
 {checkRefine();
  return openIndex(qForm,keyPath,startKey,shwMode,common,threl,theInput);
 }
