/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

 /* query.js */

 //nome della finestra statica (vuota) che viene aperta quando c' un popup in modo che venga mantenuto il protocollo
 //corrente (http o https)
 var staticEmptyWindow = "./../formatter/html/templates/static.html";

 var theIndexWindow=null;
 var thePopupWindow=null;
 var theCollectionWindow=null;
 var theTitleWindow=null;
 var thePhraseWindow=null;
 var theChooseWindow=null;
 var oldFocusHandler=window.onfocus;
 window.onfocus=focusHandler;

 function withNull(str)
 {
     return((-1!=str.indexOf(",,")) || (""==str) || (','==str.charAt(0)) || (','==str.charAt(str.length-1)))
 }

 function withRealSel()
 {
     return(-1!=uid2id(getForm('hxpForm').selid.value,true).search(/[^,]/));
 }

 function isSel(prevSel,prevDb,nowSel,nowDb)
 {
     var arrSel=prevSel.split(',');
     var arrDb=prevDb.split(',');
     var ret=false;//sfiducia costruttiva
     var i;
     for(i=0;(!ret)&&(i<arrDb.length);i++)
         ret=((arrSel[i]==nowSel)&&(arrDb[i]==nowDb));
     return(ret);
 }

 function deSel(listSele,listDb,sele,db)
 {var arrSele;
  var arrDb;
  var ret="";
  var i;
  var sepChar='';//nullo inizialmente
//alert("deSel (entrata)\nlistSele["+listSele+"]\nlistDb["+listDb+"]\nsele["+sele+"]\ndb["+db+"]");
  listSele=fillSeleList(listSele,listDb);
  arrSele=listSele.split(',');
  arrDb=listDb.split(',');
  for(i=0;i<arrDb.length;i++)
   if((sele!=arrSele[i])||(db!=arrDb[i]))
    {ret+=sepChar+arrSele[i];
     sepChar=',';
    }
//alert("deSel (uscita)\nlistSele["+ret+"]\nlistDb["+listDb+"]\nsele["+sele+"]\ndb["+db+"]");
  return(ret);
 }

 function deArch(listSele,listDb,sele,db)
 {var arrSele;
  var arrDb;
  var ret="";
  var i;
  var sepChar='';//nullo inizialmente
//alert("deArch (entrata)\nlistSele["+listSele+"]\nlistDb["+listDb+"]\nsele["+sele+"]\ndb["+db+"]");
  listSele=fillSeleList(listSele,listDb);
  arrSele=listSele.split(',');
  arrDb=listDb.split(',');
  for(i=0;i<arrDb.length;i++)
   if((sele!=arrSele[i])||(db!=arrDb[i]))
    {ret+=sepChar+arrDb[i];
     sepChar=',';
    }
//alert("deArch (entrata)\nlistSele["+listSele+"]\nlistDb["+ret+"]\nsele["+sele+"]\ndb["+db+"]");
  return(ret);
 }

 function fillSeleList(seleList,dbList)
 {var arrDb;
  var sepChar;
  var i;
//alert("fillSeleList: db2uid(civile)["+db2uid('civile')+"]");
  if((""==seleList)&&(""!=dbList)){
   arrDb=dbList.split(',');
   //sepChar='';
   for(i=0;i<arrDb.length;i++){
	if(i)seleList+=',';
	seleList+=db2uid(arrDb[i]);
    //seleList+=sepChar;
    //sepChar=',';
   }
  }
  return(seleList);
 }

 function selezioniCorrenti(selid,event,db,mode)
 {var thepreviousselid=getForm('hxpForm').selid.value;
  var thepreviousdb=getForm('hxpForm').db.value;
  var sepChar;
//alert("selezioniCorrenti():\nselid["+selid+"]\nevent["+event+"]\ndb["+db+"]\nmode["+mode+"]");
//alert("selezioni
// correnti:\nprevSel["+thepreviousselid+"]\nprevDb["+thepreviousdb+"]\nnowSel["+selid+"]\nnowDb["+db+"]\nmode{"+mode+"}");
  var selected;
  thepreviousselid=fillSeleList(thepreviousselid,thepreviousdb);
  if((""==selid)&&(""==db)){
   getForm('hxpForm').selid.value="";
   getForm('indexForm').selid.value="";
   getForm('hxpForm').db.value="";
   getForm('indexForm').db.value="";
   selid=thepreviousselid;  // pro customSelChangeHandler()
   db=thepreviousdb;        // pro customSelChangeHandler()
  }else if("single"==mode){
   getForm('hxpForm').selid.value=unescape(selid);
   getForm('indexForm').selid.value=unescape(selid);
   getForm('hxpForm').db.value=unescape(db);
   getForm('indexForm').db.value=unescape(db);
  }else{
   selected=isSel(thepreviousselid,thepreviousdb,unescape(selid),unescape(db));
   if (!selected){
    sepChar=(""!=getForm('hxpForm').db.value?',':'');
    getForm('hxpForm').selid.value+=sepChar+unescape(selid);
    getForm('indexForm').selid.value+=sepChar+unescape(selid);
    getForm('hxpForm').db.value+=sepChar+unescape(db);
    getForm('indexForm').db.value+=sepChar+unescape(db);
   }else{
    if (("clear"==mode)||(unescape(db)!=thepreviousdb)||(unescape(selid)!=thepreviousselid)){
     getForm('hxpForm').selid.value=getForm('indexForm').selid.value=deSel(thepreviousselid,thepreviousdb,unescape(selid),unescape(db));
     getForm('hxpForm').db.value=getForm('indexForm').db.value=deArch(thepreviousselid,thepreviousdb,unescape(selid),unescape(db));
     mode="desel";
    }
    else
     mode="single";
   }
  }
//alert("selezioni correnti (end):\nSel["+getForm('hxpForm').selid.value+"]\nDb["+getForm('hxpForm').db.value+"]");
//alert("selezioni correnti
// (custom):\nprevSel["+thepreviousselid+"]\nprevDb["+thepreviousdb+"]\nnowSel["+selid+"]\nnowDb["+db+"]");
  if(typeof(customSelChangeHandler)!='undefined')
   customSelChangeHandler(thepreviousselid,selid,thepreviousdb,db,mode);
  return false;
 }

 function impestaSelezioneCorrente(selid,event,db)
 {var mode=((null!=event) && event.ctrlKey)?"multi":"single";
//alert("isc:["+selid+"]["+db+"]{"+mode+"}");
  return(selezioniCorrenti(selid,event,db,mode));
 }

 function cancellaSelezioniCorrenti()
 {var listSele=getForm('hxpForm').selid.value;
  var listDb=getForm('hxpForm').db.value;
  var i;
//alert("csc");
  listSele=fillSeleList(listSele,listDb);
  arrSelid=listSele.split(',');
  arrDb=listDb.split(',');
  for(i=0;i<arrDb.length;i++)
   selezioniCorrenti(arrSelid[i],null,arrDb[i],"clear");
  getForm('hxpForm').selid.value="";
  getForm('indexForm').selid.value="";
  getForm('hxpForm').db.value="";
  getForm('indexForm').db.value="";
  return(true);
 }

 // *** imposta la selezione corrente (anche multipla)
 function impostaSelezioneCorrente(selid,event,db)
 {
//alert("selid,event,db:"+selid+','+event+','+db)
  var mode=((null!=event) && event.shiftKey)?"multi":"single";
  var arrDb;
  var arrSelid;
  var i;
//alert("imposta selezione corrente:\nnowSel["+selid+"]\nnowDb["+db+"]\nmode{"+mode+"}");

  //resetto la form nel caso di cambio archivio
  if ( (event!=null) && (db!=getForm('hxpForm').db.value) )
   resetQuery();


  selid=fillSeleList(selid,db);
  arrDb=db.split(',');
  arrSelid=selid.split(',');
  if(1<arrDb.length){
   cancellaSelezioniCorrenti();
   mode="multi";
  }

//  if(arrDb.length!=arrSelid.length)
//   alert("impostaSelezioneCorrente(): array di lunghezza differente ["+arrSelid.length+"]["+arrDb.length+"]");
  for(i=0;i<arrDb.length;i++){
   selezioniCorrenti(arrSelid[i],event,arrDb[i],mode);
  }
//alert("impostaSelezioneCorrente 006");
  //ciclare su una coppia di array paralleli (un controllo sul length di
  //entrambi potrebbe non essere una cattiva idea) ottenuto dagli 'split()'
  //di 'selid' ed 'event'; se 'selid' e' vuoto, costruirlo da 'db' (possibile
  //perdita di compatibilita' col passato!); se gli array hanno piu' di un
  //elemento, si passa alla fase "multi" (ma "multi" come? tutti selezione?
  //complementare?)

  /* cambiamento del titolo della pagina */
  if (typeof(customchangeArchTitle)!='undefined')
   customchangeArchTitle();

  return(false);
 }

 // *** torna l'identificativo di selezione corrente
 function ottieniSelezioneCorrente()
 {return getForm('hxpForm').selid.value;
 }
 // *** chiamata all'apertura della pagina

 function loadHandler()
 {

 //DD 29/01/06 Valorizza tutti gli attributi title delle immagini
   setAllImgTitlesFromAlt();

    restoreTuple();
    if ( getForm('hxpForm').warnings.value != '' )
        alert(getForm('hxpForm').warnings.value);

    //simone 15 Set 2004 - disabilitata pulizia di qord
 	//getForm('hxpForm').qext.value = "";
	//getForm('hxpForm').qord.value = "";

	//Federica 15/11/2006 pulizia di qopt
	getForm('hxpForm').qopt.value = "0";

    //carico ultimo ordinamento selezionato nella tendina
    var theForm = ( getForm('theOptsForm') != null )? getForm('theOptsForm') : getForm('theForm');
    var fieldIdxName = 'qordIdx';
    if ( typeof(customFieldIdxName) != 'undefined')
        fieldIdxName = customFieldIdxName(fieldIdxName, getForm('hxpForm').dbTable.value);

    if (theForm!=null && fieldIdxName.length > 0 && typeof(theForm.xwOrd) != 'undefined' && getForm('hxpForm')[fieldIdxName].value.length > 0) {
        if (theForm.xwOrd[getForm('hxpForm')[fieldIdxName].value]){
            theForm.xwOrd[getForm('hxpForm')[fieldIdxName].value].selected = true;
        }
    }

 	getForm('hxpForm').selid.value = id2uid(getForm('hxpForm').selid.value);

  	impostaSelezioneCorrente(getForm('hxpForm').selid.value,null,getForm('hxpForm').db.value);

  	/* cambio il titolo della pagina */
  	if ( typeof(customchangeArchTitle) != 'undefined' )
   		customchangeArchTitle();

  	if( typeof(customLoadHandler) != 'undefined' )
   		customLoadHandler();
 }

 // *** chiamata alla chiusura della pagina
 function unloadHandler()
 {
    if ( theIndexWindow != null )
 		theIndexWindow.close();

  	if ( thePopupWindow != null )
  		thePopupWindow.close();

  	if ( theCollectionWindow != null )
  		theCollectionWindow.close();

  	//if(theTitleWindow!=null)theTitleWindow.close();

  	if ( thePhraseWindow != null )
  		thePhraseWindow.close();

  	if ( theChooseWindow != null )
  		theChooseWindow.close();

	/*
	 * Federica 24/04/2007 [RW 0043771]: Rimozione della tupla listOfPropertiesAdmTools da _cd
	 */
	 hxpS = new _hxpSession(getForm('hxpForm'));
	 hxpS.setParameter("listOfPropertiesAdmTools", null);

	/*
     * Modifica di Federico del 30/09/2004: La chiamata alla 'CloseWaitMsg()'  necessaria con Opera e Mozilla per
     * evitare che il div di attesa rimanga visibile dopo aver premuto il pulsante indietro nella pagina di errore
     * visualizzata dopo una ricerca fallita.
     */
	if (typeof(CloseWaitMsg) != 'undefined') {
		CloseWaitMsg();
    }
 }

 function focusHandler()
 {
  if( theIndexWindow != null ) {
  	theIndexWindow.close();
  	theIndexWindow = null;
  }

  //if(theCollectionWindow!=null)theCollectionWindow.close();
  //theCollectionWindow=null;

  if( thePopupWindow != null ) {
	thePopupWindow.close();
	thePopupWindow = null;
  }

  //if(theTitleWindow!=null)theTitleWindow.close();
  //theTitleWindow=null;

  if( thePhraseWindow != null ) {
  	thePhraseWindow.close();
  	thePhraseWindow = null;
  }

  if( theChooseWindow != null ) {
  	theChooseWindow.close();
  	theChooseWindow = null;
  }
 }
 // *** costruisce la query a partire dai dati di tre array
 function arr2Query(names,values,types)
 {var i       =0           ;
  var brackPos=0           ;
  var numAdj  =0           ;
  var adjArr  =new Array(0);
  var oldAdj  =""          ;
  var newAdj  =""          ;
  var preAdj  =""          ;
  var postAdj =""          ;
  var theQuery=""          ;
  var theChar;
  var oper1;
  var oper2;
  var val;
  var operNot;
  if(("undefined"==typeof(document["theForm"]["isOper"]))
   ||("and"==document["theForm"]["isOper"].value)){
   oper1=" AND ";
   oper2=" ADJ ";
  }else{
   oper1=" OR ";
   oper2=" OR ";
  }
//   oper1=" AND ";
//   oper2=" ADJ ";
  for(i=0;i<names.length;i++){
   if(0<values[i].length){
    rName=names[i].split("#")[0];
    // filtra gli elementi: solo nomi che iniziano con '[' o '{' o '}' e terminano con ']'
    if(((theChar=rName.substring(0,1))!='[' && theChar!='}'&&theChar!='{')
       || rName.substring(rName.length-1)!=']')
         continue;
    if(types[i]=="text" || types[i]=="textarea") {
     if(null!=values[i].match(/^\s*no[nt]\s+/i)){
      operNot="not ";
      val=values[i].replace(/^\s*no[nt]\s+/i,"");
     }else{
      operNot="";
      val=values[i];
     }
     if('{'==rName.charAt(0)){
      preAdj=rName.replace(/^(\{[^\}]+\}).*$/,"$1");
      postAdj=rName.replace(/^\{[^\}]+\}(.*)$/,"$1");
      if((val.indexOf(' ')>0)||(""!=operNot))
       adjArr[numAdj++]=preAdj+operNot+"("+postAdj+"="+val+")";
      else
       adjArr[numAdj++]=preAdj+postAdj+"="+val;
     }else {
      if(theQuery.length)theQuery+=oper1;
      if((val.indexOf(' ')>0)||(""!=operNot))
       theQuery+=operNot+'('+rName+'='+val+')';
      else
       theQuery+=rName+'='+val;
      // pre inversione 'not': due righe seguenti
      //if(values[i].indexOf(' ')>0)theQuery+='('+rName+'='+values[i]+')';
      //else theQuery+=rName+'='+values[i];
     }
    }
    else if (types[i]=='select-one' || types[i]=='select-multiple') {
     if('{'==rName.charAt(0)) adjArr[numAdj++]=rName+"="+  "\"" + values[i] + "\"";
     else if (values[i]!='') {
      if (theQuery!='') theQuery+=oper1;
      //alert(rName + "\n" + names + "\n" + values[i] + "\n" + types)
      theQuery+=rName+'='+ "\"" + values[i] + "\"";
     }
    }//ELSE IF select-one || select-multi...
   }//if
  }//for
  if(0<adjArr.length){
   adjArr.sort();
   oldAdj=adjArr[0].replace(/^\{([^\}]+)\}.*$/,"$1");
   postAdj=adjArr[0].replace(/^\{[^\}]+\}(.*)$/,"$1");
   //brackPos=adjArr[0].indexOf("}");
   //oldAdj =adjArr[0].substr(0,brackPos);
   //postAdj =adjArr[0].substr(brackPos+1);
   adjArr[0]="("+postAdj;
   for(i=1;i<adjArr.length;i++){
    newAdj=adjArr[i].replace(/^\{([^\}]+)\}.*$/,"$1");
    postAdj=adjArr[i].replace(/^\{[^\}]+\}(.*)$/,"$1");
    //brackPos=adjArr[i].indexOf("}") ;
    //newAdj =adjArr[i].substr(0, brackPos);
    //postAdj=adjArr[i].substr(brackPos+1) ;
    if(newAdj==oldAdj )
     adjArr[i]=oper2+postAdj ;
    else{
     oldAdj=newAdj ;
     adjArr[i]=")"+oper1+"("+postAdj ;
    }
   }
   if(theQuery.length)theQuery+=oper1;
   theQuery+=adjArr.join('')+')';
  }

  // RW: 0036207 - NDRAGO - INIZIO
  if (typeof(removeStopListWord) != 'undefined') {
      if (removeStopListWord && (theQuery.indexOf(']=') > 0)) {
        // alert(theQuery);
        theQuery = theQuery.replace(/]=/g, "|SrcStp:null]=");
        // alert(theQuery);
      }
    }
  // RW: 0036207 - NDRAGO - FINE

  return theQuery;
 }

 function keys2Query()
 {var i       =0           ;
  var brackPos=0           ;
  var numAdj  =0           ;
  var adjArr  =new Array(0);
  var oldAdj  =""          ;
  var newAdj  =""          ;
  var postAdj =""          ;
  var theQuery=""          ;
  var theChar;

  with (getForm('theForm'))
  {// costruiamo l'array per i valori in adiacenza
   for(i=0;i<length;i++ ) {
     if (    (typeof(elements[i].value!='undefined'))
          && ('undefined'!=typeof(elements[i].value))
          && (0 < elements[i].value.length)
          && !elements[i].disabled) {
     with (elements[i]) {
       //if (name.indexOf('[') >= 0)  alert(value);
       //filtra gli elementi: solo nomi che iniziano con '[' o '{' o '}' e terminano con ']'
       rName=name.split("#")[0];

       if(typeof(elements[i].name)=='undefined'||
          ((theChar=rName.substring(0,1))!='['&&
           theChar!='}'&&theChar!='{')||
          rName.substring(rName.length-1)!=']')
         continue;

		//se scelta di doppi apici
		var addQuotes = false;
		var addSpaceAfterQuotes = "";
		if ( rName.charAt(1) == '"' ) {
			addQuotes = true;
			rName = rName.charAt(0) + rName.substring(2);
			if ( rName.charAt(1) == ' ' ) {
				addSpaceAfterQuotes = " ";
				rName = rName.charAt(0) + rName.substring(2);
			}
		}

       if(elements[i].type=="text"||
          elements[i].type=="textarea" ||
          elements[i].type=="hidden" ||
                         (elements[i].type == 'radio' && elements[i].checked) ||
                         (elements[i].type == 'checkbox' && elements[i].checked && elements[i].name.substr(0,7)!='chkres_') ) {//checkbox ad esclusione dei restriction gestiti da applyRestriction()

          if('{'==rName.charAt(0)) adjArr[numAdj++]=rName+"="+value ;
          else {
           if(theQuery.length)theQuery+=' AND ';

           var val;
           if ( rName.indexOf('|adj|') != -1 ) {
            vect = rName.split('|');

				if ( value.indexOf(" or ") != -1 )
					value = "{" + value.replace(/ or /g, ',') + "}";

			// Federico 13/04/2005: corretta regular expression di replace [RW0027519]
			val = "(" + vect[0] + "]=" + value.replace('/"/gi','\\"') + ") adj ([" + vect[2] + "]=" + vect[3].slice(0,-1) + ")";

           }
           else {//caso semplice di alias tra quadre (con eventuale doppio apice in testa)
		         if  ( addQuotes == true && value != '"' ) //se occorre mettere doppi apici e non ci sono nel valore
                                                           //li metto
		            // Federico 13/04/2005: corretta regular expression di replace [RW0027519]
		            val = rName + '="' + addSpaceAfterQuotes + value.replace('/"/gi','\\"') + '"';
		         else
		            // Federico 13/04/2005: corretta regular expression di replace [RW0027519]
		         	val =  rName + '=' + value.replace('/"/gi','\\"');
            }

           if(value.indexOf(' ')>0){
            theQuery+='(' + val + ')';
           }
           else theQuery+=val;
         }
       }
       else if (elements[i].type == 'select-one' ||
                elements[i].type == 'select-multiple') {
         if('{' == rName.charAt(0)) adjArr[numAdj++]=rName+"="+options[selectedIndex].value ;
         else if (options[selectedIndex].value != '')  {
            if (theQuery != '')   {
               theQuery += ' AND ';
            }
            if  ( addQuotes == true && options[selectedIndex].value.charAt(0) != '"' ) //se occorre mettere doppi apici
                                                                                       // e non ci sono nel valore li
                                                                                       // metto
            	theQuery+=rName+'="' + addSpaceAfterQuotes + options[selectedIndex].value + '"';
            else
            	theQuery+=rName+'='+options[selectedIndex].value;
         }
       }//ELSE IF select-one || select-multi...
     }// WITH
     }//if
   }// FOR
   // costruiamo la sottofrase in adiacenza

   if(0<adjArr.length)
   {adjArr.sort();
    brackPos=adjArr[0].indexOf("}");
    oldAdj  =adjArr[0].substr(0,brackPos);
    postAdj =adjArr[0].substr(brackPos+1);
    adjArr[0]="("+postAdj;
    for(i=1;i<adjArr.length;i++)
    {brackPos=adjArr[i].indexOf("}")      ;
     newAdj =adjArr[i].substr(0, brackPos);
     postAdj=adjArr[i].substr(brackPos+1) ;
     if(newAdj==oldAdj )
      adjArr[i]=" ADJ "+postAdj ;
     else
     {oldAdj=newAdj ;
      adjArr[i]=") AND ("+postAdj ;
     }
    }
    if(theQuery.length)theQuery+=' AND ';
    theQuery+=adjArr.join('')+')';
   }
  }

  // RW: 0036207 - NDRAGO - INIZIO
  if (typeof(removeStopListWord) != 'undefined') {
      if (removeStopListWord && (theQuery.indexOf(']=') > 0)) {
        // alert(theQuery);
        theQuery = theQuery.replace(/]=/g, "|SrcStp:null]=");
        // alert(theQuery);
      }
    }
  // RW: 0036207 - NDRAGO - FINE

  return theQuery;
 }


 function CheckOrdering()
 {
	if(typeof(getForm('theForm').qord)!='undefined')
		if ( getForm('theForm').qord.options[getForm('theForm').qord.selectedIndex].value != '' )
			getForm('hxpForm').qord.value=getForm('theForm').qord.options[getForm('theForm').qord.selectedIndex].value;
 }


 // *** modifica lo stato a seguito di una apertura/chiusura di un ramo dell'albero delle selezioni
 function impostaRamo(ramo,aperto)
 {var sele=getForm('hxpForm').sele.value;
  var start=sele.indexOf(','+ramo+' ');
  start=sele.lastIndexOf(';',start);
  var lev=parseInt(sele.substring(start+1,sele.indexOf(' ',start+1)),10);
  start=sele.indexOf(' ',start+1);
  var stop=sele.indexOf(' ',start+1);
  var value=parseInt(sele.substring(start+1,stop),16);
  getForm('hxpForm').sele.value=
   getForm('hxpForm').sele.value.substring(0,start+1)+
   (aperto==true?(value|(1<<(lev+1))):(value&~(1<<(lev+1)))).toString(16)+
   getForm('hxpForm').sele.value.substring(stop,getForm('hxpForm').sele.value.length);
 }

 /*
  * function impostaRamo(ramo,aperto) {ramo=unescape(ramo); var stop=getForm('hxpForm').sele.value.indexOf(' '+ramo+',');
  * if(stop <=0){alert('stop <=0');return;} var start=getForm('hxpForm').sele.value.lastIndexOf(' ',stop-1); if(start
  * <=0){alert('start <=0');return;} var value=parseInt(getForm('hxpForm').sele.value.substring(start+1,stop),16);
  * //start=getForm('hxpForm').sele.value.lastIndexOf(' ',stop-1); var
  * lev=getForm('hxpForm').sele.value.lastIndexOf(';',start-1); //if(lev==-1)lev=0;
  * lev=parseInt(getForm('hxpForm').sele.value.substring(lev+1,start),10); getForm('hxpForm').sele.value=
  * getForm('hxpForm').sele.value.substring(0,start+1)+ (aperto==true?(value|(1 < <(lev+1))):(value&~(1 <
  * <(lev+1)))).toString(16)+ getForm('hxpForm').sele.value.substring(stop,getForm('hxpForm').sele.value.length); }
  */
 function impostaAperto(ramo){
 	impostaRamo(ramo,true);
 }

 function impostaChiuso(ramo){
 	impostaRamo(ramo,false);
 }

 function sendRequest(theVerb, theXverb, toRestore)
 {
     if (typeof(toRestore)=='undefined' || toRestore == true)
         setGlobalFormRestore('verbo', 'xverb', 'selid');

     var verbo = getForm('hxpForm').verbo.value;
     var xverb = getForm('hxpForm').xverb.value;
     getForm('hxpForm').verbo.value = theVerb;
     getForm('hxpForm').xverb.value = (typeof(theXverb) == 'undefined')?'':theXverb;
     getForm('hxpForm').submit();
     getForm('hxpForm').verbo.value = verbo;
     getForm('hxpForm').xverb.value = xverb;
     return false;
 }

 function checkBeforeSendQuery(query) {
     if (typeof(customCheckBeforeSendQuery) != 'undefined')
         return customCheckBeforeSendQuery(query);
     return true;
 }

 // Federico 25/10/05: aggiunto parametro 'xverb'
 function sendQuery(paramVerbo, toRestore, xverb)
 {
    if (!checkBeforeSendQuery(getForm('hxpForm').query.value))
        return;

    paramVerbo = (typeof(paramVerbo) == 'undefined') ? 'query' : paramVerbo;

    if((!isHierBrowser) && (typeof(customQueryHandler) != 'undefined')) {
        customQueryHandler(getForm('hxpForm').query);
    }

    // Federico 25/10/05: aggiunto parametro 'xverb'
    if (typeof(xverb) == 'undefined') {
        xverb = '';
    }

    return (typeof(customSendRequest) != 'undefined' ? customSendRequest(paramVerbo, toRestore, xverb) :
                                                       sendRequest(paramVerbo, xverb, toRestore));
 }

 function clearSelExtension(theValue)
 {
     var re=/\(\[\?SEL\]\="[^"]+"\)\s((and not)|(or)|(and))/gi;
     return theValue.replace(re,'');
 }

 var theSavedLastQuery = '';
 var isHierBrowser = false;     // true if hier context (no better way?)

 function makeBaseQuery(alrt_disable)
 {if(isHierBrowser)
  {getForm('hxpForm').query.value='[{findHier '+
                                window.frames['inventario'].getForm('hxpForm').docCurrent.value+
                                ' '+window.frames['inventario'].currentHierTitle+
                                '}]';
   return window.frames['inventario'].getForm('hxpForm').docCurrent.value>0;
  }

  if(typeof(customQueryComposer)!='undefined') {
    // va in AND con la composizione standard
    // Federico 04/05/09: introdotta possibilit di avere errori bloccanti nelle pag. di ricerca [M 0000015]
    if (customQueryComposer() == '__STOP_QUERY__') return false;
  }

  CheckOrdering();

  if ( getForm('hxpForm').query.value.length == 0 )
   getForm('hxpForm').query.value=keys2Query();
  else {
   theSavedLastQuery=getForm('hxpForm').query.value;
  	var ret = keys2Query();
  	if ( ret.length > 0 )
    getForm('hxpForm').query.value='('+getForm('hxpForm').query.value+') AND (' +ret+')';
	}

	//aggiungo eventuali campi range
   var res='';
   if(typeof(getLastChkResult)!='undefined')
    if((res = getLastChkResult())!=''){
     res.focus();
     return '';
   }
   if(typeof(addRangeToQuery)!='undefined')
    if((res=addRangeToQuery())!='')
	  if(getForm('hxpForm').query.value!='')
    	getForm('hxpForm').query.value='('+getForm('hxpForm').query.value+') AND '+res;
     else
      getForm('hxpForm').query.value=res;

   //se esistono restrizioni le applico
   res='';
	if(typeof(applyRestriction)!='undefined')
    if((res=applyRestriction())!=''){
	  if(getForm('hxpForm').query.value!='')
    	getForm('hxpForm').query.value='('+getForm('hxpForm').query.value+') AND '+res;
     else
      getForm('hxpForm').query.value=res;
    }

   if(getForm('hxpForm').query.value=='' && typeof(getForm('theForm').elements['default_query'])!='undefined')
    getForm('hxpForm').query.value=getForm('theForm').elements['default_query'].value;

//////////////////////////////////////
//alert(getForm('hxpForm').query.value);
//////////////////////////////////////

  if ( typeof(customQueryRules) != 'undefined' ){
    if ( !customQueryRules(alrt_disable) ) return false;
  }

  /*
   * Aggiunto da Federico il 20/08/2004. Se esiste, chiamo la funzione convertDateRange() (definita nel file di
   * genericPres. 'date_range.js') che converte tutte le date dei range specificati mediante il building block generico
   * 'inputDate_q' nel formato extraway aaaammgg (se no la ricerca per range di date non funziona correttamente).
   *
   * NOTA: Dopo aver dichiarato le chiavi dei campi relativi alle date come chiavi di tipo 'date' (applicazione
   * XSpring), questa conversione si  rivelata inutile, visto che Extraway  in grado di gestire date in formati
   * differenti a quello highway ('aaaammgg'). La chiamata a 'convertDateRange()'  stata, quindi, disabilitata.
   * Aspettare, cmq, a cancellarla definitivamente.
   */
  /*
   * if( typeof(convertDateRange) != 'undefined' ) { getForm('hxpForm').query.value =
   * convertDateRange(getForm('hxpForm').query.value); }
   */

  /*
   * Modifica di Federico del 03/12/2004: In un'applicazione multilingua, che possiede un thesaurus gerarchico
   * multilingua,  necessario effettuare le ricerche solo sul codice del termine del thesaurus selezionato e non sulla
   * stringa restituita nel campo input associato al thesaurus. Dato che solo l'applicazione conosce quali sono i campi
   * associati al thesaurus, occorre invocare, se esiste, un metodo custom che ha il compito di modificare la query
   * opportunamente.
   */
  if ( typeof(customQueryCheckMultiLangThFields) != 'undefined' ){
  	getForm('hxpForm').query.value= customQueryCheckMultiLangThFields(getForm('hxpForm').query.value);
  }

  return(getForm('hxpForm').query.value!='');
 }

 function queryerase()
 {var ret;
  if("undefined"!=typeof(customQueryErase))
   ret=customQueryErase();
  else{
   if(ottieniSelezioneCorrente()=='')return;
   // === dubbio: dobbiamo mandare sendRequest() quando nella selezione
   // corrente ci sono delle selezioni effettive o anche quando la selezione
   // corrente *non* coincide con l'elenco degli archivi figli di primo
   // livello del 'ricerca' piu' esterno
   var prevselid=getForm('hxpForm').selid.value;
   getForm('hxpForm').selid.value=uid2id(prevselid,true);
   var result=sendRequest('rewind');
   getForm('hxpForm').selid.value=prevselid;
   ret=result;
  }
  return(ret)
 }

 function svuotaSelezione()
 {
     thepreviousdb=getForm('hxpForm').db.value;
     cancellaSelezioniCorrenti();
     impostaSelezioneCorrente('', null, thepreviousdb);
 }

// Federico 25/08/09: introdotta function per ricerche senza raffinamento (anche se selId  valorizzata) [EB 116]
function findplain(listaRepVisCompleta, verbo, xverb)
{
    svuotaSelezione();

    if (getForm('hxpForm').xverb.value == '@refine') getForm('hxpForm').xverb.value = '';

    return queryplain(listaRepVisCompleta, verbo, xverb);
}

 // *** esegue una ricerca senza riferimenti
 // Federico 25/10/05: aggiunti parametri 'verbo' e 'xverb'
 // Federico 30/10/08: var che indica a 'makeBaseQuery()' che  stata lanciata la ricerca dall'utente [RW 0054938]
 var queryplainCalled = false;

 function queryplain(listaRepVisCompleta, verbo, xverb)
 {


    setGlobalFormRestore('verbo', 'xverb', 'selid');

    // ndrago;
    // alert(getForm('hxpForm').verbo.value);
    // alert(getForm('hxpForm').xverb.value);
    // alert(getForm('hxpForm').selid.value);

    getForm('hxpForm').query.value = '';
 	if ('undefined' != typeof(listaRepVisCompleta))
 	    getForm('hxpForm').repVisComp.value = listaRepVisCompleta;

    queryplainCalled = true;

    if(!makeBaseQuery()) {
        queryplainCalled = false;
 	    return false;
    }

    queryplainCalled = false;

	setExtensionsAndOrd();

  	if (getForm('hxpForm').xverb.value != '@refine')
  	    svuotaSelezione();
  	else
     {
        // Data: 13/10/2005 - Rif. 0027109
        // User: ndrago@3di.it
        // Raffinamento: prima compongo la fase e poi svuoto la selezione corrente.
        // Da verificare bene su Docway
        var tmpRefineQuery = "([?SEL]=\"" + getForm('hxpForm').selid.value + "\")";
        if (getForm('hxpForm').query.value != "")
            tmpRefineQuery = "(" + getForm('hxpForm').query.value + ") AND " + tmpRefineQuery;
        svuotaSelezione();
        // alert(getForm('hxpForm').query.value);
        getForm('hxpForm').query.value = tmpRefineQuery;
        getForm('hxpForm').xverb.value = "";  // Prima c'era solo questa riga
     }

    OpenWaitMsg();

    // Federico 25/10/05: aggiunti parametri 'verbo' e 'xverb'
    if (typeof(xverb) == 'undefined') {
        xverb = '';
    }

    if (typeof(verbo) != 'undefined' && verbo.length > 0) {
        return sendQuery(verbo, false, xverb);
    }
    else {
        return sendQuery('queryplain', false, xverb);
    }
 }


 // Query in raffinamento.
 function refineQuery(id) {
    // Precedenza all'eventuale ID impostato
    if('undefined' != typeof(id)) getForm('hxpForm').selid.value = id;
    else if( ('' == getForm('hxpForm').selid.value) &&
             ('undefined' != typeof(currentSet)) )  getForm('hxpForm').selid.value = currentSet;
    // Se risulta impostato il nome del DB si richiede query su intero archivio (selid = '')
    if(getForm('hxpForm').db.value == getForm('hxpForm').selid.value) getForm('hxpForm').selid.value = '';
    getForm('hxpForm').xverb.value = '@refine';
    return queryplain();
 }

 function checkBraces(theValue)
 {if(theValue.length>0)
  {if(theValue.indexOf(' o ')>0||theValue.indexOf(' O ')>0||
      theValue.indexOf(' or ')>0||theValue.indexOf(' OR ')>0)
    return '('+theValue+')';
  }
  return theValue;
 }
 // *** query senza sele (ricerca sull'intero archivio)
 function queryq()
 {
  if(!makeBaseQuery()){return false;}
  if(withRealSel()){
   svuotaSelezione();
  }
  return sendQuery();
 }
 // *** query and sele (raffinamento)
 function queryqas()
 {if(!makeBaseQuery()){return false;}
  if(!withRealSel()/* ottieniSelezioneCorrente()=='' */)
   {return queryplain();}
  //getForm('hxpForm').query.value+=' AND ([?SEL]="'+ottieniSelezioneCorrente()+'")';
  getForm('hxpForm').query.value='([?SEL]="'+uid2id(ottieniSelezioneCorrente(),true)+'") AND '+checkBraces(getForm('hxpForm').query.value);
  return sendQuery();
 }
 // *** query and not sele (contorno)
 function queryqans()
 {if(!makeBaseQuery())return false;
  if(!withRealSel()/* ottieniSelezioneCorrente()=='' */)return;
  // === si proceda alla soppressione (eventalmente dopo conferma) delle
  // false selezioni (quelle corrispondenti ad archivi completi)
  //getForm('hxpForm').query.value+=' AND NOT ([?SEL]="'+ottieniSelezioneCorrente()+'")';
  getForm('hxpForm').query.value='NOT ([?SEL]="'+uid2id(ottieniSelezioneCorrente(),true)+'") AND '+checkBraces(getForm('hxpForm').query.value);
  svuotaSelezione();
  return sendQuery();
 }
 // *** not query and sele
 function querynqas()
 {if(!makeBaseQuery())return false;
  if(!withRealSel()/* ottieniSelezioneCorrente()=='' */)return;
  //getForm('hxpForm').query.value='not ('+getForm('hxpForm').query.value+') AND
  // ([?SEL]="'+ottieniSelezioneCorrente()+'")';
  getForm('hxpForm').query.value='([?SEL]="'+uid2id(ottieniSelezioneCorrente(),true)+'") AND NOT ('+getForm('hxpForm').query.value+')';
  return sendQuery();
 }
 function mostraSelezione(selid,childwin,descr)
 {getForm('hxpForm').pos.value='0';
  var verbo=getForm('hxpForm').verbo.value;
  var xverb=getForm('hxpForm').xverb.value;
  var prevTarget=getForm('hxpForm').target;
  var prevselid=getForm('hxpForm').selid.value;
  var nameWin="win#"+selid;
  if(("undefined"!=typeof(descr))&&(0<descr.length))
   nameWin+="#"+escape(xw2app(unescape(descr)));
  getForm('hxpForm').selid.value=uid2id(selid,true);
//alert("selid:["+getForm('hxpForm').selid.value+"]("+getForm('hxpForm').sele.value+")");
  if(childwin){
   getForm('hxpForm').target=exEscape(nameWin); //"titoli"; //nameWin;
   theTitleWindow=window.open
   ('', getForm('hxpForm').target /* 'titlechild' */,
    "status,resizable=yes,scrollbars=yes,width=800,height=600,top=0,left=0");
   theTitleWindow.focus()
  }
  sendRequest('showtitles',childwin?'child':'');
  getForm('hxpForm').selid.value=prevselid;
  getForm('hxpForm').target=prevTarget;
  getForm('hxpForm').verbo.value=verbo;
  getForm('hxpForm').xverb.value=xverb;
  return false;
 }
 // *** chiede una pagina di titoli
 function mostraTitoli(selid,childwin,db,descr)
 {impostaSelezioneCorrente(selid,null,db);
  if(getForm('hxpForm').selid.value==uid2id(getForm('hxpForm').selid.value))
   return false;
  return mostraSelezione(selid,childwin,descr);
 }
 function getFeatures()
 {var keyCount=0+getForm('indexForm').keyCount.value;
  var features="status,resizable=yes,alwaysRaised=yes";
  var w=80+(keyCount>20?
            Math.ceil(Math.min(720,screen.availWidth*0.8)):
            Math.ceil(Math.min(360,screen.availWidth*0.5)));
  var h=60+Math.ceil(Math.min(540,screen.availHeight*0.7));
  var sb=navigator.appName=='Netscape'?true:false;
  return(features+",width="+w+",height="+h+(sb?",scrollbars=yes":""));
 }
 function chkKeyPath(keyPath)
 {if(keyPath.indexOf('/')!=-1&&keyPath.indexOf('@')==-1&&keyPath[keyPath.length-1]!="/")keyPath+="/";
  return keyPath;
 }
 function checkVal(val){return(typeof(val)!='undefined'?val:'');}
 /**
  * Apre una nuova finestra sulle relazioni
  */
 function openThes(qForm,   // la form con cui interagisce lo user
                   keyPath, // identifica la chiave negli indici
                   vRels,   // elenco degli indici di relazione visibili (comma delimited)
                   xRels,   // elenco degli indici di relazione espandibili (comma delimited)
                   startKey,// posizionamento
                   cPath,   // percorso comune
                   lRel,    // relazione da leggere comunque sull'ultimo termine di un percorso
                   theInput,// opzionalmente l'input dove depositare l'esito della selezione
                   presOper)// operatore opzionale da mettere in relazione con l'eventuale operatore del campo
 {var iForm;
  var qKey;
  var element;
  var prOpr;
  iForm=getForm('indexForm');
  proArch="";
  prOpr="";

  if(("undefined"!=typeof(theInput))&&("string"!=typeof(theInput)))
  {element=theInput;
   qKey=theInput.name;
  }
  else
  {if ("undefined"!=typeof(customGetIndexedElement)){
    qKey=customGetIndexedElement(keyPath);
    element=qForm[qKey];
   }
   else
   {proArch="";
    if("undefined"!=typeof(getNowArch))
     proArch="#"+getNowArch(getForm('hxpForm').db.value);
    qKey="["+keyPath+"]"+proArch;
    element=qForm[qKey];
    if(!element)
    {qKey="["+keyPath+"]";
     element=qForm[qKey];
    }
   }
  }
  if(!element)alert("openThes: campo di input \""+qKey+"\" non trovato");

  if("undefined"!=typeof(qForm["iFocus"]))
   qForm["iFocus"].value=qKey;

  if(("undefined"!=typeof(presOper))&&presOper&&element&&element.value)
   prOpr="preserve:("+element.value+") "+presOper+" ";
  if(/* startKey==''&& */element&&element.value)
   startKey=element.value.toUpperCase();
  if(startKey.substring(0,1)=='"')
   startKey=startKey.substring(1,startKey.length);

  keyPath=chkKeyPath(keyPath);
  iForm.verbo.value='showthes';
  iForm.keypath.value=unescape(keyPath);
  iForm.vRels.value=vRels;
  iForm.xRels.value=checkVal(xRels);
  iForm.cPath.value=checkVal(cPath);
  iForm.sele.value='';
  iForm.xMode.value=prOpr;
  iForm.startkey.value=checkVal(cPath)+checkVal(startKey);
  iForm.lRel.value=checkVal(lRel);
  iForm.selid.value=uid2id(getForm('hxpForm').selid.value,true);
  // theIndexWindow=window.open(staticEmptyWindow,iForm.target,getFeatures());
  theIndexWindow=window.open(staticEmptyWindow,iForm.winTarget.value,getFeatures());

  iForm.target = iForm.winTarget.value;
  iForm.submit();
  return false;
 }

  /**
   * Apre una nuova finestra sugli indici
   */
 var vocTitle;
 function openIndex(qForm,   // la form con cui interagisce lo user
                    keyPath, // identifica la chiave negli indici
                    startKey,// posizionamento
                    winAppearance, //aspetto della finestra da aprire
                    shwMode, // imposta la modalit di formattazione ('dt' per data)
                    common,  // parte comune (se contiene '|^|' allora la parte della chiave che precede '|^|' viene
                             // scartata)
                    threl,   // opzionalmente l'indice della relazione con cui attingere
                             // la descrizione associata alla chiave (classificazioni)
                    theInput,// opzionalmente l'input dove depositare l'esito della selezione
                    windowTitle)// window title
 {
 	//alert("keyPath=" + keyPath + "\nstartKey=" + startKey + "\nshwMode=" + shwMode + "\nthrel=" + threl +
     // "\ntheInput=" + theInput);

	vocTitle ='Vocabolario';

	if ( typeof(windowTitle) != 'undefined' )
		vocTitle = windowTitle;

 	//alert("vocTitle: " + vocTitle);

	// "view" viene impiegato per trasmettere il titolo del vocabolario
	var old_view = getForm('indexForm').view.value;
	getForm('indexForm').view.value = vocTitle;

  	var iForm;
  	var qKey;
  	var element;
  	iForm=getForm('indexForm');
  	proArch="";

  	if("undefined"!=typeof(customGetKeyName))
   		keyPath=customGetKeyName(keyPath);

  //alert('theInput:= '+ theInput);
  if(("undefined"!=typeof(theInput))&&(""!=theInput))
  {//element=theInput;
   qKey=theInput;
   element=qForm[qKey];
  }
  else
  {if ("undefined"!=typeof(customGetIndexedElement))
   {qKey=customGetIndexedElement(keyPath);
    element=qForm[qKey];
   }
   else
   {proArch="";
    if("undefined"!=typeof(getNowArch))
     proArch="#"+getNowArch(getForm('hxpForm').db.value);
    qKey="["+keyPath+"]"+proArch;
    element=qForm[qKey];
    if(!element){
     qKey="["+keyPath+"]";
     element=qForm[qKey];
    }
   }
  }

//  if("{"==keyPath.charAt(0)){
//   i=keyPath.indexOf("}");
//   prePath=keyPath.substr(0, i+1);
//   keyPath=keyPath.substr(i+1);
//  }
//  if("undefined"!=typeof(getNowArch))
//   proArch="#"+getNowArch(getForm('hxpForm').db.value);
//  qKey=prePath+"["+keyPath+"]"+proArch;
//  element=qForm[qKey];
//  if(!element)qKey=prePath+"["+keyPath+"]"+proArch;


  if(!element)alert("openIndex: campo di input \""+qKey+"\" non trovato");

  if("undefined"!=typeof(qForm["iFocus"]))
   qForm["iFocus"].value=qKey;
  if(element&&element.value)
   startKey=element.value.toUpperCase();
  if(startKey.substring(0,1)=='"')
   startKey=startKey.substring(1,startKey.length);
  keyPath=chkKeyPath(keyPath);
  iForm.verbo.value='showindex';

  iForm.threl.value=checkVal(threl);
  iForm.cPath.value=checkVal(common);
  iForm.doubleKey.value=(' '==checkVal(common)?"1":"0");
  iForm.shwMode.value=checkVal(shwMode);
  iForm.sele.value='';
  iForm.startkey.value=checkVal(common)+checkVal(startKey);
  iForm.selid.value=uid2id(getForm('hxpForm').selid.value,true);

  //per riempimento da index al ritorno
  /*
   * if ( typeof(theInput) != 'undefined' ) iForm.fillField.value = unescape(theInput.slice(1,-1)); //elimino le
   * parentesi '[' e ']' else iForm.fillField.value = unescape(keyPath);
   */

	// Nick - 05/04/2004
	if (( typeof(theInput) != 'undefined' )&&(theInput != '')) { //simone - in test
        if (theInput.indexOf('[') != 0)
            theInput = '!!' + theInput + "!";
        iForm.fillField.value = unescape(theInput.slice(1,-1)); //elimino le parentesi '[' e ']'
	}else{
		iForm.fillField.value = unescape(keyPath);
	}

  iForm.keypath.value=unescape(keyPath);

  //simone - 13 Dic 2004
  var raffinamento = false, treeOpened = false;
  var treeDiv = '';

  /*
   * Federico 17/12/04: nel typeof era specificato '_DIV_ID_' e non _DIV_ID_, quindi nel secondo
   * termine del test dell'if veniva segnalato un errore javascript (in XSpring) a causa della mancata definizione della
   * variabile _DIV_ID_.
   */
  if (typeof(_DIV_ID_) != 'undefined' && (treeDiv=document.getElementById(_DIV_ID_)) != null && treeDiv.style.display != 'none')
    treeOpened = true;

  if (getForm('hxpForm').xverb.value == '@refine')
    raffinamento = true;
  // Federico 01/03/06: aggiunto test "currentSet != null" [RW 0034978]
  else if (typeof(currentSet) != 'undefined' && currentSet != null && currentSet != getForm('hxpForm').db.value && treeOpened) {
    raffinamento = true;
    iForm.selid.value = currentSet;
  }

  if (!raffinamento) svuotaSelezione();

  // theIndexWindow=window.open(staticEmptyWindow,iForm.target,getAppearance(winAppearance));
  theIndexWindow=window.open(staticEmptyWindow,iForm.winTarget.value,getAppearance(winAppearance));

  iForm.target = iForm.winTarget.value;
  iForm.submit();

  getForm('indexForm').view.value = old_view;

  return false;
 }

 // usate dalla finestra di lookup per il posizionamento
 var theQueryTemplate; // template per query se chiave disponibile
 var theCriteriaTemplate; // template addizionale usato se theListCriteria!=''
 var theEmptyKeyQuery; // query in assenza di chiave
 var theListCriteria;  // regole da soddisfare per il contenuto degli elementi
 // chiamata anche dalla finestra di lookup per il posizionamento
 function getQuery(queryKey)
 {var result=(queryKey==''||queryKey=='*')?theEmptyKeyQuery:theQueryTemplate.replace(/\%k/g,queryKey);
  if(theListCriteria!='')result+=theCriteriaTemplate.replace(/\%k/g,theListCriteria);
  return result;
 }
 /**
  * Apre una nuova finestra per lookup da selezione
  */
 // lette dalla finestra di lookup per la generazione della lista
 var theListElements; // elenco elementi da prelevare
 var theListInput;
 function queryLookup(theInput,
                      db, // il db destinazione
                      queryKey, // da sostituire nel template
                      queryTemplate, // sostituisce %k con queryKey
                      emptyKeyQuery, // in caso queryKey==''
                      listElements, // attributi da prelevare
                      criteriaTemplate, // da aggiungere alla query in caso listCriteria!='' (sostituisce %k con
                                        // listCriteria)
                      listCriteria) // criteri
 {var prevTarget=getForm('hxpForm').target;
  var prevDb=getForm('hxpForm').db.value;
  theListInput=theInput;
  theQueryTemplate=queryTemplate;
  theCriteriaTemplate=criteriaTemplate;
  theEmptyKeyQuery=emptyKeyQuery;
  theListElements=listElements;
  theListCriteria=listCriteria;
  getForm('hxpForm').db.value=db;
  getForm('hxpForm').query.value=getQuery(queryKey);
  theTitleWindow=window.open(staticEmptyWindow,getForm('hxpForm').target='titlechild',getFeatures());
  sendRequest('query','titlechild');
  getForm('hxpForm').target=prevTarget;
  getForm('hxpForm').db.value=prevDb;
  return false;
 }
 function queryInputChangeHandler(theInput)
 {if(typeof(customQueryInputChangeHandler)!='undefined')
   customQueryInputChangeHandler(theInput);
  return true;
 }
 function openRange(rngMode,field,fieldDescr)
 {var toUrl="../formatter/html/data/common/extra/range/range.html" ;
  toUrl+="?"+escape("field")+"="+escape(field) ;
  toUrl+="&"+escape("mode") +"="+escape(rngMode) ;
  toUrl+="&"+escape("descr")+"="+escape(fieldDescr) ;
  thePopupWindow=window.open(toUrl,"rangeWindow","width=300,height=150,resizable=no,modal=yes,alwaysRaised=yes");
  return false;
 }
 function openProfile()
 {var toUrl="../formatter/html/data/common/extra/profile/profile.html";
  thePopupWindow=window.open(toUrl,"profileWindow","width=360,height=400,resizable=no,scrollbars=no,modal=yes,alwaysRaised=yes");
  return false;
 }
 function openPhrase()
 {var toUrl="../formatter/html/data/common/extra/qedit/qedit.html";
  thePhraseWindow=window.open(toUrl,"qEditWindow","width=400,height=200,resizable=no,modal=yes,alwaysRaised=yes");
  return false;
 }

 /*
  * function openCollections(theXVerb,theWin) {//var
  * toUrl=location.pathname+'?verbo=collect&host='+getForm('hxpForm').host.value+'&port='+getForm('hxpForm').port.value+'&user='+getForm('hxpForm').user.value+'&pwd='+getForm('hxpForm').pwd.value;
  * //thePopupWindow=window.open(toUrl,"collectionsWindow","width=640,height=460,resizable=no,modal=yes,alwaysRaised=yes");
  *
  * if(typeof(theWin)=='undefined')theWin=this;
  *
  * var verbo=getForm('hxpForm').verbo.value; var xverb=getForm('hxpForm').xverb.value; var
  * prevTarget=getForm('hxpForm').target; var prevselid=getForm('hxpForm').selid.value;
  *
  * theXVerb=(typeof(theXVerb)=='undefined'||theXVerb=='')? (/*getForm('hxpForm').cName.value==''?'':'open'
  *//*
                                                            * ''):('@'+theXVerb); var nameWin='collections'+theXVerb;
                                                            * getForm('hxpForm').target=exEscape(nameWin);
                                                            *
                                                            * var theWindow = theWin.window.open
                                                            * ('',getForm('hxpForm').target,
                                                            * theXVerb.length>0&&theXVerb.substring(0,1)!='@'?
                                                            * //getForm('hxpForm').cName.value==''?
                                                            */
                 /*
                  * "width=540,height=130,resizable=no,scrollbars=no,modal=yes,alwaysRaised=yes":
                  * "width=640,height=460,resizable=no,scrollbars=no,modal=yes,alwaysRaised=yes"
                  */
                 /*
                  * "width=540,height=130,resizable=no,scrollbars=no": "width=640,height=460,resizable=no,scrollbars=no" );
                  *
                  * //if(theXVerb=='')theWin.thePopupWindow=theWindow; //else theWin.theCollectionWindow=theWindow;
                  *
                  * sendRequest('collect',theXVerb);
                  *
                  * getForm('hxpForm').selid.value=prevselid; getForm('hxpForm').target=prevTarget;
                  * getForm('hxpForm').verbo.value=verbo; getForm('hxpForm').xverb.value=xverb; return false; }
                  */

 function openCollections(theXVerb,theWin,theTarget)
  {
   if(typeof(theWin)=='undefined')theWin=this;
   //if(typeof(theTarget)=='undefined')theTarget='collections'+theXVerb;
   if(typeof(theTarget)=='undefined')theTarget='collections'+(typeof(theXVerb)=='undefined'?'':theXVerb);

   var verbo=getForm('hxpForm').verbo.value;
   var xverb=getForm('hxpForm').xverb.value;
   var prevTarget=getForm('hxpForm').target;
   var prevselid=getForm('hxpForm').selid.value;

   theXVerb=(typeof(theXVerb)=='undefined'||theXVerb=='')?
			 (/* getForm('hxpForm').cName.value==''?'':'open' */''):('@'+theXVerb);
   if(typeof(theTarget)=='undefined'||''==theTarget)theTarget=exEscape('collections'+theXVerb);
   //var nameWin='collections'+theXVerb;
   getForm('hxpForm').target=theTarget;

   var theWindow = theWin.window.open
				 ('',getForm('hxpForm').target,
				  theXVerb.length>0&&theXVerb.substring(0,1)!='@'?
				  //getForm('hxpForm').cName.value==''?
				  /*
                   * "width=540,height=130,resizable=no,scrollbars=no,modal=yes,alwaysRaised=yes":
                   * "width=640,height=460,resizable=no,scrollbars=no,modal=yes,alwaysRaised=yes"
                   */
				  "width=540,height=130,resizable=no,scrollbars=no":
				  "width=640,height=460,resizable=no,scrollbars=no"
				 );
   if(theTarget!='queryIFrameDevNull')
	theWindow.focus();

   //if(theXVerb=='')theWin.thePopupWindow=theWindow;
   //else theWin.theCollectionWindow=theWindow;

   sendRequest('collect',theXVerb);

   getForm('hxpForm').selid.value=prevselid;
   getForm('hxpForm').target=prevTarget;
   getForm('hxpForm').verbo.value=verbo;
   getForm('hxpForm').xverb.value=xverb;
   return false;
  }

 function submitOnEnter(event)
 {var key=document.layers?event.which:event.keyCode;
  if(key==13)
  {//if(!event.srcElement||event.srcElement.nodeName.toUpperCase()=='INPUT')
   var elem=event.target?event.target:event.srcElement;
   if(!elem||elem.nodeName.toUpperCase()=='INPUT'/* ||elem.nodeName.toUpperCase()=='TEXTAREA' */)
   {if(elem&&elem.onchange)elem.onchange(elem);
    event.cancelBubble = true;
    event.returnValue = false;
    if(event.stopPropagation)event.stopPropagation();
    if(event.preventDefault)event.preventDefault();
    if (typeof(customSubmitOnEnter)!='undefined')
    {customSubmitOnEnter();
     // window.focus(); // ?? why ??
     // window.setTimeout("customSubmitOnEnter()",100);
    }
    queryqas();
   }
  }
  return key;
 }
 /*
  * function submitOnEnter(event) {var key=document.layers?event.which:event.keyCode; if(key==13) {event.cancelBubble =
  * true; event.returnValue = false; if (typeof(customSubmitOnEnter) != 'undefined'){ window.focus();
  * window.setTimeout("customSubmitOnEnter()",100); } queryqas(); } return key; }
  */
 function exEscape(str)
 {var ret="";
  for(i=0;i<str.length;i++)
   ret+=str.charCodeAt(i).toString(16);
  return(ret);
 }

 /*
  * function collectionHandler(action,name,id,count,theWin) {var el=document.getElementById("activeCollection");
  * if(action=="open") { alert("collectionHandler open called"); if(el!=null)el.innerHTML=name+' ['+count+']'; else
  * alert("el == null!!!"); getForm('hxpForm').cId.value=id; getForm('hxpForm').cName.value=name;
  * getForm('hxpForm').cCount.value=count; this.window.focus(); } else if(action=="show") {getForm('hxpForm').cId.value=id;
  * getForm('hxpForm').cName.value=name; getForm('hxpForm').cCount.value=count; // svuota il parametro db confidando nella
  * impostazione di default applicativa var xDb=getForm('hxpForm').db.value; getForm('hxpForm').db.value='';
  * mostraSelezione(id,true,'Raccolta: '+ name); getForm('hxpForm').db.value=xDb; } else if(action=="close")
  * {if(el!=null)el.innerHTML=''; getForm('hxpForm').cId.value=''; getForm('hxpForm').cName.value='';
  * getForm('hxpForm').cCount.value=''; } else if(action=="addDoc") {var selid=getForm('hxpForm').selid.value; var
  * keylist=getForm('hxpForm').keylist.value; var xDb=getForm('hxpForm').db.value; getForm('hxpForm').selid.value=id;
  * getForm('hxpForm').keylist.value=count; getForm('hxpForm').db.value=theWin.getForm('hxpForm').db.value;
  * openCollections('addDoc',theWin); getForm('hxpForm').db.value=xDb; getForm('hxpForm').selid.value=selid;
  * getForm('hxpForm').keylist.value=keylist; } else if(action=="save") {openCollections('save',theWin); } else
  * if(action=="saveas") {getForm('hxpForm').cName.value=name; openCollections('saveas',theWin); } }
  */

 // funzione modificata per la gestione delle raccolte (XSpring)
 function collectionHandler(action,name,id,ispublic,count,theWin,theTarget)
  {var el = document.getElementById("activeCollection");

  	//debug
	//alert("query.collectionHandler(): action == " + action);

   if(action=="open")
   {if(el!=null)el.innerHTML=name+' ['+count+']';
	getForm('hxpForm').cId.value=id;
	getForm('hxpForm').cIsPublic.value=ispublic;
	getForm('hxpForm').cName.value=name;
	getForm('hxpForm').cCount.value=count;
	//this.window.focus():1
   }
   else if(action=="show")
   {
	var xCId;
	var xCIsPublic;
	var xCName;
	var xCCount;
	var xDb;

	// 2003.07.03: su richiesta di Annarita Laurenzi, '@show' non deve piu'
	// attivare la richiesta mostrata
	xCId=getForm('hxpForm').cId.value;
	xCIsPublic=getForm('hxpForm').cIsPublic.value;
	xCName=getForm('hxpForm').cName.value;
	xCCount=getForm('hxpForm').cCount.value;

	// svuota il parametro db confidando nella impostazione di default applicativa
	xDb=getForm('hxpForm').db.value;

	getForm('hxpForm').cId.value=id;
	getForm('hxpForm').cIsPublic.value=ispublic;
	getForm('hxpForm').cName.value=name;
	getForm('hxpForm').cCount.value=count;
	getForm('hxpForm').db.value='';

	mostraSelezione(id,true,'Raccolta: '+ name);

	// ripristiniamo i valori precedenti
	getForm('hxpForm').cId.value=xCId;
	getForm('hxpForm').cIsPublic.value=xCIsPublic;
	getForm('hxpForm').cName.value=xCName;
	getForm('hxpForm').cCount.value=xCCount;
	getForm('hxpForm').db.value=xDb;
   }
   else if(action=="close")
   {if(el!=null)el.innerHTML='';
	getForm('hxpForm').cIsPublic.value='';
	getForm('hxpForm').cId.value='';
	getForm('hxpForm').cName.value='';
	getForm('hxpForm').cCount.value='';
   }
   else if((action=="addDoc")||("openOnly"==action))
   {var selid=getForm('hxpForm').selid.value;
	var keylist=getForm('hxpForm').keylist.value;
	var xDb=getForm('hxpForm').db.value;
	getForm('hxpForm').selid.value=id;
	getForm('hxpForm').keylist.value=count;
	getForm('hxpForm').db.value=theWin.getForm('hxpForm').db.value;
// alert("selid["+getForm('hxpForm').selid.value+"]\n"+
//		 "keylist["+getForm('hxpForm').keylist.value+"]\n"+
//		 "db["+getForm('hxpForm').db.value+"]");
 /*
  * MSIE non rispetta il target quando trasforma alert("1:"+typeof(parent.frames["queryIFrameDevNull"]));
  * alert("2:"+action); if(typeof(parent.frames["queryIFrameDevNull"])=='undefined'||("openOnly"==action))
  * if(theTarget=="queryIFrameDevNull") {theWin=parent.frames["queryIFrameDevNull"]; theTarget=''; }
  */
	openCollections(("addDoc"==action?action:""),theWin,theTarget);
	getForm('hxpForm').db.value=xDb;
	getForm('hxpForm').selid.value=selid;
	getForm('hxpForm').keylist.value=keylist;
   }
   else if(action=="save")
   {openCollections('save',theWin);
   }
   else if(action=="saveas")
   {getForm('hxpForm').cName.value=name;
	openCollections('saveas',theWin);
   }
   else if( action == "disable" ) {
   			getForm('hxpForm').cName.value = '';
			getForm('hxpForm').cId.value = '';
			getForm('hxpForm').cIsPublic.value = ispublic;
			getForm('hxpForm').cCount.value = '';
	  	}
  }

 /* COPIA DELLA FUNCTION IN profile.js */
 function openPushConf(){
  var toUrl="../formatter/html/data/common/extra/profile/push_conf.html";
  thePushConfWindow=window.open(toUrl,"push_confWindow","width=380,height=540,resizable=no,scrollbars=no,modal=yes,alwaysRaised=yes");
  thePushConfWindowExist = true;
 }

 function undoerase(){
  if(typeof(customUndoErase)!='undefined')
   customUndoErase();
 }

 function doundoerase(e){
  if(e.ctrlKey)
   undoerase();
  else
   queryerase();
  return false;
 }

function resetQuery() {
    getForm('theForm').reset();
    getForm('hxpForm').reset();
    // ndrago@ndrago.it
    // alert(getForm('hxpForm').query.value);

    if ( getForm('theQLForm') != null ) {
        getForm('theQLForm').reset();
	}
}

function gotoTableQ(name,general){
	getForm('hxpForm').query.value = '';
	getForm('hxpForm').dbTable.value = '@' + name;

	if(general!='true')
	{
	getForm('hxpForm').selTable.value=getForm('hxpForm').dbTable.value;
	}
    else
    {
	getForm('hxpForm').selTable.value='*'+getForm('hxpForm').dbTable.value;
	}


	/*
	 * Federica 23/04/2007 [RW 0043771]: gestione delle funzionalit disponibili in strumenti
	 * di amministrazione
	 */
	if ( name == "adm_tools" ) {

		var listOfPropertiesAdmTools = "invioEmailNotifica:Si:Si";

		if (typeof(customSetPropertyStatus) != 'undefined') {
			listOfPropertiesAdmTools = customSetPropertyStatus(listOfPropertiesAdmTools);
		}

		if (typeof(customLoadPropertiesList) != 'undefined') {
			customLoadPropertiesList();
		}

		hxpS = new _hxpSession(getForm('hxpForm'));
		hxpS.setParameter("listOfPropertiesAdmTools", listOfPropertiesAdmTools);
	}

	if ( name == "collect" ) {
		/*
         * gestione delle raccolte (occorre cambiare verbo per avviare la classe relativa alle raccolte)
         */
		getForm('hxpForm').verbo.value = "collect";
		getForm('hxpForm').xverb.value = "@list";

        getForm('hxpForm').personalView.value = "";

		var oldTarget = getForm('hxpForm').target;

		// apro una nuova finestra per le raccolte di documenti
		var iForm = getForm('hxpForm');

		iForm.target = iForm.target + "raccolte";
		window.name = "mainMenu"; // necessario per riconoscere la finestra invocante
		theCollectionWindow = window.open(staticEmptyWindow,iForm.target,"width=600,height=500");
		iForm.submit();
		theCollectionWindow.focus();

		// ripristino il target affinch non si aprano sempre finestre di popup
		getForm('hxpForm').target = oldTarget;
	}
	else {
        var index;

        setGlobalFormRestore('dbTable', 'personalView');

        if ((index=name.indexOf("#personalView=")) != -1) {
            getForm('hxpForm').dbTable.value = '@' + name.substring(0, index);
            getForm('hxpForm').personalView.value = name.substring(index + 14);
        }

		/*
         * Modifica effettuata da Federico il 26/08/2004: se c' chiamo una funzione custom (richiesto da XSpring per la
         * gestione dei flap).
         */
		if ( typeof(customGotoTableQ) != 'undefined' ) {
			//  previsto che la funzione custom faccia il submit
			customGotoTableQ(name);
		}
		getForm('hxpForm').verbo.value = "query";
		getForm('hxpForm').submit();
	}

	return false;
}

function insTableDoc(name){
    setGlobalFormRestore('verbo', 'xverb', 'pos', 'physDoc', 'selid', 'dbTable');

	getForm('hxpForm').verbo.value="docEdit";
	getForm('hxpForm').xverb.value = "";
	//DD 28/7/5 HttpUnit valuterebbe questa chiave come 0.0 dando
	//   		problemi a Request.java
	//getForm('hxpForm').pos.value=0;
	//getForm('hxpForm').physDoc.value=0;
	getForm('hxpForm').pos.value="0";
	getForm('hxpForm').physDoc.value="0";

	getForm('hxpForm').selid.value="";

        if ((index = name.indexOf("#personalView=")) != -1) {
            getForm("hxpForm").dbTable.value = '@' + name.substring(0, index);
            getForm("hxpForm").personalView.value = name.substring(index + 14);
        }
        else
	getForm('hxpForm').dbTable.value='@'+name;


	/*
     * modifica di Federico del 16/08/2004: inserita l'apertura forzata di una sezione di un doc. di XSpring in una
     * funzione custom.
     */
	if ( typeof(customInsTableDoc) != 'undefined' ) {
		customInsTableDoc();
		return false;
	}

	getForm('hxpForm').submit();
	return false;
}

//utile per tornare alla pagina di ricerca archivio da quella specifica di tabella
function queryPage()
{
    setGlobalFormRestore('verbo', 'dbTable', 'query', 'selid');

    // ndrago 26/04/06
    // alert(getForm('hxpForm').verbo.value);
    // alert(getForm('hxpForm').xverb.value);
    // alert(getForm('hxpForm').selid.value);

    getForm('hxpForm').verbo.value='query';
    getForm('hxpForm').xverb.value='';
	getForm('hxpForm').dbTable.value='';
	getForm('hxpForm').query.value='';
	getForm('hxpForm').selid.value='';
	getForm('hxpForm').submit();
	return false;
}

function getAppearance(configuration)
{
	switch(configuration){
		case 'idx1': return "width=620,height=520,scrollbars=yes";
		case 'idxCustom': return customSetWindowFeature();
		case '' : default: return "width=620,height=520,scrollbars=yes"
	}
}


function paginaBrowse(numDoc,toggle,numRows)
{
	if ( typeof(toggle) != 'undefined' && toggle == true)
		getForm('hbfeeder').docToggle.value = numDoc;
	if ( typeof(numRows) != 'undefined' )
		getForm('hbfeeder').hierCount.value = numRows;
	getForm('hbfeeder').docStart.value = numDoc;
	getForm('hbfeeder').verbo.value = 'hierBrowser';
	getForm('hbfeeder').hierStatus.value = '';
	getForm('hbfeeder').submit();
	return false;
}


function importDocs()
{
        setGlobalFormRestore('verbo', 'xverb', 'rangeDocs');
        getForm('hxpForm').verbo.value = "importdocs_response";
        getForm('hxpForm').xverb.value = "";
        var ifile = document.getElementById("importFile");
        if ( ifile != null ) {
                if ( ifile.value == "" )
                        return false;

                getForm('hxpForm').appendChild(ifile);
        }
        else {
                return false;
        }

        /*
        * Estensione dell'import:  stato implementato un controllo che consente di
        * specificare se importare o meno gli allegati dei documenti da importare.
        * Tale funzionalit pu essere controllata tramite checkbox (interattivo)
        * oppure pu essere forzata tramite input text hidden (non interattivo)
        */
        var chkAttach = document.getElementById("chkImpAttach");
        if ( chkAttach != null ) {
                if (chkAttach.type == 'hidden') {
                        getForm('hxpForm').rangeDocs.value = chkAttach.value == 'true' ? "true" : "false";
                }
                else if (chkAttach.type == 'checkbox') {
                        getForm('hxpForm').rangeDocs.value = chkAttach.checked ? "true" : "false";
                }
                else {
                }
        }
        getForm('hxpForm').submit();
        return false;
}

function exportDocs()
{

	var theForm 		= getForm('theForm');
	var hxpForm 		= getForm('hxpForm');
	var i;
	var el;
	var bCheckRange 	= false;
	var iTypeExp		= -1;
	var bAttachments	= false;
	var sExport			= "";

    setGlobalFormRestore('verbo', 'xverb', 'rangeDocs');

	hxpForm.verbo.value = "Exportdocs_response"; // class name
	hxpForm.xverb.value = "";

	var typeSelected = false;
	for ( var i = 0; i < theForm.length; i++ )
		if ( theForm[i].name == 'typeSelection' && theForm[i].checked == true ) {
			typeSelected = true;
			break;
		}


	if ( typeSelected == false )
		return false;


	/*
     * SETS TUPLE
     *
     * name tuple: exclusionFields rangeDocs
     */

	// init
	var tuplaExclFields = hxpForm.exclusionFields;
	var tuplaInclFields = hxpForm.inclusionFields;

	tuplaExclFields.value 	= "";
	tuplaInclFields.value 	= "";
	hxpForm.rangeDocs.value = "";

	// loop form elements
	for(i=0; i < theForm.length; i++){
		el = theForm.elements[i];

		/** set flag attachments */
		if (el.name == "chkExpAttach" && el.checked == true){
			bAttachments = true;
		}

		/** set typeExport value */
		if (el.name == 'typeExport' && el.checked == true){ // type export radio button

			/*
             * from Export.java private static final int EXP_ALL = 0; private static final int EXP_WITH_INCLUSION = 1;
             * private static final int EXP_WITH_EXCLUSION = 2; private static final int EXP_ATTACHMENTS = 3;
             */

			if ( el.value == "radExpAll" ){
				iTypeExp = 0;
			}
			else if( el.value == "radExpExcl" ){
				iTypeExp = 2;
			}
			else if( el.value == "radExpIncl" ){
				iTypeExp = 1;
			}
		}

		/** set tupla exclusionFields ( xPath value | xPath value | ...) */
		if(el.name.substring(0,8) == 'chkExcl_' && el.checked == true){
			// set tupla
			tuplaExclFields.value =
									tuplaExclFields.value 	+
									el.value 				+
									"|";
			//DD 13/09/2005 RW:27962 - Richiedo l'esculsione di alcuni campi (EXP_WITH_EXCLUSION = 2);
			iTypeExp = 2;
		 }

		/** set tupla inclusionFields ( xPath value | xPath value | ...) */
		if(el.name.substring(0,8) == 'chkIncl_' && el.checked == true){
			// set tupla
			tuplaInclFields.value =
									tuplaInclFields.value 	+
									el.value 				+
									"|";
		 }

		if (bCheckRange == false){
			switch (el.value)
			{

				case "radSelection":
					if (el.checked == true){

						sExport 	= "radSelection";
						bCheckRange = true;
					}
					break;

				case "radRange":
					if (el.checked == true){

						sExport 	= "radRange";
						bCheckRange = true;
					}
					break;
			}// switch
		}
	}

	/** set tupla rangeDocs ( typeExp | selId | from | to | typeRange | Attachmnets ) */
	switch (sExport)
	{
		case "radSelection":
			// set tupla
			hxpForm.rangeDocs.value = 	iTypeExp 				+ "|" +
										hxpForm.selid.value 	+ "|" +
										"0" 					+ "|" +
										"0" 					+ "|" +
										"selection"				+ "|" +
										bAttachments;
			break;

		case "radRange":
			var j;
			var from 	= "";
			var to 		= "";

			// loop form elements
			for(j = 0; j < theForm.length; j++){
				el = theForm.elements[j];

				switch (el.name){
					case "rangenum_docnrecord_from":
						from = el.value;
						break;

					case "rangenum_docnrecord_to":
						to = el.value;
						break;
				}
			}
			// set tupla
			hxpForm.rangeDocs.value =	iTypeExp 				+ "|" +
										hxpForm.selid.value 	+ "|" +
										from 					+ "|" +
										to 						+ "|" +
										"range"					+ "|" +
										bAttachments;
			break;
	}

        /*
         * Gregorio 25/10/07 [RW 0047738]:
         * funzione specifica per valorizzazione input hidden "xslExportFilterName" (vedi "query.xsl")
         */
        if(typeof(customSetExclusionFile)!='undefined') {
                customSetExclusionFile();
        }

	getForm('hxpForm').submit();
	return false;
}

function importTH()
{
    setGlobalFormRestore('verbo', 'xverb');
    getForm('hxpForm').verbo.value = "Thimp_response";
    getForm('hxpForm').xverb.value = "";
    var ifile = document.getElementById("importFileTH");
    if ( ifile == null )
    {
        alert('(null) File non trovato.');
        return false;
    }
    if ( ifile.value == "" )
    {
        alert('(empty) File non trovato.');
        return false;
    }
    getForm('hxpForm').appendChild(ifile);
    getForm('hxpForm').submit();
    return false;
}

function exportTH()
{
    var params = "";
    var rights = "";
    var url = "";

    params += "?db=" + getForm("hxpForm").db.value;
    params += "&verbo=Thexp_response";
    params += "&host=" + getForm("hxpForm").host.value;
    params += "&port=" + getForm("hxpForm").port.value;
    params += "&login=" + getForm("hxpForm").login.value;
    if (getForm("hxpForm").transformJava.value == 'true') params += "&transformJava=true";
    if (getForm("hxpForm").enableIW.value.length > 0) params += "&enableIW=" + getForm("hxpForm").enableIW.value;
    if (typeof(getForm("hxpForm").language) != 'undefined') params += "&language=" + getForm("hxpForm").language.value;
    /*
    rights += "&userRights=" + realEscape(getForm("hxpForm").userRights.value);
    rights += "&specificAppCode=" + realEscape(getForm("hxpForm").specificAppCode.value);
    rights += "&specificDbCode=" + realEscape(getForm("hxpForm").specificDbCode.value);
    rights += "&showdocUOR=" + realEscape(getForm("hxpForm").showdocUOR.value);
    rights += "&doceditUOR=" + realEscape(getForm("hxpForm").doceditUOR.value);*/
    url = window.location + params + rights;
    var newWin = window.open(url, 'Export_thesausus', "toolbar=0,location=0,directories=0,status=0,menubar=0,scrollbars=1,resizable=0,copyhistory=0,left=200,top=200,width=400,height=300,screenX=200,screenY=200");
    return false;
}

function viewModeSame(rel, keypath, startkey, alias)
{
    setGlobalFormRestore('verbo', 'xverb', 'keypath', 'startKey', 'relation', 'xMode');

	getForm('hxpForm').verbo.value = "showthes";
	getForm('hxpForm').xverb.value = "@" + rel; //per template in cui sfociare
	getForm('hxpForm').keypath.value = keypath; //canale del ths
	getForm('hxpForm').startkey.value = startkey; //primo termine della relazione
	getForm('hxpForm').relation.value = rel; //relazione
	getForm('hxpForm').xMode.value = alias; //alias da utilizzare quando si arriva alla foglia

	getForm('hxpForm').submit();

	return false;
}

function viewModeNew(rel, keypath, startkey, alias)
{
	var iForm;
	var old_target = getForm('hxpForm').target;
	var old_verbo = getForm('hxpForm').verbo.value;
	var old_xverb = getForm('hxpForm').xverb.value;

	iForm = getForm('hxpForm');
	iForm.verbo.value = "showthes";
	iForm.xverb.value = "@" + rel; 		//per template in cui sfociare
	iForm.keypath.value = keypath;	 	//canale del ths
	iForm.startkey.value = startkey; 	//primo termine della relazione

	/*
     * Debug Fede: decommentare il codice seguente per debuggare il pulsante back del thesauro gerarchico (si veda anche
     * file query.xml di XSpring e query.xsl generico).
     */
	/*
     * iForm.cPath.value = "|50 RADICE"; iForm.thBackPage.value = "www.cultframe.com!|50 RADICE|INFOCITTA'.50.01 - IO
     * CITTADINO";
     */

	iForm.target = "thesWindow"; 	//iForm.target + 'lookup_titolario_child';

	/*
     * Modifica di Federico del 06/10/2004. Devo imporre l'uso delle scrollbars, se no Mozilla non le mostra mai nel
     * thesauro gerarchico.
     */
	theTitolarioLookupWindow = window.open(staticEmptyWindow, iForm.target, "width=800 height=600, scrollbars");

	iForm.submit();
	theTitolarioLookupWindow.focus();

	getForm('hxpForm').target = old_target;
	getForm('hxpForm').verbo.value = old_verbo;
	getForm('hxpForm').xverb.value = old_xverb;
	getForm('hxpForm').keypath.value = keypath; 	//canale del ths
	getForm('hxpForm').startkey.value = startkey; //primo termine della relazione
	getForm('hxpForm').relation.value = rel; 		//relazione

	return false;
}

// visualizza thesauro gerarchico
var thesDad = null;
var thesField = null;
var viewmode_use = 'SAME_WINDOW';
var thesTitle;

function showthesRel(inputNode, rel, keypath, startkey, alias, qext, viewmode, windowTitle)
{
	/*
     * Modifica di Federico del 21/12/2004: la tupla 'toDo' viene utilizzata per indicare alla classe generica
     * 'Showthes.java' di mostrare tutti i figli di un termine del th secondo una certa relazione, che hanno una
     * frequenza maggiore o uguale a quella indicata nella var. 'thMinFreq' (che deve essere definita a livello
     * specifico). Settare la tupla 'toDo' in questa funzione consente di navigare il thesauro, senza visualizzare i
     * termini con frequenze inferiori a 'thMinFreq'.
     */
  	if (typeof(thMinFreq) != 'undefined' && typeof(getForm('hxpForm').toDo) != 'undefined' &&
		thMinFreq != '') {
		getForm('hxpForm').toDo.value = "set_minFreq_for_TH_navigation:" + thMinFreq;
  	}

	thesTitle = 'Thesauro gerarchico';

	if ( typeof(windowTitle) != 'undefined' )
		thesTitle = windowTitle;

	if ( typeof(qext) != 'undefined' )
		getForm('hxpForm').qext.value = qext;

	if ( typeof(viewmode) != 'undefined' )
		viewmode_use = viewmode;

	if(viewmode_use == 'NEW_WINDOW'){
		// new window
		viewModeNew(rel, keypath, startkey, alias);

	}else{
		// same window
		viewModeSame(rel, keypath, startkey, alias);
	}

	thesDad = null;
	thesField = alias;

	return false;
}


// visualizza thesauro vincolato
function thVincolato(
					inputNode,
					numTitles4Page,
					field,
					radice,
					relazione,
					chiave,
					insRight,
					delRight,
					windowTitle)
{
	thesTitle = 'Thesauro vincolato';

	if ( typeof(windowTitle) != 'undefined' )
		thesTitle = windowTitle;

	var iForm, val;
	var old_target = getForm('hxpForm').target;
	var old_verbo = getForm('hxpForm').verbo.value;
	var old_xverb = getForm('hxpForm').xverb.value;
	var old_pageCount = getForm('hxpForm').pageCount.value;

	// gestione del posizionamento (mantenuto per compatibilit con il posizionamento nei vocabolari)
	var old_keypath = getForm('hxpForm').keypath.value;

	/*
     * "lookup_new" viene impiegato per gestire i diritti di inserimento e cancellazione nel thesaurus vincolato.
     */
	var old_lookup_new = getForm('hxpForm').lookup_new.value;

	// "view" viene impiegato per trasmettere il titolo del thesauro
	var old_view = getForm('hxpForm').view.value;
	getForm('hxpForm').view.value = thesTitle;

	if ( numTitles4Page == 'DEF' )
		numTitles4Page = 15;

	//no multistanza
	dad = null;
	val = getForm('theForm')[field].value;

	iForm = getForm('hxpForm');
	iForm.lookup_campi.value = radice + "|" + relazione + "|" + chiave + "|" + field;
	iForm.lookup_fieldVal.value = val;

	// in ricerca non ha senso inserire e/o cancellare termini nel thesaurus
	iForm.lookup_new.value = "disableAll";

	iForm.pageCount.value = numTitles4Page;
	iForm.verbo.value = "thesauro_response";

	/*
     * Uso dei checkbox nei thesauri vincolati.
     *
     * Modifica di Federico del 02/09/2004. L'uso dei chekbox nei thesauri vincolati in ricerca deve essere a
     * discrezione dell'applicazione e non nella parte generica.
     */

	/*
     * Modifica di Federico del 15/10/2004: al posto di dbTable ora viene utilizzata la tupla 'thVOptions' per usare i
     * checkbox al posto dei radio button nel thesauro vincolato (si veda anomalia 0022367). Il nome di tale tupla 
     * volutamente generico (cio non riferito all'uso dei checkbox) in modo che possa essere utilizzata per trasmettere
     * anche altre opzioni relative ai th vincolati (possibili usi futuri).
     */
	var old_thVOptions = getForm('hxpForm').thVOptions.value;

	if ( typeof(customUseChkBoxQueryDefault) != 'undefined'
			&& customUseChkBoxQueryDefault() == true ) {
		/*
         * Se esiste, chiamo una funzione custom per inizializzare la variabile thVOptions (l'applicazione potrebbe
         * volere i checkbox anche in ricerca).
         */

		 // thVOptions deve essere 'useChkBox' per attivare i checkbox al posto dei radio button
		 iForm.thVOptions.value = "useChkBox";
	}

	iForm.target = iForm.target + 'thvincolato_child';
	var windowFeature = "width=620, height=520, scrollbars"; // aggiunte le scrollbars

	if ( typeof(customSetWindowFeature) != 'undefined' )
		windowFeature = customSetWindowFeature();

	theIndexWindow=window.open(staticEmptyWindow, iForm.target, windowFeature);
	theIndexWindow.focus();

	// gestione del posizionamento (mantenuto per compatibilit con il posizionamento nei vocabolari)
	iForm.keypath.value = chiave;

	iForm.submit();
	getForm('hxpForm').target = old_target;
	getForm('hxpForm').verbo.value = old_verbo;
	getForm('hxpForm').xverb.value = old_xverb;
	getForm('hxpForm').pageCount.value = old_pageCount;
	getForm('hxpForm').view.value = old_view;
	getForm('hxpForm').lookup_new.value = old_lookup_new;
	getForm('hxpForm').thVOptions.value = old_thVOptions;
	getForm('hxpForm').keypath.value = old_keypath;

	return false;
}

function qbeToQl()
{
	makeBaseQuery();
	getForm('theForm').qlQuery.value = getForm('hxpForm').query.value;

	if ( typeof(customQbeToQl) != 'undefined' )
		customQbeToQl();

	return false;
}

function qlToQbe()
{
	getForm('hxpForm').query.value = "";

	if ( typeof(customQlToQbe) != 'undefined' )
		customQlToQbe();
	return false;
}

function queryplainWithPreviouslyBuiltPhrase()
{
    getForm('hxpForm').query.value = getForm('theForm').qlQuery.value;
	if ( getForm('hxpForm').query.value == '' )
		return false;
	setExtensionsAndOrd();
	if ( getForm('hxpForm').xverb.value != '@refine' ) svuotaSelezione();
	else getForm('hxpForm').xverb.value = "";
	OpenWaitMsg();
	return sendQuery('queryplain');
}

function setExtensionsAndOrd()
{
	/*
     * Federico 04/02/2005: chiamata a una eventuale funzione custom per l'impostazione delle estensioni
     *  e delle opzioni di ordinamento.
     */
    if (typeof(customSetExtensionsAndOrd) != 'undefined') {
        customSetExtensionsAndOrd();
        return;
    }

	var theForm = ( getForm('theOptsForm') != null )? getForm('theOptsForm') : getForm('theForm');

	//genere numero
	if ( typeof(theForm.xwOptGenere_Numero) != 'undefined' && theForm.xwOptGenere_Numero.checked )
		getForm('hxpForm').qopt.value = eval(getForm('hxpForm').qopt.value) + 2;

	//somiglianza
	if ( typeof(theForm.xwOptSomiglianza) != 'undefined' && theForm.xwOptSomiglianza.checked )
		getForm('hxpForm').qopt.value = eval(getForm('hxpForm').qopt.value) + 8;

	//estensione al ths
	if ( typeof(theForm.xwExtThs) != 'undefined' && theForm.xwExtThs.checked )
	getForm('hxpForm').qext.value = theForm.xwExtThs.value;

	//ordinamento e probabilistica
	if ( typeof(theForm.xwOrd) != 'undefined' && theForm.xwOrd.selectedIndex != -1 ) {
		var val = theForm.xwOrd.options[theForm.xwOrd.selectedIndex].value;
		if ( val == '*xwProb*' ) {
			getForm('hxpForm').qopt.value = eval(getForm('hxpForm').qopt.value) + 1;
			getForm('hxpForm').query.value += "[?REVSORT]";
		}
		else {
			getForm('hxpForm').qord.value = val;

            var fieldIdxName = 'qordIdx';
            if ( typeof(customFieldIdxName) != 'undefined')
                fieldIdxName = customFieldIdxName(fieldIdxName, getForm('hxpForm').dbTable.value);
            if (fieldIdxName.length > 0)
                getForm('hxpForm')[fieldIdxName].value = theForm.xwOrd.selectedIndex;
        }
	}

	//Federica 15/11/2006 test checkbox probabilistica (in alternativa a opzione select)
	if ( typeof(theForm.chkbox_Prob) != 'undefined' && theForm.chkbox_Prob.checked) {
		getForm('hxpForm').qopt.value = eval(getForm('hxpForm').qopt.value) + 1;
		getForm('hxpForm').query.value += "[?REVSORT]";
	}
}

function findAndPrint()
{
	var old_selid = getForm('hxpForm').selid.value;
	var old_view = getForm('hxpForm').view.value;

	if ( typeof(customPreFindAndPrint) != 'undefined' )
		customPreFindAndPrint();

	getForm('hxpForm').query.value = "";

	if ( getForm('hxpForm').selid.value == '' ) {
		makeBaseQuery();
		setExtensionsAndOrd();
	}

    if (!checkBeforeSendQuery(getForm('hxpForm').query.value))
        return;

	var old_verbo = getForm('hxpForm').verbo.value;
	var old_xverb = getForm('hxpForm').xverb.value;
	var old_target = getForm('hxpForm').target;
    var old_errorMsgHandType = getForm('hxpForm').errorMsgHandType.value;

	iForm = getForm('hxpForm');

	iForm.verbo.value = 'queryplain';
	iForm.xverb.value = '@print';
	iForm.target = "print";

    // Federico 05/12/06: in caso di messaggi di errore il pulsante 'indietro' deve chiudere la finestra [RW 0033834]
    iForm.errorMsgHandType.value = "CLOSE";

	var thePrintWindow = window.open(staticEmptyWindow, iForm.target);
	thePrintWindow.focus();

	//RW0047906 - Stampa repertori
	if ( typeof(customPostFindAndPrint) != 'undefined' )
		customPostFindAndPrint();

	iForm.submit();

	getForm('hxpForm').target = old_target;
	getForm('hxpForm').verbo.value = old_verbo;
	getForm('hxpForm').xverb.value = old_xverb;
	getForm('hxpForm').selid.value = old_selid;
	getForm('hxpForm').view.value = old_view;
    getForm('hxpForm').errorMsgHandType.value = old_errorMsgHandType;

	return false;
}

/*
 * Created on: 19/08/2004 by: Federico Grillini organization: 3D Informatica description: Funzione invocata ogni volta
 * che deve essere controllato il formato di una data (in ricerca). Il terzo parametro indica se devono essere accettati
 * degli intervalli di date nella forma {da|a}.
 */
function queryChkDate(theInput, verbose, acceptRange)
{
	var ret = true;
	lastChkResult = '';

	// salto il controllo se ho una stringa vuota o se ci sono date in or (uso del vocabolario)
	if ( theInput.value == '' || theInput.value.indexOf("or") != -1 ) {
		return true;
	}

	if ( typeof(acceptRange) != 'undefined' && acceptRange && theInput.value.indexOf("|") != -1 ) {
		// verifica di un intervallo di date
		var valDate = theInput.value;

		if ( valDate.charAt(0) == '{' ) {
			valDate = valDate.substring(1);
		}

		if ( valDate.charAt(valDate.length - 1) == '}' ) {
			valDate = valDate.substring(0,valDate.length - 1);
		}

		var tmpVal1;
		var tmpElem = theInput;

		tmpElem.value = valDate.substring(0, valDate.indexOf("|"));

		ret = chkDate(tmpElem, verbose);

		if ( ret ) {
			tmpVal1 = tmpElem.value;

			tmpElem.value = valDate.substring(valDate.indexOf("|") + 1);

			ret = chkDate(tmpElem, verbose);

			if ( ret ) {
				theInput.value = "{" + tmpVal1 + "|" + tmpElem.value + "}";
			}
			else {
				theInput.value = "{" + valDate + "}"; // errore: ripristino il vecchio valore
			}
		}
		else {
			theInput.value = "{" + valDate + "}"; // errore: ripristino il vecchio valore
		}
	}
	else {
		// verifica di una data singola
		if ( theInput.value.length == 8 &&
				eval(theInput.value.substring(4,6)) < 13 ) {

			// ho una data del tipo aaaammgg --> devo convertire in ggmmaaaa
			theInput.value = theInput.value.substring(6) + theInput.value.substring(4,6) + theInput.value.substring(0,4);
		}

		ret = chkDate(theInput, verbose);
	}

	if ( ret == false ) {
		// errore nel formato della/delle date
		setTimeout(function(){theInput.focus()}, 10);
		theInput.select();
		lastChkResult = theInput;

		return false;
	}

	return ret;
}


function showAccessInfo()
{
    if (getForm('hxpForm').pwdInfo.value.length > 0) {
        var v = getForm('hxpForm').pwdInfo.value.split("|");
        var lastDate = v[0];
        var lastDateMsg = "";
        if (lastDate.length > 0) {
            lastDate = lastDate.substring(6,8) + "/" + lastDate.substring(4,6) + '/' + lastDate.substring(0,4);
            var lastTime = v[1];
            lastDateMsg = "\n\nUltimo accesso: " + lastDate + " alle " + lastTime;
        }
        var pwdLeftTime = '';
        var pwdMsg = '';
        if (v.length > 2) {
            pwdLeftTime = v[2];
            var giorno = (pwdLeftTime==1)? " giorno" : " giorni";
            if (pwdLeftTime.length > 0)
            pwdMsg = "\n\nValidit password: " + pwdLeftTime + giorno;
        }
        var userInfo = getForm('hxpForm').userInfo.value;
        if (userInfo.lastIndexOf('[') != -1)
            userInfo = userInfo.substring(0,userInfo.lastIndexOf('['));
        alert("Benvenuto " + userInfo + lastDateMsg + pwdMsg);
    }
}

function showAccessPwdChange(){
    if (getForm('hxpForm').xverb.value != '@changePwd')
        alert("Password scaduta.\n\nPer entrare nel sistema  necessario cambiarla.");
}


function annulChangePwd()
{
    setGlobalFormRestore('xverb');

    if (getForm('hxpForm').xverb.value == '@changePwd')
        getForm('hxpForm').xverb.value = "@annulChangePwdCanEnter";
    else
        getForm('hxpForm').xverb.value = "@annulChangePwd";
    getForm('hxpForm').submit();
    return false;
}

function confirmChangePwd()
{
    setGlobalFormRestore('xverb', 'userRights', 'pwdChangeInfo');

    OpenWaitMsg();
    getForm('hxpForm').xverb.value = "@confirmChangePwd";
//    getForm('hxpForm').userRights.value = "";

    var hxpS = new _hxpSession(getForm('hxpForm'));
    hxpS.setParameter("forceLogin", "true");

    getForm('hxpForm').pwdChangeInfo.value = getForm('theForm').login.value + "_-" + getForm('theForm').pwd.value + "_-" + getForm('theForm').pwd1.value + "_-" + getForm('theForm').pwd2.value;
    getForm('hxpForm').submit();
    return false;
}

function goToChangePwd()
{
    setGlobalFormRestore('xverb');

    getForm('hxpForm').xverb.value = '@changePwd';
    getForm('hxpForm').submit();
    return false;
}

/*
 * Created on: 10/11/2004
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Funzione per il cambiamento della lingua corrente. Se la variabile "lang" corrisponde
 *              alla lingua corrente, non viene effettuata alcuna operazione. Negli altri casi, invece,
 *              viene impostata la nuova lingua nella tupla "language" di hxpForm e viene effettuato un
 *              submit per cambiare la lingua.
 */
function changeLanguage(lang)
{
    setGlobalFormRestore('verbo', 'xverb', 'dbTable', 'language');

	if (typeof(lang) != 'undefined' && getForm('hxpForm').language.value != lang) {
		getForm('hxpForm').language.value = lang;

		/*
         * Modifica di Federico del 12/11/2004: occorre reimpostare i seguenti parametri poich, aprendo, per esempio,
         * la finestra delle raccolte, in essi rimangono dei valori errati che provocano comportamenti anomali nel
         * refresh della pagina.
         */
		getForm('hxpForm').verbo.value = "query";
		getForm('hxpForm').xverb.value = "";
		getForm('hxpForm').dbTable.value = "";

		getForm('hxpForm').submit();
	}

	return false;
}
/*
	DD 22/01/06 Fa check(val=true)/uncheck(val=false) del checkbox dal nome passato.
*/
function simpleCheckboxSet(checkboxname, val){
	chkb = getInputByNameAndType(checkboxname, "checkbox")
	if(chkb != null) chkb.checked = val;
}

/*
 * Created on: 13/03/06
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Funzione che consente di attivare o meno le email di notifica dagli strumenti di
 *              amministrazione [RW 0035037].
 */
function changeSendMailStatus(propVal)
{
    // Federico 20/10/07: fix: per abilitare/disabilitare le email occorre invocare 'changePropertyValue' [RW 0047701]
    return changePropertyValue("invioEmailNotifica", propVal);
}

/**
 * Created on: 		23/04/07
 * by: 				Federica Cossu
 * organization: 	3D Informatica
 * description: 	Funzione che consente di modificare la property indicata col valore dato [RW 0043771].
 */
function changePropertyValue(propName, propVal)
{
    if ((typeof(propName) != 'undefined' && propName != null && propName.length > 0) &&
    	(typeof(propVal) != 'undefined' && propVal != null && propVal.length > 0)) {
        setGlobalFormRestore('verbo', 'xverb', 'dbTable');

        getForm('hxpForm').verbo.value = "query";
        getForm('hxpForm').xverb.value = "@setPropertyValue:" + propName + ":" + propVal;

        getForm('hxpForm').dbTable.value = "@adm_tools";
        getForm('hxpForm').submit();
    }

    return false;
}

 /**
  * Apre il dialogo 'Ricerche frequenti'
  */
 function openQList(theEvent, theQuery)
 {var f=getForm('hxpForm');
  var prevTarget=f.target;
  var prevQuery=f.query.value;
  var theSendQuery;
  var selidId;
  var dbId;
  selidId=f.selid.value;
  dbId=f.sele.value.replace(RegExp("^.*\\,(\\w*)\\s"+f.db.value+"\\;.*$"),"$1");
  theSendQuery=(dbId==selidId?"":theSavedLastQuery);
  if((typeof(theEvent)!='undefined')&&
     (typeof(theEvent.shiftKey)!='undefined')&&
     (theEvent.shiftKey==true)){
   theSendQuery="";
  }
  if(f.db.value.indexOf(',')>=0)
  {alert(jres['susa']);
   return false;
  }
  var nameWin='qListDialog';
  f.query.value=theSendQuery;
  f.target=exEscape(nameWin);
  var theWindow = window.open('',f.target,
                              //"width=540,height=130,resizable=no,scrollbars=no"
                              "width=640,height=360,resizable=no,scrollbars=no"
                             );
  sendRequest('appData','');
  f.target=prevTarget;
  f.query.value=prevQuery;
  return false;
 }
