/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

 /* spotEdit.js */

 function getSpotEditSessionForm()
 {if(getForm('hxpForm')!=null)
   return getForm('hxpForm');
  if(typeof(document.sessione)!='undefined')
   return document.sessione;
  alert('unable to find form object!');
  return null;
 }
 function impostaVerbo(verbo,xverb,nextverb,nextxverb)
 {if(typeof(customShowDoc)=='undefined'||!customShowDoc(getSpotEditSessionForm().db.value,verbo,xverb,nextverb,nextxverb))
  {getSpotEditSessionForm().verbo.value=verbo;
   getSpotEditSessionForm().xverb.value=xverb;
   getSpotEditSessionForm().nextVerb.value =typeof(nextverb )!='undefined'?nextverb :'';
   getSpotEditSessionForm().nextXVerb.value=typeof(nextxverb)!='undefined'?nextxverb:'';
  }
 }
 function setRevSel()//se le coordinate di selezione sono rovesciate
 {if(getSpotEditSessionForm().revSel.value==''&&
     getSpotEditSessionForm().selid.value!=''&&
     getSpotEditSessionForm().selid.value!=getSpotEditSessionForm().cId.value)
   getSpotEditSessionForm().revSel.value='1';
 }
 function isSele()
 {return(getSpotEditSessionForm().xverb.value.indexOf('@sel')>0);
 }
 function isSpotSele()
 {return(getSpotEditSessionForm().xverb.value.indexOf('spot@sel')>0);
 }
 function saveDocument()
 {impostaVerbo(getSpotEditSessionForm().verbo.value,'@update',
               isSele()?(isSpotSele()?'':getSpotEditSessionForm().verbo.value):'showdoc',
               isSele()?(isSpotSele()?'':getSpotEditSessionForm().xverb.value):'@child');
  setRevSel();
  if(getSpotEditSessionForm().pne.value=='')
   getSpotEditSessionForm().pne.value=getSpotEditSessionForm().db.value;
  if(getSpotEditSessionForm().pnce.value=='')
   getSpotEditSessionForm().pnce.value='listof_'+getSpotEditSessionForm().pne.value;
  getSpotEditSessionForm().submit();
  return false;
 }
 function unlockDocument()
 {if(getSpotEditSessionForm().pos.value!=''&&
     (getSpotEditSessionForm().pos.value!='0'||
      getSpotEditSessionForm().selid.value!=''))
  {impostaVerbo(getSpotEditSessionForm().verbo.value,'@unlock','showdoc','@child');
   setRevSel();
   getSpotEditSessionForm().submit();
  }
  else if(typeof(opener)!='undefined')
  {opener.focus();
   self.close();
  }
  return false;
 }
 function nextDocument()//abbandona e passa al successivo
 {if(getSpotEditSessionForm().pos.value!=''&&
     (getSpotEditSessionForm().pos.value!='0'||
      getSpotEditSessionForm().selid.value!='')/*&&
     getSpotEditSessionForm().xverb.value.indexOf('@sel')>0*/)
  {impostaVerbo(getSpotEditSessionForm().verbo.value,'@unlock@sel','docEdit','spot@sel');
   setRevSel();
   getSpotEditSessionForm().submit();
  }
  return false;
 }
 function findChildInput(theNode,theName)//torna il nodo input descendant or self di theNode con nome theName
 {var inputList=theNode.getElementsByTagName("input");
  for (var i=0; i<inputList.length; i++){
   if(inputList.item(i).getAttribute("name")==theName){
    return inputList.item(i);
   }
  }
  var textareaList=theNode.getElementsByTagName("textarea");
  for (var i=0; i<textareaList.length; i++){
   if(textareaList.item(i).getAttribute("name")==theName){
    return textareaList.item(i);
   }
  }  
  return null;
 }
 var theChangedDataContent=new Array();
 var theChangedDataPosition=new Array();
 var theChangedDataKey=new Array();
 function changeText(elem,allowinsert)
 {var addDict=false;
  if(!allowinsert||!(addDict=confirm("Confermare per l'inserimento in dizionario o annullare per la correzione del termine")))
  {result=prompt(elem.id,elem.innerHTML);
   if(result==null)return;
   elem.innerHTML=result;
  }
  /*
  if(typeof(theChangedDataPosition[elem.id])=='undefined')
  {theChangedDataPosition[elem.id]=theChangedDataContent.length;
   var nextIndex=theChangedDataContent.length;
   theChangedDataContent[nextIndex]=result;
   theChangedDataKey[nextIndex]=elem.id;
  }
  else theChangedDataContent[theChangedDataPosition[elem.id]]=result;
  //for(var i=0;i<theChangedDataContent.length;i++)
  // alert(theChangedDataKey[i]+' => '+theChangedDataContent[i]);
  */
  /* MSIE 6 si rifiuta */
  var theInput=findChildInput(getSpotEditSessionForm(),elem.id);
  if(theInput==null)
  //if(typeof(getSpotEditSessionForm()[elem.id])=='undefined')
  {var theInput=document.createElement("input");
   theInput.setAttribute("type","hidden");
   theInput.setAttribute("name",elem.id);
   getSpotEditSessionForm().appendChild(theInput);
  }
  theInput.value = elem.innerHTML;
  //getSpotEditSessionForm()[elem.id].value=elem.innerHTML;
  var dictInputName="dictNodeList";
  theInput=findChildInput(getSpotEditSessionForm(),dictInputName);
  if(theInput==null)
  {var theInput=document.createElement("input");
   theInput.setAttribute("type","hidden");
   theInput.setAttribute("name",dictInputName);
   theInput.setAttribute("value","");
   getSpotEditSessionForm().appendChild(theInput);
  }
  var theList=theInput.getAttribute("value");
  var pos=0;
  for(;;)
  {pos=theList.indexOf(elem.id);
   if(pos<0)break;
   if((pos=0&&(theList.length==elem.id.length||theList.charAt(elem.id.length)==','))||
      (pos>0&&theList.charAt(pos-1)==','&&(theList.length==pos+elem.id.length||theList.charAt(pos+elem.id.length)==',')))
    break;
  }
  if(pos<0)
  {if(addDict)
   {if(theList!='')
     theList+=',';
    theList+=elem.id;
   }
  }
  else if(!addDict)
   theList=theList.substring(0,pos)+theList.substring(pos+elem.id.length);
  theInput.value = theList;
  if(elem.className=='changeerror')
   elem.className=addDict?'confirmederror':'changederror';
  else
  if(elem.className=='changetext')
   elem.className='changedtext';
 }
 function loadHandler()
 {
 }
 function unloadHandler()
 {
 }
