/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

 /* titles.js */

 //nome della finestra statica (vuota) che viene aperta quando c' un popup in modo che venga mantenuto il protocollo
 //corrente (http o https)
 var staticEmptyWindow = "./../formatter/html/templates/static.html";

 /* funzioni per la pagina di titoli */
 
 var thePopupWindow=null;
 var theCollectionWindow=null;
 var oldFocusHandler=window.onfocus;
 window.onfocus=focusHandler;

 function sendRequestT()
 {if(getForm('hxpForm').verbo.value=='showtitles')
  {//compila il parametro per l'ordinamento manuale
   var param='';
   var startIndex=parseInt(getForm('hxpForm').pos.value);
   for(var index=0;index<titlePos.length;index++)
    if(titlePos[index]!=index)
    {if(param.length)param+=';';
     param+=''+(index+startIndex)+','+(titlePos[index]+startIndex);
    }
   /*
   if(param.length>0)
    getForm('hxpForm').keylist.value='@'+param+'@'+getForm('hxpForm').keylist.value;
   */
  }
  getForm('hxpForm').submit();
 }
 function nuovaRicerca()
 {if(getForm('hxpForm').xverb.value.indexOf('child')>=0)
  {if(typeof(opener)!='undefined'&&opener!=null&&typeof(opener.document)!='unknown')
   {if(typeof(opener.theDocWindow)!='undefined')opener.theDocWindow=null;
    if(typeof(opener.thetitleWindow)!='undefined')opener.theTitleWindow=null;
    opener.focus();
   }
   self.close();
  }
  else
  {
   setGlobalFormRestore('verbo','xverb','dbTable','query','selid','personalView');
   getForm('hxpForm').verbo.value='query';
   getForm('hxpForm').dbTable.value='';
   getForm('hxpForm').personalView.value='';
   getForm('hxpForm').query.value='';
   getForm('hxpForm').xverb.value='';
	getForm('hxpForm').selid.value='';
   sendRequestT();
  }
  return false;
 }
 // posizioneAttuale  un indice in base zero
 function primaPagina(posizioneAttuale){
  if(posizioneAttuale>0){
   setGlobalFormRestore('verbo','pos');
   getForm('hxpForm').verbo.value='showtitles';
   getForm('hxpForm').pos.value=0;
   sendRequestT();
  }
  return false;
 }
 function paginaPrecedente(posizioneAttuale,perPagina){
  if(posizioneAttuale>0){
   setGlobalFormRestore('verbo','pos');
   getForm('hxpForm').verbo.value='showtitles';
   getForm('hxpForm').pos.value=(posizioneAttuale-perPagina<0)?0:posizioneAttuale-perPagina;
   sendRequestT();
  }
  return false;
 }
 function paginaSuccessiva(posizioneAttuale,perPagina,totaleSelezionati){
  if(totaleSelezionati>posizioneAttuale+perPagina){
   setGlobalFormRestore('verbo','pos');
   getForm('hxpForm').verbo.value='showtitles';
   getForm('hxpForm').pos.value=posizioneAttuale+perPagina;
   sendRequestT();
  }
  return false;
 }
 function ultimaPagina(posizioneAttuale,perPagina,totaleSelezionati){
  if(totaleSelezionati>posizioneAttuale+perPagina){
   setGlobalFormRestore('verbo','pos');
   getForm('hxpForm').verbo.value='showtitles';
   getForm('hxpForm').pos.value=Math.floor((totaleSelezionati-1)/perPagina)*perPagina;
   sendRequestT();
  }
  return false;
 }

 // <!-- Gregorio_Aggiunta -->
 function ricaricaPaginaCorrente(posizioneAttuale){
  setGlobalFormRestore('verbo','pos');
  getForm('hxpForm').verbo.value='showtitles';
  getForm('hxpForm').pos.value=posizioneAttuale;
  sendRequestT();
  return false;
 }

function gotoPagina(posizioneAttuale, perPagina, totaleSelezionati) {
	var numeroPaginaTitoliCorrente = (posizioneAttuale/perPagina)+1;
	var numeroPaginaTitoliRichiesta = 0;
	if(typeof(customGotoPagina) != 'undefined') {
		numeroPaginaTitoliRichiesta = customGotoPagina(posizioneAttuale, perPagina, totaleSelezionati); 
	}
	else {
		numeroPaginaTitoliRichiesta = prompt('Inserire un numero compreso tra 1 e ' + Math.ceil(totaleSelezionati/perPagina) + '', Math.ceil(totaleSelezionati/perPagina)); 
	}
	// Analisi della risposta immessa dall'utente
	if (numeroPaginaTitoliRichiesta == null)   {
		return false;
	}
	else if (numeroPaginaTitoliRichiesta.split(' ').join('') == '')   {
		return false;
	}
	else   {
		var numeroPaginaTitoliRichiestaSenzaSpazi = numeroPaginaTitoliRichiesta.split(' ').join('');
		for (var i = 0; i < numeroPaginaTitoliRichiestaSenzaSpazi.length; i++) {
			if ('0123456789'.indexOf(numeroPaginaTitoliRichiestaSenzaSpazi.charAt(i)) == -1) {
				alert('Quanto immesso nel dialogo non\rsembra essere un numero valido.');
				return false;
			}
		}
		if (parseInt(numeroPaginaTitoliRichiestaSenzaSpazi, 10) > 0 && parseInt(numeroPaginaTitoliRichiestaSenzaSpazi, 10) < (Math.ceil(totaleSelezionati/perPagina) + 1)) { 
			if ( numeroPaginaTitoliCorrente != parseInt(numeroPaginaTitoliRichiestaSenzaSpazi, 10) ){
                setGlobalFormRestore('verbo','pos');
				getForm('hxpForm').verbo.value = 'showtitles';
				getForm('hxpForm').pos.value = (parseInt(numeroPaginaTitoliRichiestaSenzaSpazi, 10)*parseInt(perPagina, 10))-(parseInt(perPagina, 10));
				sendRequestT();
			}
		}
		else {
			alert('Il numero immesso nel dialogo\rnon rientra nell\'intervallo valido.');
			return false;
		}
	}
	return false;
}

 
function mostraDocumento(posizione, tipo, asText, xdoc){
    return mostraDocumento(posizione, tipo, asText, xdoc, null);
}

//mbussetti, 20/09/2005: aggiunta gestione del campo 'dbTable'
function mostraDocumento(posizione, tipo, asText, xdoc, dbTable) {

  var originalXverb = getForm('hxpForm').xverb.value;
  
  if (tipo == 'xcrossway') {
      var iForm = getForm('hxpForm');
      var old_verbo = iForm.verbo.value;
      var old_pos = iForm.pos.value;
      var old_db = iForm.db.value;
      var old_xverb = iForm.xverb.value;
      var old_xDoc = iForm.xDoc.value;
      var old_target = iForm.target;
      
      var old_dbTable = null;
      if (null != dbTable) old_dbTable = iForm.dbTable;
      
      iForm.target = getForm('hxpForm').target + "_document";
      var newWindow = window.open(staticEmptyWindow, iForm.target, "");      
  }
  else {
      if (null != dbTable)
          setGlobalFormRestore('verbo','xverb','pos','db','xDoc','dbTable');
      else
          setGlobalFormRestore('verbo','xverb','pos','db','xDoc');
  }
    
  if(typeof(tipo)=='undefined' || typeof(customShowDocTitles)=='undefined' || !customShowDocTitles(tipo,'showdoc',getForm('hxpForm').xverb.value))
      getForm('hxpForm').verbo.value='showdoc';
 
  getForm('hxpForm').pos.value=posizione;
  getForm('hxpForm').db.value=tipo;
  
  if (null != dbTable)
      getForm('hxpForm').dbTable.value = dbTable;
  
  var asTextCmd='@asText';
  if(asText==1) {
      if(getForm('hxpForm').xverb.value.indexOf(asTextCmd)<0)
	      getForm('hxpForm').xverb.value+=asTextCmd;
  }
  else getForm('hxpForm').xverb.value=getForm('hxpForm').xverb.value.replace(asTextCmd,'');
  
  if(typeof(xdoc)!='undefined')
      getForm('hxpForm').xDoc.value=xdoc;
  
  //DD 18/04/2006 se Gerarchia Fascicoli  attiva apro i link ai documenti in una pagina nuova (RW: 0006138)
  var oldTarget_gerarchiaFasc = null;
  var newWindow = null;
  if(typeof(getForm('hxpForm').fascicoli_MostraGerarchia)!='undefined' 
      && getForm('hxpForm').fascicoli_MostraGerarchia.value=='true'
      && originalXverb != '@fascicolo') {
     oldTarget_gerarchiaFasc = getForm('hxpForm').target;
     getForm('hxpForm').target = "win_document";
     newWindow = window.open(staticEmptyWindow, getForm('hxpForm').target, "");     
     newWindow.focus();
     if(typeof(newWindow.OpenWaitMsg) == 'function') newWindow.OpenWaitMsg();
  }

  sendRequestT();
 
  //DD 18/04/2006 Ripristino il vecchio target e le altre informazioni(RW: 0006138) 
  if(oldTarget_gerarchiaFasc != null){
      getForm('hxpForm').target=oldTarget_gerarchiaFasc;
      restoreTuple();
  }
   
  if (tipo == 'xcrossway') {
      newWindow.focus();
      iForm.verbo.value = old_verbo;
      iForm.pos.value = old_pos;
      iForm.db.value = old_db;
      iForm.xverb.value = old_xverb;
      iForm.xDoc.value = old_xDoc;     
      iForm.target = old_target;
      if (null != old_dbTable) iForm.dbTable.value = old_dbTable;
  }

  return false;
}

 var titlePos=new Array();
 
 function loadHandler()
 {
 	//Federica 15/11/2006 pulizia di qopt
 	getForm('hxpForm').qopt.value = "0";
 	
 	//DD 29/01/06 Valorizza tutti gli attributi title delle immagini 
   setAllImgTitlesFromAlt();
     
    restoreTuple();
 	if ( typeof(top) != 'undefined' && typeof(top.alertRaised) != 'undefined' )
 		if ( top.alertRaised == false && getForm('hxpForm').view.value.indexOf("verificaDuplicati") != -1 ) {
 			alert("Rilevata presenza di documenti in arrivo con gli stessi estremi");
 			top.alertRaised = true;
 		}
 	
 	self.focus(); //porta in primo piano la pagina (utile nel caso in cui esista gi)

    //simone 16 Set 2004
   //carico ultimo ordinamento selezionato nella tendina
   var fieldIdxName = 'qordIdx';
   if ( typeof(customFieldIdxName) != 'undefined')
       fieldIdxName = customFieldIdxName(fieldIdxName, getForm('hxpForm').dbTable.value);

   if (fieldIdxName.length > 0 && typeof(getForm('theForm').xwOrd) != 'undefined' && getForm('hxpForm')[fieldIdxName].value.length > 0) {
       getForm('theForm').xwOrd[getForm('hxpForm')[fieldIdxName].value].selected = true;
   }
   
	filelistLoadHandler();
 	
 	//inizializzazione array posizioni;
  for(var index=0;index<parseInt(getForm('hxpForm').pageCount.value,10);index++)
   if(document.getElementById('title_'+(index+parseInt(getForm('hxpForm').pos.value,10)+1)))
    titlePos[index]=index;
  if(getForm('hxpForm').xverb.value=='@remove@child')
  {//richiesta di cancellazione titoli
   getForm('hxpForm').xverb.value='child';
   //aggiornamento descrizione albero
   if(opener && opener.document)
   var el=opener.document.getElementById('selCounter_'+getForm('hxpForm').selid.value);
   if(el)
   {var count=el.innerHTML;
    var pos=count.indexOf('-');
    if(pos>0)count=count.substring(0,pos);
    el.innerHTML=count+'-'+(parseInt(count)-parseInt(getForm('hxpForm').count.value));
   }
  }

  // <!-- Gregorio_Aggiunta -->
  if (getForm('theForm')['titleautochecked']) {
        // se  presente un input con nome titleautochecked non viene effettuata
        // la spuntatura via javascript dei checkbox 
  }
  else {
          // vengono selezionate le option della select impostate prima del caricamento
          checkList(getForm('theForm'),getForm('hxpForm').keylist.value);
  }

  titleString = getForm('hxpForm').ripropz.value;
  if (titleString != ""){               //Non titolo di default
   elVect = titleString.split('#|#');
   elVect[0] = elVect[0].slice(1,-3);
   selectVect = elVect[0].split(','); //vect delle option da selezionare nella select
   
   if (typeof(getForm('theForm').select_ripropz) != 'undefined'){ //pagina di stampa non contiene select
    getForm('theForm').select_ripropz.options[0].selected = false;
    for (i in selectVect)
     getForm('theForm').select_ripropz.options[selectVect[i]].selected = true;
   }
  }
  if(typeof(getForm('theForm').ord_channel)!='undefined'){ //pagina di stampa non contiene select e checkbox per ordinamento titolo
   //getForm('hxpForm').xverb.value="";  //per evitare il sort se si scorrono  le pagine dei titoli  	 
   if(getForm('hxpForm').xverb.value=='@sort')
    getForm('hxpForm').xverb.value='child';
   var i;
   var theList = getForm('theForm').ord_channel;
   var arch = getForm('hxpForm').db.value; 	
   var valore = getForm('hxpForm').qord.value;
   
   if (valore=="")
    theList.options[0].selected = true;
   else if (valore=="*"){
    getForm('theForm').ord_asc.checked = true;
    theList.options[0].selected = true;
   }
   else{
    //reimposto il valore del checkbox
    
    if (valore.substr(0,3)=='xml')
     getForm('theForm').ord_asc.checked = true;

    valore = valore.replace(/XML\(/ig, 'XML('); //altrimenti potrebbe non matchare
        
    //reimposto il valore della select
    for (i=0;i<theList.options.length;i++){
     current = theList.options[i];
     if (current.value == valore)
      current.selected=true;   
    }
   }
     
  }
  
  // 31/03/2005 Gregorio:
  // la presenza persistente di @sort in xverb (a seguito di un ordinamento
  // precedentemente effettuato) causa una nuova richiesta di ordinamento
  // ogni qual volta si utilizza lo scorrimento delle pagine dei titoli,  
  // ordinamento assolutamente inutile in quanto la selezione  gi ordinata
  if(getForm('hxpForm').xverb.value=='@sort') {
	getForm('hxpForm').xverb.value='';
  }
  
  if(typeof(customLoadHandler)!='undefined')
   customLoadHandler();

  // see titles.xsl
  var el=document.getElementById('titnavbarcode');
  if(el)
  {el.innerHTML=eval(el.innerHTML);
   el.style.display='';
  }
  // barra di navigazione titoli con numeri
  el=document.getElementById('numtitnavbarcode');
  if(el)
  {el.innerHTML=eval(el.innerHTML);
   el.style.display='';
  }
 }
 
 function unloadHandler(){
  if ( thePopupWindow != null ) 
  	thePopupWindow.close();
  	
  if ( theCollectionWindow != null )
  	theCollectionWindow.close();
 }
 
 function focusHandler()
 {//if(theCollectionWindow!=null)theCollectionWindow.close();
  //theCollectionWindow=null;
  
  if ( thePopupWindow != null ) {
  	thePopupWindow.close();
  	thePopupWindow = null;
  }
 } 
 
 function elSwap(el1,el2)
 {var html1=el1.innerHTML;
  el1.innerHTML=el2.innerHTML;
  el2.innerHTML=html1;
 }
 function arSwap(ar,i1,i2)
 {var e1=ar[i1];
  ar[i1]=ar[i2];
  ar[i2]=e1;
 }
 function spostaIndietro(indiceRichiesto,  // base 0 la posizione originale nella selezione
                         indicePagina,     // base 0 la posizione originale nella selezione del primo elemento nella pagina
                         totaleSelezionati)// totale nella selezione
 {if(titlePos.length&&indiceRichiesto>indicePagina)
  {var indiceArray=indiceRichiesto-indicePagina;
   arSwap(titlePos,indiceArray,indiceArray-1);
   elSwap(document.getElementById('title_'+(indiceRichiesto+1)),
          document.getElementById('title_'+(indiceRichiesto+1-1)));
  }
  return false;
 }
 function spostaAvanti(indiceRichiesto,  // base 0 la posizione nella selezione
                       indicePagina,     // base 0 la posizione del primo elemento nella pagina
                       totaleSelezionati)// totale nella selezione
 {if(titlePos.length&&indiceRichiesto<indicePagina+titlePos.length-1)
  {var indiceArray=indiceRichiesto-indicePagina;
   arSwap(titlePos,indiceArray,indiceArray-1);
   elSwap(document.getElementById('title_'+(indiceRichiesto+1)),
          document.getElementById('title_'+(indiceRichiesto+1+1)));
  }
  return false;
 }
 function deselect(posizioneAttuale,totaleSelezionati)//deselezione di documenti
 {//implementazione di test: modifica la selezione e torna
  if(getForm('hxpForm').keylist.value=='')
  {alert('Nessun titolo selezionato!');
   return false;
  }
  setGlobalFormRestore('verbo','xverb','keylist','pos');
  
  var theList=curly2Comma(getForm('hxpForm').keylist.value);
  getForm('hxpForm').verbo.value='showtitles';
  getForm('hxpForm').xverb.value='@remove@child';
  getForm('hxpForm').keylist.value=theList;
  getForm('hxpForm').pos.value=posizioneAttuale;
  sendRequestT();
  return false;

//  alert("IMPLEMENTARE FUNZIONE deselect() in titles.js");
//DECIDERE COME FARE LA GESTIONE

 /* if(getForm('hxpForm').xverb.value.indexOf('child')>=0){
  	if(typeof(opener)!='undefined'){
  	 if(typeof(opener.theDocWindow)!='undefined')opener.theDocWindow=null;
    if(typeof(opener.thetitleWindow)!='undefined')opener.theTitleWindow=null;
    opener.focus();
   }
   self.close();
  }*/
 }
 function riprOpzionali(theButton, event, posizioneAttuale){     //riproduzioni opzionali (parti di documento)
  var arch = getForm('hxpForm').db.value; 	
  var theList = getForm('theForm').select_ripropz;
  var titleString="";
  var indexString='"';
  var i;
  var atLeastOne = false;
  if (theList.options[0].selected == false){        //se non e' stato selezionato default
   for (i=1;i<theList.options.length;i++){
    current = theList.options[i];
    if (current.selected == true){
     atLeastOne = true;
     indexString += i +','; 
     selVect = current.value.split('|');
     for (index in selVect){
     	el2Vect = selVect[index].split(';');    //isolo nome campo
      elVect = el2Vect[0].split(',');         //isolo classe
      if (typeof(elVect[1]) == 'undefined')   //nessuna classe per il campo
       elVect[1] = "";
      if (typeof(el2Vect[1]) == 'undefined')  //nessun nome per il campo
       nomeCampo = "";
      else
       nomeCampo = ' "#' + el2Vect[1] + '"';
       //archivi che riferiscono a dtd-nir non richiedono nome archivio nella stringa per rich. titolo
      if (isNormativo(arch) ==  true)
       titleString += '"|'+ elVect[1] + '|" ' + 'XML,/' + elVect[0]+ nomeCampo  + ' ';
      else{
       if ((arch == 'snciv') || (arch == 'snpen'))
        arch = 'snintegrale';
       titleString += '"|'+ elVect[1] + '|" ' + 'XML,/' + arch + '/' + elVect[0]+ nomeCampo  + ' ';
      }
     }
     titleString += ' "#|#" ';
    }
   }
  }
  else{ //titolo di default
   setGlobalFormRestore('verbo','pos','ripropz');
   
   getForm('hxpForm').ripropz.value="";
   getForm('hxpForm').verbo.value='showtitles';
   getForm('hxpForm').pos.value=posizioneAttuale;
   ordManager();
   sendRequestT();
  }
  if (atLeastOne == true){
   setGlobalFormRestore('verbo','pos','ripropz');
   
   indexString = indexString.slice(0,-1);
   titleString = titleString.slice(0,-7);
   indexString += '"';
   getForm('hxpForm').ripropz.value = indexString + ' "#|#" ' + titleString;
   getForm('hxpForm').verbo.value='showtitles';
   getForm('hxpForm').pos.value=posizioneAttuale;
   ordManager();
   sendRequestT();
//alert(getForm('hxpForm').ripropz.value); 
  }
  return false;
 }
 
 /* Usata da riprOpzionali - check della select per ordinamento e del checkbox per ascendente */
 function ordManager(){
  var theList = getForm('theForm').ord_channel;
  var current, ord_string, var_xml;	
  for (i=0;i<theList.options.length;i++){
   current = theList.options[i];
   if (current.selected == true)
    ord_string = current.value;   
  }

  var_xml = (getForm('theForm').ord_asc.checked==false)? 'XML(': 'xml(';
  ord_string = ord_string.replace(/XML\(/g, var_xml);

  if (theList.options[0].selected==true){  //selezionato ordinamento naturale
   ord_string="*";
   if (getForm('theForm').ord_asc.checked==false)         //ord. naturale ma inverso
    ord_string="";      
  }

  // eseguire ordinamento solo se necessario (diverso da quello attuale)
  if (ord_string != getForm('hxpForm').qord.value){
   getForm('hxpForm').qord .value=ord_string;  
   getForm('hxpForm').xverb.value='@sort';  
  }
 // else
 //  alert("NON ORDINARE");
 } 
 
 var selectionDefaultState = true; //true se nella select e' selezionato il titolo di default
 //il default deve essere mutualmente esclusivo con le altre selezioni
 function selectTitleManager(theSelect,event){ 
  if (selectionDefaultState == true){      //Default prec. selezionato -> se ci sono altre opzioni selezionate deseleziono default
  	fine = false;
  	var i;
   for (i=1;(i<theSelect.options.length) && (fine==false);i++){
    current = theSelect.options[i];
    if (current.selected == true){
     selectionDefaultState = false;
     theSelect.options[0].selected = false;
     fine = true;
    }
   }
  }
  else{       //Default non prec. selezionato -> se e' selezionato il default deseleziono tutte le altre opzioni
   if (theSelect.options[0].selected == true){
    for (i=1;i<theSelect.options.length;i++)
     theSelect.options[i].selected = false;
    selectionDefaultState = true;
   }
  } 
 }
 function curly2Comma(s)
 {var re=/\}\{\}\{/g; 
  s=s.replace(re,',');
  re=/\}\{/g; 
  return s.replace(re,'');
 }
 
 // funzione per la gestione delle raccolte
 function collection(name)
 {
 	/*if( getForm('hxpForm').keylist.value != '' ) {
  		if(opener.getForm('hxpForm').cName.value!=''&&
      		confirm("Aggiungere alla raccolta '"+getForm('hxpForm').cName.value+"' i titoli selezionati ?"))
    		opener.collectionHandler('addDoc','',getForm('hxpForm').selid.value,curly2Comma(getForm('hxpForm').keylist.value),this);
  	}
  	else
  		alert('Nessun elemento selezionato.');*/
  	
	/*
	 * gestione delle raccolte (occorre cambiare verbo per avviare la classe
	 * relativa alle raccolte)
	 */
	getForm('hxpForm').verbo.value = "collect";
	
	// backup delle var di hxpForm che verranno modificate da collectionHandler()
	var selid = getForm('hxpForm').selid.value;
	var keylist = getForm('hxpForm').keylist.value;
	var xDb = getForm('hxpForm').db.value;
	var oldTarget = getForm('hxpForm').target;
	
	var doSubmit = true;
		
	if( name == "insCollect" ) {
		if ( getForm('hxpForm').cName.value == '' ) {
			alert("Nessuna raccolta attivata. E' necessario selezionarne una.");
			getForm('hxpForm').xverb.value = "@list";
		}
		else {
			if( getForm('hxpForm').keylist.value != '' ) {
				if( confirm("Aggiungere alla raccolta '" + getForm('hxpForm').cName.value + "' i titoli selezionati ?") ) 
					collectionHandler('addDoc',
											'',
											getForm('hxpForm').selid.value,
											getForm('hxpForm').cIsPublic.value,
											curly2Comma(getForm('hxpForm').keylist.value),
											this/*,
											theTarget*/);
				else
					doSubmit = false;
			}
			else 
				if( confirm("Aggiungere alla raccolta '" + getForm('hxpForm').cName.value + "' l\'intera selezione ?") )
					collectionHandler('addDoc',
											'',
											getForm('hxpForm').selid.value,
											getForm('hxpForm').cIsPublic.value,
											'*',
											this/*,
											theTarget*/);
				else
					doSubmit = false;
		}
	}
	else
		getForm('hxpForm').xverb.value = "@list";

		
	if ( doSubmit ) {
		// apro una nuova finestra per le raccolte di documenti
		var iForm = getForm('hxpForm'); 
		if(iForm.target.indexOf("raccolte")==-1)
		iForm.target = iForm.target + "raccolte";
		window.name = "titlesWin"; // necessario per riconoscere la finestra invocante
		if(theCollectionWindow==null)
		theCollectionWindow = window.open(staticEmptyWindow,iForm.target,"width=600,height=500");
		iForm.submit();
		theCollectionWindow.focus();
		
		// ripristino le var di hxpForm modificate
		getForm('hxpForm').target = oldTarget;
		getForm('hxpForm').db.value = xDb;
		getForm('hxpForm').selid.value = selid;
		getForm('hxpForm').keylist.value = keylist;
	}
 }
 
 /*function collectionHandler(action,name,id,count,theWin)
 {
	opener.collectionHandler(action,name,id,count,theWin);
 }*/
 
 function collectionHandler(action,name,id,ispublic,count,theWin,theTarget)
 { var el=document.getElementById("activeCollection");
   
   //debug
   //alert("titles.collectionHandler(): action == " + action);
   
   if ( action == "open" ) {
   		if ( el != null)
   			el.innerHTML = name+' ['+count+']';
   			
		getForm('hxpForm').cId.value = id;
		getForm('hxpForm').cIsPublic.value = ispublic;
		getForm('hxpForm').cName.value = name;
		getForm('hxpForm').cCount.value = count;
   }
   else 
   		if(action == "show") {
   		}
   		else
   			if(action == "close") {
   			}
   			else
   				if( (action == "addDoc") || ("openOnly" == action) ) {
					getForm('hxpForm').selid.value = id;
					getForm('hxpForm').keylist.value = count;
					getForm('hxpForm').db.value = theWin.getForm('hxpForm').db.value;
					getForm('hxpForm').xverb.value = "@addDoc";
   				}
   				else
   					if(action == "save") {
   					}
   					else 
   						if(action == "saveas") {
   						}
						else if( action == "disable" ) {
								getForm('hxpForm').cName.value = '';
								getForm('hxpForm').cId.value = '';
								getForm('hxpForm').cIsPublic.value = ispublic;
								getForm('hxpForm').cCount.value = '';
							 }
  }
  
 //per function riprOpzionali
 normativo=['titlex','cir','eco','codici','lexr','lexs','lavoro','eurlex'];
 
 function isNormativo(arch){
  var i;
  for (i in normativo)
   if (arch == normativo[i])
    return true;
  return false;
 }
 
 /* COSTANTI */
 var MAX_PRINT_TITLES = 200;
 var WARNING_PRINT_TITLES = 100;
 
 /* stampa dei titoli */ 
 function printitles(countTitles){
  setGlobalFormRestore('verbo','xverb','target','pageCount','selid');
  
  getForm('hxpForm').pos.value='0';
  var verbo=getForm('hxpForm').verbo.value;
  var xverb=getForm('hxpForm').xverb.value;
  var prevTarget=getForm('hxpForm').target;
  var xcount = getForm('hxpForm').pageCount.value;
  var nameWin="win_print_"+getForm('hxpForm').selid.value;
  
  //nome alla finestra basato su quello della finestra titoli (passa in automatico la frase di ricerca)
  nameWin = 'cc' + window.name;
 
  getForm('hxpForm').verbo.value = 'showtitles';
  getForm('hxpForm').xverb.value = '@print';
  if (countTitles > WARNING_PRINT_TITLES)
   if (countTitles > MAX_PRINT_TITLES)
    alert("Numero di documenti troppo elevato: verranno stampati solo i primi " + MAX_PRINT_TITLES + " documenti");
   else
    alert("Numero di documenti elevato");
  getForm('hxpForm').pageCount.value = Math.min(countTitles,MAX_PRINT_TITLES); 
  getForm('hxpForm').target=nameWin;
  window.open
   ('', getForm('hxpForm').target,
    "status,resizable=yes,scrollbars=yes,width=800,height=600,top=0,left=0"); 
  getForm('hxpForm').submit();
  
  getForm('hxpForm').pageCount.value = xcount;
  getForm('hxpForm').target=prevTarget;
  getForm('hxpForm').verbo.value=verbo;
  getForm('hxpForm').xverb.value=xverb;
  return false;
 }
 
 /* stampa fisica di una pagina */
 function printPage(){
  window.print();
 }
 
 /* stampa dei documenti */
 function printdocs(countTitles, tipo){
  var nameWin;
  if (typeof(tipo)!='undefined'){
   if (tipo=='all')
    nameWin = 'ee' + window.name; //non cambiare il nome della finestra (vedi load_status.js)
   else
    nameWin = 'ff' + window.name; //non cambiare il nome della finestra (vedi load_status.js)
  }
  else
   nameWin = 'ff' + window.name; //non cambiare il nome della finestra (vedi load_status.js)

  if (countTitles > WARNING_PRINT_TITLES)
   if (countTitles > MAX_PRINT_TITLES)
    alert("Numero di documenti troppo elevato: verranno stampati solo i primi " + MAX_PRINT_TITLES + " documenti");
   else
    alert("Numero di documenti elevato");
  window.open
   ('../formatter/html/data/common/extra/load_status/frameset.html', nameWin,
    "status,resizable=yes,scrollbars=yes,width=800,height=600,top=0,left=0"); 
  return false;
 }
 
 function gotoTableQ(name, refine){
    setGlobalFormRestore('verbo','xverb','selid','dbTable');
    
	getForm('hxpForm').query.value='';

	if ( name != "collect" && name != "insCollect" && typeof(refine) != 'undefined'
		&& refine == 'R')
		getForm('hxpForm').xverb.value = "@refine";
	
	if ( name.length > 0 ) {
        // Federico 21/11/05: introdotta gestione della personalView [RW 0032015]
        var index;
        
        if ((index = name.indexOf("#personalView=")) != -1) {
            getForm("hxpForm").dbTable.value = '@' + name.substring(0, index);
            getForm("hxpForm").personalView.value = name.substring(index + 14);
        }
        else {
        	if (name != 'fascicolo') //sstagni - 26 gennaio 2011 - per andare in ricerca dei fasicoli del personale da pagina dei titoli dei fascicoli del personale 
        		getForm('hxpForm').dbTable.value = '@' + name;
        }
    }
	else {
		getForm('hxpForm').dbTable.value = '';
		getForm('hxpForm').selid.value = '';
        getForm("hxpForm").personalView.value = "";
	}
	
	if ( name == "collect" || name == "insCollect" ) {
		// gestione delle raccolte
		collection(name);
	}
	else {
		getForm('hxpForm').verbo.value = "query";
		getForm('hxpForm').submit();
	}
	
	return false;
}

function invertOrder()
{
    setGlobalFormRestore('verbo','xverb','qord');
    
    OpenWaitMsg();
    if ( getForm('hxpForm').qord.value == "*" )
        getForm('hxpForm').qord.value = "";
    else if (getForm('hxpForm').qord.value == "")  
        getForm('hxpForm').qord.value = "*";
    else {
        var s = getForm('hxpForm').qord.value;
        var index = -1;
        var TOOBIG = 99999;
        var chr;
        var cs;

        while (true){
            index = Math.min(s.indexOf("xml", index + 1)==-1?TOOBIG:s.indexOf("xml", index + 1),
                             s.indexOf("XML", index + 1)==-1?TOOBIG:s.indexOf("XML", index + 1));
            if (index == TOOBIG)
                break;

            cs = (s.charAt(index) == 'x')? true: false;

            for (var j=index; j<index+3; j++) {
                chr = cs? s.charAt(j).toUpperCase() : s.charAt(j).toLowerCase();
                s = s.substring(0,j) + chr + s.substring(j+1);
            }
        }

//alert(getForm('hxpForm').qord.value + "\n" +s)        
        
        getForm('hxpForm').qord.value = s;        
    }        
   	
   getForm('hxpForm').xverb.value='@sort';
   getForm('hxpForm').submit();
   return false;
}

function deleteSel()
{
	if ( typeof(customConfirmDeleteSel) != 'undefined' && customConfirmDeleteSel() == false )
		return false;
	
	if ( confirm("Procedere con l'eliminazione?") == false )
		return false;
    
    setGlobalFormRestore('verbo','xverb');    
	
	getForm('hxpForm').verbo.value = "docEdit";
	getForm('hxpForm').xverb.value = "@removesel";
	getForm('hxpForm').submit();
	return false;
}


function store()
{
	var old_target = getForm('hxpForm').target;
	var old_verbo = getForm('hxpForm').verbo.value;
	var old_xverb = getForm('hxpForm').xverb.value;

	iForm = getForm('hxpForm');
	iForm.verbo.value = "queryplain";
	iForm.xverb.value = "store";
	
	iForm.target = getForm('hxpForm').target + "_store";
	var newWindow = window.open(staticEmptyWindow, iForm.target, "width=800,height=600,toolbar=no,location=no,status=yes,scrollbars=yes");
	iForm.submit();
	newWindow.focus();
	
	getForm('hxpForm').target = old_target;
	getForm('hxpForm').verbo.value = old_verbo;
	getForm('hxpForm').xverb.value = old_xverb;	

	return false;
}

function sort(colSort)
{
    setGlobalFormRestore('xverb','qopt','qord','pos');
    
    OpenWaitMsg();
    var theForm = getForm('theForm');
    
    var theList=curly2Comma(getForm('hxpForm').keylist.value);

    getForm('hxpForm').keylist.value=theList;
    
    if (typeof(colSort) != 'undefined') {//ordinamento in base a colonna di titolo
        var lastSort = getForm('hxpForm').titColOrd.value;        
        if (lastSort.length > 0 && lastSort.toLowerCase() == colSort.toLowerCase()) {//invert order      
            if (lastSort.charAt(0) == 'x')
                colSort = replaceAll(colSort, 'xml', 'XML');
            else
                colSort = replaceAll(colSort, 'XML', 'xml');
        }
        getForm('hxpForm').qord.value = colSort;
        getForm('hxpForm').titColOrd.value = colSort;
    }
    else if ( typeof(theForm.xwOrd) != 'undefined' ) { //ordinamento e probabilistica in base alla tendina 
        getForm('hxpForm').titColOrd.value  = '';
        var val = theForm.xwOrd.options[theForm.xwOrd.selectedIndex].value;
            
        if ( val == '*xwProb*' )
            getForm('hxpForm').qopt.value = eval(getForm('hxpForm').qopt.value) + 1;
        else {
            getForm('hxpForm').qord.value = val;
    
            var fieldIdxName = 'qordIdx';
            if ( typeof(customFieldIdxName) != 'undefined')
                fieldIdxName = customFieldIdxName(fieldIdxName, getForm('hxpForm').dbTable.value);                 
            if (fieldIdxName.length > 0)
                getForm('hxpForm')[fieldIdxName].value = theForm.xwOrd.selectedIndex;
        }
    
    }

	// 31/03/2005 GMG, VM
	// Modificato valore tupla pos per effettuare il posizionamento sul primo documento della nuova selezione ordinata
	getForm('hxpForm').pos.value='0';

    getForm('hxpForm').xverb.value='@sort';
    getForm('hxpForm').submit();
    return false;
}

/* 
 * Created on: 28/10/2004
 * by: Federico Grillini (fgr)
 * organization: 3D Informatica
 * description: Funzione invocata per la visualizzazione della pagina dei profili di stampa.
 */
function printProfiles()
{
    setGlobalFormRestore('verbo','dbTable');
    
	getForm('hxpForm').verbo.value='print_profiles';
	getForm('hxpForm').dbTable.value='';
	  
	getForm('hxpForm').submit();
	  
	return false;	
}

function insTableDoc(name){
    setGlobalFormRestore('verbo','xverb','pos','physDoc','selid','dbTable');
    
	getForm('hxpForm').verbo.value="docEdit";
	getForm('hxpForm').xverb.value = "";	
	if (getForm('hxpForm').pos) {
		getForm('hxpForm').pos.value=0;	
	}
	if (getForm('hxpForm').physDoc) {
		getForm('hxpForm').physDoc.value=0;
	}
	if (getForm('hxpForm').selid) {
		getForm('hxpForm').selid.value="";
	}
	if (getForm('hxpForm').dbTable) {
		if (name != 'fascicolo')
			getForm('hxpForm').dbTable.value='@'+name;	//sstagni - 26 gennaio 2011 - per andare in inserimento dei fasicoli del personale da pagina dei titoli dei fascicoli del personale
	}
	
	/* modifica di Federico del 16/08/2004: inserita l'apertura forzata di una sezione di un doc. di XSpring
	 * in una funzione custom.
	 */
	if ( typeof(customInsTableDoc) != 'undefined' ) {
		customInsTableDoc();
		return false;
	}
	
	getForm('hxpForm').submit();
	return false;
}


function raccogli(selezione, verbose, tutti)
{
    var kl = getForm('hxpForm').keylist.value;
    var svuota = false;

    if (kl.length == 0) {
        if (typeof(tutti) == 'undefined') {
            getForm('hxpForm').klRac.value = getForm('hxpForm').selRac.value = "";
            //DD 27/02/2006 Non esco, devo visualizzare l'alert
            alert("Non  stato selezionato alcun documento");
            return false;            
        }
        else {
            for (var i=1; i<=tutti; i++)
                kl += "}{" + i + "}{"; 
            getForm('hxpForm').keylist.value = kl;
            svuota = true;
        }
    }

    var count = contaDocumentiRaccolti(kl);

    var f = count == 1? "o" : "i";
    if (typeof(verbose) == 'undefined' || verbose)
        alert(count + " document" + f + " raccolt" + f);
    getForm('hxpForm').klRac.value = getForm('hxpForm').keylist.value;
    if (svuota)
        getForm('hxpForm').keylist.value = '';
    getForm('hxpForm').selRac.value = selezione;
    
    return false;
}


function contaDocumentiRaccolti(kl) {
    var count = 0;
    var index = 0;
    while ((index=kl.indexOf(separator, index)) != -1) {
        count++;
        index++;
    }
    return count / 2;
}

function esportaCSV() {
	
	if (getForm('hxpForm').db.value == 'acl' && getForm('hxpForm').dbTable.value == '') {
		alert('Impossibile effettuare l\'esportazione da Ricerca Globale. Utilizzare le maschere ricerca avanzata!');
		return false;
	}
	
    raccogli(getForm('hxpForm').selid.value, false);
    
    var tot = getForm('hxpForm').count.value;
    var kl = getForm('hxpForm').klRac.value;
    if (kl.length > 0) {
        tot = contaDocumentiRaccolti(kl);
    }
    var f = tot == 1? "o" : "i";
    if (!confirm("Confermare esportazione di " + tot + " document" + f + "?"))
        return false;
    
    var old_target = getForm('hxpForm').target;
    var old_verbo = getForm('hxpForm').verbo.value;
    var old_xverb = getForm('hxpForm').xverb.value;
    iForm = getForm('hxpForm');
    iForm.target += "exportdocs_response";
    iForm.verbo.value = "exportdocs_response";
    iForm.xverb.value = "@exportCSV";
    var theTrasferimentoWindow = window.open(staticEmptyWindow, iForm.target, "scrollbars=yes,width=800,height=520");
    theTrasferimentoWindow.focus();
    iForm.submit();
    getForm('hxpForm').target = old_target;    
    getForm('hxpForm').verbo.value = old_verbo;
    getForm('hxpForm').xverb.value = old_xverb;
    
    return false;
}

function removeSelFromFasc() {
    raccogli(getForm('hxpForm').selid.value, false);
    
    var tot = getForm('hxpForm').count.value;
    var kl = getForm('hxpForm').klRac.value;
    if (kl.length > 0) {
        tot = contaDocumentiRaccolti(kl);
    }
    var f = tot == 1? "o" : "i";
    if (!confirm("Confermare trasferimento di " + tot + " document" + f + "?"))
        return false;
    
    var old_target = getForm('hxpForm').target;
    var old_verbo = getForm('hxpForm').verbo.value;
    var old_xverb = getForm('hxpForm').xverb.value;
    iForm = getForm('hxpForm');
    iForm.target += "fascicolo_response";
    iForm.verbo.value = "fascicolo_response";
    iForm.xverb.value = "@removeSelFormFasc";
    var theTrasferimentoWindow = window.open(staticEmptyWindow, iForm.target, "scrollbars=yes width=800 height=520");
    theTrasferimentoWindow.focus();
    iForm.submit();
    getForm('hxpForm').target = old_target;    
    getForm('hxpForm').verbo.value = old_verbo;
    getForm('hxpForm').xverb.value = old_xverb;
    
    return false;
}

var trasfFascWindowOpened = false;
function openRifInt(addType)
{
    raccogli(getForm('hxpForm').selid.value, false, getForm('hxpForm').count.value);
    
    var iForm;
    var old_target = getForm('hxpForm').target;
    var old_verbo = getForm('hxpForm').verbo.value;
    var old_xverb = getForm('hxpForm').xverb.value;
    var old_rifint = getForm('hxpForm').rifInt.value;
    var old_dbTable = getForm('hxpForm').dbTable.value;
    var old_toDo = getForm('hxpForm').toDo.value;

    iForm = getForm('hxpForm');
    iForm.verbo.value = "rifint_response";
    iForm.xverb.value = "@openRif";
    iForm.rifInt.value = addType;
    if (iForm.dbTable.value == '@fascicolo')
        iForm.toDo.value = "from_fasc_titles";
    else
        iForm.toDo.value = "from_titles";
    if (iForm.dbTable.value != '@raccoglitore')
        iForm.dbTable.value = "";

    iForm.target = iForm.target + 'rifint_child';
    var rifWindow=window.open(staticEmptyWindow, iForm.target, "status=yes,scrollbars=yes width=800 height=520");
    iForm.submit();
    rifWindow.focus();
    if (addType == 'TRASF')
        trasfFascWindowOpened = true;
    
    getForm('hxpForm').rifInt.value = old_rifint;
    getForm('hxpForm').target = old_target;
    getForm('hxpForm').verbo.value = old_verbo;
    getForm('hxpForm').xverb.value = old_xverb;
    getForm('hxpForm').dbTable.value = old_dbTable;
    getForm('hxpForm').toDo.value = old_toDo;

    if ( getForm('hxpForm').selid.value.length == 0 ) //occorre aprire in base a # fisico
        getForm('hxpForm').pos.value = getForm('hxpForm').physDoc.value - 1;

    return false;   
}

/*Federica 09/01/2007 Apertura nuova finestra per cambio classificazione*/
function openClassifSpec(operation)
{
	if (((typeof(getForm('hxpForm').physDoc) != 'undefined') && (getForm('hxpForm').physDoc.value == "")) ||
		(typeof(getForm('hxpForm').physDoc) == 'undefined')) {
		raccogli(getForm('hxpForm').selid.value, false, getForm('hxpForm').count.value);
	}
	
    var iForm;
    var old_target = getForm("hxpForm").target;
    var old_verbo = getForm("hxpForm").verbo.value;
    var old_xverb = getForm("hxpForm").xverb.value;
    var old_dbTable = getForm('hxpForm').dbTable.value;
    var old_selid = getForm('hxpForm').selid.value;
    var hxpS = new _hxpSession(getForm('hxpForm'));
    hxpS.setParameter("operationToDo", operation);
    
	getForm('hxpForm').selid.value = "";
    
    iForm = getForm("hxpForm");
	iForm.verbo.value = "docEdit";
	iForm.xverb.value = "";
	iForm.dbTable.value = "@classifspec";
    
    iForm.target = iForm.target + 'classif_child';
    var classifWindow=window.open(staticEmptyWindow, iForm.target, "status=yes,scrollbars=yes,width=800,height=520");
    iForm.submit();
    classifWindow.focus();

    getForm("hxpForm").target = old_target;
    getForm("hxpForm").verbo.value = old_verbo;
    getForm("hxpForm").xverb.value = old_xverb;
    getForm('hxpForm').dbTable.value = old_dbTable;
    getForm('hxpForm').selid.value = old_selid;
    getForm('hxpForm').selRac.value = "";
    getForm('hxpForm').klRac.value = "";
    
    return false;	
}

/*
   DD 20/04/2006 Apre una finestra popup che mostra le immagini del documento

*/
function mostraImmaginiDocumento(posizione, tipo, asText, xdoc, dbTable) {  
   var iForm = getForm("hxpForm");   
   var oldTarget = iForm.target;
   var oldXverb = iForm.xverb.value;
   
   var fullscreen = true;   
   //Se non c' IW apro la pagina senza fullscreen
   if (typeof(getForm('hxpForm').enableIW) != 'undefined' && getForm('hxpForm').enableIW.value != 'true')
         fullscreen = false;
            
   iForm.xverb.value = "@immagini";
   iForm.target = "win_immagini";
	theWindow  = OpenWinEx(staticEmptyWindow, iForm.target, "toolbar=no,location=no,status=no,resizable=yes", fullscreen);
	theWindow.focus();
   mostraDocumento(posizione, tipo, asText, xdoc, dbTable);
   
   iForm.target = oldTarget;    
   iForm.xverb.value = oldXverb; 
}