/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/
//<!--
//Ultimate client-side JavaScript client sniff. Version 3.03
//(C) Netscape Communications 1999-2001.  Permission granted to reuse and distribute.
//Revised 17 May 99 to add is_nav5up and is_ie5up (see below).
//Revised 20 Dec 00 to add is_gecko and change is_nav5up to is_nav6up
//also added support for IE5.5 Opera4&5 HotJava3 AOLTV
//Revised 22 Feb 01 to correct Javascript Detection for IE 5.x, Opera 4,
//correct Opera 5 detection
//add support for winME and win2k
//synch with browser-type-oo.js
//Revised 26 Mar 01 to correct Opera detection
//Revised 02 Oct 01 to add IE6 detection

//Everything you always wanted to know about your JavaScript client
//but were afraid to ask. Creates "is_" variables indicating:
//(1) browser vendor:
//is_nav, is_ie, is_opera, is_hotjava, is_webtv, is_TVNavigator, is_AOLTV
//(2) browser version number:
//is_major (integer indicating major version number: 2, 3, 4 ...)
//is_minor (float   indicating full  version number: 2.02, 3.01, 4.04 ...)
//(3) browser vendor AND major version number
//is_nav2, is_nav3, is_nav4, is_nav4up, is_nav6, is_nav6up, is_gecko, is_ie3,
//is_ie4, is_ie4up, is_ie5, is_ie5up, is_ie5_5, is_ie5_5up, is_ie6, is_ie6up, is_hotjava3, is_hotjava3up,
//is_opera2, is_opera3, is_opera4, is_opera5, is_opera5up
//(4) JavaScript version number:
//is_js (float indicating full JavaScript version number: 1, 1.1, 1.2 ...)
//(5) OS platform and version:
//is_win, is_win16, is_win32, is_win31, is_win95, is_winnt, is_win98, is_winme, is_win2k
//is_os2
//is_mac, is_mac68k, is_macppc
//is_unix
//is_sun, is_sun4, is_sun5, is_suni86
//is_irix, is_irix5, is_irix6
//is_hpux, is_hpux9, is_hpux10
//is_aix, is_aix1, is_aix2, is_aix3, is_aix4
//is_linux, is_sco, is_unixware, is_mpras, is_reliant
//is_dec, is_sinix, is_freebsd, is_bsd
//is_vms

//See http://www.it97.de/JavaScript/JS_tutorial/bstat/navobj.html and
//http://www.it97.de/JavaScript/JS_tutorial/bstat/Browseraol.html
//for detailed lists of userAgent strings.

//Note: you don't want your Nav4 or IE4 code to "turn off" or
//stop working when new versions of browsers are released, so
//in conditional code forks, use is_ie5up ("IE 5.0 or greater")
//is_opera5up ("Opera 5.0 or greater") instead of is_ie5 or is_opera5
//to check version in code which you want to work on future
//versions.

// convert all characters to lowercase to simplify testing
var agt=navigator.userAgent.toLowerCase();

// *** BROWSER VERSION ***
// Note: On IE5, these return 4, so use is_ie5up to detect IE5.
var is_major = parseInt(navigator.appVersion);
var is_minor = parseFloat(navigator.appVersion);

// Note: Opera and WebTV spoof Navigator.  We do strict client detection.
// If you want to allow spoofing, take out the tests for opera and webtv.
var is_nav  = ((agt.indexOf('mozilla')!=-1) && (agt.indexOf('spoofer')==-1)
        && (agt.indexOf('compatible') == -1) && (agt.indexOf('opera')==-1)
        && (agt.indexOf('webtv')==-1) && (agt.indexOf('hotjava')==-1));
var is_nav2 = (is_nav && (is_major == 2));
var is_nav3 = (is_nav && (is_major == 3));
var is_nav4 = (is_nav && (is_major == 4));
var is_nav4up = (is_nav && (is_major >= 4));
var is_navonly      = (is_nav && ((agt.indexOf(";nav") != -1) ||
        (agt.indexOf("; nav") != -1)) );
var is_nav6 = (is_nav && (is_major == 5));
var is_nav6up = (is_nav && (is_major >= 5));
var is_gecko = (agt.indexOf('gecko') != -1);


var is_ie     = ((agt.indexOf("msie") != -1) && (agt.indexOf("opera") == -1));
var is_ie3    = (is_ie && (is_major < 4));
var is_ie4    = (is_ie && (is_major == 4) && (agt.indexOf("msie 4")!=-1) );
var is_ie4up  = (is_ie && (is_major >= 4));
var is_ie5    = (is_ie && (is_major == 4) && (agt.indexOf("msie 5.0")!=-1) );
var is_ie5_5  = (is_ie && (is_major == 4) && (agt.indexOf("msie 5.5") !=-1));
var is_ie5up  = (is_ie && !is_ie3 && !is_ie4);
var is_ie5_5up =(is_ie && !is_ie3 && !is_ie4 && !is_ie5);
var is_ie6    = (is_ie && (is_major == 4) && (agt.indexOf("msie 6.")!=-1) );
var is_ie6up  = (is_ie && !is_ie3 && !is_ie4 && !is_ie5 && !is_ie5_5);

// KNOWN BUG: On AOL4, returns false if IE3 is embedded browser
// or if this is the first browser window opened.  Thus the
// variables is_aol, is_aol3, and is_aol4 aren't 100% reliable.
var is_aol   = (agt.indexOf("aol") != -1);
var is_aol3  = (is_aol && is_ie3);
var is_aol4  = (is_aol && is_ie4);
var is_aol5  = (agt.indexOf("aol 5") != -1);
var is_aol6  = (agt.indexOf("aol 6") != -1);

var is_opera = (agt.indexOf("opera") != -1);
var is_opera2 = (agt.indexOf("opera 2") != -1 || agt.indexOf("opera/2") != -1);
var is_opera3 = (agt.indexOf("opera 3") != -1 || agt.indexOf("opera/3") != -1);
var is_opera4 = (agt.indexOf("opera 4") != -1 || agt.indexOf("opera/4") != -1);
var is_opera5 = (agt.indexOf("opera 5") != -1 || agt.indexOf("opera/5") != -1);
var is_opera5up = (is_opera && !is_opera2 && !is_opera3 && !is_opera4);

var is_webtv = (agt.indexOf("webtv") != -1);

var is_TVNavigator = ((agt.indexOf("navio") != -1) || (agt.indexOf("navio_aoltv") != -1));
var is_AOLTV = is_TVNavigator;

var is_hotjava = (agt.indexOf("hotjava") != -1);
var is_hotjava3 = (is_hotjava && (is_major == 3));
var is_hotjava3up = (is_hotjava && (is_major >= 3));

// *** JAVASCRIPT VERSION CHECK ***
var is_js;
if (is_nav2 || is_ie3) is_js = 1.0;
else if (is_nav3) is_js = 1.1;
else if (is_opera5up) is_js = 1.3;
else if (is_opera) is_js = 1.1;
else if ((is_nav4 && (is_minor <= 4.05)) || is_ie4) is_js = 1.2;
else if ((is_nav4 && (is_minor > 4.05)) || is_ie5) is_js = 1.3;
else if (is_hotjava3up) is_js = 1.4;
else if (is_nav6 || is_gecko) is_js = 1.5;
// NOTE: In the future, update this code when newer versions of JS
// are released. For now, we try to provide some upward compatibility
// so that future versions of Nav and IE will show they are at
// *least* JS 1.x capable. Always check for JS version compatibility
// with > or >=.
else if (is_nav6up) is_js = 1.5;
// NOTE: ie5up on mac is 1.4
else if (is_ie5up) is_js = 1.3

// HACK: no idea for other browsers; always check for JS version with > or >=
else is_js = 0.0;

// *** PLATFORM ***
var is_win   = ( (agt.indexOf("win")!=-1) || (agt.indexOf("16bit")!=-1) );
// NOTE: On Opera 3.0, the userAgent string includes "Windows 95/NT4" on all
//        Win32, so you can't distinguish between Win95 and WinNT.
var is_win95 = ((agt.indexOf("win95")!=-1) || (agt.indexOf("windows 95")!=-1));

// is this a 16 bit compiled version?
var is_win16 = ((agt.indexOf("win16")!=-1) ||
        (agt.indexOf("16bit")!=-1) || (agt.indexOf("windows 3.1")!=-1) ||
        (agt.indexOf("windows 16-bit")!=-1) );

var is_win31 = ((agt.indexOf("windows 3.1")!=-1) || (agt.indexOf("win16")!=-1) ||
        (agt.indexOf("windows 16-bit")!=-1));

var is_winme = ((agt.indexOf("win 9x 4.90")!=-1));
var is_win2k = ((agt.indexOf("windows nt 5.0")!=-1));

// NOTE: Reliable detection of Win98 may not be possible. It appears that:
//       - On Nav 4.x and before you'll get plain "Windows" in userAgent.
//       - On Mercury client, the 32-bit version will return "Win98", but
//         the 16-bit version running on Win98 will still return "Win95".
var is_win98 = ((agt.indexOf("win98")!=-1) || (agt.indexOf("windows 98")!=-1));
var is_winnt = ((agt.indexOf("winnt")!=-1) || (agt.indexOf("windows nt")!=-1));
var is_win32 = (is_win95 || is_winnt || is_win98 ||
        ((is_major >= 4) && (navigator.platform == "Win32")) ||
        (agt.indexOf("win32")!=-1) || (agt.indexOf("32bit")!=-1));

var is_os2   = ((agt.indexOf("os/2")!=-1) ||
        (navigator.appVersion.indexOf("OS/2")!=-1) ||
        (agt.indexOf("ibm-webexplorer")!=-1));

var is_mac    = (agt.indexOf("mac")!=-1);
// hack ie5 js version for mac
if (is_mac && is_ie5up) is_js = 1.4;
var is_mac68k = (is_mac && ((agt.indexOf("68k")!=-1) ||
        (agt.indexOf("68000")!=-1)));
var is_macppc = (is_mac && ((agt.indexOf("ppc")!=-1) ||
        (agt.indexOf("powerpc")!=-1)));

var is_sun   = (agt.indexOf("sunos")!=-1);
var is_sun4  = (agt.indexOf("sunos 4")!=-1);
var is_sun5  = (agt.indexOf("sunos 5")!=-1);
var is_suni86= (is_sun && (agt.indexOf("i86")!=-1));
var is_irix  = (agt.indexOf("irix") !=-1);    // SGI
var is_irix5 = (agt.indexOf("irix 5") !=-1);
var is_irix6 = ((agt.indexOf("irix 6") !=-1) || (agt.indexOf("irix6") !=-1));
var is_hpux  = (agt.indexOf("hp-ux")!=-1);
var is_hpux9 = (is_hpux && (agt.indexOf("09.")!=-1));
var is_hpux10= (is_hpux && (agt.indexOf("10.")!=-1));
var is_aix   = (agt.indexOf("aix") !=-1);      // IBM
var is_aix1  = (agt.indexOf("aix 1") !=-1);
var is_aix2  = (agt.indexOf("aix 2") !=-1);
var is_aix3  = (agt.indexOf("aix 3") !=-1);
var is_aix4  = (agt.indexOf("aix 4") !=-1);
var is_linux = (agt.indexOf("inux")!=-1);
var is_sco   = (agt.indexOf("sco")!=-1) || (agt.indexOf("unix_sv")!=-1);
var is_unixware = (agt.indexOf("unix_system_v")!=-1);
var is_mpras    = (agt.indexOf("ncr")!=-1);
var is_reliant  = (agt.indexOf("reliantunix")!=-1);
var is_dec   = ((agt.indexOf("dec")!=-1) || (agt.indexOf("osf1")!=-1) ||
        (agt.indexOf("dec_alpha")!=-1) || (agt.indexOf("alphaserver")!=-1) ||
        (agt.indexOf("ultrix")!=-1) || (agt.indexOf("alphastation")!=-1));
var is_sinix = (agt.indexOf("sinix")!=-1);
var is_freebsd = (agt.indexOf("freebsd")!=-1);
var is_bsd = (agt.indexOf("bsd")!=-1);
var is_unix  = ((agt.indexOf("x11")!=-1) || is_sun || is_irix || is_hpux ||
        is_sco ||is_unixware || is_mpras || is_reliant ||
        is_dec || is_sinix || is_aix || is_linux || is_bsd || is_freebsd);

var is_vms   = ((agt.indexOf("vax")!=-1) || (agt.indexOf("openvms")!=-1));

//--> end hide JavaScript



function detectClient()
{
    var browsname;
    if(getForm("hxpForm").browser.value.length==0)
    {
        if(is_ie3 || is_ie4 || is_ie4up || is_ie5 || is_ie5up || is_ie5_5 || is_ie5_5up || is_ie6 || is_ie6up)
        {
            browsname="Explorer";
        }
        else if (is_nav2 || is_nav3 || is_nav4 || is_nav4up || is_nav6 || is_nav6up)
        {
            browsname="Netscape";
        }

        else if (is_opera2 || is_opera3 || is_opera4 || is_opera5 || is_opera5up)
        {
            browsname="Opera";
        }

        else if(is_hotjava3 || is_hotjava3up)
        {
            browsname="HotJava";
        }

        else if(is_gecko)
        {
            browsname="Gecko";
        }

        else
        {
            browsname="Unknown";
        }



        if(agt.indexOf('safari')!=-1)
        {
            browsname="Safari";
        }


        if(browsname=="Explorer")
            getForm("hxpForm").enableIW.value="true";
        else
            getForm("hxpForm").enableIW.value="false";

        getForm("hxpForm").browser.value=browsname;

    }

}

function OpenWinEx(path, namewin, param, FullSize)
{
    if ( FullSize )  {
        param += ',width=';
        if ( document.all )
            param += screen.availWidth - 4;
        else  {
            param += window.top.innerWidth;
        }
        param += ',height=';
        if ( document.all )  {
            var h = screen.availHeight - 26;
            if ( param.indexOf('menubar') >= 0 )
                h -= 32;
            if ( param.indexOf('status') >= 0 )
                h -= 32;
            param += h;
        }
        else  {
            var h = window.top.innerHeight - 4;
            if ( param.indexOf('menubar') >= 0 )
                h -= 20;
            param += h;
        }
    }
    NewWin=window.open(path,namewin,param);
    NewWin.moveTo(-4, -4);
//  NewWin.focus();
    return NewWin;
}


function CloseWaitMsg()
{
    var el = document.getElementById("WaitMsg");

    if ( el != null )
        with (el.style) display = "none";

    //modifica di mbussetti del 30/06/05
    el = document.getElementById("WaitMsg4Wf");

    if ( el != null )
        with (el.style) display = "none";

}

function OpenWaitMsg()
{
    if (typeof(customOpenWaitMsg) != 'undefined') {
        return customOpenWaitMsg();
    }
    var el = document.getElementById("WaitMsg");
    if (el != null) {
        // DD 28/7/5 body non  definito per l'ambiente di test
        if (typeof(document.body)!='undefined') {
            h = document.body.clientHeight - 125;
        }
        else {
            h = 600;
        }
        with (el.style) {
            height = h;
            display = "block";
        }
        // per togliere focus da pulsante premuto
        // (si evitano inserimenti indesiderati)
        self.focus();
    }
    return;
}

function OpenWaitMsg4Wf()
{
    var el = document.getElementById("WaitMsg4Wf");
    if ( el != null )
        with (el.style) {
        //h = document.body.clientHeight - 125;

        //height = h;
        display = "block";
    }
    return;
}

//funzioni per le gestione delle tuple di preferenze di applicativo
function getAppStringPreference(preferences, position)
{
    //alert (preferences);
    var v = preferences.split("");
    if ( position < v.length )
        return v[position];
    else
        return '';
}



function getAppPreference()
{

}


function decodeAppPreference()
{

}


function startModalWindow(sameWindow)
{
    if (typeof(sameWindow) == 'undefined')
        sameWindow = false;

    // Federico 08/08/05: 'opener' pu essere null con Firefox e Opera
    // Federico 21/12/05: sostituiti tutti gli 'opener' con 'window.opener'
    if (!sameWindow && (typeof(window.opener) == "undefined" || window.opener == null)) return;

    /* Federico 21/12/05: introdotto try-catch per intercettare eventuali errori dovuti alla presenza di un
     * window.opener.document che in realt non dovrebbe essere definito (per es. quando si clicca su un link
     * dal programma di posta: l'opener  la finestra del email client!) [RW 0032983 o 0032801]
     */
    var el = null;
    var doc;
    try {
        doc = sameWindow? document : window.opener.document;
        el = doc.getElementById("modalWindow");
    }
    catch (ex) {
        return;
    }

    if ( el != null ) {
        with (el.style) {
            //DD 28/7/5 body non  definito nell'ambiente di test.
            if( typeof(document.body)!='undefined') {
                height = doc.body.clientHeight;
                width = doc.body.clientWidth;
                display = "";
                if (typeof(Drag) != 'undefined')
                    Drag.centerDiv(el);
            }
        }
    }

    return;
}

function stopModalWindow(sameWindow)
{
    if (typeof(sameWindow) == 'undefined')
        sameWindow = false;

    if (!sameWindow && !window.opener) return;

    /* Federico 21/12/05: introdotto try-catch per intercettare eventuali errori dovuti alla presenza di un
     * window.opener.document che in realt non dovrebbe essere definito (per es. quando si clicca su un link
     * dal programma di posta: l'opener  la finestra del email client!) [RW 0032983 o 0032801]
     */
    var el;

    try {
        el = sameWindow ? document.getElementById("modalWindow") : window.opener.document.getElementById("modalWindow");
    }
    catch (ex) {
        return;
    }

    if (el != null) with (el.style) display = "none";
}

//-------------------------- funzioni per l'elaborazione di stringhe --------------------------

/*
 * Created on: 20/08/2004
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Funzione che ribalta una stringa.
 */
function reverseString(str)
{
    var s = "";
    var i = str.length;

    while ( i > 0 ) {
        s += str.substring(i-1, i);
        i--;
    }

    return s;
}

/*
 * Created on: 08/10/2004
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Funzione che sostituisce tutte le occorrenze di 'findStr' in 'oldStr' con 'repStr'.
 */
function replaceAll(oldStr, findStr, repStr)
{
    var srchNdx = 0;  // indice che tiene traccia della posizione iniziale per la scansione di oldStr
    var newStr = "";  // nuova stringa

    while (oldStr.indexOf(findStr, srchNdx) != -1) {
        newStr += oldStr.substring(srchNdx, oldStr.indexOf(findStr,srchNdx)) + repStr;
        srchNdx = (oldStr.indexOf(findStr,srchNdx) + findStr.length);
    }

    newStr += oldStr.substring(srchNdx,oldStr.length);

    return newStr;
}

/*
 * Created on: 27/10/2004
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Funzione che elimina tutti i white space all'inizio e alla fine di str.
 */
function trim_str(str)
{
    if (!str) return str;

    while (str.length && (str.substring(0,1) == " " || str.substring(0,1) == "\t" )) {
        str = str.substring(1, str.length);
    }

    while (str.length && (str.substring(str.length - 1, str.length) == " " ||
            str.substring(str.length - 1, str.length) == "\t")) {
        str = str.substring(0, str.length - 1);
    }

    return str;
}

/*
 * Created on: 03/03/2005
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Funzione che verifica se la stringa 'str' termina o meno con la stringa 'suffix'.
 */
function strEndsWith(str, suffix)
{
    if (str.length >= suffix.length) {
        if (str.lastIndexOf(suffix) == str.length - suffix.length) {
            return true;
        }
    }

    return false;
}

/*
 * Created on: 11/05/2005
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Funzione che verifica se la stringa 'str' inizia o meno con la stringa 'prefix'.
 */
function strStartsWith(str, prefix)
{
    if (str.length >= prefix.length) {
        if (str.indexOf(prefix) == 0) {
            return true;
        }
    }

    return false;
}

//-------------------------- funzioni per il reperimento di elementi in una pagina HTML --------------------------

/*
 * Spostata qui da mbussetti il 16/05/2005
 */
function getElementByName(name,tagName)
{
    if ("undefined" == typeof(tagName)) tagName = "input";
    var elements = document.getElementsByTagName(tagName);

    for (var i = 0; i < elements.length; i++ ) {
        if (typeof(elements[i].name) != 'undefined')
            if (elements[i].name == name) return elements[i];
    }

    return null;
}

/*
 * DD 18/01/2005
 * Permette di recuperare l'input dal name e type passati.
 */
function getInputByNameAndType(name, i_type)
{
    tagName = "input";
    var elements = document.getElementsByTagName(tagName);

    for (var i = 0; i < elements.length; i++ ) {
        if (typeof(elements[i].name) != 'undefined')
            if (elements[i].name == name && elements[i].type == i_type) return elements[i];
    }

    return null;
}

/*
 * Spostata qui da mbussetti il 16/05/2005
 */
function getElementByValue(value)
{
    var elements = document.getElementsByTagName("input");

    for (var i = 0; i < elements.length; i++ )
        if ( elements[i].value == value )
            return elements[i];
}

/*
 * Aggiunta da mbussetti il 16/05/2005
 */
function getElementById(id,tagName)
{
    var metaSearch = document.getElementsByTagName(tagName);
    for (d = 0; d < metaSearch.length; d++){
        if (metaSearch[d].getAttribute('id') == id){
            return metaSearch[d];
        }
    }
}

/*
 * Created on: 03/08/05
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Funzione che recupera una form dato il suo identificativo. La ricerca avviene esaminando prima
 *              l'array delle form del documento, poi, se con il name non si trova nulla, viene esaminato
 *              l'attributo 'id'.
 *              In questo modo  possibile recuperare una form sia mediante il 'name' (attributo proibito in
 *              xhtml) sia mediante l'id (attributo consentito in xhtml).
 *              Qualora la form cercata non venga trovata, la funzione restituisce null.
 *
 *              DD 09/09/05
 *              Aggiunto il parametro documentObj che permette di passare l'oggetto document in cui cercare la
 *              form. Utilizzato nei casi in cui la form si trova su altra finestra o altro frame.
 */
function getForm(formName, documentObj)
{
    var form = null;
    var oDoc = null;

    if (typeof(formName) != 'undefined') {
        //DD 09/09/05 Se non  stato specificato un document specifico cerco nel document di default
        //Federico 14/09/05: aggiunto controllo nullit di 'documentObj' (utile con Firefox/Opera)
        if (typeof(documentObj) == 'undefined' || documentObj == null){
            oDoc = document;
        }else{
            oDoc = documentObj;
        }

        // DD 27/8/05 Prima di tutto cerco nell'array dei forms
        // Federico 21/09/05: 'oDoc.forms' pu essere 'undefined' [RW 0030432]
        if (typeof(oDoc.forms) != 'undefined') {
            form = oDoc.forms[formName];
        }

        // Federico 20/09/05: se 'formName' non c'e', 'oDoc.forms' restituisce 'undefined'
        if (form == null || typeof(form) == 'undefined') {
            // non e' stata trovata la form, la cerco attraverso l'attributo 'id'
            form = oDoc.getElementById(formName);
        }
    }

    return form;
}

/*
 * Aggiunta da mbussetti il 16/05/2005
 * Passato come elemento un elemento 'select', restituisce il tag selezionato
 */
function getSelectedOption(tendinaElement){
    var optionsList = tendinaElement.getElementsByTagName('option');
    for (s = 0; s < optionsList.length; s++){
        if (optionsList[s].getAttribute('selected')){
            return optionsList[s];
        }
    }
}

/*
 * Aggiunta da mbussetti il 17 mag 2005
 * Passati come argomenti una tendina e un valore, seleziona nella tendina l'elemento con quel valore
 */
function selectByValue(tendinaElement,valueToSelect){
    var exit = false;
    var optionsList = tendinaElement.getElementsByTagName('option');
    for (s = 0; s < optionsList.length; s++){
        if (optionsList[s].value == valueToSelect){
            optionsList[s].selected = true;
            exit = true;
        }
        else if (optionsList[s].getAttribute('selected')){
            optionsList[s].selected = false;
        }
    }
    return exit;
}

function buildUrlForGet(uri, returnOnlyURI, forceLogin, fromIw, onlyParams) {
    var url = "";
    if (typeof(fromIw) == 'undefined')
        fromIw = false;
    if (typeof(uri) == 'undefined' || uri.length == 0)
        uri = getForm("hxpForm").uri.value;
    var params = "";
    if (uri.indexOf("?db=") == -1)
        params += "?db=" + getForm("hxpForm").db.value;
    else {
        if (uri.indexOf("?db=" + getForm("hxpForm").db.value) == -1)
            forceLogin = true; //cambio di db -> forzo login
    }
    if (typeof(onlyParams) == 'undefined')
        onlyParams = false;
    params += "&host=" + getForm("hxpForm").host.value;
    params += "&port=" + getForm("hxpForm").port.value;
    params += "&login=" + realEscape(getForm("hxpForm").login.value);
    if (!fromIw) {
        if (getForm("hxpForm").transformJava.value == 'true')
            params += "&transformJava=true";
        if (getForm("hxpForm").enableIW.value.length > 0)
            params += "&enableIW=" + getForm("hxpForm").enableIW.value;
        if (typeof(getForm("hxpForm").language) != 'undefined')
            params += "&language=" + getForm("hxpForm").language.value;
    }
    params += "&_cd=" + realEscape(getForm("hxpForm")["_cd"].value);

    var rights = "";
    if (typeof(forceLogin) == 'undefined' || forceLogin == false) {
        rights = "&userRights=" + realEscape(getForm("hxpForm").userRights.value) +
        "&specificAppCode=" + realEscape(getForm("hxpForm").specificAppCode.value) +
        "&specificDbCode=" + realEscape(getForm("hxpForm").specificDbCode.value) +
        "&showdocUOR=" + realEscape(getForm("hxpForm").showdocUOR.value) +
        "&doceditUOR=" + realEscape(getForm("hxpForm").doceditUOR.value);
        /*                "&acl=" + realEscape(getForm("hxpForm").acl.value) +
                "&docInGestioneUOR=" + getForm("hxpForm").docInGestioneUOR.value +
                "&uorInGestioneSelected=" + getForm("hxpForm").uorInGestioneSelected.value +
                "&browser=" + getForm("hxpForm").browser.value +
                "&wfActive=" + getForm("hxpForm").wfActive.value;*/
    }
    else {//forceLogin
        rights = "&matricola=" + realEscape(getForm("hxpForm").matricola.value);
    }

    url = uri + params + rights;

    if (typeof(returnOnlyURI) == 'undefined' || returnOnlyURI == false) {
        var wHost = vGetHost();
        var wPort = window.location.port;
        if (wPort.length > 0)
            wPort = ":" + wPort;
        var protocol = window.location.protocol;
        url = protocol + "//" + wHost + wPort + url;
    }

    if (onlyParams) {
        var index = url.indexOf("?");
        if (index != -1 && index <= url.length)
            return url.substring(index + 1);
    }

    return url;
}

function vGetHost()
{
    /* DD 19/12/2005 - RW: 0031529
    var host = window.location.host;
    if ( host.indexOf(':') != -1 )
        host = host.substring(0, host.indexOf(':'));
    return host;
     */
    return window.location.hostname;

}

/* DD 27/07/05
 * Torna true se la modalit TEST  attiva.
 * Questo avviene quando la stringa navigator.userAgent
 * contiene "TEST_MODE".
 */
function isTestMode(){
    if(navigator.userAgent.toUpperCase().indexOf("TEST_MODE") != -1)
        return true;

    return false;
}

/*
 * Created on: 09/09/05
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Questa funzione prepara un url che consente di accedere ad un documento mediante il suo nrecord.
 *              Tale url contiene le stringhe "%PNE%" e "%NRECORD%" che devono essere sostituite rispettivamente
 *              con il pne e l'nrecord del documento che si vuole visualizzare.
 *              Inoltre, mediante la property "baseDocUrl" e' possibile specificare la parte iniziale dell'url
 *              (fino a '?' escluso). Se non viene indicato nulla, la parte iniziale viene costruita a partire
 *              dall'url corrente.
 *
 *              NOTA: La parte java trasmette il valore di tale property nella tupla "_cd".
 */
function prepareDocURL()
{
    var hxpForm = getForm("hxpForm");

    /* Federico 31/01/06: data la possibilit di specificare la parte iniziale dell'url (fino a '?' escluso)
     * mediante la property "baseDocUrl" [RW 0032659]
     */

    var hxpS = new _hxpSession(hxpForm);
    var docUrl = hxpS.getParameter("baseDocUrl");

    /*
    alert(  "\n URL : " + docUrl +
            "\n PROT: " + window.location.protocol +
            "\n HOST: " + window.location.host +
            "\n PORT: " + window.location.port +
            "\n URI : " + hxpForm.uri.value + "\n\n" );
    /* */

    if (docUrl == 'undefined' || docUrl.length == 0) {
        docUrl = window.location.protocol + "//" + window.location.host;
        if (window.location.protocol.indexOf(":") == -1) {
            if (window.location.port.length() != 0) {
                docUrl += ":" + window.location.port;
            }
        }
        docUrl += hxpForm.uri.value;
    }

    if (docUrl.indexOf("?") != -1) {
        docUrl = docUrl.substring(0, docUrl.indexOf("?"));
    }

    // URL che consente di recuperare un documento dato il suo nrecord.
    docUrl += "?db=" + hxpForm.db.value + "&amp;transformJava=true&amp;verbo=queryplain" +
    "&amp;language=" + hxpForm.language.value +
    "&amp;query=[xml,/%PNE%/@nrecord]%3d%NRECORD%";

    // controllo parametro 'enableIW'
    var enIw = hxpForm.enableIW.value;

    if (enIw.length > 0) {
        docUrl += "&amp;enableIW=" + enIw;
    }

    // se  stata specificata aggiungo anche la view
    var viewToUse = hxpForm.view.value;

    if (viewToUse.length > 0) {
        docUrl += "&amp;view=" + viewToUse;
    }

    return docUrl;
}

//VM - 06/10/2005 Funzione generica per la gestione del cambio lingua in tutte le fasi operative
function genericChangeLanguage(lang)
{
    setGlobalFormRestore('verbo', 'xverb', 'dbTable', 'language');

    if (typeof(lang) != 'undefined' && getForm("hxpForm").language.value != lang) {
        getForm("hxpForm").language.value = lang;
        getForm("hxpForm").submit();
    }

    return false;
}

/*
 * Created on: 28/11/05
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Questa funzione, spostata da 'filelist.js', effettua l'escaping della stringa passata come
 *              parametro.
 *              'realEscape'  particolarmente utile per escapare il contenuto di tuple da inserire in un URL.
 */
function realEscape(s)
{
    var ret = escape(s);
    ret = ret.replace(/\+/g, '%2B');
    ret = ret.replace(/\*/g, '%2A');
    ret = ret.replace(/\@/g, '%40');
    ret = ret.replace(/\-/g, '%2D');
    ret = ret.replace(/\_/g, '%5F');
    ret = ret.replace(/\./g, '%2E');

    // Federico 02/12/08: introdotto escaping del carattere '?' [RW 0055649]
    ret = ret.replace(/\?/g, '%3F');

    return ret;
}

function realUnEscape(s)
{
    var ret = unescape(s);
    ret = ret.replace(/%2B/g, '+');
    ret = ret.replace(/%2A/g, '*');
    ret = ret.replace(/%40/g, '@');
    ret = ret.replace(/%2D/g, '-');
    ret = ret.replace(/%5F/g, '_');
    ret = ret.replace(/%2E/g, '.');

    // Federico 02/12/08: introdotto unescaping del carattere '?' [RW 0055649]
    ret = ret.replace(/%3F/g, '?');

    return ret;
}

/* DD 28/11/2005 Recupera i values di tutti i checkbox dal nome passato, che sono selezionati
 *	e li forma sottoforma di "lista" separata dal carattere richiesto.
 * <valore><sep>|[<valore><sep>|]
 */
function getValuesFromCheckboxList(targetName, sep)
{
    theRetVal = "";
    inputList = document.getElementsByTagName('input');
    for ( var i = 0; i < inputList.length; i++){
        if ( inputList[i].name == targetName )
            if (inputList[i].checked == true) theRetVal += inputList[i].value + sep;
    }
    return theRetVal;
}
/*
 * DD 29/01/2006 Valorizza tutti gli attributi title delle immagini con il
 * valore dell'atributo alt per permettere la visualizzazione dei tooltips con mozilla
 */
function setAllImgTitlesFromAlt()
{

    if(getForm("hxpForm").browser == "Explorer") return;

    var elements = document.getElementsByTagName("img");
    for (var i = 0; i < elements.length; i++ ) {
        if (typeof(elements[i].alt) != 'undefined')
            elements[i].title = elements[i].alt;
    }
    return;
}
/***************************************************************
 	Funzioni per la classificazione 'custom' (vedi RW: 0033152)
 ***************************************************************/

/* DD 13/02/2006	Formatta la classificazione passata in
	base al pattern definito nell'input classifFormat.
 */
function formatClassif(sLabel){
    //Verifico che sia definito un pattern altrimenti esco
    //if(oClassif == null || typeof(oClassif.innerHTML) == 'undefined') return;
    var pattern = getClassifFormat();
    if(pattern == null) return sLabel;

    //Il pattern c'. Recupero il valore della label
    aLabel = sLabel.split(" - ");
    codice = aLabel[0];
    var sep=pattern.replace("AA", "").replace("A", "").replace("R", "").replace("D", "").replace("DD", "").replace("D", "");
    aPattern = pattern.split(sep);
    aCod = codice.split("/");
    var ret = '';
    var index;
    for (var i=0; i<aCod.length;i++) {
        index = i==0?0:1;
        ret += sep + formatSingleCode(aCod[i], aPattern[index]);
    }
    if (ret.charAt(0) == '/')
        ret = ret.substring(1);

    //Riporto tutto ci che seguiva il codice nella stringa originale
    if(aLabel.length > 1){
        for(i = 1; i < aLabel.length; i++) ret+=" - " + aLabel[i];
    }
    return(ret);

}

/* DD 13/02/2006	Ottiene il codice numerico dalla classificazione passata formattata in
	base al pattern definito nell'input classifFormat.
 */
function unformatClassif(sLabel){

    if(sLabel.length == 0) return("");
    //Verifico che sia definito un pattern altrimenti esco
    //if(oClassif == null || typeof(oClassif.innerHTML) == 'undefined') return;
    var pattern = getClassifFormat();
    if(pattern == null) return sLabel;

    //Il pattern c'. Recupero gli altri dati
    aLabel = sLabel.split(" - ");
    codice = aLabel[0];
    var sep=pattern.replace("AA", "").replace("A", "").replace("R", "").replace("D", "").replace("DD", "").replace("D", "");
    aPattern = pattern.split(sep);
    if(codice.indexOf(sep) != -1){
        aCod = codice.split(sep);
    } else {
        //Accetto sempre la barra
        aCod = codice.split("/");
    }
    var ret = '';

    ret = unformatSingleCode(aCod[0], aPattern[0]);
    if(aCod.length == 2 && aCod[1].length > 0){
        ret += "/";
        ret += unformatSingleCode(aCod[1], aPattern[1]);
    } else {
        if(!isNaN(parseInt(aCod[0]))){
            /*Se  stato inserito solo un numero (o qualcosa di trasformabile in tale numero),
			considero che si tratti del titolo e cerco titolo*/
            ret += "/*";
            /* alert('debug:' + ret); */
        }
    }
    //Riporto tutto ci che seguiva il codice nella stringa originale
    if(aLabel.length > 1){
        for(i = 1; i < aLabel.length; i++) ret+=" - " + aLabel[i];
    }
    return(ret);

}

/* DD 13/02/2006	Ottiene il pattern definito nell'input classifFormat, se presente.
	Altrimenti torna null;
 */
function getClassifFormat(){
    var theForm = getForm('indexForm');
    if(theForm == null && typeof(opener) != 'undefined'){
        theForm = opener.getForm('indexForm');
        if(theForm == null) return null;
    }
    if(typeof(theForm.classifFormat) == 'undefined') return null;
    if(theForm.classifFormat.value.length == 0) return null;

    var pattern = theForm.classifFormat.value;
    return(pattern)
}

/* DD 13/02/2006	Formatta il numero passato (titolo o classe) in base al pattern (singolo) passato */
function formatSingleCode(sVal, sPattern){
    if (sPattern == 'R') return arab2roman(sVal);
    if (sPattern == 'A') return arab2alfa(sVal);
    if (sPattern == 'AA') return arab2doubleAlfa(sVal);
    if (sPattern == 'D'){
        sVal = sVal.charAt(0)== "0" ? sVal.substring(1) : sVal;
        return sVal;
    }
    if (sPattern == 'DD') return sVal;

    //ERRORE
    return sVal;
}

/* DD 13/02/2006	Decodifica il dato passato in base al pattern (singolo) passato */
function unformatSingleCode(sVal, sPattern){
    var sRet = sVal;
    if (sPattern == 'R') sRet = roman2arab(sVal);
    if (sPattern == 'A') sRet = alfa2arab(sVal);
    if (sPattern == 'AA') sRet = doubleAlfa2arab(sVal);
    //Se si tratta di un numero di un carattere, aggiungo lo 0 in testa
    if(sRet.length == 1 ){
        var numeri="1234567890";
        if (numeri.indexOf(sRet)!=-1) sRet = "0" + sRet;
    }

    return sRet;
}

function arab2roman(num)
{
    switch ( num ) {
    case '00': return '0';
    case '01': return 'I';
    case '02': return 'II';
    case '03': return 'III';
    case '04': return 'IV';
    case '05': return 'V';
    case '06': return 'VI';
    case '07': return 'VII';
    case '08': return 'VIII';
    case '09': return 'IX';
    case '10': return 'X';
    case '11': return 'XI';
    case '12': return 'XII';
    case '13': return 'XIII';
    case '14': return 'XIV';
    case '15': return 'XV';
    case '16': return 'XVI';
    case '17': return 'XVII';
    case '18': return 'XVIII';
    case '19': return 'XIX';
    case '20': return 'XX';
    case '21': return 'XXI';
    case '22': return 'XXII';
    case '23': return 'XXIII';
    case '24': return 'XXIV';
    case '25': return 'XXV';
    case '26': return 'XXVI';
    case '27': return 'XVII';
    case '28': return 'XVIII';
    case '29': return 'XIX';
    case '30': return 'XXX';
    }
}
function roman2arab(num)
{
    switch ( num ) {
    case 'i' : case 'I' : return '1';
    case 'ii' : case 'II' : return '2';
    case 'iii' : case 'III' : return '3';
    case 'iv' : case 'IV' : return '4';
    case 'v' : case 'V' : return '5';
    case 'vi' : case 'VI' : return '6';
    case 'vii' : case 'VII' : return '7';
    case 'viii' : case 'VIII' : return '8';
    case 'ix' : case 'IX' : return '9';
    case 'x' : case 'X' : return '10';
    case 'xi' : case 'XI' : return '11';
    case 'xii' : case 'XII' : return '12';
    case 'xiii' : case 'XIII' : return '13';
    case 'xiv' : case 'XIV' : return '14';
    case 'xv' : case 'XV' : return '15';
    case 'xvi' : case 'XVI' : return '16';
    case 'xvii' : case 'XVII' : return '17';
    case 'xviii' : case 'XVIII' : return '18';
    case 'xix' : case 'XIX' : return '19';
    case 'xx' : case 'XX' : return '20';
    case 'xxi' : case 'XXI' : return '21';
    case 'xxii' : case 'XXII' : return '22';
    case 'xxiii' : case 'XXIII' : return '23';
    case 'xxiv' : case 'XXIV' : return '24';
    case 'xxv' : case 'XXV' : return '25';
    case 'xxvi' : case 'XXVI' : return '26';
    case 'xxvii' : case 'XXVII' : return '27';
    case 'xxviii' : case 'XXVIII' : return '28';
    case 'xxix' : case 'XXIX' : return '29';
    case 'xxx' : case 'XXX' : return '30';
    }
    return num;
}

/* DD 13/02/2006	Es: 5=E, 0=0 */
function arab2alfa(num)
{
    var valori = "0ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    idx = eval(num);
    return(valori.charAt(idx));
}
/* DD 13/02/2006	Es: 5=AE, 0=0, 28=BB */
function arab2doubleAlfa(num)
{
    n = eval(num);
    var ret ="";
    if(n == 0) return ("0");
    if(n > 26){
        ret = "B" + arab2alfa(n - 26);
    } else {
        ret = "A" + arab2alfa(num);
    }
    return(ret);
}
/* DD 13/02/2006	Es: B=2, 0=0 */
function alfa2arab(sChar)
{
    sChar = sChar.toUpperCase();
    if(sChar == "0") return ("0");
    var valori = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    idx = valori.indexOf(sChar);
    if(idx == -1) return sChar;
    //L'array  in base 0...
    idx = idx + 1;

    return(idx.toString());
}
/* DD 13/02/2006	Es: AA=1, BC=29, 0=0 */
function doubleAlfa2arab(sChars)
{
    if(sChars.length != 2) return sChars;
    sRet = alfa2arab(sChars.charAt(1));
    if(sRet == sChars.charAt(1)) return sChars;
    nUnita = eval(sRet);
    sRet = alfa2arab(sChars.charAt(0));
    if(sRet == sChars.charAt(0)) return sChars;
    nDecine = eval(sRet - 1) * 26;
    return (nUnita+nDecine).toString();
}
/* DD 27/03/2006 Spostata qui da xdcowayPresentation */
function decodeAppStringPreference(val)
{
    if ( val == "ClassificazioneAutomatica" )
        return 0;
    else if ( val == "LunghezzaMinimaOggetto" )
        return 1;
    else if ( val == "ScartoAutomatico" )
        return 2;
    else if ( val == "checkRipetizioniInOggetto" )
        return 6;
    else if ( val == "RTFPropostaObbligatorio" )
        return 7;
    else if ( val == "RTFComunicazioneObbligatorio" )
        return 8;
    else if ( val == "warningSeSenzaAllegato" )
        return 9;
    else if ( val == "CheckboxEmailNotifica" )
        return 10;
    else if (val == 'notificaOggettiDiversiConClassificazione')
        return 11;
    //RW0052224 - fcossu - Numero ripetizione caratteri inusuali
    else if ( val == "numeroRipetizioniInOggetto" )
        return 13;
}

/**********************************************************/

function setFormTuplesFromURL(url, form) {
    var ret = form.uri.value;
    var uri = url;
    var params = '';
    var oldUserRights = '';
    if (uri.indexOf('?') != -1) {
        params = uri.substring(uri.indexOf('?') + 1);
        uri = uri.substring(0, uri.indexOf('?'));
        ret += '?';
    }
    if (uri != form.uri.value) {//diversa uri -> forzo login
        oldUserRights = form.userRights.value;
        form.userRights.value = '';
        form.uri.value = uri;
        form.action = uri;
    }
    var v = params.split('&');
    var el, name, val;
    for (var i=0; i<v.length; i++) {
        el = v[i];
        name = el.substring(0, el.indexOf('='));
        val = el.substring(el.indexOf('=') + 1);
        if (i != 0) {
            ret += '&';
        }
        if (form[name]) {
            ret += name + '=' + realEscape(form[name].value);
            form[name].value = realUnEscape(val);
        }
        else {//non presente nella form
            ret += name + '=';
            var eF = document.createElement(name);
            eF.value = val;
            form.appendChild(eF);
        }
    }
    if (oldUserRights.length > 0) {
        ret += '&userRights=' + realEscape(oldUserRights);
    }
    return ret;
}

/* Funzioni per la restituzione di un elemento dato il name e un elemento root */
var elFound = null; //private
function visita(root, attrVal, attrName) { //private
    if ( elFound != null )
        return;

    /*Federica RW0040840 24/11/2006*/
    if (root == null)
        return;

    // Federico 11/05/07: introdotta possibilita' di recuperare un elemento dentro a 'root' dato
    // il valore di un generico attributo [RW 0043770]
    if (typeof(attrName) == 'undefined' || attrName == null) attrName = 'name';

    if ( typeof(root.getAttribute) != 'undefined' && root.getAttribute(attrName) == attrVal )
        elFound = root;

    var l = root.childNodes;
    for (var i = 0; i < l.length; i++)
        visita(l.item(i), attrVal, attrName);
}

function getElementByNameWithRoot(root, name) {//public
    elFound = null;
    visita(root, name);
    return elFound;
}

// Federico 11/05/07: recupera un elemento dentro a 'root' dato il valore di un generico
// attributo [RW 0043770]
function getElementByAttrWithRoot(root, attrVal, attrName) {//public
    elFound = null;
    visita(root, attrVal, attrName);
    return elFound;
}

/* ******************* */

function getFilePost(id, name, db) {
    var iForm = getForm("hxpForm");

    var oldTarget = iForm.target;
    var oldVerbo = iForm.verbo.value;
    var oldXVerb = iForm.xverb.value;
    var oldDb = iForm.db.value;

    iForm.target = iForm.target + "getfile";
    iForm.verbo.value = 'attach';
    iForm.xverb.value = '';
    iForm.db.value = db;

    var idEl = null;
    var nameEl = null;

    if (typeof(iForm.id.value) == 'undefined') {
        idEl = document.createElement('input');
        idEl.setAttribute('type', 'hidden');
        idEl.setAttribute('name', 'id');
        idEl.setAttribute('value', id);
        iForm.appendChild(idEl);
    }
    else
        iForm.id.value = id;

    if (typeof(iForm.name.value) == 'undefined') {
        nameEl = document.createElement('input');
        nameEl.setAttribute('type', 'hidden');
        nameEl.setAttribute('name', 'name');
        nameEl.setAttribute('value', name);
        iForm.appendChild(nameEl);
    }
    else
        iForm.name.value = name;

    window.name = "getFileWin"; // necessario per riconoscere la finestra invocante
    var fileWin = window.open(staticEmptyWindow,iForm.target,"width=600,height=500");
    iForm.submit();
    fileWin.focus();

    // ripristino le var di hxpForm modificate
    iForm.target = oldTarget;
    iForm.verbo.value = oldVerbo;
    iForm.xverb.value = oldXVerb;
    iForm.db.value = oldDb;

    if (idEl != null)
        idEl.parentNode.removeChild(idEl);
    if (nameEl != null)
        nameEl.parentNode.removeChild(nameEl);

    return false;
}

/*
 * Created on: 30/04/07
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Questa funzione svuota il value di tutti gli input text (quindi NON HIDDEN!) contenuti nell'elemento con id
 *              'containerId'.
 *              In caso di multistanza, occorre indicare l'id dell'istanza che contiene l'elemento di cui si vogliono
 *              svuotare gli input ('instanceBlockId') e l'elemento corrente ('currentNode').
 */
function clearInputsValues(containerId, instanceBlockId, currentNode)
{
    var container;

    if (typeof(instanceBlockId) != 'undefined' && instanceBlockId != null &&
            typeof(currentNode) != 'undefined' && currentNode != null) {

        // gestione dei multistanza
        if (instanceBlockId.indexOf('$hxp_instance()') != -1) {
            var instNumber = getInstanceNumber(currentNode, instanceBlockId);
            instanceBlockId = instanceBlockId.replace('$hxp_instance()', instNumber);
        }

        var mainContainer = document.getElementById(instanceBlockId);

        if (mainContainer != null) {
            container = getElementByAttrWithRoot(mainContainer, containerId, 'id');
        }
        else {
            alert("Elemento '" + instanceBlockId + "' non trovato!");
            return;
        }
    }
    else {
        container = document.getElementById(containerId);
    }

    if (container != null) {
        var inputsList = container.getElementsByTagName('input');

        for (var j = 0; j < inputsList.length; j++) {
            if (inputsList[j].type == 'text' && typeof(inputsList[j].value) != 'undefined') {
                inputsList[j].value = '';
            }
        }
    }
    else {
        alert("Elemento '" + containerId + "' non trovato!");
    }
}

/*
 * Created on: 02/05/07
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Questa funzione imposta a 'value' il valore dell'input indicato.
 *              L'input viene recuperato mediante il nome.
 *              La funzione e' in grado di gestire i multistanza (solo se viene passato
 *              l'elemento corrente - 'currentNode' - e l'eventuale stringa - contenente
 *              "[$hxp_instance()]" o "$hxp_instance()" - per l'identificazione
 *              della sezione che rappresenta l'istanza).
 */
function setInputValue(inputName, value, currentNode, hxp_inst_str)
{
    // gestione dei multistanza
    if (inputName.indexOf('$hxp_instance()') != -1 &&
            currentNode != null && typeof(currentNode) != 'undefined') {

        if (typeof(hxp_inst_str) == 'undefined' || hxp_inst_str == null) {
            hxp_inst_str = inputName;
        }

        var instNumber = getInstanceNumber(currentNode, hxp_inst_str);
        inputName = inputName.replace('$hxp_instance()', instNumber);
    }

    var input = getElementByName(inputName);

    if (input != null) {
        input.value = value;
    }
    else {
        alert("Input '" + inputName + "' non trovato!");
    }
}

/*
 * Created on: 11/05/07
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Questa funzione recupera l'id d'istanza dato l'elemento corrente e la stringa
 *              che contiene "[$hxp_instance()]" o "$hxp_instance()" (nome dell'input multistanza
 *              o altro).
 *              Se l'id non viene trovato restituisce una stringa vuota.
 */
function getInstanceNumber(currentNode, hxp_inst_str)
{
    var pos = hxp_inst_str.indexOf('[$hxp_instance()]');

    if (pos == -1) pos = hxp_inst_str.indexOf('$hxp_instance()');

    var prefix = hxp_inst_str.substring(0, pos);
    var sep = '.';

    if (prefix.lastIndexOf('.') == (prefix.length - 1)) sep = '';

    var dad = currentNode.parentNode;

    while (dad != null && (typeof(dad.id) == 'undefined' ||
            (typeof(dad.id.indexOf) != 'undefined' && dad.id.indexOf(prefix + sep) == -1))) {

        dad = dad.parentNode;
    }

    if (dad != null) return dad.id.substring(dad.id.indexOf('.') + 1);
    else             return '';
}

/*
 * Created on: 11/06/07
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Questa funzione mostra/nasconde un elemento di cui viene passato l'id.
 */
function showHideElement(elementId)
{
    var el = document.getElementById(elementId);

    if (el != null) {
        with (el.style) {
            if (display == 'block')     display = 'none';
            else if (display == 'none') blockNoneElement(el);
            else                        display = 'none';
        }
    }
}

/*
 * Created on: 12/07/07
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Questa funzione indica se un termine ('value') e' presente o meno nell'array di stringhe
 *              indicato ('arrayToBeChecked').
 */
function isPresent(arrayToBeChecked, value)
{
    var ret = false;

    for (var j = 0; j < arrayToBeChecked.length; j++) {
        if (arrayToBeChecked[j] == value) {
            ret = true;
            break;
        }
    }

    return ret;
}
/*
 * Created on: 26/09/2007
 * by: fgr
 * organization: 3D Informatica
 * description: Restituisce 'true' se la tupla indicata esiste e vale 'tupleValue'.
 */
function testTuple(form, tupleName, tupleValue)
{
    return typeof(getForm(form)[tupleName]) != 'undefined' &&
                getForm(form)[tupleName] != null &&
                getForm(form)[tupleName].value == tupleValue;
}

/*
 * Created on: 08/10/2007
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Mostra/nasconde i div indicati nella tupla 'toDo' [RW 0047021].
 */
function showHideDivs(functionName, displayValue)
{
    var hideShowDivsStartIndex = getForm("hxpForm").toDo.value.indexOf(functionName + "(");

    if (hideShowDivsStartIndex != -1) {
        var hideShowDivsEndIndex = getForm("hxpForm").toDo.value.indexOf(")", hideShowDivsStartIndex);

        if (hideShowDivsEndIndex != -1) {
            var divsListStr   = getForm("hxpForm").toDo.value.substring(hideShowDivsStartIndex + functionName.length + 1,
                                                                        hideShowDivsEndIndex);
            var divsListArray = divsListStr.split(',');

            for (var j = 0; j < divsListArray.length; j++) {
                var element = document.getElementById(divsListArray[j]);

                if (element != null) element.style.display = displayValue;
            }
        }
    }
}

/*
 * Created on: 30/07/2008
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Crea un oggetto Date a partire da una data nel formato italiano (es. "01/01/2008" o "01-01-2008").
 *              [RW 0052915]
 */
function createDate(it_date)
{
    var sep = "/";

    if (it_date.indexOf('-') != -1) sep = "-";

    var tmp  = it_date.split(sep);

    // la data deve essere inizializzata con i metodi set*, se no non e' corretta!
    var date = new Date();

    date.setDate(parseInt(tmp[0], 10));
    date.setMonth(parseInt(tmp[1], 10) - 1);
    date.setFullYear(parseInt(tmp[2], 10));

    return date;
}

// Federico 08/10/09: function per la ripulitura degli eventuali dati di sessione dei lookup SAP [EA 999]
function cleanSAPLookupSessionData()
{
    var hxpS               = new _hxpSession(getForm('hxpForm'));
    var currentSAPLookupId = hxpS.getParameter("currentSAPLookupId");

    if (currentSAPLookupId != null && currentSAPLookupId.length > 0) {
        var params = buildUrlForGet("", true, true, true, true) + "&currentSAPLookupId=" + currentSAPLookupId + "&verbo=apps.generic.utils.sap.CleanSAPLookupSessionData";

        if (typeof(jsXML) != "undefined")             jsXML.sendAsyncPost(getForm('hxpForm').uri.value, params, null, null, null);
        else if (typeof(opener.jsXML) != "undefined") opener.jsXML.sendAsyncPost(getForm('hxpForm').uri.value, params, null, null, null);
        else                                          alert('Oggetto jsXML non trovato!');

        hxpS.setParameter("currentSAPLookupId", null);
    }
}

// Federico 14/10/09: imposta una tupla in '_cd' [EB 111]
function setCDTuple(formName, tupleName, tupleValue)
{
    var hxpS = new _hxpSession(getForm(formName));

    hxpS.setParameter(tupleName, tupleValue);
}
