// Conditional alert.
function cAlert (message){if(!this.silent) alert(message);}
// Conditional confirm.
function cConfirm (message){if(this.silent) return true; return confirm(message);}
// Variable indicating whether or not installation should proceed.
bInstall = true;
// Make sure Java is enabled before doing anything else.
if(!navigator.javaEnabled()){bInstall=false; cAlert("Java must be enabled to install.");}
// Make sure installation is attempted on correct machine architecture.
else if(navigator.platform!='Win32'){bInstall=false;cAlert("This plug-in only runs on Win32 platforms.");}
// Check user-interface language, if appropriate.
/*else if(navigator.languge.compareTo("en")!=0){bInstall=cConfirm("This plug-in uses the English language. You do not appear to be using English on this machine. Install anyway?");}
*/
var bAbort = true;
// If all conditions look good, proceed with the installation.
if (bInstall) {
  // Create a version object and a software update object
  vi = new netscape.softupdate.VersionInfo(1,3,73,222);
  su = new netscape.softupdate.SoftwareUpdate(this,"Highway Imaging Control Plug-in");
  // Start the install process
  err = su.StartInstall("plugins/", vi, 
                        netscape.softupdate.SoftwareUpdate.FULL_INSTALL);
  if (err) cAlert ("Installation error (1). Aborting.");
  else {
    bAbort = false;
    // Find the plug-ins directory on the user's machine
    PIFolder = su.GetFolder("Plugins");
    // Install the files. Unpack them and list where they go
    err = su.AddSubcomponent("Highway Imaging Control Plug-in", 
                             vi, 
                             "npiw.dll",
                             PIFolder, 
                             "", 
                             this.force);
    if (err) cAlert ("Installation error (2). Aborting.");
    bAbort = bAbort || (err !=0);
    if (!bAbort) {
      err = su.AddSubcomponent("Highway Imaging Control Class", 
                               vi, 
                               "IW.class",
                               PIFolder, 
                               "", 
                               this.force);
      bAbort = bAbort || (err !=0);
      if (err) cAlert ("Installation error (3). Aborting.");
    }
    if (!bAbort) {
      err = su.AddSubcomponent("Highway Imaging Control Interface", 
                               vi, 
                               "IWInterface.class",
                               PIFolder, 
                               "", 
                               this.force);
      bAbort = bAbort || (err !=0);
      if (err) cAlert ("Installation error (4). Aborting.");
    }
    if (!bAbort) {
      err = su.AddSubcomponent("Highway Imaging Control Observer", 
                               vi, 
                               "IWObserver.class",
                               PIFolder, 
                               "", 
                               this.force);
      if (err) cAlert ("Installation error (5). Aborting.");
      bAbort = bAbort || (err !=0);
    }
    if (!bAbort) {
      err = su.AddSubcomponent("Highway Imaging Control Converter", 
                               vi, 
                               "MsConv.exe",
                               PIFolder, 
                               "", 
                               this.force);
      if (err) cAlert ("Installation error (6). Aborting.");
      bAbort = bAbort || (err !=0);
    }
  }
  // Unless there was a problem, move files to final location 
  // and update the Client Version Registry
  if (bAbort) {
    su.AbortInstall();
  }
  else {
    err = su.FinalizeInstall();
    // Refresh list of available plug-ins
    if (err == 0)
      navigator.plugins.refresh(true);
    else if (err == 999)
      cAlert("You must reboot to finish this installation.");
  }
  if (bAbort || (err!=0 && err!=999))
    cAlert("Install encountered errors.");
}
